-- MySQL dump 10.13  Distrib 5.6.49, for Linux (x86_64)
--
-- Host: localhost    Database: shiziyu
-- ------------------------------------------------------
-- Server version	5.6.49-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `oscshop_access`
--

DROP TABLE IF EXISTS `oscshop_access`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_access` (
  `id` int(11) NOT NULL,
  `role_id` int(11) NOT NULL COMMENT '角色id',
  `node_id` int(11) NOT NULL COMMENT '节点id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='结点权限访问表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_access`
--

LOCK TABLES `oscshop_access` WRITE;
/*!40000 ALTER TABLE `oscshop_access` DISABLE KEYS */;
INSERT INTO `oscshop_access` VALUES (8,2,14),(9,2,16),(10,2,19),(11,2,20),(12,2,21),(13,2,22),(14,2,23),(15,2,1),(16,2,4),(17,2,5),(18,2,6),(22,3,1),(23,3,2),(24,3,3),(25,3,4),(26,3,5);
/*!40000 ALTER TABLE `oscshop_access` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_address`
--

DROP TABLE IF EXISTS `oscshop_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_address` (
  `address_id` int(11) NOT NULL AUTO_INCREMENT,
  `member_id` int(11) NOT NULL,
  `name` varchar(20) NOT NULL,
  `telephone` varchar(20) NOT NULL,
  `address` varchar(128) NOT NULL COMMENT '地址',
  `address_name` enum('HOME','WORK') DEFAULT 'HOME' COMMENT '收货地址类型',
  `is_default` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否默认的收货地址',
  `city_id` int(11) NOT NULL COMMENT '市',
  `country_id` int(11) NOT NULL COMMENT '县乡',
  `province_id` int(11) NOT NULL COMMENT '省',
  PRIMARY KEY (`address_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户收货地址';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_address`
--

LOCK TABLES `oscshop_address` WRITE;
/*!40000 ALTER TABLE `oscshop_address` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_admin`
--

DROP TABLE IF EXISTS `oscshop_admin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_admin` (
  `a_id` mediumint(8) NOT NULL,
  `a_uname` varchar(20) NOT NULL COMMENT '用户名',
  `a_true_name` varchar(20) NOT NULL COMMENT '真名',
  `a_telephone` varchar(40) NOT NULL,
  `a_email` varchar(64) NOT NULL,
  `a_passwd` varchar(255) NOT NULL,
  `a_is_super` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否超级管理员',
  `a_role_id` int(11) NOT NULL COMMENT '所属角色id',
  `a_login_count` mediumint(8) NOT NULL COMMENT '登录次数',
  `a_last_login_ip` varchar(40) NOT NULL COMMENT '最后登录ip',
  `a_last_ip_region` varchar(40) NOT NULL,
  `a_create_time` int(11) NOT NULL COMMENT '创建时间',
  `a_last_login_time` int(11) NOT NULL COMMENT '最后登录',
  `a_status` tinyint(4) NOT NULL COMMENT '状态'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='后台管理员';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_admin`
--

LOCK TABLES `oscshop_admin` WRITE;
/*!40000 ALTER TABLE `oscshop_admin` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_admin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_apply`
--

DROP TABLE IF EXISTS `oscshop_apply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_apply` (
  `id` int(10) NOT NULL COMMENT '自增id',
  `username` varchar(255) NOT NULL COMMENT '姓名',
  `member_id` int(10) NOT NULL DEFAULT '0' COMMENT '用户id',
  `mobile` varchar(25) NOT NULL COMMENT '手机号',
  `email` varchar(50) NOT NULL COMMENT '邮箱',
  `store_name` varchar(100) NOT NULL COMMENT '店铺名称',
  `city` varchar(50) NOT NULL COMMENT '城市名称',
  `type` tinyint(1) DEFAULT '0' COMMENT '申请类型：0个人，1企业',
  `category_id` int(10) NOT NULL DEFAULT '0' COMMENT '分类id',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '状态,0申请中，1申请通过，2拒绝',
  `addtime` int(10) DEFAULT '0' COMMENT '添加时间'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_apply`
--

LOCK TABLES `oscshop_apply` WRITE;
/*!40000 ALTER TABLE `oscshop_apply` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_apply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_apply_relship`
--

DROP TABLE IF EXISTS `oscshop_apply_relship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_apply_relship` (
  `id` int(10) NOT NULL COMMENT '自增ID',
  `aid` int(10) NOT NULL COMMENT '申请ID',
  `seller_id` int(10) DEFAULT NULL COMMENT '申请成功之后的卖家ID',
  `rel_data` text NOT NULL COMMENT '关联的内容',
  `addtime` int(10) NOT NULL COMMENT '添加时间'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='申请信息关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_apply_relship`
--

LOCK TABLES `oscshop_apply_relship` WRITE;
/*!40000 ALTER TABLE `oscshop_apply_relship` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_apply_relship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_area`
--

DROP TABLE IF EXISTS `oscshop_area`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_area` (
  `area_id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '索引ID',
  `area_name` varchar(50) NOT NULL COMMENT '地区名称',
  `area_parent_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '地区父ID',
  `area_sort` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  `area_deep` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '地区深度，从1开始',
  PRIMARY KEY (`area_id`),
  KEY `area_parent_id` (`area_parent_id`)
) ENGINE=InnoDB AUTO_INCREMENT=45056 DEFAULT CHARSET=utf8 COMMENT='地区表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_area`
--

LOCK TABLES `oscshop_area` WRITE;
/*!40000 ALTER TABLE `oscshop_area` DISABLE KEYS */;
INSERT INTO `oscshop_area` VALUES (1,'北京',0,0,1),(2,'天津',0,0,1),(3,'河北省',0,0,1),(4,'山西省',0,0,1),(5,'内蒙古自治区',0,0,1),(6,'辽宁省',0,0,1),(7,'吉林省',0,0,1),(8,'黑龙江省',0,0,1),(9,'上海',0,0,1),(10,'江苏省',0,0,1),(11,'浙江省',0,0,1),(12,'安徽省',0,0,1),(13,'福建省',0,0,1),(14,'江西省',0,0,1),(15,'山东省',0,0,1),(16,'河南省',0,0,1),(17,'湖北省',0,0,1),(18,'湖南省',0,0,1),(19,'广东省',0,0,1),(20,'广西壮族自治区',0,0,1),(21,'海南省',0,0,1),(22,'重庆',0,0,1),(23,'四川省',0,0,1),(24,'贵州省',0,0,1),(25,'云南省',0,0,1),(26,'西藏自治区',0,0,1),(27,'陕西省',0,0,1),(28,'甘肃省',0,0,1),(29,'青海省',0,0,1),(30,'宁夏回族自治区',0,0,1),(31,'新疆维吾尔自治区',0,0,1),(32,'台湾省',0,0,1),(33,'香港特别行政区',0,0,1),(34,'澳门特别行政区',0,0,1),(35,'海外',0,0,1),(36,'北京市',1,0,2),(37,'东城区',36,0,3),(38,'西城区',36,0,3),(39,'上海市',9,0,2),(40,'天津市',2,0,2),(41,'朝阳区',36,0,3),(42,'丰台区',36,0,3),(43,'石景山区',36,0,3),(44,'海淀区',36,0,3),(45,'门头沟区',36,0,3),(46,'房山区',36,0,3),(47,'通州区',36,0,3),(48,'顺义区',36,0,3),(49,'昌平区',36,0,3),(50,'大兴区',36,0,3),(51,'怀柔区',36,0,3),(52,'平谷区',36,0,3),(53,'密云县',36,0,3),(54,'延庆县',36,0,3),(55,'和平区',40,0,3),(56,'河东区',40,0,3),(57,'河西区',40,0,3),(58,'南开区',40,0,3),(59,'河北区',40,0,3),(60,'红桥区',40,0,3),(61,'塘沽区',40,0,3),(62,'重庆市',22,0,2),(64,'东丽区',40,0,3),(65,'西青区',40,0,3),(66,'津南区',40,0,3),(67,'北辰区',40,0,3),(68,'武清区',40,0,3),(69,'宝坻区',40,0,3),(70,'宁河县',40,0,3),(71,'静海县',40,0,3),(72,'蓟县',40,0,3),(73,'石家庄市',3,0,2),(74,'唐山市',3,0,2),(75,'秦皇岛市',3,0,2),(76,'邯郸市',3,0,2),(77,'邢台市',3,0,2),(78,'保定市',3,0,2),(79,'张家口市',3,0,2),(80,'承德市',3,0,2),(81,'衡水市',3,0,2),(82,'廊坊市',3,0,2),(83,'沧州市',3,0,2),(84,'太原市',4,0,2),(85,'大同市',4,0,2),(86,'阳泉市',4,0,2),(87,'长治市',4,0,2),(88,'晋城市',4,0,2),(89,'朔州市',4,0,2),(90,'晋中市',4,0,2),(91,'运城市',4,0,2),(92,'忻州市',4,0,2),(93,'临汾市',4,0,2),(94,'吕梁市',4,0,2),(95,'呼和浩特市',5,0,2),(96,'包头市',5,0,2),(97,'乌海市',5,0,2),(98,'赤峰市',5,0,2),(99,'通辽市',5,0,2),(100,'鄂尔多斯市',5,0,2),(101,'呼伦贝尔市',5,0,2),(102,'巴彦淖尔市',5,0,2),(103,'乌兰察布市',5,0,2),(104,'兴安盟',5,0,2),(105,'锡林郭勒盟',5,0,2),(106,'阿拉善盟',5,0,2),(107,'沈阳市',6,0,2),(108,'大连市',6,0,2),(109,'鞍山市',6,0,2),(110,'抚顺市',6,0,2),(111,'本溪市',6,0,2),(112,'丹东市',6,0,2),(113,'锦州市',6,0,2),(114,'营口市',6,0,2),(115,'阜新市',6,0,2),(116,'辽阳市',6,0,2),(117,'盘锦市',6,0,2),(118,'铁岭市',6,0,2),(119,'朝阳市',6,0,2),(120,'葫芦岛市',6,0,2),(121,'长春市',7,0,2),(122,'吉林市',7,0,2),(123,'四平市',7,0,2),(124,'辽源市',7,0,2),(125,'通化市',7,0,2),(126,'白山市',7,0,2),(127,'松原市',7,0,2),(128,'白城市',7,0,2),(129,'延边朝鲜族自治州',7,0,2),(130,'哈尔滨市',8,0,2),(131,'齐齐哈尔市',8,0,2),(132,'鸡西市',8,0,2),(133,'鹤岗市',8,0,2),(134,'双鸭山市',8,0,2),(135,'大庆市',8,0,2),(136,'伊春市',8,0,2),(137,'佳木斯市',8,0,2),(138,'七台河市',8,0,2),(139,'牡丹江市',8,0,2),(140,'黑河市',8,0,2),(141,'绥化市',8,0,2),(142,'大兴安岭地区',8,0,2),(143,'黄浦区',39,0,3),(144,'卢湾区',39,0,3),(145,'徐汇区',39,0,3),(146,'长宁区',39,0,3),(147,'静安区',39,0,3),(148,'普陀区',39,0,3),(149,'闸北区',39,0,3),(150,'虹口区',39,0,3),(151,'杨浦区',39,0,3),(152,'闵行区',39,0,3),(153,'宝山区',39,0,3),(154,'嘉定区',39,0,3),(155,'浦东新区',39,0,3),(156,'金山区',39,0,3),(157,'松江区',39,0,3),(158,'青浦区',39,0,3),(159,'南汇区',39,0,3),(160,'奉贤区',39,0,3),(161,'崇明县',39,0,3),(162,'南京市',10,0,2),(163,'无锡市',10,0,2),(164,'徐州市',10,0,2),(165,'常州市',10,0,2),(166,'苏州市',10,0,2),(167,'南通市',10,0,2),(168,'连云港市',10,0,2),(169,'淮安市',10,0,2),(170,'盐城市',10,0,2),(171,'扬州市',10,0,2),(172,'镇江市',10,0,2),(173,'泰州市',10,0,2),(174,'宿迁市',10,0,2),(175,'杭州市',11,0,2),(176,'宁波市',11,0,2),(177,'温州市',11,0,2),(178,'嘉兴市',11,0,2),(179,'湖州市',11,0,2),(180,'绍兴市',11,0,2),(181,'舟山市',11,0,2),(182,'衢州市',11,0,2),(183,'金华市',11,0,2),(184,'台州市',11,0,2),(185,'丽水市',11,0,2),(186,'合肥市',12,0,2),(187,'芜湖市',12,0,2),(188,'蚌埠市',12,0,2),(189,'淮南市',12,0,2),(190,'马鞍山市',12,0,2),(191,'淮北市',12,0,2),(192,'铜陵市',12,0,2),(193,'安庆市',12,0,2),(194,'黄山市',12,0,2),(195,'滁州市',12,0,2),(196,'阜阳市',12,0,2),(197,'宿州市',12,0,2),(198,'巢湖市',12,0,2),(199,'六安市',12,0,2),(200,'亳州市',12,0,2),(201,'池州市',12,0,2),(202,'宣城市',12,0,2),(203,'福州市',13,0,2),(204,'厦门市',13,0,2),(205,'莆田市',13,0,2),(206,'三明市',13,0,2),(207,'泉州市',13,0,2),(208,'漳州市',13,0,2),(209,'南平市',13,0,2),(210,'龙岩市',13,0,2),(211,'宁德市',13,0,2),(212,'南昌市',14,0,2),(213,'景德镇市',14,0,2),(214,'萍乡市',14,0,2),(215,'九江市',14,0,2),(216,'新余市',14,0,2),(217,'鹰潭市',14,0,2),(218,'赣州市',14,0,2),(219,'吉安市',14,0,2),(220,'宜春市',14,0,2),(221,'抚州市',14,0,2),(222,'上饶市',14,0,2),(223,'济南市',15,0,2),(224,'青岛市',15,0,2),(225,'淄博市',15,0,2),(226,'枣庄市',15,0,2),(227,'东营市',15,0,2),(228,'烟台市',15,0,2),(229,'潍坊市',15,0,2),(230,'济宁市',15,0,2),(231,'泰安市',15,0,2),(232,'威海市',15,0,2),(233,'日照市',15,0,2),(234,'莱芜市',15,0,2),(235,'临沂市',15,0,2),(236,'德州市',15,0,2),(237,'聊城市',15,0,2),(238,'滨州市',15,0,2),(239,'菏泽市',15,0,2),(240,'郑州市',16,0,2),(241,'开封市',16,0,2),(242,'洛阳市',16,0,2),(243,'平顶山市',16,0,2),(244,'安阳市',16,0,2),(245,'鹤壁市',16,0,2),(246,'新乡市',16,0,2),(247,'焦作市',16,0,2),(248,'濮阳市',16,0,2),(249,'许昌市',16,0,2),(250,'漯河市',16,0,2),(251,'三门峡市',16,0,2),(252,'南阳市',16,0,2),(253,'商丘市',16,0,2),(254,'信阳市',16,0,2),(255,'周口市',16,0,2),(256,'驻马店市',16,0,2),(257,'济源市',16,0,2),(258,'武汉市',17,0,2),(259,'黄石市',17,0,2),(260,'十堰市',17,0,2),(261,'宜昌市',17,0,2),(262,'襄樊市',17,0,2),(263,'鄂州市',17,0,2),(264,'荆门市',17,0,2),(265,'孝感市',17,0,2),(266,'荆州市',17,0,2),(267,'黄冈市',17,0,2),(268,'咸宁市',17,0,2),(269,'随州市',17,0,2),(270,'恩施土家族苗族自治州',17,0,2),(271,'仙桃市',17,0,2),(272,'潜江市',17,0,2),(273,'天门市',17,0,2),(274,'神农架林区',17,0,2),(275,'长沙市',18,0,2),(276,'株洲市',18,0,2),(277,'湘潭市',18,0,2),(278,'衡阳市',18,0,2),(279,'邵阳市',18,0,2),(280,'岳阳市',18,0,2),(281,'常德市',18,0,2),(282,'张家界市',18,0,2),(283,'益阳市',18,0,2),(284,'郴州市',18,0,2),(285,'永州市',18,0,2),(286,'怀化市',18,0,2),(287,'娄底市',18,0,2),(288,'湘西土家族苗族自治州',18,0,2),(289,'广州市',19,0,2),(290,'韶关市',19,0,2),(291,'深圳市',19,0,2),(292,'珠海市',19,0,2),(293,'汕头市',19,0,2),(294,'佛山市',19,0,2),(295,'江门市',19,0,2),(296,'湛江市',19,0,2),(297,'茂名市',19,0,2),(298,'肇庆市',19,0,2),(299,'惠州市',19,0,2),(300,'梅州市',19,0,2),(301,'汕尾市',19,0,2),(302,'河源市',19,0,2),(303,'阳江市',19,0,2),(304,'清远市',19,0,2),(305,'东莞市',19,0,2),(306,'中山市',19,0,2),(307,'潮州市',19,0,2),(308,'揭阳市',19,0,2),(309,'云浮市',19,0,2),(310,'南宁市',20,0,2),(311,'柳州市',20,0,2),(312,'桂林市',20,0,2),(313,'梧州市',20,0,2),(314,'北海市',20,0,2),(315,'防城港市',20,0,2),(316,'钦州市',20,0,2),(317,'贵港市',20,0,2),(318,'玉林市',20,0,2),(319,'百色市',20,0,2),(320,'贺州市',20,0,2),(321,'河池市',20,0,2),(322,'来宾市',20,0,2),(323,'崇左市',20,0,2),(324,'海口市',21,0,2),(325,'三亚市',21,0,2),(326,'五指山市',21,0,2),(327,'琼海市',21,0,2),(328,'儋州市',21,0,2),(329,'文昌市',21,0,2),(330,'万宁市',21,0,2),(331,'东方市',21,0,2),(332,'定安县',21,0,2),(333,'屯昌县',21,0,2),(334,'澄迈县',21,0,2),(335,'临高县',21,0,2),(336,'白沙黎族自治县',21,0,2),(337,'昌江黎族自治县',21,0,2),(338,'乐东黎族自治县',21,0,2),(339,'陵水黎族自治县',21,0,2),(340,'保亭黎族苗族自治县',21,0,2),(341,'琼中黎族苗族自治县',21,0,2),(342,'西沙群岛',21,0,2),(343,'南沙群岛',21,0,2),(344,'中沙群岛的岛礁及其海域',21,0,2),(345,'万州区',62,0,3),(346,'涪陵区',62,0,3),(347,'渝中区',62,0,3),(348,'大渡口区',62,0,3),(349,'江北区',62,0,3),(350,'沙坪坝区',62,0,3),(351,'九龙坡区',62,0,3),(352,'南岸区',62,0,3),(353,'北碚区',62,0,3),(354,'双桥区',62,0,3),(355,'万盛区',62,0,3),(356,'渝北区',62,0,3),(357,'巴南区',62,0,3),(358,'黔江区',62,0,3),(359,'长寿区',62,0,3),(360,'綦江县',62,0,3),(361,'潼南县',62,0,3),(362,'铜梁县',62,0,3),(363,'大足县',62,0,3),(364,'荣昌县',62,0,3),(365,'璧山县',62,0,3),(366,'梁平县',62,0,3),(367,'城口县',62,0,3),(368,'丰都县',62,0,3),(369,'垫江县',62,0,3),(370,'武隆县',62,0,3),(371,'忠县',62,0,3),(372,'开县',62,0,3),(373,'云阳县',62,0,3),(374,'奉节县',62,0,3),(375,'巫山县',62,0,3),(376,'巫溪县',62,0,3),(377,'石柱土家族自治县',62,0,3),(378,'秀山土家族苗族自治县',62,0,3),(379,'酉阳土家族苗族自治县',62,0,3),(380,'彭水苗族土家族自治县',62,0,3),(381,'江津市',62,0,3),(382,'合川市',62,0,3),(383,'永川市',62,0,3),(384,'南川市',62,0,3),(385,'成都市',23,0,2),(386,'自贡市',23,0,2),(387,'攀枝花市',23,0,2),(388,'泸州市',23,0,2),(389,'德阳市',23,0,2),(390,'绵阳市',23,0,2),(391,'广元市',23,0,2),(392,'遂宁市',23,0,2),(393,'内江市',23,0,2),(394,'乐山市',23,0,2),(395,'南充市',23,0,2),(396,'眉山市',23,0,2),(397,'宜宾市',23,0,2),(398,'广安市',23,0,2),(399,'达州市',23,0,2),(400,'雅安市',23,0,2),(401,'巴中市',23,0,2),(402,'资阳市',23,0,2),(403,'阿坝藏族羌族自治州',23,0,2),(404,'甘孜藏族自治州',23,0,2),(405,'凉山彝族自治州',23,0,2),(406,'贵阳市',24,0,2),(407,'六盘水市',24,0,2),(408,'遵义市',24,0,2),(409,'安顺市',24,0,2),(410,'铜仁地区',24,0,2),(411,'黔西南布依族苗族自治州',24,0,2),(412,'毕节地区',24,0,2),(413,'黔东南苗族侗族自治州',24,0,2),(414,'黔南布依族苗族自治州',24,0,2),(415,'昆明市',25,0,2),(416,'曲靖市',25,0,2),(417,'玉溪市',25,0,2),(418,'保山市',25,0,2),(419,'昭通市',25,0,2),(420,'丽江市',25,0,2),(421,'思茅市',25,0,2),(422,'临沧市',25,0,2),(423,'楚雄彝族自治州',25,0,2),(424,'红河哈尼族彝族自治州',25,0,2),(425,'文山壮族苗族自治州',25,0,2),(426,'西双版纳傣族自治州',25,0,2),(427,'大理白族自治州',25,0,2),(428,'德宏傣族景颇族自治州',25,0,2),(429,'怒江傈僳族自治州',25,0,2),(430,'迪庆藏族自治州',25,0,2),(431,'拉萨市',26,0,2),(432,'昌都地区',26,0,2),(433,'山南地区',26,0,2),(434,'日喀则地区',26,0,2),(435,'那曲地区',26,0,2),(436,'阿里地区',26,0,2),(437,'林芝地区',26,0,2),(438,'西安市',27,0,2),(439,'铜川市',27,0,2),(440,'宝鸡市',27,0,2),(441,'咸阳市',27,0,2),(442,'渭南市',27,0,2),(443,'延安市',27,0,2),(444,'汉中市',27,0,2),(445,'榆林市',27,0,2),(446,'安康市',27,0,2),(447,'商洛市',27,0,2),(448,'兰州市',28,0,2),(449,'嘉峪关市',28,0,2),(450,'金昌市',28,0,2),(451,'白银市',28,0,2),(452,'天水市',28,0,2),(453,'武威市',28,0,2),(454,'张掖市',28,0,2),(455,'平凉市',28,0,2),(456,'酒泉市',28,0,2),(457,'庆阳市',28,0,2),(458,'定西市',28,0,2),(459,'陇南市',28,0,2),(460,'临夏回族自治州',28,0,2),(461,'甘南藏族自治州',28,0,2),(462,'西宁市',29,0,2),(463,'海东地区',29,0,2),(464,'海北藏族自治州',29,0,2),(465,'黄南藏族自治州',29,0,2),(466,'海南藏族自治州',29,0,2),(467,'果洛藏族自治州',29,0,2),(468,'玉树藏族自治州',29,0,2),(469,'海西蒙古族藏族自治州',29,0,2),(470,'银川市',30,0,2),(471,'石嘴山市',30,0,2),(472,'吴忠市',30,0,2),(473,'固原市',30,0,2),(474,'中卫市',30,0,2),(475,'乌鲁木齐市',31,0,2),(476,'克拉玛依市',31,0,2),(477,'吐鲁番地区',31,0,2),(478,'哈密地区',31,0,2),(479,'昌吉回族自治州',31,0,2),(480,'博尔塔拉蒙古自治州',31,0,2),(481,'巴音郭楞蒙古自治州',31,0,2),(482,'阿克苏地区',31,0,2),(483,'克孜勒苏柯尔克孜自治州',31,0,2),(484,'喀什地区',31,0,2),(485,'和田地区',31,0,2),(486,'伊犁哈萨克自治州',31,0,2),(487,'塔城地区',31,0,2),(488,'阿勒泰地区',31,0,2),(489,'石河子市',31,0,2),(490,'阿拉尔市',31,0,2),(491,'图木舒克市',31,0,2),(492,'五家渠市',31,0,2),(493,'台北市',32,0,2),(494,'高雄市',32,0,2),(495,'基隆市',32,0,2),(496,'台中市',32,0,2),(497,'台南市',32,0,2),(498,'新竹市',32,0,2),(499,'嘉义市',32,0,2),(500,'台北县',32,0,2),(501,'宜兰县',32,0,2),(502,'桃园县',32,0,2),(503,'新竹县',32,0,2),(504,'苗栗县',32,0,2),(505,'台中县',32,0,2),(506,'彰化县',32,0,2),(507,'南投县',32,0,2),(508,'云林县',32,0,2),(509,'嘉义县',32,0,2),(510,'台南县',32,0,2),(511,'高雄县',32,0,2),(512,'屏东县',32,0,2),(513,'澎湖县',32,0,2),(514,'台东县',32,0,2),(515,'花莲县',32,0,2),(516,'中西区',33,0,2),(517,'东区',33,0,2),(518,'九龙城区',33,0,2),(519,'观塘区',33,0,2),(520,'南区',33,0,2),(521,'深水埗区',33,0,2),(522,'黄大仙区',33,0,2),(523,'湾仔区',33,0,2),(524,'油尖旺区',33,0,2),(525,'离岛区',33,0,2),(526,'葵青区',33,0,2),(527,'北区',33,0,2),(528,'西贡区',33,0,2),(529,'沙田区',33,0,2),(530,'屯门区',33,0,2),(531,'大埔区',33,0,2),(532,'荃湾区',33,0,2),(533,'元朗区',33,0,2),(534,'澳门特别行政区',34,0,2),(535,'美国',45055,0,3),(536,'加拿大',45055,0,3),(537,'澳大利亚',45055,0,3),(538,'新西兰',45055,0,3),(539,'英国',45055,0,3),(540,'法国',45055,0,3),(541,'德国',45055,0,3),(542,'捷克',45055,0,3),(543,'荷兰',45055,0,3),(544,'瑞士',45055,0,3),(545,'希腊',45055,0,3),(546,'挪威',45055,0,3),(547,'瑞典',45055,0,3),(548,'丹麦',45055,0,3),(549,'芬兰',45055,0,3),(550,'爱尔兰',45055,0,3),(551,'奥地利',45055,0,3),(552,'意大利',45055,0,3),(553,'乌克兰',45055,0,3),(554,'俄罗斯',45055,0,3),(555,'西班牙',45055,0,3),(556,'韩国',45055,0,3),(557,'新加坡',45055,0,3),(558,'马来西亚',45055,0,3),(559,'印度',45055,0,3),(560,'泰国',45055,0,3),(561,'日本',45055,0,3),(562,'巴西',45055,0,3),(563,'阿根廷',45055,0,3),(564,'南非',45055,0,3),(565,'埃及',45055,0,3),(566,'其他',36,0,3),(1126,'井陉县',73,0,3),(1127,'井陉矿区',73,0,3),(1128,'元氏县',73,0,3),(1129,'平山县',73,0,3),(1130,'新乐市',73,0,3),(1131,'新华区',73,0,3),(1132,'无极县',73,0,3),(1133,'晋州市',73,0,3),(1134,'栾城县',73,0,3),(1135,'桥东区',73,0,3),(1136,'桥西区',73,0,3),(1137,'正定县',73,0,3),(1138,'深泽县',73,0,3),(1139,'灵寿县',73,0,3),(1140,'藁城市',73,0,3),(1141,'行唐县',73,0,3),(1142,'裕华区',73,0,3),(1143,'赞皇县',73,0,3),(1144,'赵县',73,0,3),(1145,'辛集市',73,0,3),(1146,'长安区',73,0,3),(1147,'高邑县',73,0,3),(1148,'鹿泉市',73,0,3),(1149,'丰南区',74,0,3),(1150,'丰润区',74,0,3),(1151,'乐亭县',74,0,3),(1152,'古冶区',74,0,3),(1153,'唐海县',74,0,3),(1154,'开平区',74,0,3),(1155,'滦南县',74,0,3),(1156,'滦县',74,0,3),(1157,'玉田县',74,0,3),(1158,'路北区',74,0,3),(1159,'路南区',74,0,3),(1160,'迁安市',74,0,3),(1161,'迁西县',74,0,3),(1162,'遵化市',74,0,3),(1163,'北戴河区',75,0,3),(1164,'卢龙县',75,0,3),(1165,'山海关区',75,0,3),(1166,'抚宁县',75,0,3),(1167,'昌黎县',75,0,3),(1168,'海港区',75,0,3),(1169,'青龙满族自治县',75,0,3),(1170,'丛台区',76,0,3),(1171,'临漳县',76,0,3),(1172,'复兴区',76,0,3),(1173,'大名县',76,0,3),(1174,'峰峰矿区',76,0,3),(1175,'广平县',76,0,3),(1176,'成安县',76,0,3),(1177,'曲周县',76,0,3),(1178,'武安市',76,0,3),(1179,'永年县',76,0,3),(1180,'涉县',76,0,3),(1181,'磁县',76,0,3),(1182,'肥乡县',76,0,3),(1183,'邯山区',76,0,3),(1184,'邯郸县',76,0,3),(1185,'邱县',76,0,3),(1186,'馆陶县',76,0,3),(1187,'魏县',76,0,3),(1188,'鸡泽县',76,0,3),(1189,'临城县',77,0,3),(1190,'临西县',77,0,3),(1191,'任县',77,0,3),(1192,'内丘县',77,0,3),(1193,'南和县',77,0,3),(1194,'南宫市',77,0,3),(1195,'威县',77,0,3),(1196,'宁晋县',77,0,3),(1197,'巨鹿县',77,0,3),(1198,'平乡县',77,0,3),(1199,'广宗县',77,0,3),(1200,'新河县',77,0,3),(1201,'柏乡县',77,0,3),(1202,'桥东区',77,0,3),(1203,'桥西区',77,0,3),(1204,'沙河市',77,0,3),(1205,'清河县',77,0,3),(1206,'邢台县',77,0,3),(1207,'隆尧县',77,0,3),(1208,'北市区',78,0,3),(1209,'南市区',78,0,3),(1210,'博野县',78,0,3),(1211,'唐县',78,0,3),(1212,'安国市',78,0,3),(1213,'安新县',78,0,3),(1214,'定兴县',78,0,3),(1215,'定州市',78,0,3),(1216,'容城县',78,0,3),(1217,'徐水县',78,0,3),(1218,'新市区',78,0,3),(1219,'易县',78,0,3),(1220,'曲阳县',78,0,3),(1221,'望都县',78,0,3),(1222,'涞水县',78,0,3),(1223,'涞源县',78,0,3),(1224,'涿州市',78,0,3),(1225,'清苑县',78,0,3),(1226,'满城县',78,0,3),(1227,'蠡县',78,0,3),(1228,'阜平县',78,0,3),(1229,'雄县',78,0,3),(1230,'顺平县',78,0,3),(1231,'高碑店市',78,0,3),(1232,'高阳县',78,0,3),(1233,'万全县',79,0,3),(1234,'下花园区',79,0,3),(1235,'宣化区',79,0,3),(1236,'宣化县',79,0,3),(1237,'尚义县',79,0,3),(1238,'崇礼县',79,0,3),(1239,'康保县',79,0,3),(1240,'张北县',79,0,3),(1241,'怀安县',79,0,3),(1242,'怀来县',79,0,3),(1243,'桥东区',79,0,3),(1244,'桥西区',79,0,3),(1245,'沽源县',79,0,3),(1246,'涿鹿县',79,0,3),(1247,'蔚县',79,0,3),(1248,'赤城县',79,0,3),(1249,'阳原县',79,0,3),(1250,'丰宁满族自治县',80,0,3),(1251,'兴隆县',80,0,3),(1252,'双桥区',80,0,3),(1253,'双滦区',80,0,3),(1254,'围场满族蒙古族自治县',80,0,3),(1255,'宽城满族自治县',80,0,3),(1256,'平泉县',80,0,3),(1257,'承德县',80,0,3),(1258,'滦平县',80,0,3),(1259,'隆化县',80,0,3),(1260,'鹰手营子矿区',80,0,3),(1261,'冀州市',81,0,3),(1262,'安平县',81,0,3),(1263,'故城县',81,0,3),(1264,'景县',81,0,3),(1265,'枣强县',81,0,3),(1266,'桃城区',81,0,3),(1267,'武强县',81,0,3),(1268,'武邑县',81,0,3),(1269,'深州市',81,0,3),(1270,'阜城县',81,0,3),(1271,'饶阳县',81,0,3),(1272,'三河市',82,0,3),(1273,'固安县',82,0,3),(1274,'大厂回族自治县',82,0,3),(1275,'大城县',82,0,3),(1276,'安次区',82,0,3),(1277,'广阳区',82,0,3),(1278,'文安县',82,0,3),(1279,'永清县',82,0,3),(1280,'霸州市',82,0,3),(1281,'香河县',82,0,3),(1282,'东光县',83,0,3),(1283,'任丘市',83,0,3),(1284,'南皮县',83,0,3),(1285,'吴桥县',83,0,3),(1286,'孟村回族自治县',83,0,3),(1287,'新华区',83,0,3),(1288,'沧县',83,0,3),(1289,'河间市',83,0,3),(1290,'泊头市',83,0,3),(1291,'海兴县',83,0,3),(1292,'献县',83,0,3),(1293,'盐山县',83,0,3),(1294,'肃宁县',83,0,3),(1295,'运河区',83,0,3),(1296,'青县',83,0,3),(1297,'黄骅市',83,0,3),(1298,'万柏林区',84,0,3),(1299,'古交市',84,0,3),(1300,'娄烦县',84,0,3),(1301,'小店区',84,0,3),(1302,'尖草坪区',84,0,3),(1303,'晋源区',84,0,3),(1304,'杏花岭区',84,0,3),(1305,'清徐县',84,0,3),(1306,'迎泽区',84,0,3),(1307,'阳曲县',84,0,3),(1308,'南郊区',85,0,3),(1309,'城区',85,0,3),(1310,'大同县',85,0,3),(1311,'天镇县',85,0,3),(1312,'左云县',85,0,3),(1313,'广灵县',85,0,3),(1314,'新荣区',85,0,3),(1315,'浑源县',85,0,3),(1316,'灵丘县',85,0,3),(1317,'矿区',85,0,3),(1318,'阳高县',85,0,3),(1319,'城区',86,0,3),(1320,'平定县',86,0,3),(1321,'盂县',86,0,3),(1322,'矿区',86,0,3),(1323,'郊区',86,0,3),(1324,'城区',87,0,3),(1325,'壶关县',87,0,3),(1326,'屯留县',87,0,3),(1327,'平顺县',87,0,3),(1328,'武乡县',87,0,3),(1329,'沁县',87,0,3),(1330,'沁源县',87,0,3),(1331,'潞城市',87,0,3),(1332,'襄垣县',87,0,3),(1333,'郊区',87,0,3),(1334,'长子县',87,0,3),(1335,'长治县',87,0,3),(1336,'黎城县',87,0,3),(1337,'城区',88,0,3),(1338,'沁水县',88,0,3),(1339,'泽州县',88,0,3),(1340,'阳城县',88,0,3),(1341,'陵川县',88,0,3),(1342,'高平市',88,0,3),(1343,'右玉县',89,0,3),(1344,'山阴县',89,0,3),(1345,'平鲁区',89,0,3),(1346,'应县',89,0,3),(1347,'怀仁县',89,0,3),(1348,'朔城区',89,0,3),(1349,'介休市',90,0,3),(1350,'和顺县',90,0,3),(1351,'太谷县',90,0,3),(1352,'寿阳县',90,0,3),(1353,'左权县',90,0,3),(1354,'平遥县',90,0,3),(1355,'昔阳县',90,0,3),(1356,'榆次区',90,0,3),(1357,'榆社县',90,0,3),(1358,'灵石县',90,0,3),(1359,'祁县',90,0,3),(1360,'万荣县',91,0,3),(1361,'临猗县',91,0,3),(1362,'垣曲县',91,0,3),(1363,'夏县',91,0,3),(1364,'平陆县',91,0,3),(1365,'新绛县',91,0,3),(1366,'永济市',91,0,3),(1367,'河津市',91,0,3),(1368,'盐湖区',91,0,3),(1369,'稷山县',91,0,3),(1370,'绛县',91,0,3),(1371,'芮城县',91,0,3),(1372,'闻喜县',91,0,3),(1373,'五台县',92,0,3),(1374,'五寨县',92,0,3),(1375,'代县',92,0,3),(1376,'保德县',92,0,3),(1377,'偏关县',92,0,3),(1378,'原平市',92,0,3),(1379,'宁武县',92,0,3),(1380,'定襄县',92,0,3),(1381,'岢岚县',92,0,3),(1382,'忻府区',92,0,3),(1383,'河曲县',92,0,3),(1384,'神池县',92,0,3),(1385,'繁峙县',92,0,3),(1386,'静乐县',92,0,3),(1387,'乡宁县',93,0,3),(1388,'侯马市',93,0,3),(1389,'古县',93,0,3),(1390,'吉县',93,0,3),(1391,'大宁县',93,0,3),(1392,'安泽县',93,0,3),(1393,'尧都区',93,0,3),(1394,'曲沃县',93,0,3),(1395,'永和县',93,0,3),(1396,'汾西县',93,0,3),(1397,'洪洞县',93,0,3),(1398,'浮山县',93,0,3),(1399,'翼城县',93,0,3),(1400,'蒲县',93,0,3),(1401,'襄汾县',93,0,3),(1402,'隰县',93,0,3),(1403,'霍州市',93,0,3),(1404,'中阳县',94,0,3),(1405,'临县',94,0,3),(1406,'交口县',94,0,3),(1407,'交城县',94,0,3),(1408,'兴县',94,0,3),(1409,'孝义市',94,0,3),(1410,'岚县',94,0,3),(1411,'文水县',94,0,3),(1412,'方山县',94,0,3),(1413,'柳林县',94,0,3),(1414,'汾阳市',94,0,3),(1415,'石楼县',94,0,3),(1416,'离石区',94,0,3),(1417,'和林格尔县',95,0,3),(1418,'回民区',95,0,3),(1419,'土默特左旗',95,0,3),(1420,'托克托县',95,0,3),(1421,'新城区',95,0,3),(1422,'武川县',95,0,3),(1423,'清水河县',95,0,3),(1424,'玉泉区',95,0,3),(1425,'赛罕区',95,0,3),(1426,'东河区',96,0,3),(1427,'九原区',96,0,3),(1428,'固阳县',96,0,3),(1429,'土默特右旗',96,0,3),(1430,'昆都仑区',96,0,3),(1431,'白云矿区',96,0,3),(1432,'石拐区',96,0,3),(1433,'达尔罕茂明安联合旗',96,0,3),(1434,'青山区',96,0,3),(1435,'乌达区',97,0,3),(1436,'海勃湾区',97,0,3),(1437,'海南区',97,0,3),(1438,'元宝山区',98,0,3),(1439,'克什克腾旗',98,0,3),(1440,'喀喇沁旗',98,0,3),(1441,'宁城县',98,0,3),(1442,'巴林右旗',98,0,3),(1443,'巴林左旗',98,0,3),(1444,'敖汉旗',98,0,3),(1445,'松山区',98,0,3),(1446,'林西县',98,0,3),(1447,'红山区',98,0,3),(1448,'翁牛特旗',98,0,3),(1449,'阿鲁科尔沁旗',98,0,3),(1450,'奈曼旗',99,0,3),(1451,'库伦旗',99,0,3),(1452,'开鲁县',99,0,3),(1453,'扎鲁特旗',99,0,3),(1454,'科尔沁区',99,0,3),(1455,'科尔沁左翼中旗',99,0,3),(1456,'科尔沁左翼后旗',99,0,3),(1457,'霍林郭勒市',99,0,3),(1458,'东胜区',100,0,3),(1459,'乌审旗',100,0,3),(1460,'伊金霍洛旗',100,0,3),(1461,'准格尔旗',100,0,3),(1462,'杭锦旗',100,0,3),(1463,'达拉特旗',100,0,3),(1464,'鄂东胜区',100,0,3),(1465,'鄂托克前旗',100,0,3),(1466,'鄂托克旗',100,0,3),(1467,'扎兰屯市',101,0,3),(1468,'新巴尔虎右旗',101,0,3),(1469,'新巴尔虎左旗',101,0,3),(1470,'根河市',101,0,3),(1471,'海拉尔区',101,0,3),(1472,'满洲里市',101,0,3),(1473,'牙克石市',101,0,3),(1474,'莫力达瓦达斡尔族自治旗',101,0,3),(1475,'鄂伦春自治旗',101,0,3),(1476,'鄂温克族自治旗',101,0,3),(1477,'阿荣旗',101,0,3),(1478,'陈巴尔虎旗',101,0,3),(1479,'额尔古纳市',101,0,3),(1480,'临河区',102,0,3),(1481,'乌拉特中旗',102,0,3),(1482,'乌拉特前旗',102,0,3),(1483,'乌拉特后旗',102,0,3),(1484,'五原县',102,0,3),(1485,'杭锦后旗',102,0,3),(1486,'磴口县',102,0,3),(1487,'丰镇市',103,0,3),(1488,'兴和县',103,0,3),(1489,'凉城县',103,0,3),(1490,'化德县',103,0,3),(1491,'卓资县',103,0,3),(1492,'商都县',103,0,3),(1493,'四子王旗',103,0,3),(1494,'察哈尔右翼中旗',103,0,3),(1495,'察哈尔右翼前旗',103,0,3),(1496,'察哈尔右翼后旗',103,0,3),(1497,'集宁区',103,0,3),(1498,'乌兰浩特市',104,0,3),(1499,'扎赉特旗',104,0,3),(1500,'科尔沁右翼中旗',104,0,3),(1501,'科尔沁右翼前旗',104,0,3),(1502,'突泉县',104,0,3),(1503,'阿尔山市',104,0,3),(1504,'东乌珠穆沁旗',105,0,3),(1505,'二连浩特市',105,0,3),(1506,'多伦县',105,0,3),(1507,'太仆寺旗',105,0,3),(1508,'正蓝旗',105,0,3),(1509,'正镶白旗',105,0,3),(1510,'苏尼特右旗',105,0,3),(1511,'苏尼特左旗',105,0,3),(1512,'西乌珠穆沁旗',105,0,3),(1513,'锡林浩特市',105,0,3),(1514,'镶黄旗',105,0,3),(1515,'阿巴嘎旗',105,0,3),(1516,'阿拉善右旗',106,0,3),(1517,'阿拉善左旗',106,0,3),(1518,'额济纳旗',106,0,3),(1519,'东陵区',107,0,3),(1520,'于洪区',107,0,3),(1521,'和平区',107,0,3),(1522,'大东区',107,0,3),(1523,'康平县',107,0,3),(1524,'新民市',107,0,3),(1525,'沈北新区',107,0,3),(1526,'沈河区',107,0,3),(1527,'法库县',107,0,3),(1528,'皇姑区',107,0,3),(1529,'苏家屯区',107,0,3),(1530,'辽中县',107,0,3),(1531,'铁西区',107,0,3),(1532,'中山区',108,0,3),(1533,'庄河市',108,0,3),(1534,'旅顺口区',108,0,3),(1535,'普兰店市',108,0,3),(1536,'沙河口区',108,0,3),(1537,'瓦房店市',108,0,3),(1538,'甘井子区',108,0,3),(1539,'西岗区',108,0,3),(1540,'金州区',108,0,3),(1541,'长海县',108,0,3),(1542,'千山区',109,0,3),(1543,'台安县',109,0,3),(1544,'岫岩满族自治县',109,0,3),(1545,'海城市',109,0,3),(1546,'立山区',109,0,3),(1547,'铁东区',109,0,3),(1548,'铁西区',109,0,3),(1549,'东洲区',110,0,3),(1550,'抚顺县',110,0,3),(1551,'新宾满族自治县',110,0,3),(1552,'新抚区',110,0,3),(1553,'望花区',110,0,3),(1554,'清原满族自治县',110,0,3),(1555,'顺城区',110,0,3),(1556,'南芬区',111,0,3),(1557,'平山区',111,0,3),(1558,'明山区',111,0,3),(1559,'本溪满族自治县',111,0,3),(1560,'桓仁满族自治县',111,0,3),(1561,'溪湖区',111,0,3),(1562,'东港市',112,0,3),(1563,'元宝区',112,0,3),(1564,'凤城市',112,0,3),(1565,'宽甸满族自治县',112,0,3),(1566,'振兴区',112,0,3),(1567,'振安区',112,0,3),(1568,'义县',113,0,3),(1569,'凌河区',113,0,3),(1570,'凌海市',113,0,3),(1571,'北镇市',113,0,3),(1572,'古塔区',113,0,3),(1573,'太和区',113,0,3),(1574,'黑山县',113,0,3),(1575,'大石桥市',114,0,3),(1576,'盖州市',114,0,3),(1577,'站前区',114,0,3),(1578,'老边区',114,0,3),(1579,'西市区',114,0,3),(1580,'鲅鱼圈区',114,0,3),(1581,'太平区',115,0,3),(1582,'彰武县',115,0,3),(1583,'新邱区',115,0,3),(1584,'海州区',115,0,3),(1585,'清河门区',115,0,3),(1586,'细河区',115,0,3),(1587,'蒙古族自治县',115,0,3),(1588,'太子河区',116,0,3),(1589,'宏伟区',116,0,3),(1590,'弓长岭区',116,0,3),(1591,'文圣区',116,0,3),(1592,'灯塔市',116,0,3),(1593,'白塔区',116,0,3),(1594,'辽阳县',116,0,3),(1595,'兴隆台区',117,0,3),(1596,'双台子区',117,0,3),(1597,'大洼县',117,0,3),(1598,'盘山县',117,0,3),(1599,'开原市',118,0,3),(1600,'昌图县',118,0,3),(1601,'清河区',118,0,3),(1602,'西丰县',118,0,3),(1603,'调兵山市',118,0,3),(1604,'铁岭县',118,0,3),(1605,'银州区',118,0,3),(1606,'凌源市',119,0,3),(1607,'北票市',119,0,3),(1608,'双塔区',119,0,3),(1609,'喀喇沁左翼蒙古族自治县',119,0,3),(1610,'建平县',119,0,3),(1611,'朝阳县',119,0,3),(1612,'龙城区',119,0,3),(1613,'兴城市',120,0,3),(1614,'南票区',120,0,3),(1615,'建昌县',120,0,3),(1616,'绥中县',120,0,3),(1617,'连山区',120,0,3),(1618,'龙港区',120,0,3),(1619,'九台市',121,0,3),(1620,'二道区',121,0,3),(1621,'农安县',121,0,3),(1622,'南关区',121,0,3),(1623,'双阳区',121,0,3),(1624,'宽城区',121,0,3),(1625,'德惠市',121,0,3),(1626,'朝阳区',121,0,3),(1627,'榆树市',121,0,3),(1628,'绿园区',121,0,3),(1629,'丰满区',122,0,3),(1630,'昌邑区',122,0,3),(1631,'桦甸市',122,0,3),(1632,'永吉县',122,0,3),(1633,'磐石市',122,0,3),(1634,'舒兰市',122,0,3),(1635,'船营区',122,0,3),(1636,'蛟河市',122,0,3),(1637,'龙潭区',122,0,3),(1638,'伊通满族自治县',123,0,3),(1639,'公主岭市',123,0,3),(1640,'双辽市',123,0,3),(1641,'梨树县',123,0,3),(1642,'铁东区',123,0,3),(1643,'铁西区',123,0,3),(1644,'东丰县',124,0,3),(1645,'东辽县',124,0,3),(1646,'西安区',124,0,3),(1647,'龙山区',124,0,3),(1648,'东昌区',125,0,3),(1649,'二道江区',125,0,3),(1650,'柳河县',125,0,3),(1651,'梅河口市',125,0,3),(1652,'辉南县',125,0,3),(1653,'通化县',125,0,3),(1654,'集安市',125,0,3),(1655,'临江市',126,0,3),(1656,'八道江区',126,0,3),(1657,'抚松县',126,0,3),(1658,'江源区',126,0,3),(1659,'长白朝鲜族自治县',126,0,3),(1660,'靖宇县',126,0,3),(1661,'干安县',127,0,3),(1662,'前郭尔罗斯蒙古族自治县',127,0,3),(1663,'宁江区',127,0,3),(1664,'扶余县',127,0,3),(1665,'长岭县',127,0,3),(1666,'大安市',128,0,3),(1667,'洮北区',128,0,3),(1668,'洮南市',128,0,3),(1669,'通榆县',128,0,3),(1670,'镇赉县',128,0,3),(1671,'和龙市',129,0,3),(1672,'图们市',129,0,3),(1673,'安图县',129,0,3),(1674,'延吉市',129,0,3),(1675,'敦化市',129,0,3),(1676,'汪清县',129,0,3),(1677,'珲春市',129,0,3),(1678,'龙井市',129,0,3),(1679,'五常市',130,0,3),(1680,'依兰县',130,0,3),(1681,'南岗区',130,0,3),(1682,'双城市',130,0,3),(1683,'呼兰区',130,0,3),(1684,'哈尔滨市道里区',130,0,3),(1685,'宾县',130,0,3),(1686,'尚志市',130,0,3),(1687,'巴彦县',130,0,3),(1688,'平房区',130,0,3),(1689,'延寿县',130,0,3),(1690,'方正县',130,0,3),(1691,'木兰县',130,0,3),(1692,'松北区',130,0,3),(1693,'通河县',130,0,3),(1694,'道外区',130,0,3),(1695,'阿城区',130,0,3),(1696,'香坊区',130,0,3),(1697,'依安县',131,0,3),(1698,'克东县',131,0,3),(1699,'克山县',131,0,3),(1700,'富拉尔基区',131,0,3),(1701,'富裕县',131,0,3),(1702,'建华区',131,0,3),(1703,'拜泉县',131,0,3),(1704,'昂昂溪区',131,0,3),(1705,'梅里斯达斡尔族区',131,0,3),(1706,'泰来县',131,0,3),(1707,'甘南县',131,0,3),(1708,'碾子山区',131,0,3),(1709,'讷河市',131,0,3),(1710,'铁锋区',131,0,3),(1711,'龙江县',131,0,3),(1712,'龙沙区',131,0,3),(1713,'城子河区',132,0,3),(1714,'密山市',132,0,3),(1715,'恒山区',132,0,3),(1716,'梨树区',132,0,3),(1717,'滴道区',132,0,3),(1718,'虎林市',132,0,3),(1719,'鸡东县',132,0,3),(1720,'鸡冠区',132,0,3),(1721,'麻山区',132,0,3),(1722,'东山区',133,0,3),(1723,'兴安区',133,0,3),(1724,'兴山区',133,0,3),(1725,'南山区',133,0,3),(1726,'向阳区',133,0,3),(1727,'工农区',133,0,3),(1728,'绥滨县',133,0,3),(1729,'萝北县',133,0,3),(1730,'友谊县',134,0,3),(1731,'四方台区',134,0,3),(1732,'宝山区',134,0,3),(1733,'宝清县',134,0,3),(1734,'尖山区',134,0,3),(1735,'岭东区',134,0,3),(1736,'集贤县',134,0,3),(1737,'饶河县',134,0,3),(1738,'大同区',135,0,3),(1739,'杜尔伯特蒙古族自治县',135,0,3),(1740,'林甸县',135,0,3),(1741,'红岗区',135,0,3),(1742,'肇州县',135,0,3),(1743,'肇源县',135,0,3),(1744,'胡路区',135,0,3),(1745,'萨尔图区',135,0,3),(1746,'龙凤区',135,0,3),(1747,'上甘岭区',136,0,3),(1748,'乌伊岭区',136,0,3),(1749,'乌马河区',136,0,3),(1750,'五营区',136,0,3),(1751,'伊春区',136,0,3),(1752,'南岔区',136,0,3),(1753,'友好区',136,0,3),(1754,'嘉荫县',136,0,3),(1755,'带岭区',136,0,3),(1756,'新青区',136,0,3),(1757,'汤旺河区',136,0,3),(1758,'红星区',136,0,3),(1759,'美溪区',136,0,3),(1760,'翠峦区',136,0,3),(1761,'西林区',136,0,3),(1762,'金山屯区',136,0,3),(1763,'铁力市',136,0,3),(1764,'东风区',137,0,3),(1765,'前进区',137,0,3),(1766,'同江市',137,0,3),(1767,'向阳区',137,0,3),(1768,'富锦市',137,0,3),(1769,'抚远县',137,0,3),(1770,'桦南县',137,0,3),(1771,'桦川县',137,0,3),(1772,'汤原县',137,0,3),(1773,'郊区',137,0,3),(1774,'勃利县',138,0,3),(1775,'新兴区',138,0,3),(1776,'桃山区',138,0,3),(1777,'茄子河区',138,0,3),(1778,'东宁县',139,0,3),(1779,'东安区',139,0,3),(1780,'宁安市',139,0,3),(1781,'林口县',139,0,3),(1782,'海林市',139,0,3),(1783,'爱民区',139,0,3),(1784,'穆棱市',139,0,3),(1785,'绥芬河市',139,0,3),(1786,'西安区',139,0,3),(1787,'阳明区',139,0,3),(1788,'五大连池市',140,0,3),(1789,'北安市',140,0,3),(1790,'嫩江县',140,0,3),(1791,'孙吴县',140,0,3),(1792,'爱辉区',140,0,3),(1793,'车逊克县',140,0,3),(1794,'逊克县',140,0,3),(1795,'兰西县',141,0,3),(1796,'安达市',141,0,3),(1797,'庆安县',141,0,3),(1798,'明水县',141,0,3),(1799,'望奎县',141,0,3),(1800,'海伦市',141,0,3),(1801,'绥化市北林区',141,0,3),(1802,'绥棱县',141,0,3),(1803,'肇东市',141,0,3),(1804,'青冈县',141,0,3),(1805,'呼玛县',142,0,3),(1806,'塔河县',142,0,3),(1807,'大兴安岭地区加格达奇区',142,0,3),(1808,'大兴安岭地区呼中区',142,0,3),(1809,'大兴安岭地区新林区',142,0,3),(1810,'大兴安岭地区松岭区',142,0,3),(1811,'漠河县',142,0,3),(2027,'下关区',162,0,3),(2028,'六合区',162,0,3),(2029,'建邺区',162,0,3),(2030,'栖霞区',162,0,3),(2031,'江宁区',162,0,3),(2032,'浦口区',162,0,3),(2033,'溧水县',162,0,3),(2034,'玄武区',162,0,3),(2035,'白下区',162,0,3),(2036,'秦淮区',162,0,3),(2037,'雨花台区',162,0,3),(2038,'高淳县',162,0,3),(2039,'鼓楼区',162,0,3),(2040,'北塘区',163,0,3),(2041,'南长区',163,0,3),(2042,'宜兴市',163,0,3),(2043,'崇安区',163,0,3),(2044,'惠山区',163,0,3),(2045,'江阴市',163,0,3),(2046,'滨湖区',163,0,3),(2047,'锡山区',163,0,3),(2048,'丰县',164,0,3),(2049,'九里区',164,0,3),(2050,'云龙区',164,0,3),(2051,'新沂市',164,0,3),(2052,'沛县',164,0,3),(2053,'泉山区',164,0,3),(2054,'睢宁县',164,0,3),(2055,'贾汪区',164,0,3),(2056,'邳州市',164,0,3),(2057,'铜山县',164,0,3),(2058,'鼓楼区',164,0,3),(2059,'天宁区',165,0,3),(2060,'戚墅堰区',165,0,3),(2061,'新北区',165,0,3),(2062,'武进区',165,0,3),(2063,'溧阳市',165,0,3),(2064,'金坛市',165,0,3),(2065,'钟楼区',165,0,3),(2066,'吴中区',166,0,3),(2067,'吴江市',166,0,3),(2068,'太仓市',166,0,3),(2069,'常熟市',166,0,3),(2070,'平江区',166,0,3),(2071,'张家港市',166,0,3),(2072,'昆山市',166,0,3),(2073,'沧浪区',166,0,3),(2074,'相城区',166,0,3),(2075,'苏州工业园区',166,0,3),(2076,'虎丘区',166,0,3),(2077,'金阊区',166,0,3),(2078,'启东市',167,0,3),(2079,'如东县',167,0,3),(2080,'如皋市',167,0,3),(2081,'崇川区',167,0,3),(2082,'海安县',167,0,3),(2083,'海门市',167,0,3),(2084,'港闸区',167,0,3),(2085,'通州市',167,0,3),(2086,'东海县',168,0,3),(2087,'新浦区',168,0,3),(2088,'海州区',168,0,3),(2089,'灌云县',168,0,3),(2090,'灌南县',168,0,3),(2091,'赣榆县',168,0,3),(2092,'连云区',168,0,3),(2093,'楚州区',169,0,3),(2094,'洪泽县',169,0,3),(2095,'涟水县',169,0,3),(2096,'淮阴区',169,0,3),(2097,'清河区',169,0,3),(2098,'清浦区',169,0,3),(2099,'盱眙县',169,0,3),(2100,'金湖县',169,0,3),(2101,'东台市',170,0,3),(2102,'亭湖区',170,0,3),(2103,'响水县',170,0,3),(2104,'大丰市',170,0,3),(2105,'射阳县',170,0,3),(2106,'建湖县',170,0,3),(2107,'滨海县',170,0,3),(2108,'盐都区',170,0,3),(2109,'阜宁县',170,0,3),(2110,'仪征市',171,0,3),(2111,'宝应县',171,0,3),(2112,'广陵区',171,0,3),(2113,'江都市',171,0,3),(2114,'维扬区',171,0,3),(2115,'邗江区',171,0,3),(2116,'高邮市',171,0,3),(2117,'丹徒区',172,0,3),(2118,'丹阳市',172,0,3),(2119,'京口区',172,0,3),(2120,'句容市',172,0,3),(2121,'扬中市',172,0,3),(2122,'润州区',172,0,3),(2123,'兴化市',173,0,3),(2124,'姜堰市',173,0,3),(2125,'泰兴市',173,0,3),(2126,'海陵区',173,0,3),(2127,'靖江市',173,0,3),(2128,'高港区',173,0,3),(2129,'宿城区',174,0,3),(2130,'宿豫区',174,0,3),(2131,'沭阳县',174,0,3),(2132,'泗洪县',174,0,3),(2133,'泗阳县',174,0,3),(2134,'上城区',175,0,3),(2135,'下城区',175,0,3),(2136,'临安市',175,0,3),(2137,'余杭区',175,0,3),(2138,'富阳市',175,0,3),(2139,'建德市',175,0,3),(2140,'拱墅区',175,0,3),(2141,'桐庐县',175,0,3),(2142,'江干区',175,0,3),(2143,'淳安县',175,0,3),(2144,'滨江区',175,0,3),(2145,'萧山区',175,0,3),(2146,'西湖区',175,0,3),(2147,'余姚市',176,0,3),(2148,'北仑区',176,0,3),(2149,'奉化区',176,0,3),(2150,'宁海县',176,0,3),(2151,'慈溪市',176,0,3),(2153,'江北区',176,0,3),(2154,'海曙区',176,0,3),(2155,'象山县',176,0,3),(2156,'鄞州区',176,0,3),(2157,'镇海区',176,0,3),(2158,'乐清市',177,0,3),(2159,'平阳县',177,0,3),(2160,'文成县',177,0,3),(2161,'永嘉县',177,0,3),(2162,'泰顺县',177,0,3),(2163,'洞头县',177,0,3),(2164,'瑞安市',177,0,3),(2165,'瓯海区',177,0,3),(2166,'苍南县',177,0,3),(2167,'鹿城区',177,0,3),(2168,'龙湾区',177,0,3),(2169,'南湖区',178,0,3),(2170,'嘉善县',178,0,3),(2171,'平湖市',178,0,3),(2172,'桐乡市',178,0,3),(2173,'海宁市',178,0,3),(2174,'海盐县',178,0,3),(2175,'秀洲区',178,0,3),(2176,'南浔区',179,0,3),(2177,'吴兴区',179,0,3),(2178,'安吉县',179,0,3),(2179,'德清县',179,0,3),(2180,'长兴县',179,0,3),(2181,'上虞市',180,0,3),(2182,'嵊州市',180,0,3),(2183,'新昌县',180,0,3),(2184,'绍兴县',180,0,3),(2185,'诸暨市',180,0,3),(2186,'越城区',180,0,3),(2187,'定海区',181,0,3),(2188,'岱山县',181,0,3),(2189,'嵊泗县',181,0,3),(2190,'普陀区',181,0,3),(2191,'常山县',182,0,3),(2192,'开化县',182,0,3),(2193,'柯城区',182,0,3),(2194,'江山市',182,0,3),(2195,'衢江区',182,0,3),(2196,'龙游县',182,0,3),(2197,'东阳市',183,0,3),(2198,'义乌市',183,0,3),(2199,'兰溪市',183,0,3),(2200,'婺城区',183,0,3),(2201,'武义县',183,0,3),(2202,'永康市',183,0,3),(2203,'浦江县',183,0,3),(2204,'磐安县',183,0,3),(2205,'金东区',183,0,3),(2206,'三门县',184,0,3),(2207,'临海市',184,0,3),(2208,'仙居县',184,0,3),(2209,'天台县',184,0,3),(2210,'椒江区',184,0,3),(2211,'温岭市',184,0,3),(2212,'玉环县',184,0,3),(2213,'路桥区',184,0,3),(2214,'黄岩区',184,0,3),(2215,'云和县',185,0,3),(2216,'庆元县',185,0,3),(2217,'景宁畲族自治县',185,0,3),(2218,'松阳县',185,0,3),(2219,'缙云县',185,0,3),(2220,'莲都区',185,0,3),(2221,'遂昌县',185,0,3),(2222,'青田县',185,0,3),(2223,'龙泉市',185,0,3),(2224,'包河区',186,0,3),(2225,'庐阳区',186,0,3),(2226,'瑶海区',186,0,3),(2227,'肥东县',186,0,3),(2228,'肥西县',186,0,3),(2229,'蜀山区',186,0,3),(2230,'长丰县',186,0,3),(2231,'三山区',187,0,3),(2232,'南陵县',187,0,3),(2233,'弋江区',187,0,3),(2234,'繁昌县',187,0,3),(2235,'芜湖县',187,0,3),(2236,'镜湖区',187,0,3),(2237,'鸠江区',187,0,3),(2238,'五河县',188,0,3),(2239,'固镇县',188,0,3),(2240,'怀远县',188,0,3),(2241,'淮上区',188,0,3),(2242,'禹会区',188,0,3),(2243,'蚌山区',188,0,3),(2244,'龙子湖区',188,0,3),(2245,'八公山区',189,0,3),(2246,'凤台县',189,0,3),(2247,'大通区',189,0,3),(2248,'潘集区',189,0,3),(2249,'田家庵区',189,0,3),(2250,'谢家集区',189,0,3),(2251,'当涂县',190,0,3),(2252,'花山区',190,0,3),(2253,'金家庄区',190,0,3),(2254,'雨山区',190,0,3),(2255,'杜集区',191,0,3),(2256,'濉溪县',191,0,3),(2257,'烈山区',191,0,3),(2258,'相山区',191,0,3),(2259,'狮子山区',192,0,3),(2260,'郊区',192,0,3),(2261,'铜官山区',192,0,3),(2262,'铜陵县',192,0,3),(2263,'大观区',193,0,3),(2264,'太湖县',193,0,3),(2265,'宜秀区',193,0,3),(2266,'宿松县',193,0,3),(2267,'岳西县',193,0,3),(2268,'怀宁县',193,0,3),(2269,'望江县',193,0,3),(2270,'枞阳县',193,0,3),(2271,'桐城市',193,0,3),(2272,'潜山县',193,0,3),(2273,'迎江区',193,0,3),(2274,'休宁县',194,0,3),(2275,'屯溪区',194,0,3),(2276,'徽州区',194,0,3),(2277,'歙县',194,0,3),(2278,'祁门县',194,0,3),(2279,'黄山区',194,0,3),(2280,'黟县',194,0,3),(2281,'全椒县',195,0,3),(2282,'凤阳县',195,0,3),(2283,'南谯区',195,0,3),(2284,'天长市',195,0,3),(2285,'定远县',195,0,3),(2286,'明光市',195,0,3),(2287,'来安县',195,0,3),(2288,'琅玡区',195,0,3),(2289,'临泉县',196,0,3),(2290,'太和县',196,0,3),(2291,'界首市',196,0,3),(2292,'阜南县',196,0,3),(2293,'颍东区',196,0,3),(2294,'颍州区',196,0,3),(2295,'颍泉区',196,0,3),(2296,'颖上县',196,0,3),(2297,'埇桥区',197,0,3),(2298,'泗县辖',197,0,3),(2299,'灵璧县',197,0,3),(2300,'砀山县',197,0,3),(2301,'萧县',197,0,3),(2302,'含山县',198,0,3),(2303,'和县',198,0,3),(2304,'居巢区',198,0,3),(2305,'庐江县',198,0,3),(2306,'无为县',198,0,3),(2307,'寿县',199,0,3),(2308,'舒城县',199,0,3),(2309,'裕安区',199,0,3),(2310,'金安区',199,0,3),(2311,'金寨县',199,0,3),(2312,'霍山县',199,0,3),(2313,'霍邱县',199,0,3),(2314,'利辛县',200,0,3),(2315,'涡阳县',200,0,3),(2316,'蒙城县',200,0,3),(2317,'谯城区',200,0,3),(2318,'东至县',201,0,3),(2319,'石台县',201,0,3),(2320,'贵池区',201,0,3),(2321,'青阳县',201,0,3),(2322,'宁国市',202,0,3),(2323,'宣州区',202,0,3),(2324,'广德县',202,0,3),(2325,'旌德县',202,0,3),(2326,'泾县',202,0,3),(2327,'绩溪县',202,0,3),(2328,'郎溪县',202,0,3),(2329,'仓山区',203,0,3),(2330,'台江区',203,0,3),(2331,'平潭县',203,0,3),(2332,'晋安区',203,0,3),(2333,'永泰县',203,0,3),(2334,'福清市',203,0,3),(2335,'罗源县',203,0,3),(2336,'连江县',203,0,3),(2337,'长乐市',203,0,3),(2338,'闽侯县',203,0,3),(2339,'闽清县',203,0,3),(2340,'马尾区',203,0,3),(2341,'鼓楼区',203,0,3),(2342,'同安区',204,0,3),(2343,'思明区',204,0,3),(2344,'海沧区',204,0,3),(2345,'湖里区',204,0,3),(2346,'翔安区',204,0,3),(2347,'集美区',204,0,3),(2348,'仙游县',205,0,3),(2349,'城厢区',205,0,3),(2350,'涵江区',205,0,3),(2351,'秀屿区',205,0,3),(2352,'荔城区',205,0,3),(2353,'三元区',206,0,3),(2354,'大田县',206,0,3),(2355,'宁化县',206,0,3),(2356,'将乐县',206,0,3),(2357,'尤溪县',206,0,3),(2358,'建宁县',206,0,3),(2359,'明溪县',206,0,3),(2360,'梅列区',206,0,3),(2361,'永安市',206,0,3),(2362,'沙县',206,0,3),(2363,'泰宁县',206,0,3),(2364,'清流县',206,0,3),(2365,'丰泽区',207,0,3),(2366,'南安市',207,0,3),(2367,'安溪县',207,0,3),(2368,'德化县',207,0,3),(2369,'惠安县',207,0,3),(2370,'晋江市',207,0,3),(2371,'永春县',207,0,3),(2372,'泉港区',207,0,3),(2373,'洛江区',207,0,3),(2374,'石狮市',207,0,3),(2375,'金门县',207,0,3),(2376,'鲤城区',207,0,3),(2377,'东山县',208,0,3),(2378,'云霄县',208,0,3),(2379,'华安县',208,0,3),(2380,'南靖县',208,0,3),(2381,'平和县',208,0,3),(2382,'漳浦县',208,0,3),(2383,'芗城区',208,0,3),(2384,'诏安县',208,0,3),(2385,'长泰县',208,0,3),(2386,'龙文区',208,0,3),(2387,'龙海市',208,0,3),(2388,'光泽县',209,0,3),(2389,'延平区',209,0,3),(2390,'建瓯市',209,0,3),(2391,'建阳市',209,0,3),(2392,'政和县',209,0,3),(2393,'松溪县',209,0,3),(2394,'武夷山市',209,0,3),(2395,'浦城县',209,0,3),(2396,'邵武市',209,0,3),(2397,'顺昌县',209,0,3),(2398,'上杭县',210,0,3),(2399,'新罗区',210,0,3),(2400,'武平县',210,0,3),(2401,'永定县',210,0,3),(2402,'漳平市',210,0,3),(2403,'连城县',210,0,3),(2404,'长汀县',210,0,3),(2405,'古田县',211,0,3),(2406,'周宁县',211,0,3),(2407,'寿宁县',211,0,3),(2408,'屏南县',211,0,3),(2409,'柘荣县',211,0,3),(2410,'福安市',211,0,3),(2411,'福鼎市',211,0,3),(2412,'蕉城区',211,0,3),(2413,'霞浦县',211,0,3),(2414,'东湖区',212,0,3),(2415,'南昌县',212,0,3),(2416,'安义县',212,0,3),(2417,'新建县',212,0,3),(2418,'湾里区',212,0,3),(2419,'西湖区',212,0,3),(2420,'进贤县',212,0,3),(2421,'青云谱区',212,0,3),(2422,'青山湖区',212,0,3),(2423,'乐平市',213,0,3),(2424,'昌江区',213,0,3),(2425,'浮梁县',213,0,3),(2426,'珠山区',213,0,3),(2427,'上栗县',214,0,3),(2428,'安源区',214,0,3),(2429,'湘东区',214,0,3),(2430,'芦溪县',214,0,3),(2431,'莲花县',214,0,3),(2432,'九江县',215,0,3),(2433,'修水县',215,0,3),(2434,'庐山区',215,0,3),(2435,'彭泽县',215,0,3),(2436,'德安县',215,0,3),(2437,'星子县',215,0,3),(2438,'武宁县',215,0,3),(2439,'永修县',215,0,3),(2440,'浔阳区',215,0,3),(2441,'湖口县',215,0,3),(2442,'瑞昌市',215,0,3),(2443,'都昌县',215,0,3),(2444,'分宜县',216,0,3),(2445,'渝水区',216,0,3),(2446,'余江县',217,0,3),(2447,'月湖区',217,0,3),(2448,'贵溪市',217,0,3),(2449,'上犹县',218,0,3),(2450,'于都县',218,0,3),(2451,'会昌县',218,0,3),(2452,'信丰县',218,0,3),(2453,'全南县',218,0,3),(2454,'兴国县',218,0,3),(2455,'南康市',218,0,3),(2456,'大余县',218,0,3),(2457,'宁都县',218,0,3),(2458,'安远县',218,0,3),(2459,'定南县',218,0,3),(2460,'寻乌县',218,0,3),(2461,'崇义县',218,0,3),(2462,'瑞金市',218,0,3),(2463,'石城县',218,0,3),(2464,'章贡区',218,0,3),(2465,'赣县',218,0,3),(2466,'龙南县',218,0,3),(2467,'万安县',219,0,3),(2468,'井冈山市',219,0,3),(2469,'吉安县',219,0,3),(2470,'吉州区',219,0,3),(2471,'吉水县',219,0,3),(2472,'安福县',219,0,3),(2473,'峡江县',219,0,3),(2474,'新干县',219,0,3),(2475,'永丰县',219,0,3),(2476,'永新县',219,0,3),(2477,'泰和县',219,0,3),(2478,'遂川县',219,0,3),(2479,'青原区',219,0,3),(2480,'万载县',220,0,3),(2481,'上高县',220,0,3),(2482,'丰城市',220,0,3),(2483,'奉新县',220,0,3),(2484,'宜丰县',220,0,3),(2485,'樟树市',220,0,3),(2486,'袁州区',220,0,3),(2487,'铜鼓县',220,0,3),(2488,'靖安县',220,0,3),(2489,'高安市',220,0,3),(2490,'东乡县',221,0,3),(2491,'临川区',221,0,3),(2492,'乐安县',221,0,3),(2493,'南丰县',221,0,3),(2494,'南城县',221,0,3),(2495,'宜黄县',221,0,3),(2496,'崇仁县',221,0,3),(2497,'广昌县',221,0,3),(2498,'资溪县',221,0,3),(2499,'金溪县',221,0,3),(2500,'黎川县',221,0,3),(2501,'万年县',222,0,3),(2502,'上饶县',222,0,3),(2503,'余干县',222,0,3),(2504,'信州区',222,0,3),(2505,'婺源县',222,0,3),(2506,'广丰县',222,0,3),(2507,'弋阳县',222,0,3),(2508,'德兴市',222,0,3),(2509,'横峰县',222,0,3),(2510,'玉山县',222,0,3),(2511,'鄱阳县',222,0,3),(2512,'铅山县',222,0,3),(2513,'历下区',223,0,3),(2514,'历城区',223,0,3),(2515,'商河县',223,0,3),(2516,'天桥区',223,0,3),(2517,'市中区',223,0,3),(2518,'平阴县',223,0,3),(2519,'槐荫区',223,0,3),(2520,'济阳县',223,0,3),(2521,'章丘市',223,0,3),(2522,'长清区',223,0,3),(2523,'即墨市',224,0,3),(2524,'四方区',224,0,3),(2525,'城阳区',224,0,3),(2526,'崂山区',224,0,3),(2527,'市北区',224,0,3),(2528,'市南区',224,0,3),(2529,'平度市',224,0,3),(2530,'李沧区',224,0,3),(2531,'胶南市',224,0,3),(2532,'胶州市',224,0,3),(2533,'莱西市',224,0,3),(2534,'黄岛区',224,0,3),(2535,'临淄区',225,0,3),(2536,'博山区',225,0,3),(2537,'周村区',225,0,3),(2538,'张店区',225,0,3),(2539,'桓台县',225,0,3),(2540,'沂源县',225,0,3),(2541,'淄川区',225,0,3),(2542,'高青县',225,0,3),(2543,'台儿庄区',226,0,3),(2544,'山亭区',226,0,3),(2545,'峄城区',226,0,3),(2546,'市中区',226,0,3),(2547,'滕州市',226,0,3),(2548,'薛城区',226,0,3),(2549,'东营区',227,0,3),(2550,'利津县',227,0,3),(2551,'垦利县',227,0,3),(2552,'广饶县',227,0,3),(2553,'河口区',227,0,3),(2554,'招远市',228,0,3),(2555,'栖霞市',228,0,3),(2556,'海阳市',228,0,3),(2557,'牟平区',228,0,3),(2558,'福山区',228,0,3),(2559,'芝罘区',228,0,3),(2560,'莱山区',228,0,3),(2561,'莱州市',228,0,3),(2562,'莱阳市',228,0,3),(2563,'蓬莱市',228,0,3),(2564,'长岛县',228,0,3),(2565,'龙口市',228,0,3),(2566,'临朐县',229,0,3),(2567,'坊子区',229,0,3),(2568,'奎文区',229,0,3),(2569,'安丘市',229,0,3),(2570,'寒亭区',229,0,3),(2571,'寿光市',229,0,3),(2572,'昌乐县',229,0,3),(2573,'昌邑市',229,0,3),(2574,'潍城区',229,0,3),(2575,'诸城市',229,0,3),(2576,'青州市',229,0,3),(2577,'高密市',229,0,3),(2578,'任城区',230,0,3),(2579,'兖州市',230,0,3),(2580,'嘉祥县',230,0,3),(2581,'市中区',230,0,3),(2582,'微山县',230,0,3),(2583,'曲阜市',230,0,3),(2584,'梁山县',230,0,3),(2585,'汶上县',230,0,3),(2586,'泗水县',230,0,3),(2587,'邹城市',230,0,3),(2588,'金乡县',230,0,3),(2589,'鱼台县',230,0,3),(2590,'东平县',231,0,3),(2591,'宁阳县',231,0,3),(2592,'岱岳区',231,0,3),(2593,'新泰市',231,0,3),(2594,'泰山区',231,0,3),(2595,'肥城市',231,0,3),(2596,'乳山市',232,0,3),(2597,'文登市',232,0,3),(2598,'环翠区',232,0,3),(2599,'荣成市',232,0,3),(2600,'东港区',233,0,3),(2601,'五莲县',233,0,3),(2602,'岚山区',233,0,3),(2603,'莒县',233,0,3),(2604,'莱城区',234,0,3),(2605,'钢城区',234,0,3),(2606,'临沭县',235,0,3),(2607,'兰山区',235,0,3),(2608,'平邑县',235,0,3),(2609,'沂南县',235,0,3),(2610,'沂水县',235,0,3),(2611,'河东区',235,0,3),(2612,'罗庄区',235,0,3),(2613,'苍山县',235,0,3),(2614,'莒南县',235,0,3),(2615,'蒙阴县',235,0,3),(2616,'费县',235,0,3),(2617,'郯城县',235,0,3),(2618,'临邑县',236,0,3),(2619,'乐陵市',236,0,3),(2620,'夏津县',236,0,3),(2621,'宁津县',236,0,3),(2622,'平原县',236,0,3),(2623,'庆云县',236,0,3),(2624,'德城区',236,0,3),(2625,'武城县',236,0,3),(2626,'禹城市',236,0,3),(2627,'陵县',236,0,3),(2628,'齐河县',236,0,3),(2629,'东昌府区',237,0,3),(2630,'东阿县',237,0,3),(2631,'临清市',237,0,3),(2632,'冠县',237,0,3),(2633,'茌平县',237,0,3),(2634,'莘县',237,0,3),(2635,'阳谷县',237,0,3),(2636,'高唐县',237,0,3),(2637,'博兴县',238,0,3),(2638,'惠民县',238,0,3),(2639,'无棣县',238,0,3),(2640,'沾化县',238,0,3),(2641,'滨城区',238,0,3),(2642,'邹平县',238,0,3),(2643,'阳信县',238,0,3),(2644,'东明县',239,0,3),(2645,'单县',239,0,3),(2646,'定陶县',239,0,3),(2647,'巨野县',239,0,3),(2648,'成武县',239,0,3),(2649,'曹县',239,0,3),(2650,'牡丹区',239,0,3),(2651,'郓城县',239,0,3),(2652,'鄄城县',239,0,3),(2653,'上街区',240,0,3),(2654,'中原区',240,0,3),(2655,'中牟县',240,0,3),(2656,'二七区',240,0,3),(2657,'巩义市',240,0,3),(2658,'惠济区',240,0,3),(2659,'新密市',240,0,3),(2660,'新郑市',240,0,3),(2661,'登封市',240,0,3),(2662,'管城回族区',240,0,3),(2663,'荥阳市',240,0,3),(2664,'金水区',240,0,3),(2665,'兰考县',241,0,3),(2666,'尉氏县',241,0,3),(2667,'开封县',241,0,3),(2668,'杞县',241,0,3),(2669,'禹王台区',241,0,3),(2670,'通许县',241,0,3),(2671,'金明区',241,0,3),(2672,'顺河回族区',241,0,3),(2673,'鼓楼区',241,0,3),(2674,'龙亭区',241,0,3),(2675,'伊川县',242,0,3),(2676,'偃师市',242,0,3),(2677,'吉利区',242,0,3),(2678,'孟津县',242,0,3),(2679,'宜阳县',242,0,3),(2680,'嵩县',242,0,3),(2681,'新安县',242,0,3),(2682,'栾川县',242,0,3),(2683,'汝阳县',242,0,3),(2684,'洛宁县',242,0,3),(2685,'洛龙区',242,0,3),(2686,'涧西区',242,0,3),(2687,'瀍河回族区',242,0,3),(2688,'老城区',242,0,3),(2689,'西工区',242,0,3),(2690,'卫东区',243,0,3),(2691,'叶县',243,0,3),(2692,'宝丰县',243,0,3),(2693,'新华区',243,0,3),(2694,'汝州市',243,0,3),(2695,'湛河区',243,0,3),(2696,'石龙区',243,0,3),(2697,'舞钢市',243,0,3),(2698,'郏县',243,0,3),(2699,'鲁山县',243,0,3),(2700,'内黄县',244,0,3),(2701,'北关区',244,0,3),(2702,'安阳县',244,0,3),(2703,'文峰区',244,0,3),(2704,'林州市',244,0,3),(2705,'殷都区',244,0,3),(2706,'汤阴县',244,0,3),(2707,'滑县',244,0,3),(2708,'龙安区',244,0,3),(2709,'山城区',245,0,3),(2710,'浚县',245,0,3),(2711,'淇县',245,0,3),(2712,'淇滨区',245,0,3),(2713,'鹤山区',245,0,3),(2714,'凤泉区',246,0,3),(2715,'卫滨区',246,0,3),(2716,'卫辉市',246,0,3),(2717,'原阳县',246,0,3),(2718,'封丘县',246,0,3),(2719,'延津县',246,0,3),(2720,'新乡县',246,0,3),(2721,'牧野区',246,0,3),(2722,'红旗区',246,0,3),(2723,'获嘉县',246,0,3),(2724,'辉县市',246,0,3),(2725,'长垣县',246,0,3),(2726,'中站区',247,0,3),(2727,'修武县',247,0,3),(2728,'博爱县',247,0,3),(2729,'孟州市',247,0,3),(2730,'山阳区',247,0,3),(2731,'武陟县',247,0,3),(2732,'沁阳市',247,0,3),(2733,'温县',247,0,3),(2734,'解放区',247,0,3),(2735,'马村区',247,0,3),(2736,'华龙区',248,0,3),(2737,'南乐县',248,0,3),(2738,'台前县',248,0,3),(2739,'清丰县',248,0,3),(2740,'濮阳县',248,0,3),(2741,'范县',248,0,3),(2742,'禹州市',249,0,3),(2743,'襄城县',249,0,3),(2744,'许昌县',249,0,3),(2745,'鄢陵县',249,0,3),(2746,'长葛市',249,0,3),(2747,'魏都区',249,0,3),(2748,'临颍县',250,0,3),(2749,'召陵区',250,0,3),(2750,'源汇区',250,0,3),(2751,'舞阳县',250,0,3),(2752,'郾城区',250,0,3),(2753,'义马市',251,0,3),(2754,'卢氏县',251,0,3),(2755,'渑池县',251,0,3),(2756,'湖滨区',251,0,3),(2757,'灵宝市',251,0,3),(2758,'陕县',251,0,3),(2759,'内乡县',252,0,3),(2760,'南召县',252,0,3),(2761,'卧龙区',252,0,3),(2762,'唐河县',252,0,3),(2763,'宛城区',252,0,3),(2764,'新野县',252,0,3),(2765,'方城县',252,0,3),(2766,'桐柏县',252,0,3),(2767,'淅川县',252,0,3),(2768,'社旗县',252,0,3),(2769,'西峡县',252,0,3),(2770,'邓州市',252,0,3),(2771,'镇平县',252,0,3),(2772,'夏邑县',253,0,3),(2773,'宁陵县',253,0,3),(2774,'柘城县',253,0,3),(2775,'民权县',253,0,3),(2776,'永城市',253,0,3),(2777,'睢县',253,0,3),(2778,'睢阳区',253,0,3),(2779,'粱园区',253,0,3),(2780,'虞城县',253,0,3),(2781,'光山县',254,0,3),(2782,'商城县',254,0,3),(2783,'固始县',254,0,3),(2784,'平桥区',254,0,3),(2785,'息县',254,0,3),(2786,'新县',254,0,3),(2787,'浉河区',254,0,3),(2788,'淮滨县',254,0,3),(2789,'潢川县',254,0,3),(2790,'罗山县',254,0,3),(2791,'商水县',255,0,3),(2792,'太康县',255,0,3),(2793,'川汇区',255,0,3),(2794,'扶沟县',255,0,3),(2795,'沈丘县',255,0,3),(2796,'淮阳县',255,0,3),(2797,'西华县',255,0,3),(2798,'郸城县',255,0,3),(2799,'项城市',255,0,3),(2800,'鹿邑县',255,0,3),(2801,'上蔡县',256,0,3),(2802,'平舆县',256,0,3),(2803,'新蔡县',256,0,3),(2804,'正阳县',256,0,3),(2805,'汝南县',256,0,3),(2806,'泌阳县',256,0,3),(2807,'确山县',256,0,3),(2808,'西平县',256,0,3),(2809,'遂平县',256,0,3),(2810,'驿城区',256,0,3),(2811,'济源市',257,0,3),(2812,'东西湖区',258,0,3),(2813,'新洲区',258,0,3),(2814,'武昌区',258,0,3),(2815,'汉南区',258,0,3),(2816,'汉阳区',258,0,3),(2817,'江夏区',258,0,3),(2818,'江岸区',258,0,3),(2819,'江汉区',258,0,3),(2820,'洪山区',258,0,3),(2821,'硚口区',258,0,3),(2822,'蔡甸区',258,0,3),(2823,'青山区',258,0,3),(2824,'黄陂区',258,0,3),(2825,'下陆区',259,0,3),(2826,'大冶市',259,0,3),(2827,'西塞山区',259,0,3),(2828,'铁山区',259,0,3),(2829,'阳新县',259,0,3),(2830,'黄石港区',259,0,3),(2831,'丹江口市',260,0,3),(2832,'张湾区',260,0,3),(2833,'房县',260,0,3),(2834,'竹山县',260,0,3),(2835,'竹溪县',260,0,3),(2836,'茅箭区',260,0,3),(2837,'郧县',260,0,3),(2838,'郧西县',260,0,3),(2839,'五峰土家族自治县',261,0,3),(2840,'伍家岗区',261,0,3),(2841,'兴山县',261,0,3),(2842,'夷陵区',261,0,3),(2843,'宜都市',261,0,3),(2844,'当阳市',261,0,3),(2845,'枝江市',261,0,3),(2846,'点军区',261,0,3),(2847,'秭归县',261,0,3),(2848,'虢亭区',261,0,3),(2849,'西陵区',261,0,3),(2850,'远安县',261,0,3),(2851,'长阳土家族自治县',261,0,3),(2852,'保康县',262,0,3),(2853,'南漳县',262,0,3),(2854,'宜城市',262,0,3),(2855,'枣阳市',262,0,3),(2856,'樊城区',262,0,3),(2857,'老河口市',262,0,3),(2858,'襄城区',262,0,3),(2859,'襄阳区',262,0,3),(2860,'谷城县',262,0,3),(2861,'华容区',263,0,3),(2862,'粱子湖',263,0,3),(2863,'鄂城区',263,0,3),(2864,'东宝区',264,0,3),(2865,'京山县',264,0,3),(2866,'掇刀区',264,0,3),(2867,'沙洋县',264,0,3),(2868,'钟祥市',264,0,3),(2869,'云梦县',265,0,3),(2870,'大悟县',265,0,3),(2871,'孝南区',265,0,3),(2872,'孝昌县',265,0,3),(2873,'安陆市',265,0,3),(2874,'应城市',265,0,3),(2875,'汉川市',265,0,3),(2876,'公安县',266,0,3),(2877,'松滋市',266,0,3),(2878,'江陵县',266,0,3),(2879,'沙市区',266,0,3),(2880,'洪湖市',266,0,3),(2881,'监利县',266,0,3),(2882,'石首市',266,0,3),(2883,'荆州区',266,0,3),(2884,'团风县',267,0,3),(2885,'武穴市',267,0,3),(2886,'浠水县',267,0,3),(2887,'红安县',267,0,3),(2888,'罗田县',267,0,3),(2889,'英山县',267,0,3),(2890,'蕲春县',267,0,3),(2891,'麻城市',267,0,3),(2892,'黄州区',267,0,3),(2893,'黄梅县',267,0,3),(2894,'咸安区',268,0,3),(2895,'嘉鱼县',268,0,3),(2896,'崇阳县',268,0,3),(2897,'赤壁市',268,0,3),(2898,'通城县',268,0,3),(2899,'通山县',268,0,3),(2900,'广水市',269,0,3),(2901,'曾都区',269,0,3),(2902,'利川市',270,0,3),(2903,'咸丰县',270,0,3),(2904,'宣恩县',270,0,3),(2905,'巴东县',270,0,3),(2906,'建始县',270,0,3),(2907,'恩施市',270,0,3),(2908,'来凤县',270,0,3),(2909,'鹤峰县',270,0,3),(2910,'仙桃市',271,0,3),(2911,'潜江市',272,0,3),(2912,'天门市',273,0,3),(2913,'神农架林区',274,0,3),(2914,'天心区',275,0,3),(2915,'宁乡县',275,0,3),(2916,'岳麓区',275,0,3),(2917,'开福区',275,0,3),(2918,'望城县',275,0,3),(2919,'浏阳市',275,0,3),(2920,'芙蓉区',275,0,3),(2921,'长沙县',275,0,3),(2922,'雨花区',275,0,3),(2923,'天元区',276,0,3),(2924,'攸县',276,0,3),(2925,'株洲县',276,0,3),(2926,'炎陵县',276,0,3),(2927,'石峰区',276,0,3),(2928,'芦淞区',276,0,3),(2929,'茶陵县',276,0,3),(2930,'荷塘区',276,0,3),(2931,'醴陵市',276,0,3),(2932,'岳塘区',277,0,3),(2933,'湘乡市',277,0,3),(2934,'湘潭县',277,0,3),(2935,'雨湖区',277,0,3),(2936,'韶山市',277,0,3),(2937,'南岳区',278,0,3),(2938,'常宁市',278,0,3),(2939,'珠晖区',278,0,3),(2940,'石鼓区',278,0,3),(2941,'祁东县',278,0,3),(2942,'耒阳市',278,0,3),(2943,'蒸湘区',278,0,3),(2944,'衡东县',278,0,3),(2945,'衡南县',278,0,3),(2946,'衡山县',278,0,3),(2947,'衡阳县',278,0,3),(2948,'雁峰区',278,0,3),(2949,'北塔区',279,0,3),(2950,'双清区',279,0,3),(2951,'城步苗族自治县',279,0,3),(2952,'大祥区',279,0,3),(2953,'新宁县',279,0,3),(2954,'新邵县',279,0,3),(2955,'武冈市',279,0,3),(2956,'洞口县',279,0,3),(2957,'绥宁县',279,0,3),(2958,'邵东县',279,0,3),(2959,'邵阳县',279,0,3),(2960,'隆回县',279,0,3),(2961,'临湘市',280,0,3),(2962,'云溪区',280,0,3),(2963,'华容县',280,0,3),(2964,'君山区',280,0,3),(2965,'岳阳县',280,0,3),(2966,'岳阳楼区',280,0,3),(2967,'平江县',280,0,3),(2968,'汨罗市',280,0,3),(2969,'湘阴县',280,0,3),(2970,'临澧县',281,0,3),(2971,'安乡县',281,0,3),(2972,'桃源县',281,0,3),(2973,'武陵区',281,0,3),(2974,'汉寿县',281,0,3),(2975,'津市市',281,0,3),(2976,'澧县',281,0,3),(2977,'石门县',281,0,3),(2978,'鼎城区',281,0,3),(2979,'慈利县',282,0,3),(2980,'桑植县',282,0,3),(2981,'武陵源区',282,0,3),(2982,'永定区',282,0,3),(2983,'南县',283,0,3),(2984,'安化县',283,0,3),(2985,'桃江县',283,0,3),(2986,'沅江市',283,0,3),(2987,'资阳区',283,0,3),(2988,'赫山区',283,0,3),(2989,'临武县',284,0,3),(2990,'北湖区',284,0,3),(2991,'嘉禾县',284,0,3),(2992,'安仁县',284,0,3),(2993,'宜章县',284,0,3),(2994,'桂东县',284,0,3),(2995,'桂阳县',284,0,3),(2996,'永兴县',284,0,3),(2997,'汝城县',284,0,3),(2998,'苏仙区',284,0,3),(2999,'资兴市',284,0,3),(3000,'东安县',285,0,3),(3001,'冷水滩区',285,0,3),(3002,'双牌县',285,0,3),(3003,'宁远县',285,0,3),(3004,'新田县',285,0,3),(3005,'江华瑶族自治县',285,0,3),(3006,'江永县',285,0,3),(3007,'祁阳县',285,0,3),(3008,'蓝山县',285,0,3),(3009,'道县',285,0,3),(3010,'零陵区',285,0,3),(3011,'中方县',286,0,3),(3012,'会同县',286,0,3),(3013,'新晃侗族自治县',286,0,3),(3014,'沅陵县',286,0,3),(3015,'洪江市/洪江区',286,0,3),(3016,'溆浦县',286,0,3),(3017,'芷江侗族自治县',286,0,3),(3018,'辰溪县',286,0,3),(3019,'通道侗族自治县',286,0,3),(3020,'靖州苗族侗族自治县',286,0,3),(3021,'鹤城区',286,0,3),(3022,'麻阳苗族自治县',286,0,3),(3023,'冷水江市',287,0,3),(3024,'双峰县',287,0,3),(3025,'娄星区',287,0,3),(3026,'新化县',287,0,3),(3027,'涟源市',287,0,3),(3028,'保靖县',288,0,3),(3029,'凤凰县',288,0,3),(3030,'古丈县',288,0,3),(3031,'吉首市',288,0,3),(3032,'永顺县',288,0,3),(3033,'泸溪县',288,0,3),(3034,'花垣县',288,0,3),(3035,'龙山县',288,0,3),(3036,'萝岗区',289,0,3),(3037,'南沙区',289,0,3),(3038,'从化市',289,0,3),(3039,'增城市',289,0,3),(3040,'天河区',289,0,3),(3041,'海珠区',289,0,3),(3042,'番禺区',289,0,3),(3043,'白云区',289,0,3),(3044,'花都区',289,0,3),(3045,'荔湾区',289,0,3),(3046,'越秀区',289,0,3),(3047,'黄埔区',289,0,3),(3048,'乐昌市',290,0,3),(3049,'乳源瑶族自治县',290,0,3),(3050,'仁化县',290,0,3),(3051,'南雄市',290,0,3),(3052,'始兴县',290,0,3),(3053,'新丰县',290,0,3),(3054,'曲江区',290,0,3),(3055,'武江区',290,0,3),(3056,'浈江区',290,0,3),(3057,'翁源县',290,0,3),(3058,'南山区',291,0,3),(3059,'宝安区',291,0,3),(3060,'盐田区',291,0,3),(3061,'福田区',291,0,3),(3062,'罗湖区',291,0,3),(3063,'龙岗区',291,0,3),(3064,'斗门区',292,0,3),(3065,'金湾区',292,0,3),(3066,'香洲区',292,0,3),(3067,'南澳县',293,0,3),(3068,'潮南区',293,0,3),(3069,'潮阳区',293,0,3),(3070,'澄海区',293,0,3),(3071,'濠江区',293,0,3),(3072,'金平区',293,0,3),(3073,'龙湖区',293,0,3),(3074,'三水区',294,0,3),(3075,'南海区',294,0,3),(3076,'禅城区',294,0,3),(3077,'顺德区',294,0,3),(3078,'高明区',294,0,3),(3079,'台山市',295,0,3),(3080,'开平市',295,0,3),(3081,'恩平市',295,0,3),(3082,'新会区',295,0,3),(3083,'江海区',295,0,3),(3084,'蓬江区',295,0,3),(3085,'鹤山市',295,0,3),(3086,'吴川市',296,0,3),(3087,'坡头区',296,0,3),(3088,'廉江市',296,0,3),(3089,'徐闻县',296,0,3),(3090,'赤坎区',296,0,3),(3091,'遂溪县',296,0,3),(3092,'雷州市',296,0,3),(3093,'霞山区',296,0,3),(3094,'麻章区',296,0,3),(3095,'信宜市',297,0,3),(3096,'化州市',297,0,3),(3097,'电白县',297,0,3),(3098,'茂南区',297,0,3),(3099,'茂港区',297,0,3),(3100,'高州市',297,0,3),(3101,'四会市',298,0,3),(3102,'封开县',298,0,3),(3103,'广宁县',298,0,3),(3104,'德庆县',298,0,3),(3105,'怀集县',298,0,3),(3106,'端州区',298,0,3),(3107,'高要市',298,0,3),(3108,'鼎湖区',298,0,3),(3109,'博罗县',299,0,3),(3110,'惠东县',299,0,3),(3111,'惠城区',299,0,3),(3112,'惠阳区',299,0,3),(3113,'龙门县',299,0,3),(3114,'丰顺县',300,0,3),(3115,'五华县',300,0,3),(3116,'兴宁市',300,0,3),(3117,'大埔县',300,0,3),(3118,'平远县',300,0,3),(3119,'梅县',300,0,3),(3120,'梅江区',300,0,3),(3121,'蕉岭县',300,0,3),(3122,'城区',301,0,3),(3123,'海丰县',301,0,3),(3124,'陆丰市',301,0,3),(3125,'陆河县',301,0,3),(3126,'东源县',302,0,3),(3127,'和平县',302,0,3),(3128,'源城区',302,0,3),(3129,'紫金县',302,0,3),(3130,'连平县',302,0,3),(3131,'龙川县',302,0,3),(3132,'江城区',303,0,3),(3133,'阳东县',303,0,3),(3134,'阳春市',303,0,3),(3135,'阳西县',303,0,3),(3136,'佛冈县',304,0,3),(3137,'清城区',304,0,3),(3138,'清新县',304,0,3),(3139,'英德市',304,0,3),(3140,'连南瑶族自治县',304,0,3),(3141,'连山壮族瑶族自治县',304,0,3),(3142,'连州市',304,0,3),(3143,'阳山县',304,0,3),(3144,'东莞市',305,0,3),(3145,'中山市',306,0,3),(3146,'湘桥区',307,0,3),(3147,'潮安县',307,0,3),(3148,'饶平县',307,0,3),(3149,'惠来县',308,0,3),(3150,'揭东县',308,0,3),(3151,'揭西县',308,0,3),(3152,'普宁市',308,0,3),(3153,'榕城区',308,0,3),(3154,'云城区',309,0,3),(3155,'云安县',309,0,3),(3156,'新兴县',309,0,3),(3157,'罗定市',309,0,3),(3158,'郁南县',309,0,3),(3159,'上林县',310,0,3),(3160,'兴宁区',310,0,3),(3161,'宾阳县',310,0,3),(3162,'横县',310,0,3),(3163,'武鸣县',310,0,3),(3164,'江南区',310,0,3),(3165,'良庆区',310,0,3),(3166,'西乡塘区',310,0,3),(3167,'邕宁区',310,0,3),(3168,'隆安县',310,0,3),(3169,'青秀区',310,0,3),(3170,'马山县',310,0,3),(3171,'三江侗族自治县',311,0,3),(3172,'城中区',311,0,3),(3173,'柳北区',311,0,3),(3174,'柳南区',311,0,3),(3175,'柳城县',311,0,3),(3176,'柳江县',311,0,3),(3177,'融安县',311,0,3),(3178,'融水苗族自治县',311,0,3),(3179,'鱼峰区',311,0,3),(3180,'鹿寨县',311,0,3),(3181,'七星区',312,0,3),(3182,'临桂县',312,0,3),(3183,'全州县',312,0,3),(3184,'兴安县',312,0,3),(3185,'叠彩区',312,0,3),(3186,'平乐县',312,0,3),(3187,'恭城瑶族自治县',312,0,3),(3188,'永福县',312,0,3),(3189,'灌阳县',312,0,3),(3190,'灵川县',312,0,3),(3191,'秀峰区',312,0,3),(3192,'荔浦县',312,0,3),(3193,'象山区',312,0,3),(3194,'资源县',312,0,3),(3195,'阳朔县',312,0,3),(3196,'雁山区',312,0,3),(3197,'龙胜各族自治县',312,0,3),(3198,'万秀区',313,0,3),(3199,'岑溪市',313,0,3),(3200,'苍梧县',313,0,3),(3201,'蒙山县',313,0,3),(3202,'藤县',313,0,3),(3203,'蝶山区',313,0,3),(3204,'长洲区',313,0,3),(3205,'合浦县',314,0,3),(3206,'海城区',314,0,3),(3207,'铁山港区',314,0,3),(3208,'银海区',314,0,3),(3209,'上思县',315,0,3),(3210,'东兴市',315,0,3),(3211,'港口区',315,0,3),(3212,'防城区',315,0,3),(3213,'浦北县',316,0,3),(3214,'灵山县',316,0,3),(3215,'钦北区',316,0,3),(3216,'钦南区',316,0,3),(3217,'平南县',317,0,3),(3218,'桂平市',317,0,3),(3219,'港北区',317,0,3),(3220,'港南区',317,0,3),(3221,'覃塘区',317,0,3),(3222,'兴业县',318,0,3),(3223,'北流市',318,0,3),(3224,'博白县',318,0,3),(3225,'容县',318,0,3),(3226,'玉州区',318,0,3),(3227,'陆川县',318,0,3),(3228,'乐业县',319,0,3),(3229,'凌云县',319,0,3),(3230,'右江区',319,0,3),(3231,'平果县',319,0,3),(3232,'德保县',319,0,3),(3233,'田东县',319,0,3),(3234,'田林县',319,0,3),(3235,'田阳县',319,0,3),(3236,'西林县',319,0,3),(3237,'那坡县',319,0,3),(3238,'隆林各族自治县',319,0,3),(3239,'靖西县',319,0,3),(3240,'八步区',320,0,3),(3241,'富川瑶族自治县',320,0,3),(3242,'昭平县',320,0,3),(3243,'钟山县',320,0,3),(3244,'东兰县',321,0,3),(3245,'凤山县',321,0,3),(3246,'南丹县',321,0,3),(3247,'大化瑶族自治县',321,0,3),(3248,'天峨县',321,0,3),(3249,'宜州市',321,0,3),(3250,'巴马瑶族自治县',321,0,3),(3251,'环江毛南族自治县',321,0,3),(3252,'罗城仫佬族自治县',321,0,3),(3253,'都安瑶族自治县',321,0,3),(3254,'金城江区',321,0,3),(3255,'兴宾区',322,0,3),(3256,'合山市',322,0,3),(3257,'忻城县',322,0,3),(3258,'武宣县',322,0,3),(3259,'象州县',322,0,3),(3260,'金秀瑶族自治县',322,0,3),(3261,'凭祥市',323,0,3),(3262,'大新县',323,0,3),(3263,'天等县',323,0,3),(3264,'宁明县',323,0,3),(3265,'扶绥县',323,0,3),(3266,'江州区',323,0,3),(3267,'龙州县',323,0,3),(3268,'琼山区',324,0,3),(3269,'秀英区',324,0,3),(3270,'美兰区',324,0,3),(3271,'龙华区',324,0,3),(3272,'三亚市',325,0,3),(3273,'五指山市',326,0,3),(3274,'琼海市',327,0,3),(3275,'儋州市',328,0,3),(3276,'文昌市',329,0,3),(3277,'万宁市',330,0,3),(3278,'东方市',331,0,3),(3279,'定安县',332,0,3),(3280,'屯昌县',333,0,3),(3281,'澄迈县',334,0,3),(3282,'临高县',335,0,3),(3283,'白沙黎族自治县',336,0,3),(3284,'昌江黎族自治县',337,0,3),(3285,'乐东黎族自治县',338,0,3),(3286,'陵水黎族自治县',339,0,3),(3287,'保亭黎族苗族自治县',340,0,3),(3288,'琼中黎族苗族自治县',341,0,3),(4209,'双流县',385,0,3),(4210,'大邑县',385,0,3),(4211,'崇州市',385,0,3),(4212,'彭州市',385,0,3),(4213,'成华区',385,0,3),(4214,'新津县',385,0,3),(4215,'新都区',385,0,3),(4216,'武侯区',385,0,3),(4217,'温江区',385,0,3),(4218,'蒲江县',385,0,3),(4219,'邛崃市',385,0,3),(4220,'郫县',385,0,3),(4221,'都江堰市',385,0,3),(4222,'金堂县',385,0,3),(4223,'金牛区',385,0,3),(4224,'锦江区',385,0,3),(4225,'青白江区',385,0,3),(4226,'青羊区',385,0,3),(4227,'龙泉驿区',385,0,3),(4228,'大安区',386,0,3),(4229,'富顺县',386,0,3),(4230,'沿滩区',386,0,3),(4231,'自流井区',386,0,3),(4232,'荣县',386,0,3),(4233,'贡井区',386,0,3),(4234,'东区',387,0,3),(4235,'仁和区',387,0,3),(4236,'盐边县',387,0,3),(4237,'米易县',387,0,3),(4238,'西区',387,0,3),(4239,'叙永县',388,0,3),(4240,'古蔺县',388,0,3),(4241,'合江县',388,0,3),(4242,'江阳区',388,0,3),(4243,'泸县',388,0,3),(4244,'纳溪区',388,0,3),(4245,'龙马潭区',388,0,3),(4246,'中江县',389,0,3),(4247,'什邡市',389,0,3),(4248,'广汉市',389,0,3),(4249,'旌阳区',389,0,3),(4250,'绵竹市',389,0,3),(4251,'罗江县',389,0,3),(4252,'三台县',390,0,3),(4253,'北川羌族自治县',390,0,3),(4254,'安县',390,0,3),(4255,'平武县',390,0,3),(4256,'梓潼县',390,0,3),(4257,'江油市',390,0,3),(4258,'涪城区',390,0,3),(4259,'游仙区',390,0,3),(4260,'盐亭县',390,0,3),(4261,'元坝区',391,0,3),(4262,'利州区',391,0,3),(4263,'剑阁县',391,0,3),(4264,'旺苍县',391,0,3),(4265,'朝天区',391,0,3),(4266,'苍溪县',391,0,3),(4267,'青川县',391,0,3),(4268,'大英县',392,0,3),(4269,'安居区',392,0,3),(4270,'射洪县',392,0,3),(4271,'船山区',392,0,3),(4272,'蓬溪县',392,0,3),(4273,'东兴区',393,0,3),(4274,'威远县',393,0,3),(4275,'市中区',393,0,3),(4276,'资中县',393,0,3),(4277,'隆昌县',393,0,3),(4278,'五通桥区',394,0,3),(4279,'井研县',394,0,3),(4280,'夹江县',394,0,3),(4281,'峨眉山市',394,0,3),(4282,'峨边彝族自治县',394,0,3),(4283,'市中区',394,0,3),(4284,'沐川县',394,0,3),(4285,'沙湾区',394,0,3),(4286,'犍为县',394,0,3),(4287,'金口河区',394,0,3),(4288,'马边彝族自治县',394,0,3),(4289,'仪陇县',395,0,3),(4290,'南充市嘉陵区',395,0,3),(4291,'南部县',395,0,3),(4292,'嘉陵区',395,0,3),(4293,'营山县',395,0,3),(4294,'蓬安县',395,0,3),(4295,'西充县',395,0,3),(4296,'阆中市',395,0,3),(4297,'顺庆区',395,0,3),(4298,'高坪区',395,0,3),(4299,'东坡区',396,0,3),(4300,'丹棱县',396,0,3),(4301,'仁寿县',396,0,3),(4302,'彭山县',396,0,3),(4303,'洪雅县',396,0,3),(4304,'青神县',396,0,3),(4305,'兴文县',397,0,3),(4306,'南溪县',397,0,3),(4307,'宜宾县',397,0,3),(4308,'屏山县',397,0,3),(4309,'江安县',397,0,3),(4310,'珙县',397,0,3),(4311,'筠连县',397,0,3),(4312,'翠屏区',397,0,3),(4313,'长宁县',397,0,3),(4314,'高县',397,0,3),(4315,'华蓥市',398,0,3),(4316,'岳池县',398,0,3),(4317,'广安区',398,0,3),(4318,'武胜县',398,0,3),(4319,'邻水县',398,0,3),(4320,'万源市',399,0,3),(4321,'大竹县',399,0,3),(4322,'宣汉县',399,0,3),(4323,'开江县',399,0,3),(4324,'渠县',399,0,3),(4325,'达县',399,0,3),(4326,'通川区',399,0,3),(4327,'名山县',400,0,3),(4328,'天全县',400,0,3),(4329,'宝兴县',400,0,3),(4330,'汉源县',400,0,3),(4331,'石棉县',400,0,3),(4332,'芦山县',400,0,3),(4333,'荥经县',400,0,3),(4334,'雨城区',400,0,3),(4335,'南江县',401,0,3),(4336,'巴州区',401,0,3),(4337,'平昌县',401,0,3),(4338,'通江县',401,0,3),(4339,'乐至县',402,0,3),(4340,'安岳县',402,0,3),(4341,'简阳市',402,0,3),(4342,'雁江区',402,0,3),(4343,'九寨沟县',403,0,3),(4344,'壤塘县',403,0,3),(4345,'小金县',403,0,3),(4346,'松潘县',403,0,3),(4347,'汶川县',403,0,3),(4348,'理县',403,0,3),(4349,'红原县',403,0,3),(4350,'若尔盖县',403,0,3),(4351,'茂县',403,0,3),(4352,'金川县',403,0,3),(4353,'阿坝县',403,0,3),(4354,'马尔康县',403,0,3),(4355,'黑水县',403,0,3),(4356,'丹巴县',404,0,3),(4357,'乡城县',404,0,3),(4358,'巴塘县',404,0,3),(4359,'康定县',404,0,3),(4360,'得荣县',404,0,3),(4361,'德格县',404,0,3),(4362,'新龙县',404,0,3),(4363,'泸定县',404,0,3),(4364,'炉霍县',404,0,3),(4365,'理塘县',404,0,3),(4366,'甘孜县',404,0,3),(4367,'白玉县',404,0,3),(4368,'石渠县',404,0,3),(4369,'稻城县',404,0,3),(4370,'色达县',404,0,3),(4371,'道孚县',404,0,3),(4372,'雅江县',404,0,3),(4373,'会东县',405,0,3),(4374,'会理县',405,0,3),(4375,'冕宁县',405,0,3),(4376,'喜德县',405,0,3),(4377,'宁南县',405,0,3),(4378,'布拖县',405,0,3),(4379,'德昌县',405,0,3),(4380,'昭觉县',405,0,3),(4381,'普格县',405,0,3),(4382,'木里藏族自治县',405,0,3),(4383,'甘洛县',405,0,3),(4384,'盐源县',405,0,3),(4385,'美姑县',405,0,3),(4386,'西昌',405,0,3),(4387,'越西县',405,0,3),(4388,'金阳县',405,0,3),(4389,'雷波县',405,0,3),(4390,'乌当区',406,0,3),(4391,'云岩区',406,0,3),(4392,'修文县',406,0,3),(4393,'南明区',406,0,3),(4394,'小河区',406,0,3),(4395,'开阳县',406,0,3),(4396,'息烽县',406,0,3),(4397,'清镇市',406,0,3),(4398,'白云区',406,0,3),(4399,'花溪区',406,0,3),(4400,'六枝特区',407,0,3),(4401,'水城县',407,0,3),(4402,'盘县',407,0,3),(4403,'钟山区',407,0,3),(4404,'习水县',408,0,3),(4405,'仁怀市',408,0,3),(4406,'余庆县',408,0,3),(4407,'凤冈县',408,0,3),(4408,'务川仡佬族苗族自治县',408,0,3),(4409,'桐梓县',408,0,3),(4410,'正安县',408,0,3),(4411,'汇川区',408,0,3),(4412,'湄潭县',408,0,3),(4413,'红花岗区',408,0,3),(4414,'绥阳县',408,0,3),(4415,'赤水市',408,0,3),(4416,'道真仡佬族苗族自治县',408,0,3),(4417,'遵义县',408,0,3),(4418,'关岭布依族苗族自治县',409,0,3),(4419,'平坝县',409,0,3),(4420,'普定县',409,0,3),(4421,'紫云苗族布依族自治县',409,0,3),(4422,'西秀区',409,0,3),(4423,'镇宁布依族苗族自治县',409,0,3),(4424,'万山特区',410,0,3),(4425,'印江土家族苗族自治县',410,0,3),(4426,'德江县',410,0,3),(4427,'思南县',410,0,3),(4428,'松桃苗族自治县',410,0,3),(4429,'江口县',410,0,3),(4430,'沿河土家族自治县',410,0,3),(4431,'玉屏侗族自治县',410,0,3),(4432,'石阡县',410,0,3),(4433,'铜仁市',410,0,3),(4434,'兴义市',411,0,3),(4435,'兴仁县',411,0,3),(4436,'册亨县',411,0,3),(4437,'安龙县',411,0,3),(4438,'普安县',411,0,3),(4439,'晴隆县',411,0,3),(4440,'望谟县',411,0,3),(4441,'贞丰县',411,0,3),(4442,'大方县',412,0,3),(4443,'威宁彝族回族苗族自治县',412,0,3),(4444,'毕节市',412,0,3),(4445,'纳雍县',412,0,3),(4446,'织金县',412,0,3),(4447,'赫章县',412,0,3),(4448,'金沙县',412,0,3),(4449,'黔西县',412,0,3),(4450,'三穗县',413,0,3),(4451,'丹寨县',413,0,3),(4452,'从江县',413,0,3),(4453,'凯里市',413,0,3),(4454,'剑河县',413,0,3),(4455,'台江县',413,0,3),(4456,'天柱县',413,0,3),(4457,'岑巩县',413,0,3),(4458,'施秉县',413,0,3),(4459,'榕江县',413,0,3),(4460,'锦屏县',413,0,3),(4461,'镇远县',413,0,3),(4462,'雷山县',413,0,3),(4463,'麻江县',413,0,3),(4464,'黄平县',413,0,3),(4465,'黎平县',413,0,3),(4466,'三都水族自治县',414,0,3),(4467,'平塘县',414,0,3),(4468,'惠水县',414,0,3),(4469,'独山县',414,0,3),(4470,'瓮安县',414,0,3),(4471,'福泉市',414,0,3),(4472,'罗甸县',414,0,3),(4473,'荔波县',414,0,3),(4474,'贵定县',414,0,3),(4475,'都匀市',414,0,3),(4476,'长顺县',414,0,3),(4477,'龙里县',414,0,3),(4478,'东川区',415,0,3),(4479,'五华区',415,0,3),(4480,'呈贡县',415,0,3),(4481,'安宁市',415,0,3),(4482,'官渡区',415,0,3),(4483,'宜良县',415,0,3),(4484,'富民县',415,0,3),(4485,'寻甸回族彝族自治县',415,0,3),(4486,'嵩明县',415,0,3),(4487,'晋宁县',415,0,3),(4488,'盘龙区',415,0,3),(4489,'石林彝族自治县',415,0,3),(4490,'禄劝彝族苗族自治县',415,0,3),(4491,'西山区',415,0,3),(4492,'会泽县',416,0,3),(4493,'宣威市',416,0,3),(4494,'富源县',416,0,3),(4495,'师宗县',416,0,3),(4496,'沾益县',416,0,3),(4497,'罗平县',416,0,3),(4498,'陆良县',416,0,3),(4499,'马龙县',416,0,3),(4500,'麒麟区',416,0,3),(4501,'元江哈尼族彝族傣族自治县',417,0,3),(4502,'华宁县',417,0,3),(4503,'峨山彝族自治县',417,0,3),(4504,'新平彝族傣族自治县',417,0,3),(4505,'易门县',417,0,3),(4506,'江川县',417,0,3),(4507,'澄江县',417,0,3),(4508,'红塔区',417,0,3),(4509,'通海县',417,0,3),(4510,'施甸县',418,0,3),(4511,'昌宁县',418,0,3),(4512,'腾冲县',418,0,3),(4513,'隆阳区',418,0,3),(4514,'龙陵县',418,0,3),(4515,'大关县',419,0,3),(4516,'威信县',419,0,3),(4517,'巧家县',419,0,3),(4518,'彝良县',419,0,3),(4519,'昭阳区',419,0,3),(4520,'水富县',419,0,3),(4521,'永善县',419,0,3),(4522,'盐津县',419,0,3),(4523,'绥江县',419,0,3),(4524,'镇雄县',419,0,3),(4525,'鲁甸县',419,0,3),(4526,'华坪县',420,0,3),(4527,'古城区',420,0,3),(4528,'宁蒗彝族自治县',420,0,3),(4529,'永胜县',420,0,3),(4530,'玉龙纳西族自治县',420,0,3),(4531,'临翔区',422,0,3),(4532,'云县',422,0,3),(4533,'凤庆县',422,0,3),(4534,'双江拉祜族佤族布朗族傣族自治县',422,0,3),(4535,'永德县',422,0,3),(4536,'沧源佤族自治县',422,0,3),(4537,'耿马傣族佤族自治县',422,0,3),(4538,'镇康县',422,0,3),(4539,'元谋县',423,0,3),(4540,'南华县',423,0,3),(4541,'双柏县',423,0,3),(4542,'大姚县',423,0,3),(4543,'姚安县',423,0,3),(4544,'楚雄市',423,0,3),(4545,'武定县',423,0,3),(4546,'永仁县',423,0,3),(4547,'牟定县',423,0,3),(4548,'禄丰县',423,0,3),(4549,'个旧市',424,0,3),(4550,'元阳县',424,0,3),(4551,'屏边苗族自治县',424,0,3),(4552,'建水县',424,0,3),(4553,'开远市',424,0,3),(4554,'弥勒县',424,0,3),(4555,'河口瑶族自治县',424,0,3),(4556,'泸西县',424,0,3),(4557,'石屏县',424,0,3),(4558,'红河县',424,0,3),(4559,'绿春县',424,0,3),(4560,'蒙自县',424,0,3),(4561,'金平苗族瑶族傣族自治县',424,0,3),(4562,'丘北县',425,0,3),(4563,'富宁县',425,0,3),(4564,'广南县',425,0,3),(4565,'文山县',425,0,3),(4566,'砚山县',425,0,3),(4567,'西畴县',425,0,3),(4568,'马关县',425,0,3),(4569,'麻栗坡县',425,0,3),(4570,'勐海县',426,0,3),(4571,'勐腊县',426,0,3),(4572,'景洪市',426,0,3),(4573,'云龙县',427,0,3),(4574,'剑川县',427,0,3),(4575,'南涧彝族自治县',427,0,3),(4576,'大理市',427,0,3),(4577,'宾川县',427,0,3),(4578,'巍山彝族回族自治县',427,0,3),(4579,'弥渡县',427,0,3),(4580,'永平县',427,0,3),(4581,'洱源县',427,0,3),(4582,'漾濞彝族自治县',427,0,3),(4583,'祥云县',427,0,3),(4584,'鹤庆县',427,0,3),(4585,'梁河县',428,0,3),(4586,'潞西市',428,0,3),(4587,'瑞丽市',428,0,3),(4588,'盈江县',428,0,3),(4589,'陇川县',428,0,3),(4590,'德钦县',430,0,3),(4591,'维西傈僳族自治县',430,0,3),(4592,'香格里拉县',430,0,3),(4593,'城关区',431,0,3),(4594,'堆龙德庆县',431,0,3),(4595,'墨竹工卡县',431,0,3),(4596,'尼木县',431,0,3),(4597,'当雄县',431,0,3),(4598,'曲水县',431,0,3),(4599,'林周县',431,0,3),(4600,'达孜县',431,0,3),(4601,'丁青县',432,0,3),(4602,'八宿县',432,0,3),(4603,'察雅县',432,0,3),(4604,'左贡县',432,0,3),(4605,'昌都县',432,0,3),(4606,'江达县',432,0,3),(4607,'洛隆县',432,0,3),(4608,'类乌齐县',432,0,3),(4609,'芒康县',432,0,3),(4610,'贡觉县',432,0,3),(4611,'边坝县',432,0,3),(4612,'乃东县',433,0,3),(4613,'加查县',433,0,3),(4614,'扎囊县',433,0,3),(4615,'措美县',433,0,3),(4616,'曲松县',433,0,3),(4617,'桑日县',433,0,3),(4618,'洛扎县',433,0,3),(4619,'浪卡子县',433,0,3),(4620,'琼结县',433,0,3),(4621,'贡嘎县',433,0,3),(4622,'错那县',433,0,3),(4623,'隆子县',433,0,3),(4624,'亚东县',434,0,3),(4625,'仁布县',434,0,3),(4626,'仲巴县',434,0,3),(4627,'南木林县',434,0,3),(4628,'吉隆县',434,0,3),(4629,'定日县',434,0,3),(4630,'定结县',434,0,3),(4631,'岗巴县',434,0,3),(4632,'康马县',434,0,3),(4633,'拉孜县',434,0,3),(4634,'日喀则市',434,0,3),(4635,'昂仁县',434,0,3),(4636,'江孜县',434,0,3),(4637,'白朗县',434,0,3),(4638,'聂拉木县',434,0,3),(4639,'萨嘎县',434,0,3),(4640,'萨迦县',434,0,3),(4641,'谢通门县',434,0,3),(4642,'嘉黎县',435,0,3),(4643,'安多县',435,0,3),(4644,'尼玛县',435,0,3),(4645,'巴青县',435,0,3),(4646,'比如县',435,0,3),(4647,'班戈县',435,0,3),(4648,'申扎县',435,0,3),(4649,'索县',435,0,3),(4650,'聂荣县',435,0,3),(4651,'那曲县',435,0,3),(4652,'噶尔县',436,0,3),(4653,'措勤县',436,0,3),(4654,'改则县',436,0,3),(4655,'日土县',436,0,3),(4656,'普兰县',436,0,3),(4657,'札达县',436,0,3),(4658,'革吉县',436,0,3),(4659,'墨脱县',437,0,3),(4660,'察隅县',437,0,3),(4661,'工布江达县',437,0,3),(4662,'朗县',437,0,3),(4663,'林芝县',437,0,3),(4664,'波密县',437,0,3),(4665,'米林县',437,0,3),(4666,'临潼区',438,0,3),(4667,'周至县',438,0,3),(4668,'户县',438,0,3),(4669,'新城区',438,0,3),(4670,'未央区',438,0,3),(4671,'灞桥区',438,0,3),(4672,'碑林区',438,0,3),(4673,'莲湖区',438,0,3),(4674,'蓝田县',438,0,3),(4675,'长安区',438,0,3),(4676,'阎良区',438,0,3),(4677,'雁塔区',438,0,3),(4678,'高陵县',438,0,3),(4679,'印台区',439,0,3),(4680,'宜君县',439,0,3),(4681,'王益区',439,0,3),(4682,'耀州区',439,0,3),(4683,'凤县',440,0,3),(4684,'凤翔县',440,0,3),(4685,'千阳县',440,0,3),(4686,'太白县',440,0,3),(4687,'岐山县',440,0,3),(4688,'扶风县',440,0,3),(4689,'渭滨区',440,0,3),(4690,'眉县',440,0,3),(4691,'金台区',440,0,3),(4692,'陇县',440,0,3),(4693,'陈仓区',440,0,3),(4694,'麟游县',440,0,3),(4695,'三原县',441,0,3),(4696,'干县',441,0,3),(4697,'兴平市',441,0,3),(4698,'彬县',441,0,3),(4699,'旬邑县',441,0,3),(4700,'杨陵区',441,0,3),(4701,'武功县',441,0,3),(4702,'永寿县',441,0,3),(4703,'泾阳县',441,0,3),(4704,'淳化县',441,0,3),(4705,'渭城区',441,0,3),(4706,'礼泉县',441,0,3),(4707,'秦都区',441,0,3),(4708,'长武县',441,0,3),(4709,'临渭区',442,0,3),(4710,'华县',442,0,3),(4711,'华阴市',442,0,3),(4712,'合阳县',442,0,3),(4713,'大荔县',442,0,3),(4714,'富平县',442,0,3),(4715,'潼关县',442,0,3),(4716,'澄城县',442,0,3),(4717,'白水县',442,0,3),(4718,'蒲城县',442,0,3),(4719,'韩城市',442,0,3),(4720,'吴起县',443,0,3),(4721,'子长县',443,0,3),(4722,'安塞县',443,0,3),(4723,'宜川县',443,0,3),(4724,'宝塔区',443,0,3),(4725,'富县',443,0,3),(4726,'延川县',443,0,3),(4727,'延长县',443,0,3),(4728,'志丹县',443,0,3),(4729,'洛川县',443,0,3),(4730,'甘泉县',443,0,3),(4731,'黄陵县',443,0,3),(4732,'黄龙县',443,0,3),(4733,'佛坪县',444,0,3),(4734,'勉县',444,0,3),(4735,'南郑县',444,0,3),(4736,'城固县',444,0,3),(4737,'宁强县',444,0,3),(4738,'汉台区',444,0,3),(4739,'洋县',444,0,3),(4740,'留坝县',444,0,3),(4741,'略阳县',444,0,3),(4742,'西乡县',444,0,3),(4743,'镇巴县',444,0,3),(4744,'佳县',445,0,3),(4745,'吴堡县',445,0,3),(4746,'子洲县',445,0,3),(4747,'定边县',445,0,3),(4748,'府谷县',445,0,3),(4749,'榆林市榆阳区',445,0,3),(4750,'横山县',445,0,3),(4751,'清涧县',445,0,3),(4752,'神木县',445,0,3),(4753,'米脂县',445,0,3),(4754,'绥德县',445,0,3),(4755,'靖边县',445,0,3),(4756,'宁陕县',446,0,3),(4757,'岚皋县',446,0,3),(4758,'平利县',446,0,3),(4759,'旬阳县',446,0,3),(4760,'汉滨区',446,0,3),(4761,'汉阴县',446,0,3),(4762,'白河县',446,0,3),(4763,'石泉县',446,0,3),(4764,'紫阳县',446,0,3),(4765,'镇坪县',446,0,3),(4766,'丹凤县',447,0,3),(4767,'商南县',447,0,3),(4768,'商州区',447,0,3),(4769,'山阳县',447,0,3),(4770,'柞水县',447,0,3),(4771,'洛南县',447,0,3),(4772,'镇安县',447,0,3),(4773,'七里河区',448,0,3),(4774,'城关区',448,0,3),(4775,'安宁区',448,0,3),(4776,'榆中县',448,0,3),(4777,'永登县',448,0,3),(4778,'皋兰县',448,0,3),(4779,'红古区',448,0,3),(4780,'西固区',448,0,3),(4781,'嘉峪关市',449,0,3),(4782,'永昌县',450,0,3),(4783,'金川区',450,0,3),(4784,'会宁县',451,0,3),(4785,'平川区',451,0,3),(4786,'景泰县',451,0,3),(4787,'白银区',451,0,3),(4788,'靖远县',451,0,3),(4789,'张家川回族自治县',452,0,3),(4790,'武山县',452,0,3),(4791,'清水县',452,0,3),(4792,'甘谷县',452,0,3),(4793,'秦安县',452,0,3),(4794,'秦州区',452,0,3),(4795,'麦积区',452,0,3),(4796,'凉州区',453,0,3),(4797,'古浪县',453,0,3),(4798,'天祝藏族自治县',453,0,3),(4799,'民勤县',453,0,3),(4800,'临泽县',454,0,3),(4801,'山丹县',454,0,3),(4802,'民乐县',454,0,3),(4803,'甘州区',454,0,3),(4804,'肃南裕固族自治县',454,0,3),(4805,'高台县',454,0,3),(4806,'华亭县',455,0,3),(4807,'崆峒区',455,0,3),(4808,'崇信县',455,0,3),(4809,'庄浪县',455,0,3),(4810,'泾川县',455,0,3),(4811,'灵台县',455,0,3),(4812,'静宁县',455,0,3),(4813,'敦煌市',456,0,3),(4814,'玉门市',456,0,3),(4815,'瓜州县（原安西县）',456,0,3),(4816,'肃北蒙古族自治县',456,0,3),(4817,'肃州区',456,0,3),(4818,'金塔县',456,0,3),(4819,'阿克塞哈萨克族自治县',456,0,3),(4820,'华池县',457,0,3),(4821,'合水县',457,0,3),(4822,'宁县',457,0,3),(4823,'庆城县',457,0,3),(4824,'正宁县',457,0,3),(4825,'环县',457,0,3),(4826,'西峰区',457,0,3),(4827,'镇原县',457,0,3),(4828,'临洮县',458,0,3),(4829,'安定区',458,0,3),(4830,'岷县',458,0,3),(4831,'渭源县',458,0,3),(4832,'漳县',458,0,3),(4833,'通渭县',458,0,3),(4834,'陇西县',458,0,3),(4835,'两当县',459,0,3),(4836,'宕昌县',459,0,3),(4837,'康县',459,0,3),(4838,'徽县',459,0,3),(4839,'成县',459,0,3),(4840,'文县',459,0,3),(4841,'武都区',459,0,3),(4842,'礼县',459,0,3),(4843,'西和县',459,0,3),(4844,'东乡族自治县',460,0,3),(4845,'临夏县',460,0,3),(4846,'临夏市',460,0,3),(4847,'和政县',460,0,3),(4848,'广河县',460,0,3),(4849,'康乐县',460,0,3),(4850,'永靖县',460,0,3),(4851,'积石山保安族东乡族撒拉族自治县',460,0,3),(4852,'临潭县',461,0,3),(4853,'卓尼县',461,0,3),(4854,'合作市',461,0,3),(4855,'夏河县',461,0,3),(4856,'玛曲县',461,0,3),(4857,'碌曲县',461,0,3),(4858,'舟曲县',461,0,3),(4859,'迭部县',461,0,3),(4860,'城东区',462,0,3),(4861,'城中区',462,0,3),(4862,'城北区',462,0,3),(4863,'城西区',462,0,3),(4864,'大通回族土族自治县',462,0,3),(4865,'湟中县',462,0,3),(4866,'湟源县',462,0,3),(4867,'乐都县',463,0,3),(4868,'互助土族自治县',463,0,3),(4869,'化隆回族自治县',463,0,3),(4870,'平安县',463,0,3),(4871,'循化撒拉族自治县',463,0,3),(4872,'民和回族土族自治县',463,0,3),(4873,'刚察县',464,0,3),(4874,'海晏县',464,0,3),(4875,'祁连县',464,0,3),(4876,'门源回族自治县',464,0,3),(4877,'同仁县',465,0,3),(4878,'尖扎县',465,0,3),(4879,'河南蒙古族自治县',465,0,3),(4880,'泽库县',465,0,3),(4881,'共和县',466,0,3),(4882,'兴海县',466,0,3),(4883,'同德县',466,0,3),(4884,'贵南县',466,0,3),(4885,'贵德县',466,0,3),(4886,'久治县',467,0,3),(4887,'玛多县',467,0,3),(4888,'玛沁县',467,0,3),(4889,'班玛县',467,0,3),(4890,'甘德县',467,0,3),(4891,'达日县',467,0,3),(4892,'囊谦县',468,0,3),(4893,'曲麻莱县',468,0,3),(4894,'杂多县',468,0,3),(4895,'治多县',468,0,3),(4896,'玉树县',468,0,3),(4897,'称多县',468,0,3),(4898,'乌兰县',469,0,3),(4899,'冷湖行委',469,0,3),(4900,'大柴旦行委',469,0,3),(4901,'天峻县',469,0,3),(4902,'德令哈市',469,0,3),(4903,'格尔木市',469,0,3),(4904,'茫崖行委',469,0,3),(4905,'都兰县',469,0,3),(4906,'兴庆区',470,0,3),(4907,'永宁县',470,0,3),(4908,'灵武市',470,0,3),(4909,'西夏区',470,0,3),(4910,'贺兰县',470,0,3),(4911,'金凤区',470,0,3),(4912,'大武口区',471,0,3),(4913,'平罗县',471,0,3),(4914,'惠农区',471,0,3),(4915,'利通区',472,0,3),(4916,'同心县',472,0,3),(4917,'盐池县',472,0,3),(4918,'青铜峡市',472,0,3),(4919,'原州区',473,0,3),(4920,'彭阳县',473,0,3),(4921,'泾源县',473,0,3),(4922,'西吉县',473,0,3),(4923,'隆德县',473,0,3),(4924,'中宁县',474,0,3),(4925,'沙坡头区',474,0,3),(4926,'海原县',474,0,3),(4927,'东山区',475,0,3),(4928,'乌鲁木齐县',475,0,3),(4929,'天山区',475,0,3),(4930,'头屯河区',475,0,3),(4931,'新市区',475,0,3),(4932,'水磨沟区',475,0,3),(4933,'沙依巴克区',475,0,3),(4934,'达坂城区',475,0,3),(4935,'乌尔禾区',476,0,3),(4936,'克拉玛依区',476,0,3),(4937,'独山子区',476,0,3),(4938,'白碱滩区',476,0,3),(4939,'吐鲁番市',477,0,3),(4940,'托克逊县',477,0,3),(4941,'鄯善县',477,0,3),(4942,'伊吾县',478,0,3),(4943,'哈密市',478,0,3),(4944,'巴里坤哈萨克自治县',478,0,3),(4945,'吉木萨尔县',479,0,3),(4946,'呼图壁县',479,0,3),(4947,'奇台县',479,0,3),(4948,'昌吉市',479,0,3),(4949,'木垒哈萨克自治县',479,0,3),(4950,'玛纳斯县',479,0,3),(4951,'米泉市',479,0,3),(4952,'阜康市',479,0,3),(4953,'博乐市',480,0,3),(4954,'温泉县',480,0,3),(4955,'精河县',480,0,3),(4956,'博湖县',481,0,3),(4957,'和硕县',481,0,3),(4958,'和静县',481,0,3),(4959,'尉犁县',481,0,3),(4960,'库尔勒市',481,0,3),(4961,'焉耆回族自治县',481,0,3),(4962,'若羌县',481,0,3),(4963,'轮台县',481,0,3),(4964,'乌什县',482,0,3),(4965,'库车县',482,0,3),(4966,'拜城县',482,0,3),(4967,'新和县',482,0,3),(4968,'柯坪县',482,0,3),(4969,'沙雅县',482,0,3),(4970,'温宿县',482,0,3),(4971,'阿克苏市',482,0,3),(4972,'阿瓦提县',482,0,3),(4973,'乌恰县',483,0,3),(4974,'阿克陶县',483,0,3),(4975,'阿合奇县',483,0,3),(4976,'阿图什市',483,0,3),(4977,'伽师县',484,0,3),(4978,'叶城县',484,0,3),(4979,'喀什市',484,0,3),(4980,'塔什库尔干塔吉克自治县',484,0,3),(4981,'岳普湖县',484,0,3),(4982,'巴楚县',484,0,3),(4983,'泽普县',484,0,3),(4984,'疏勒县',484,0,3),(4985,'疏附县',484,0,3),(4986,'英吉沙县',484,0,3),(4987,'莎车县',484,0,3),(4988,'麦盖提县',484,0,3),(4989,'于田县',485,0,3),(4990,'和田县',485,0,3),(4991,'和田市',485,0,3),(4992,'墨玉县',485,0,3),(4993,'民丰县',485,0,3),(4994,'洛浦县',485,0,3),(4995,'皮山县',485,0,3),(4996,'策勒县',485,0,3),(4997,'伊宁县',486,0,3),(4998,'伊宁市',486,0,3),(4999,'奎屯市',486,0,3),(5000,'察布查尔锡伯自治县',486,0,3),(5001,'尼勒克县',486,0,3),(5002,'巩留县',486,0,3),(5003,'新源县',486,0,3),(5004,'昭苏县',486,0,3),(5005,'特克斯县',486,0,3),(5006,'霍城县',486,0,3),(5007,'乌苏市',487,0,3),(5008,'和布克赛尔蒙古自治县',487,0,3),(5009,'塔城市',487,0,3),(5010,'托里县',487,0,3),(5011,'沙湾县',487,0,3),(5012,'裕民县',487,0,3),(5013,'额敏县',487,0,3),(5014,'吉木乃县',488,0,3),(5015,'哈巴河县',488,0,3),(5016,'富蕴县',488,0,3),(5017,'布尔津县',488,0,3),(5018,'福海县',488,0,3),(5019,'阿勒泰市',488,0,3),(5020,'青河县',488,0,3),(5021,'石河子市',489,0,3),(5022,'阿拉尔市',490,0,3),(5023,'图木舒克市',491,0,3),(5024,'五家渠市',492,0,3),(45055,'海外',35,0,2);
/*!40000 ALTER TABLE `oscshop_area` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_bad_domain`
--

DROP TABLE IF EXISTS `oscshop_bad_domain`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_bad_domain` (
  `id` int(10) NOT NULL,
  `domain` varchar(255) NOT NULL,
  `add_time` int(10) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_bad_domain`
--

LOCK TABLES `oscshop_bad_domain` WRITE;
/*!40000 ALTER TABLE `oscshop_bad_domain` DISABLE KEYS */;
INSERT INTO `oscshop_bad_domain` VALUES (0,'/index.php?m=member&c=index&a=register&siteid=1',1507905932),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1507907299),(0,'/index.php?s=/Apicheckout/checkout/token/ddd',1507943652),(0,'/index.php?s=/apiindex/load_normal_pintuan.html',1507987837),(0,'/index.php?s=/apiindex/load_normal_pintuan.html',1507987904),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1507992015),(0,'/index.php?m=member&c=index&a=register&siteid=1',1507992016),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1507992056),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508119671),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508119697),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508172122),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508172124),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508208128),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508208130),(0,'/index.php?s=/Apicar/show_cart_goods/token/ddd',1508209161),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508242660),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508242662),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508251637),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1508251686),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508278969),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508278969),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508312228),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508312229),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508348521),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508348522),(0,'/index.php?s=/goods/comment/id/1.html',1508375418),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508377026),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508377028),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508408867),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508408868),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508424697),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508424698),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1508424749),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508439193),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508570954),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508570962),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508669879),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508669883),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508684245),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508684247),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1508684408),(0,'/index.php?s=/index/index.htmli3980209i&from=singlemessage',1508684459),(0,'/index.php?s=/index/index.htmli3980209i&from=singlemessage',1508684465),(0,'/index.php?s=/index/index.htmli3980209i&from=singlemessage',1508684466),(0,'/index.php?s=/index/index.htmli3980209i&from=singlemessage',1508684467),(0,'/index.php?s=/index/index.htmli3980209i&from=singlemessage',1508684471),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508701334),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508701334),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508719002),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508720154),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508723410),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508723413),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508727332),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508764467),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508764532),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508780881),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508808172),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508808174),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508838172),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508838173),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508857228),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508857229),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1508857466),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508873552),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508873553),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508892312),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508892331),(0,'/index.php?s=/pingoods/newman.html',1508896890),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508900996),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508904777),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508904778),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508916481),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508916556),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508920907),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508925054),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508931643),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508931782),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1508934304),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508939849),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508939850),(0,'/index.php?m=member&c=index&a=register&siteid=1',1508973167),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1508973169),(0,'/index.php?s=/user/myfavshop.html',1509004540),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509005375),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509005804),(0,'/index.php?s=/user/myfavshop.html',1509006927),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509041899),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509041901),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1509068997),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509070401),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509070421),(0,'/index.php?s=/Apigoods/seller_goods_list/seller_id/1',1509095108),(0,'/index.php?s=/Apigoods/myfavgoodst/token/dddd',1509097064),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509112564),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509112850),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509116622),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509116623),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1509116968),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509141778),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509141779),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1509160692),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509175952),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509175954),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509215277),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509215278),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1509268135),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1509276284),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509289532),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509289533),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1509289708),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1509331915),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509452870),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509452937),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509462471),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509462472),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1509462697),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509482890),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509482892),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509511037),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509511038),(0,'/index.php?s=/Apiuser/get_user_info/token/1af563b025c04262b9a800dc2cbe1b67',1509518969),(0,'/index.php?s=/Apiuser/get_user_info/token/1af563b025c04262b9a800dc2cbe1b67',1509518984),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509545670),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509545672),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509548961),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509548962),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1509549150),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1509580249),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509581599),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509581600),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509612868),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509612981),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509635461),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509635461),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1509635521),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509647296),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509647298),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509674296),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509674298),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509706372),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509706480),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509721944),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509721945),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1509722001),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509739404),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509739406),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509770554),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509770555),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509806238),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509806239),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509840188),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509840189),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1509981376),(0,'/index.php?m=member&c=index&a=register&siteid=1',1509981377),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1509981524),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510067814),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510067815),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1510067867),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510154271),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510154272),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1510154323),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1510324700),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1510421050),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1510421512),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1510453154),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1510567961),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510582898),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510583117),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1510584847),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510711488),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510711489),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1510711543),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510797966),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510797967),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1510798205),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510826138),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510826166),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510860304),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510860306),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510884432),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510884462),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1510885065),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510888510),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510888512),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510917054),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510917132),(0,'/index.php?s=/index.php/s/%2Findex%2Findex.html.html',1510948134),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510950927),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510950931),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510970874),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510970875),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1510970934),(0,'/index.php?m=member&c=index&a=register&siteid=1',1510978512),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1510978515),(0,'/index.php?m=member&c=index&a=register&siteid=1',1511017804),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1511017805),(0,'/index.php?m=member&c=index&a=register&siteid=1',1511050814),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1511050815),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1511057318),(0,'/index.php?m=member&c=index&a=register&siteid=1',1511057319),(0,'/index.php?s=/order/refund_order.html',1511057393),(0,'/index.php?s=/order/refund_order.html',1511057395),(0,'/index.php?s=/order/refund_order.html',1511057395),(0,'/index.php?s=/order/refund_order.html',1511057395),(0,'/index.php?s=/order/refund_order.html',1511057395),(0,'/index.php?s=/order/refund_order.html',1511057397),(0,'/index.php?s=/order/refund_order.html',1511057397),(0,'/index.php?s=/order/refund_order.html',1511057399),(0,'/index.php?s=/order/refund_order.html',1511057399),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1511057523),(0,'/index.php?m=member&c=index&a=register&siteid=1',1511081903),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1511082283),(0,'/index.php?m=member&c=index&a=register&siteid=1',1511123717),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1511123719),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1511143783),(0,'/index.php?m=member&c=index&a=register&siteid=1',1511143784),(0,'/index.php?g=Wap&m=Dining&a=ShowDetail&id=2%20and%20updatexml(1,concat(0x7e,md5(1),0x7e),0)%23',1511143834),(0,'/index.php?m=member&c=index&a=register&siteid=1',1511157318),(0,'/index.php?m=attachment&c=attachments&a=swfupload_json&aid=1&src=%26id=%*27a*nd%20ex*p(~(sele*ct%25*2afro*m(sele*ct+co*nc*at(0x7e,md5(233333),0x7e))x))%23%26m%3D1%26f%3Dtest%26modelid%3D2%26catid%3D6',1511157320),(0,'/dan/index.php?s=/Apiuser/hexiao_pickup/token/84cb5b6d1535f110df697ef540e94e64/pick_sn/534924238607',1513999092),(0,'/dan/index.php?s=/Apiuser/hexiao_pickup/token/84cb5b6d1535f110df697ef540e94e64/pick_sn/534924238607',1513999113),(0,'/dan/index.php?s=/Apiuser/pickup_pickage/token/7625994393e45c03c816cb91392afec6/pick_sn/534924238607',1514086925),(0,'/dan/index.php?s=/Apiuser/pickup_pickage/token/7625994393e45c03c816cb91392afec6/pick_sn/534924238607',1514086972),(0,'/index.php?c=utility&a=file&do=image&page=1&local=local&year=0&month=0&uniacid=-1&dest_dir=&global=&groupid=-1',1545116412),(0,'/index.php?c=utility&a=file&do=group_list&local=local',1545116413),(0,'/index.php?c=utility&a=file&do=image&page=1&local=wx&year=0&month=0&uniacid=-1&dest_dir=&global=&groupid=-1',1545116416),(0,'/index.php?c=utility&a=file&do=group_list&local=wx',1545116416),(0,'/index.php?c=utility&a=file&do=image&page=1&local=local&year=0&month=0&uniacid=-1&dest_dir=&global=&groupid=-1',1545116441),(0,'/index.php?c=utility&a=file&do=group_list&local=local',1545116441),(0,'/index.php?c=utility&a=file&do=upload&upload_type=image&global=&dest_dir=&uniacid=-1&quality=0&group_id=-1',1545116451),(0,'/index.php?c=utility&a=file&do=upload&upload_type=image&global=&dest_dir=&uniacid=-1&quality=0&group_id=-1',1545116471),(0,'/index.php?c=utility&a=file&do=image&page=1&local=local&year=0&month=0&uniacid=-1&dest_dir=&global=&groupid=-1',1545116653),(0,'/index.php?c=utility&a=file&do=group_list&local=local',1545116653),(0,'/index.php?c=utility&a=file&do=image&page=1&local=wx&year=0&month=0&uniacid=-1&dest_dir=&global=&groupid=-1',1545116655),(0,'/index.php?c=utility&a=file&do=group_list&local=wx',1545116655),(0,'/index.php?c=utility&a=file&do=image&page=1&local=local&year=0&month=0&uniacid=-1&dest_dir=&global=&groupid=-1',1545116656),(0,'/index.php?c=utility&a=file&do=group_list&local=local',1545116656),(0,'/index.php?c=utility&a=file&do=group_list&local=local',1545116672),(0,'/index.php?c=utility&a=file&do=image&page=1&local=local&year=2018&month=1&uniacid=-1&dest_dir=&global=&groupid=-1',1545116672),(0,'/index.php?c=utility&a=file&do=image&page=1&local=local&year=0&month=0&uniacid=-1&dest_dir=&global=&groupid=-1',1545118384),(0,'/index.php?c=utility&a=file&do=group_list&local=local',1545118384),(0,'/index.php?c=utility&a=file&do=upload&upload_type=image&global=&dest_dir=&uniacid=-1&quality=0&group_id=-1',1545118404);
/*!40000 ALTER TABLE `oscshop_bad_domain` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_bad_word`
--

DROP TABLE IF EXISTS `oscshop_bad_word`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_bad_word` (
  `bad_id` int(8) unsigned NOT NULL,
  `badword` varchar(20) NOT NULL,
  `replaceword` varchar(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='违规词过滤表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_bad_word`
--

LOCK TABLES `oscshop_bad_word` WRITE;
/*!40000 ALTER TABLE `oscshop_bad_word` DISABLE KEYS */;
INSERT INTO `oscshop_bad_word` VALUES (1,'法轮功',''),(2,'李洪志',''),(3,'大纪元',''),(4,'新唐人',''),(5,'肉棍',''),(6,'淫靡',''),(7,'淫水',''),(8,'六四事件',''),(9,'迷药',''),(10,'迷魂药',''),(11,'窃听器',''),(12,'六合彩',''),(13,'买卖枪支',''),(14,'退党',''),(15,'三唑仑',''),(16,'麻醉药',''),(17,'麻醉乙醚',''),(18,'帝国之梦',''),(19,'毛一鲜',''),(20,'黎阳评',''),(21,'色情服务',''),(22,'出售枪支',''),(23,'摇头丸',''),(24,'天葬',''),(25,'鬼村',''),(26,'军长发威',''),(27,'PK黑社会',''),(28,'恶搞晚会',''),(29,'枪决女犯',''),(30,'投毒杀人',''),(31,'强硬发言',''),(32,'出售假币',''),(33,'监听王',''),(34,'昏药',''),(35,'侦探设备',''),(36,'麻醉钢枪',''),(37,'反华',''),(38,'官商勾结',''),(39,'升达',''),(40,'手机复制',''),(41,'戴海静',''),(42,'自杀指南',''),(43,'自杀手册',''),(44,'张小平',''),(45,'安定片',''),(46,'蒙汗',''),(47,'古方迷香',''),(48,'失意药',''),(49,'迷歼药',''),(50,'透视眼镜',''),(51,'远程偷拍',''),(52,'自制手枪',''),(53,'子女任职名单',''),(54,'激情小电影',''),(55,'黄色小电影',''),(56,'色情小电影',''),(57,'天鹅之旅',''),(58,'盘古乐队',''),(59,'高校暴乱',''),(60,'群体事件',''),(61,'大学骚乱',''),(62,'高校骚乱',''),(63,'催情药',''),(64,'拍肩神药',''),(65,'春药',''),(66,'窃听器材',''),(67,'身份证生成',''),(68,'枪决现场',''),(69,'出售手枪',''),(70,'麻醉枪',''),(71,'办理证件',''),(72,'办理文凭',''),(73,'疆独',''),(74,'藏独',''),(75,'高干子弟',''),(76,'高干子女',''),(77,'枪支弹药',''),(78,'血腥图片',''),(79,'反政府',''),(80,'禁书',''),(81,'无界',''),(82,'特码',''),(83,'反共',''),(84,'成人片',''),(85,'成人电影',''),(86,'换妻',''),(87,'三级片',''),(88,'本拉登',''),(89,'地下先烈',''),(90,'领导财产公示',''),(91,'GPS预警器',''),(92,'毛主席复活',''),(93,'防拍器',''),(94,'电子狗',''),(95,'曝光王',''),(96,'隐形喷剂',''),(97,'催情水',''),(98,'变声电话',''),(99,'变声器',''),(100,'代开发票',''),(101,'二奶大赛',''),(102,'全国二奶',''),(103,'死亡笔记',''),(104,'死亡日志',''),(105,'色情电视',''),(106,'宋平顺',''),(107,'四种当',''),(108,'黄色图片',''),(109,'成人论坛',''),(110,'性爱电影',''),(111,'黄色电影',''),(112,'成人图片',''),(113,'色情图片',''),(114,'成人网站',''),(115,'成人小说',''),(116,'激情视频',''),(117,'激情图片',''),(118,'激情电影',''),(119,'色情网站',''),(120,'十八禁18禁',''),(121,'淫荡',''),(122,'成人贴图',''),(123,'毛片',''),(124,'美女视频',''),(125,'脱衣舞',''),(126,'江姐问',''),(127,'董存瑞问',''),(128,'吴琼花问',''),(129,'拉登熟知中国',''),(130,'激情自拍',''),(131,'淫书',''),(132,'激情美女',''),(133,'监听器',''),(134,'淫奸',''),(135,'淫乱',''),(136,'成人激情',''),(137,'同居社区',''),(138,'淫虫',''),(139,'右派',''),(140,'赌博专用',''),(141,'透视器',''),(142,'核武器',''),(143,'透视照片',''),(144,'拦截器',''),(145,'冰毒',''),(146,'K粉',''),(147,'麻古',''),(148,'万能钥匙',''),(149,'赌博粉',''),(150,'地磅仪',''),(151,'无网界',''),(152,'性网',''),(153,'军火',''),(154,'广安事件',''),(155,'炒股国歌',''),(156,'素女',''),(157,'裸体',''),(158,'乱伦',''),(159,'嫖妓',''),(160,'嫖鸡',''),(161,'小穴',''),(162,'淫魔',''),(163,'做鸡',''),(164,'口交',''),(165,'粗口歌',''),(166,'a片',''),(167,'性虐待',''),(168,'女优',''),(169,'包娃衣',''),(170,'耽美',''),(171,'金瓶梅18N',''),(172,'丝袜写真',''),(173,'维多利亚包',''),(174,'花花公子',''),(175,'大禁',''),(176,'美腿写真',''),(177,'H漫画',''),(178,'隐私图片',''),(179,'H电影',''),(180,'H动漫',''),(181,'龙虎豹',''),(182,'啄木鸟公司',''),(183,'巴拉斯',''),(184,'玉蒲团',''),(185,'无码',''),(186,'PLAYBOY',''),(187,'成人杂志',''),(188,'ANDREWBLAKE',''),(189,'少儿不宜',''),(190,'藏春阁',''),(191,'PRIVATE',''),(192,'痴汉是犯罪',''),(193,'美女野球拳',''),(194,'裸女对对碰',''),(195,'偷窥有罪',''),(196,'伪装美女',''),(197,'虎胆雄心',''),(198,'买春堂',''),(199,'护士24点',''),(200,'成人配色',''),(201,'秘密潜入',''),(202,'欲望格斗',''),(203,'七宗罪',''),(204,'尾行',''),(205,'冠军足球经理',''),(206,'命令与征服',''),(207,'性感扑克',''),(208,'六月联盟',''),(209,'The3FeelOnline',''),(210,'采花堂',''),(211,'爱姐妹',''),(212,'露拉3D',''),(213,'吸血莱恩',''),(214,'hcartoon',''),(215,'梦幻麻将馆',''),(216,'足球经理2005',''),(217,'性福人生',''),(218,'禁忌试玩',''),(219,'沉默杀手',''),(220,'惊悚空间',''),(221,'美少女麻雀',''),(222,'杨思敏',''),(223,'人工少女',''),(224,'电车之狼',''),(225,'Quake',''),(226,'监禁',''),(227,'臭作',''),(228,'欲望之血',''),(229,'性感沙滩',''),(230,'遗作',''),(231,'色狼网',''),(232,'ILLUSION',''),(233,'红河谷论坛',''),(234,'AV麻将',''),(235,'恐惧杀手',''),(236,'波动少女',''),(237,'MC军团',''),(238,'恐怖牢笼',''),(239,'反雷达测速',''),(240,'英语枪手',''),(241,'假钞',''),(242,'电话拦截',''),(243,'探测狗',''),(244,'手机跟踪',''),(245,'监听宝',''),(246,'针孔摄像',''),(247,'迷魂香',''),(248,'短信群发器',''),(249,'邮件群发器',''),(250,'信息群发器',''),(251,'反中游行',''),(252,'中国断交',''),(253,'大规模游行',''),(254,'中国政治力量',''),(255,'政府禁令',''),(256,'听手机',''),(257,'区长丑态',''),(258,'考察视频曝光',''),(259,'迷幻药',''),(260,'手机监听',''),(261,'手机窃听',''),(262,'窃听手机',''),(263,'强力迷魂',''),(264,'强力迷药',''),(265,'风流机械师',''),(266,'证监会忠告',''),(267,'别梦如灰',''),(268,'别说任何话语',''),(269,'梦里何时有雨',''),(270,'如何才能偶遇',''),(271,'灰色在阴霾里',''),(272,'取消农业户口',''),(273,'司马璐回忆录',''),(274,'青年下战书',''),(275,'林松岭',''),(276,'鹿庆红',''),(277,'股市欢迎你',''),(278,'恶心的八大',''),(279,'臭的蓝藻',''),(280,'苏丹红炸鸡',''),(281,'没有不隆重',''),(282,'一劝就躁',''),(283,'腐败新民谣',''),(284,'车仑工力',''),(285,'电子磅遥控',''),(286,'婚叫建',''),(287,'合叫套',''),(288,'类灭亡时',''),(289,'英联邦解散',''),(290,'奶粉s件',''),(291,'三鹿委屈',''),(292,'吉首爆发特',''),(293,'奶粉事件',''),(294,'扫黄队吃喝',''),(295,'警察是革命',''),(296,'三漉',''),(297,'股市翠花',''),(298,'婚恋如股市',''),(299,'股市八荣八耻',''),(300,'物价和主席',''),(301,'杨佳性命',''),(302,'奶业内幕',''),(303,'识了敌敌',''),(304,'识了苏丹',''),(305,'三鹿欢迎你',''),(306,'王十的爷',''),(307,'3lu奶',''),(308,'任推给三鹿',''),(309,'到股灾来',''),(310,'庆林调政协',''),(311,'锦涛忙着',''),(312,'考前不收费',''),(313,'手机卡复制',''),(314,'司法考试答案',''),(315,'石油配乐',''),(316,'婴儿宴',''),(317,'泽东在窗外',''),(318,'小平多正经',''),(319,'警察叹狗',''),(320,'邪教问题',''),(321,'512288就是',''),(322,'今年地震5月12',''),(323,'星不能入党',''),(324,'考前答案',''),(325,'瑞是毛主席',''),(326,'大跌的真正',''),(327,'德怀怎么还活',''),(328,'pe6拦截',''),(329,'脑子脱线',''),(330,'跟踪拦截器',''),(331,'拦截跟听',''),(332,'病人的艳情',''),(333,'毛主席的儿子',''),(334,'撞其火車',''),(335,'搶其火炬',''),(336,'吃女婴',''),(337,'婴儿汤',''),(338,'各省黑社会',''),(339,'张执新张执',''),(340,'普宁杀人',''),(341,'杀人卖尸',''),(342,'医疗公平',''),(343,'不光彩排名',''),(344,'共产党说反腐',''),(345,'改革提前送终',''),(346,'告密的受信',''),(347,'官被人民币',''),(348,'局长裤链没',''),(349,'考中答案',''),(350,'胸主席',''),(351,'代办回国',''),(352,'奥运一路造假',''),(353,'9个成语解释',''),(354,'九个成语解释',''),(355,'使猫吃辣椒',''),(356,'想揍你小川',''),(357,'小川管股市',''),(358,'我能暴强',''),(359,'党前干劲',''),(360,'地被删贴',''),(361,'论坛删帖',''),(362,'歪批闭幕式',''),(363,'甲奥运会结',''),(364,'28铜100',''),(365,'天把4拿',''),(366,'克隆银行卡',''),(367,'复制银行卡',''),(368,'银行卡克隆',''),(369,'银行卡复制',''),(370,'雷尔教',''),(371,'斯蒂梅德',''),(372,'绿林大学毕业',''),(373,'忽悠国家',''),(374,'忽悠政府',''),(375,'杀手培训',''),(376,'腐败培训',''),(377,'江主席出国',''),(378,'高官在咆哮',''),(379,'股民在哀号',''),(380,'做巡航导弹',''),(381,'弹体气动',''),(382,'包含舵机',''),(383,'破网软件',''),(384,'火凤凰fire',''),(385,'谢亚龙翔子',''),(386,'刘翔龙王',''),(387,'李宁跑出画卷',''),(388,'刻章',''),(389,'开幕式搞笑',''),(390,'内贾德哥们',''),(391,'是油和米',''),(392,'党员保鲜',''),(393,'肚圆当代党',''),(394,'阿扁推翻',''),(395,'杨子荣问土匪',''),(396,'数目512128',''),(397,'杨佳传',''),(398,'反对共产党',''),(399,'不怕捶坚',''),(400,'魔王的选择',''),(401,'官场段子',''),(402,'官场日志',''),(403,'公务员素描',''),(404,'当代八乱',''),(405,'任免在交易',''),(406,'组织部长谁关',''),(407,'官位难保批评',''),(408,'硝酸甘油制法',''),(409,'硝酸溶液氧化',''),(410,'布什问锦涛',''),(411,'部长华佗',''),(412,'主席李世民',''),(413,'股股下流',''),(414,'烂股盯半',''),(415,'干部十大特征',''),(416,'小姐把辈份',''),(417,'民主评论整死',''),(418,'下岗妹别流泪',''),(419,'反对执政党',''),(420,'邪党',''),(421,'售各种发票',''),(422,'原子弹制作',''),(423,'制作原子弹',''),(424,'妓女的口号',''),(425,'超级代理服务器',''),(426,'仿真枪',''),(427,'手机窃聽',''),(428,'社会六大',''),(429,'地震的时间',''),(430,'这年头续集',''),(431,'级就官位难',''),(432,'股灾风光',''),(433,'千点狂泻',''),(434,'刘翔退赛一切',''),(435,'四大会来事',''),(436,'开会三要点',''),(437,'逗逗小胡',''),(438,'涛哥靠害',''),(439,'三大扯蛋',''),(440,'四大怪事',''),(441,'五大谎言',''),(442,'六大成绩',''),(443,'六四前后',''),(444,'人是官倒',''),(445,'十五等人',''),(446,'出售手槍',''),(447,'出售猎槍',''),(448,'手槍出售',''),(449,'猎槍出售',''),(450,'温家宝唧唧',''),(451,'水扁素闻',''),(452,'套牢莽莽',''),(453,'顿时逃逃',''),(454,'福娃蟹',''),(455,'避运外出',''),(456,'恭外运恭',''),(457,'恶搞奥运',''),(458,'奥运恶搞',''),(459,'代办各种文凭',''),(460,'qie听器',''),(461,'政客我一',''),(462,'公检法决不',''),(463,'涛哥靠阴',''),(464,'基金黑幕',''),(465,'券商黑幕',''),(466,'发行黑幕',''),(467,'坐庄黑幕',''),(468,'监管黑幕',''),(469,'手機窃听',''),(470,'布什逗逗',''),(471,'船桨涛',''),(472,'名是油和米',''),(473,'不育不运',''),(474,'胡jin涛',''),(475,'迷幻液',''),(476,'小五当警察',''),(477,'中国高干子弟',''),(478,'高干子弟一览',''),(479,'千名中国城管',''),(480,'新人民公仆',''),(481,'红旗代步还',''),(482,'吾乃人民公仆',''),(483,'证监会会歌',''),(484,'队伍似豺狼',''),(485,'手机智能监听',''),(486,'起来还没有开户',''),(487,'奏中狂搓麻将',''),(488,'起立高呼胡',''),(489,'国情那帮狗日',''),(490,'台湾想要单干',''),(491,'东哥不愿',''),(492,'临终前把小平',''),(493,'致胡总书记',''),(494,'千股醉人',''),(495,'疯牛市',''),(496,'散民猴捞',''),(497,'股出圈钱百亿',''),(498,'与道琼试比',''),(499,'阴间来电',''),(500,'地主都入党',''),(501,'炸弹制作',''),(502,'制作炸弹',''),(503,'公交车爆炸',''),(504,'巴士爆炸',''),(505,'政客我一分钱',''),(506,'十大经典谎言',''),(507,'夫君中石油',''),(508,'五任老公是公安',''),(509,'馬雅預言',''),(510,'藏僧遥视',''),(511,'玛雅预言',''),(512,'万亿财富灰飞',''),(513,'石油如此多娇',''),(514,'十亿人民九亿骗',''),(515,'炸铁路抢银行',''),(516,'台风狂扫闽琼',''),(517,'北风带来疠气',''),(518,'连州谁之过',''),(519,'k粉夜总会',''),(520,'魅力似毛泽东',''),(521,'金钱同三个代表',''),(522,'像锦涛一样胡',''),(523,'2012年世界末日',''),(524,'曾庆一样红',''),(525,'罗一样干',''),(526,'中山领导流浪',''),(527,'泽东领导穷光',''),(528,'泽东导演的内战',''),(529,'过来整蒯大富',''),(530,'回首文革',''),(531,'昔日六四',''),(532,'六四名人',''),(533,'可怕的预言',''),(534,'作业出卖国土',''),(535,'蟾蜍地震',''),(536,'胡谁领导',''),(537,'谁胡是中国',''),(538,'赖斯科费',''),(539,'布什头痛的胡',''),(540,'无辜女子被警察',''),(541,'塞进jingche',''),(542,'福娃恶搞',''),(543,'恶搞福娃',''),(544,'昆明爆炸',''),(545,'西路云大医院',''),(546,'昌源路与人民',''),(547,'迷晕药',''),(548,'拍肩型',''),(549,'出售汽枪',''),(550,'汽枪出售',''),(551,'销售汽枪',''),(552,'汽枪销售',''),(553,'转让汽枪',''),(554,'汽枪转让',''),(555,'收购汽枪',''),(556,'购买汽枪',''),(557,'布什家里救拉登',''),(558,'无限制浏览器',''),(559,'慧莲功',''),(560,'三三九乘元功',''),(561,'自然特异功',''),(562,'藏独人祸',''),(563,'地震地灾',''),(564,'济世灵文',''),(565,'拐骗把钱赚',''),(566,'受贿经常干',''),(567,'官场顺口溜',''),(568,'官场之最',''),(569,'工厂变歌厅',''),(570,'穷人富人论',''),(571,'领导用过的叫文物',''),(572,'级加码马到成',''),(573,'最难捉摸的官话',''),(574,'觉晓麻将声声',''),(575,'收礼不受贿',''),(576,'吸烟基本靠送',''),(577,'喝酒基本靠贡',''),(578,'小车一响乡长心慌',''),(579,'酒杯一端政策放宽',''),(580,'不拍不吹狗屁一堆',''),(581,'资金管理是正道',''),(582,'江恩的有关秘密',''),(583,'上海杀警',''),(584,'杀警案',''),(585,'上海袭警',''),(586,'公交爆炸',''),(587,'厅长徐其耀',''),(588,'小姐自强歌',''),(589,'历史上逢8',''),(590,'逢8必灾',''),(591,'一等jc刑侦',''),(592,'三等jc特警',''),(593,'骨头酥意志颓',''),(594,'4万张麻将桌',''),(595,'16万人在热血',''),(596,'死难人数世界',''),(597,'调查中国证监',''),(598,'官媒曝震',''),(599,'中华新民谣',''),(600,'高级干部学泰森',''),(601,'对群众谎言假语',''),(602,'股市古诗词',''),(603,'套牢不觉晓',''),(604,'股市百丈冰',''),(605,'股市打油诗',''),(606,'勐马镇',''),(607,'上南村',''),(608,'炸公交车',''),(609,'炸超市',''),(610,'邓爷爷的预言',''),(611,'邓was',''),(612,'kie粉',''),(613,'连发猎枪',''),(614,'双管猎枪',''),(615,'购买猎枪',''),(616,'猎枪销售',''),(617,'销售猎枪',''),(618,'手枪销售',''),(619,'销售手枪',''),(620,'猎枪出售',''),(621,'出售猎枪',''),(622,'手枪出售',''),(623,'社会民谣',''),(624,'桑拿歌与酒',''),(625,'裕后养狗',''),(626,'校园十八怪',''),(627,'克叫学文件',''),(628,'革命小酒',''),(629,'清官谣',''),(630,'四小闹中华',''),(631,'法x功',''),(632,'做官难难做官',''),(633,'亮才好搞公',''),(634,'四森干部',''),(635,'小姐要入党',''),(636,'吃掉一千亿',''),(637,'千万人齐下岗',''),(638,'结果油价涨了',''),(639,'结果房价涨了',''),(640,'掌权的没天良',''),(641,'工商税务两条狼',''),(642,'龙醒了摇摇头',''),(643,'题板是宋庆龄',''),(644,'而出宋祖英',''),(645,'党在搞社会',''),(646,'崩盘的尸检',''),(647,'最惨烈的崩盘',''),(648,'股市梦魇',''),(649,'忠源实验',''),(650,'出自姬姓',''),(651,'任司空',''),(652,'聃被封',''),(653,'jiangzeming',''),(654,'南政英',''),(655,'丑妓',''),(656,'天价帐篷',''),(657,'气枪',''),(658,'汽抢',''),(659,'qiqiang',''),(660,'qi枪',''),(661,'汽qiang',''),(662,'气qiang',''),(663,'weng安',''),(664,'瓮an',''),(665,'文凭制作',''),(666,'发票出售',''),(667,'代办国内文凭',''),(668,'代办国内外文凭',''),(669,'代办国外文凭',''),(670,'赌博机',''),(671,'卖血',''),(672,'出售肾',''),(673,'出售器官',''),(674,'眼角膜',''),(675,'求肾',''),(676,'换肾',''),(677,'有偿肾',''),(678,'预测答案',''),(679,'考前预测',''),(680,'押题',''),(681,'代写论文',''),(682,'司考答案',''),(683,'带考',''),(684,'待考',''),(685,'提供答案',''),(686,'包过',''),(687,'考后付款',''),(688,'考题',''),(689,'顺利过',''),(690,'级答案',''),(691,'传送答案',''),(692,'替考',''),(693,'助考',''),(694,'保过',''),(695,'六级',''),(696,'无线耳机',''),(697,'语音传送',''),(698,'考试作弊',''),(699,'考前密卷',''),(700,'四六级答案',''),(701,'漏题',''),(702,'短信答案',''),(703,'轻松过',''),(704,'四大舰队',''),(705,'80部队',''),(706,'防区和任务',''),(707,'编成与基地',''),(708,'空军部署',''),(709,'陆军部署',''),(710,'海军部署',''),(711,'七个军区',''),(712,'七大军区',''),(713,'7个军区',''),(714,'7大军区',''),(715,'不办人事',''),(716,'圣战组织',''),(717,'劣等民族',''),(718,'劣等人',''),(719,'北大校园BBS',''),(720,'回汉冲突',''),(721,'民族冲突',''),(722,'鞭满',''),(723,'关塔摩',''),(724,'民族问题',''),(725,'伊斯兰',''),(726,'惨案',''),(727,'红客联盟',''),(728,'靖国',''),(729,'招收',''),(730,'雇佣',''),(731,'围攻',''),(732,'参拜',''),(733,'中特',''),(734,'一肖',''),(735,'报码',''),(736,'香港彩',''),(737,'彩宝',''),(738,'D轮盘',''),(739,'liuhecai',''),(740,'一码',''),(741,'盗号',''),(742,'盗取密码',''),(743,'盗取qq',''),(744,'买真枪',''),(745,'嗑药',''),(746,'帮招人',''),(747,'社会混',''),(748,'拜大哥',''),(749,'电警棒',''),(750,'帮人怀孕',''),(751,'打手',''),(752,'征兵计划',''),(753,'切腹',''),(754,'电鸡',''),(755,'仿真手枪',''),(756,'做炸弹',''),(757,'买枪',''),(758,'氯胺酮',''),(759,'ONS',''),(760,'走私车',''),(761,'代孕',''),(762,'史久武',''),(763,'刘亚洲',''),(764,'李登辉',''),(765,'江猪',''),(766,'耀邦',''),(767,'马英九',''),(768,'胡锦',''),(769,'邓矮子',''),(770,'xiaoping',''),(771,'邓狗',''),(772,'曾培炎',''),(773,'俞正声',''),(774,'张德江',''),(775,'张立昌',''),(776,'吴仪',''),(777,'刘淇',''),(778,'回良玉',''),(779,'王兆国',''),(780,'王乐泉',''),(781,'徐才厚',''),(782,'王刚',''),(783,'贺国强',''),(784,'周永康',''),(785,'刘云山',''),(786,'罗干',''),(787,'曾庆红',''),(788,'贾庆林',''),(789,'吴邦国',''),(790,'活体取肾',''),(791,'苏家屯',''),(792,'九抨',''),(793,'车仑大法',''),(794,'李红痔',''),(795,'XX功',''),(796,'法仑功',''),(797,'FL大法',''),(798,'zifen',''),(799,'李大轮子',''),(800,'jiuping',''),(801,'影子政府',''),(802,'张宏堡',''),(803,'张宏宝',''),(804,'中功',''),(805,'李晓英',''),(806,'董元辰',''),(807,'大妓院',''),(808,'法0功',''),(809,'法O功',''),(810,'9坪',''),(811,'法伦',''),(812,'法L',''),(813,'fa轮',''),(814,'9评',''),(815,'九凭',''),(816,'LHZ',''),(817,'自焚',''),(818,'藏字石',''),(819,'李洪X',''),(820,'9ping',''),(821,'九ping',''),(822,'自fen',''),(823,'轮子功',''),(824,'FL功',''),(825,'flg',''),(826,'法某功',''),(827,'东方闪电',''),(828,'8集团军',''),(829,'吾爾開希',''),(830,'64时期',''),(831,'TAM',''),(832,'紫阳',''),(833,'北京风波',''),(834,'政治风波',''),(835,'xuechao',''),(836,'八九六四',''),(837,'8964',''),(838,'liusi',''),(839,'89风波',''),(840,'4事件',''),(841,'6四',''),(842,'六4',''),(843,'二十四事件',''),(844,'历史的伤口',''),(845,'年的事',''),(846,'989年',''),(847,'一九八九年',''),(848,'年事件',''),(849,'学生领袖',''),(850,'学潮',''),(851,'杀害学生',''),(852,'tiananmen',''),(853,'流血事件',''),(854,'民主女神',''),(855,'89之',''),(856,'89事件',''),(857,'7年前',''),(858,'血染的风采',''),(859,'广场事件',''),(860,'屠杀学生',''),(861,'暴行',''),(862,'何新',''),(863,'天安门事件',''),(864,'六四信息',''),(865,'官匪一家',''),(866,'警匪一家',''),(867,'暴力执法',''),(868,'示wei',''),(869,'袁伟民',''),(870,'9.事件',''),(871,'8.8事件',''),(872,'瑞安事件',''),(873,'武装镇压',''),(874,'武力镇压',''),(875,'暴力袭警',''),(876,'集体抗议',''),(877,'警民冲突',''),(878,'群众冲击',''),(879,'复员',''),(880,'造反',''),(881,'信访',''),(882,'军转',''),(883,'聚集',''),(884,'买断',''),(885,'罢市',''),(886,'维权',''),(887,'上访',''),(888,'示威',''),(889,'陪聊',''),(890,'h图',''),(891,'h漫',''),(892,'开苞',''),(893,'找男',''),(894,'找女',''),(895,'口淫',''),(896,'女士服务',''),(897,'卖身',''),(898,'元一夜',''),(899,'男奴',''),(900,'女奴',''),(901,'电话交友',''),(902,'激情交友',''),(903,'激情电话',''),(904,'看JJ',''),(905,'幼交',''),(906,'性伙伴',''),(907,'有偿服务',''),(908,'做台',''),(909,'厕奴',''),(910,'骚女',''),(911,'嫩逼',''),(912,'一夜激情',''),(913,'母子乱伦',''),(914,'泡友',''),(915,'富姐',''),(916,'富婆',''),(917,'足交',''),(918,'群交',''),(919,'阴户',''),(920,'乳交',''),(921,'屁眼',''),(922,'性服务',''),(923,'性伴侣',''),(924,'反社会主义',''),(925,'现在的公安',''),(926,'第二首都',''),(927,'中国复兴党',''),(928,'共贼',''),(929,'联盟党',''),(930,'同盟党',''),(931,'言论自由',''),(932,'专政',''),(933,'一党专政',''),(934,'一党私利',''),(935,'软弱外交',''),(936,'政府无能',''),(937,'一党执政',''),(938,'讨厌中国',''),(939,'张志新',''),(940,'现在的党',''),(941,'外蒙回归',''),(942,'香港独立',''),(943,'上海独立',''),(944,'北京独立',''),(945,'民主还专政',''),(946,'人权保护',''),(947,'蒋公',''),(948,'中正纪念歌',''),(949,'中国人权',''),(950,'台独',''),(951,'台du',''),(952,'国统纲领',''),(953,'国统会',''),(954,'网络警察',''),(955,'纪念文革',''),(956,'共独',''),(957,'陆独',''),(958,'现在的社会',''),(959,'上海帮',''),(960,'现在的政府',''),(961,'反对党',''),(962,'现在的共产党',''),(963,'铁血师',''),(964,'现在的警察',''),(965,'共产觉',''),(966,'灭共',''),(967,'社会主义灭亡',''),(968,'不爱党',''),(969,'共X党',''),(970,'独夫民贼',''),(971,'伪大',''),(972,'伪政府',''),(973,'第三次世界大战',''),(974,'自由亚洲',''),(975,'公产党',''),(976,'夺权',''),(977,'网特',''),(978,'GONG党',''),(979,'CCP',''),(980,'中共洗脑',''),(981,'反G',''),(982,'死刑现场',''),(983,'雍战胜',''),(984,'校园改造工程',''),(985,'记签',''),(986,'王政',''),(987,'华闻',''),(988,'张文中',''),(989,'饲养基地',''),(990,'涿州',''),(991,'集会',''),(992,'中组部前部长直言',''),(993,'四川广安',''),(994,'段桂清',''),(995,'寂寞少妇',''),(996,'有偿捐献',''),(997,'6合',''),(998,'六HE彩',''),(999,'有码',''),(1000,'包养',''),(1001,'海洛因',''),(1002,'犬交',''),(1003,'兽交',''),(1004,'根浴',''),(1005,'买肾',''),(1006,'卖肾',''),(1007,'肾源',''),(1008,'援交',''),(1009,'性息',''),(1010,'裸聊',''),(1011,'夫妻交换',''),(1012,'中石油国家电网倒数',''),(1013,'国办发',''),(1014,'中办发',''),(1015,'菊暴',''),(1016,'菊爆',''),(1017,'暴菊',''),(1018,'爆菊',''),(1019,'小口径',''),(1020,'我虽死去',''),(1021,'我们自杀吧',''),(1022,'胡锦涛',''),(1023,'吃人',''),(1024,'GCD',''),(1025,'西藏作家组织',''),(1026,'自由西藏',''),(1027,'自由门',''),(1028,'自烧',''),(1029,'转法论',''),(1030,'转法轮',''),(1031,'属灵教',''),(1032,'主神教',''),(1033,'重阳兵变',''),(1034,'中央黑幕',''),(1035,'中南海权力斗争',''),(1036,'中南海黑幕',''),(1037,'中南海恩仇录',''),(1038,'中南海斗争',''),(1039,'中南海的权力游戏',''),(1040,'中华养生益智气',''),(1041,'中华养生益智功',''),(1042,'中华昆仑女神功',''),(1043,'中国猪',''),(1044,'中国支配下的朝鲜经济',''),(1045,'中国政府封锁消息',''),(1046,'中国正义党',''),(1047,'中国舆论监督网周洪',''),(1048,'中国网络审查',''),(1049,'中国贪官在海外',''),(1050,'中国实行血腥教育',''),(1051,'中国人民党',''),(1052,'中国没有自由',''),(1053,'中国海外腐败兵团',''),(1054,'中国过渡政府',''),(1055,'中国官场情杀案',''),(1056,'中国共和党',''),(1057,'中国高层权力斗争',''),(1058,'中共政治游戏',''),(1059,'中共邪毒素',''),(1060,'中共邪党',''),(1061,'中共退党',''),(1062,'中共三大势力谁来执政',''),(1063,'中共任用',''),(1064,'中共权力斗争',''),(1065,'中共恐惧',''),(1066,'中共近期权力斗争',''),(1067,'中共解体',''),(1068,'中共黑帮',''),(1069,'中共腐败',''),(1070,'中共封网',''),(1071,'中共封锁',''),(1072,'中共独裁',''),(1073,'中共第五代',''),(1074,'中共第六代',''),(1075,'中共帝国',''),(1076,'中共的罪恶',''),(1077,'中共的血旗',''),(1078,'中共的腐败与残暴',''),(1079,'中共党文化',''),(1080,'中共裁',''),(1081,'中共保命',''),(1082,'中共帮凶',''),(1083,'支那猪',''),(1084,'支持台湾独立',''),(1085,'政治人祸的源头',''),(1086,'政治局委员增加一倍',''),(1087,'政治局十七',''),(1088,'真善忍',''),(1089,'运动正名',''),(1090,'援藏网',''),(1091,'元极功',''),(1092,'渊盖苏文',''),(1093,'宇宙主佛',''),(1094,'宇宙毁灭',''),(1095,'宇宙大法',''),(1096,'优化官员',''),(1097,'一中一台',''),(1098,'一通健康法',''),(1099,'一通功',''),(1100,'一党独裁',''),(1101,'夜半加税',''),(1102,'业力轮',''),(1103,'业力回报',''),(1104,'耶稣基督血水圣灵全备福音布道团',''),(1105,'燕玲论坛',''),(1106,'延安日记',''),(1107,'循环轮回论',''),(1108,'血腥清场',''),(1109,'血色京畿',''),(1110,'血色京机',''),(1111,'血溅人民天堂',''),(1112,'性奴集中营',''),(1113,'兴华论谈',''),(1114,'新中华战记',''),(1115,'新闻总署态度蛮横',''),(1116,'新搪人',''),(1117,'新疆独立',''),(1118,'新疆暴乱',''),(1119,'小活佛',''),(1120,'消业之说',''),(1121,'向巴平措',''),(1122,'香功',''),(1123,'西藏人民大起义运动',''),(1124,'西藏独立',''),(1125,'无人性的政权',''),(1126,'无官正',''),(1127,'无耻语录',''),(1128,'无帮国',''),(1129,'乌云其木格',''),(1130,'瘟家宝',''),(1131,'温休曾退',''),(1132,'温下台',''),(1133,'温加饱',''),(1134,'魏京生',''),(1135,'未来的自由中国在民间',''),(1136,'伪基百科',''),(1137,'为党不为国',''),(1138,'网络封锁',''),(1139,'网管办',''),(1140,'亡共者胡',''),(1141,'亡党',''),(1142,'万法归一功',''),(1143,'退h集会',''),(1144,'推翻专制独裁的共产党',''),(1145,'突破网封索的软件',''),(1146,'统治术',''),(1147,'统一教',''),(1148,'挺胡',''),(1149,'天音功',''),(1150,'天要亡',''),(1151,'天要灭',''),(1152,'天灭中共',''),(1153,'特务机构',''),(1154,'特别党费',''),(1155,'太王四神记',''),(1156,'台湾有权独立',''),(1157,'台湾应该独立',''),(1158,'台湾国',''),(1159,'四二六社论',''),(1160,'四川朱昱',''),(1161,'四川大地震异象揭密',''),(1162,'税务总局致歉',''),(1163,'谁为腐败晚餐买单',''),(1164,'谁是新中国',''),(1165,'谁是胡的接班人',''),(1166,'双桨飞机',''),(1167,'树亲民形象不如推动政改',''),(1168,'世界之门',''),(1169,'世界以利亚福音宣教会',''),(1170,'世界十大独裁者',''),(1171,'世界基督教统一神灵协会',''),(1172,'实际神',''),(1173,'十七位老部长',''),(1174,'十七大人事安排',''),(1175,'十七大权力争霸战',''),(1176,'十八大接班人',''),(1177,'师涛',''),(1178,'剩火',''),(1179,'圣灵重建教会',''),(1180,'圣火护卫',''),(1181,'圣殿教',''),(1182,'生命树的分叉',''),(1183,'沈昌人体科技',''),(1184,'沈昌功',''),(1185,'神州忏悔录',''),(1186,'神的教会',''),(1187,'涉台政局',''),(1188,'沙皇李长春',''),(1189,'三脱',''),(1190,'三退',''),(1191,'三股势力',''),(1192,'三二二攻台作战计划',''),(1193,'三班仆人派',''),(1194,'赛克网',''),(1195,'萨斯病',''),(1196,'日月气功',''),(1197,'人宇特能功',''),(1198,'人民币恶搞',''),(1199,'人类罪恶论',''),(1200,'群体灭绝',''),(1201,'全范围教会',''),(1202,'清华帮',''),(1203,'清海无上师',''),(1204,'清海师父',''),(1205,'清官团',''),(1206,'清场内幕',''),(1207,'青海无上师',''),(1208,'沁园春血',''),(1209,'钦点接班人',''),(1210,'侵犯国外专利',''),(1211,'亲共媒体',''),(1212,'亲共分子',''),(1213,'强烈抗议中共当局',''),(1214,'千禧弘法',''),(1215,'器官贩卖',''),(1216,'平反六四',''),(1217,'跑官要官',''),(1218,'派系斗争',''),(1219,'女神教',''),(1220,'鸟巢最少死0',''),(1221,'内争人权',''),(1222,'牟新生',''),(1223,'漠视生命自私到了极点的中共政权',''),(1224,'末世论',''),(1225,'末世劫难',''),(1226,'魔难论',''),(1227,'明镜出版社',''),(1228,'明慧网',''),(1229,'明hui',''),(1230,'民主不能等待',''),(1231,'民运',''),(1232,'民殇',''),(1233,'迷失北京',''),(1234,'蒙古回归',''),(1235,'门徒会',''),(1236,'毛主席的嫡孙',''),(1237,'毛贼',''),(1238,'毛泽东侄子',''),(1239,'毛泽东复活',''),(1240,'毛时代大饥荒揭秘',''),(1241,'买官卖官',''),(1242,'轮子小报',''),(1243,'旅游新报',''),(1244,'龙虎斗',''),(1245,'六四资料馆',''),(1246,'六四受难者家属证辞',''),(1247,'六四内部日记',''),(1248,'六代接班人',''),(1249,'留四进三',''),(1250,'流亡藏人',''),(1251,'领导忽悠百姓叫号召',''),(1252,'临震预报',''),(1253,'练功群众',''),(1254,'李伟信的笔供',''),(1255,'拉线飞机',''),(1256,'拉萨僧人接连抗议',''),(1257,'拉票贿选',''),(1258,'拉帮游说',''),(1259,'恐共',''),(1260,'空中民主墙',''),(1261,'抗议磁悬浮',''),(1262,'开天目',''),(1263,'卡辛纳大道和三福大道交界处',''),(1264,'救度众生说',''),(1265,'京夫子',''),(1266,'津人治津',''),(1267,'解体中共',''),(1268,'解体的命运',''),(1269,'讲法传功',''),(1270,'江贼民',''),(1271,'江宰民',''),(1272,'江系人马',''),(1273,'江戏子',''),(1274,'江梳头',''),(1275,'江氏政治委员',''),(1276,'江氏政治局',''),(1277,'江氏家族',''),(1278,'江氏集团',''),(1279,'江三条腿',''),(1280,'江人马',''),(1281,'江泉集团',''),(1282,'江派人马',''),(1283,'江派和胡派',''),(1284,'江绵恒',''),(1285,'江驴',''),(1286,'江家帮',''),(1287,'江祸心',''),(1288,'江黑心',''),(1289,'江核心',''),(1290,'江蛤蟆',''),(1291,'江独裁',''),(1292,'江毒',''),(1293,'江嫡系',''),(1294,'江丑闻',''),(1295,'江z民',''),(1296,'监狱里的斗争',''),(1297,'监狱管理局',''),(1298,'纪念达赖喇嘛流亡49周年',''),(1299,'疾病业债说',''),(1300,'激流中国',''),(1301,'基督灵恩布道团',''),(1302,'积克馆',''),(1303,'活摘器官',''),(1304,'回忆六四',''),(1305,'回民猪',''),(1306,'回民暴动',''),(1307,'黄菊遗孀',''),(1308,'话在肉身显现',''),(1309,'华藏功',''),(1310,'护卫团',''),(1311,'胡下台',''),(1312,'胡温',''),(1313,'胡派人马',''),(1314,'胡派军委',''),(1315,'胡进涛',''),(1316,'胡紧套',''),(1317,'胡紧掏',''),(1318,'胡江争斗',''),(1319,'胡江曾',''),(1320,'胡江关系',''),(1321,'胡江风云',''),(1322,'红病历',''),(1323,'哈狗帮',''),(1324,'观音法门',''),(1325,'共字玄机',''),(1326,'共青团派',''),(1327,'共青背景',''),(1328,'共和国049',''),(1329,'共匪',''),(1330,'共产主义黑皮书',''),(1331,'共产党专制',''),(1332,'共产党的末日',''),(1333,'共产党的报应',''),(1334,'个邪的党',''),(1335,'个人圆满说',''),(1336,'蛤蟆转世',''),(1337,'佛怀煽仇录',''),(1338,'芳香型智悟气功',''),(1339,'反中共黑色暴力',''),(1340,'反共言论',''),(1341,'反共传单',''),(1342,'反攻大陆',''),(1343,'反腐总攻',''),(1344,'反对日本介入中国铁路工业',''),(1345,'反对共产主义',''),(1346,'反党',''),(1347,'珐(工力)学',''),(1348,'法西藏主义',''),(1349,'法能功',''),(1350,'法论功',''),(1351,'法轮义',''),(1352,'法轮公',''),(1353,'法轮工',''),(1354,'法轮佛法',''),(1355,'法轮大法',''),(1356,'法力像佛',''),(1357,'法拉盛缅街',''),(1358,'法功',''),(1359,'发轮功陈果',''),(1360,'发伦工',''),(1361,'发仑da发',''),(1362,'恶警',''),(1363,'恶搞人民币',''),(1364,'恶党',''),(1365,'对中共的姑息就是对死难者的残忍',''),(1366,'对共产党清算',''),(1367,'东伊运',''),(1368,'东突',''),(1369,'第五代接班梯队',''),(1370,'第五代红人',''),(1371,'递进民主',''),(1372,'抵制北京奥运',''),(1373,'邓颖超日记',''),(1374,'党内言事潮',''),(1375,'党内危机',''),(1376,'党内权争',''),(1377,'党内权力',''),(1378,'党禁',''),(1379,'党棍',''),(1380,'党风日下',''),(1381,'大圆满法',''),(1382,'大学暴动',''),(1383,'大法修炼者',''),(1384,'大法弟子',''),(1385,'打砸抢',''),(1386,'达米宣教会',''),(1387,'慈悲功',''),(1388,'传九退三',''),(1389,'赤匪',''),(1390,'成佛做主',''),(1391,'禅密功',''),(1392,'踩江',''),(1393,'北美巡回讲法',''),(1394,'北京政坛清华名人',''),(1395,'北京市委黑幕',''),(1396,'北京黑幕',''),(1397,'北京帮',''),(1398,'爱国者同盟网站',''),(1399,'爱国运动正名',''),(1400,'www.cipfg.org',''),(1401,'wenjiabao',''),(1402,'VOA采访热比娅',''),(1403,'tuidang',''),(1404,'SevenYearsinTibet',''),(1405,'RedCorner',''),(1406,'PowertotheFalunGong',''),(1407,'m功学',''),(1408,'minghui',''),(1409,'lihongzhi',''),(1410,'huzhuxi',''),(1411,'globalhumanrightstor',''),(1412,'Fa轮功',''),(1413,'fanhua',''),(1414,'fangong',''),(1415,'falungong',''),(1416,'falundafa',''),(1417,'FaLun',''),(1418,'bjork',''),(1419,'89学潮血腥屠杀',''),(1420,'89学潮大屠杀',''),(1421,'70天大事记',''),(1422,'64大屠杀',''),(1423,'《中国民主》',''),(1424,'《争鸣》',''),(1425,'《动向》',''),(1426,'脏独',''),(1427,'脏毒',''),(1428,'西藏国家民主党',''),(1429,'藏青会',''),(1430,'自由西藏学生运动',''),(1431,'九十三运动',''),(1432,'藏妇会',''),(1433,'升达毕业证',''),(1434,'佳静安定片',''),(1435,'蒙汗药粉',''),(1436,'强效失忆药',''),(1437,'迷奸药',''),(1438,'透视眼睛',''),(1439,'身份证生成器',''),(1440,'最后圆满',''),(1441,'作弊器',''),(1442,'治疗肿瘤',''),(1443,'治疗乙肝',''),(1444,'治疗性病',''),(1445,'治疗红斑狼疮',''),(1446,'针孔摄像机',''),(1447,'债务公司',''),(1448,'游戏机破解',''),(1449,'隐形摄像机',''),(1450,'隐形耳机',''),(1451,'隐蔽式摄像机',''),(1452,'银行卡复制设备',''),(1453,'一卡多号',''),(1454,'遥控信号拦截器',''),(1455,'信用卡套现',''),(1456,'消防枪',''),(1457,'消防灭火枪',''),(1458,'香港生子',''),(1459,'土炮',''),(1460,'胎盘',''),(1461,'手机窃听器',''),(1462,'手机魔卡',''),(1463,'手机卡复制器',''),(1464,'手机监听器',''),(1465,'手机跟踪定位器',''),(1466,'容弹量',''),(1467,'枪模',''),(1468,'铅弹',''),(1469,'汽狗',''),(1470,'汽车走表器',''),(1471,'气狗',''),(1472,'普提功',''),(1473,'女伟哥',''),(1474,'纽扣摄像机',''),(1475,'免电灯',''),(1476,'迷昏药',''),(1477,'卖QQ号码',''),(1478,'雷管',''),(1479,'康生丹',''),(1480,'警徽',''),(1481,'假证件',''),(1482,'假文凭',''),(1483,'假发票',''),(1484,'假币出售',''),(1485,'加油机干扰器',''),(1486,'记号扑克',''),(1487,'激光汽',''),(1488,'激光气',''),(1489,'红床',''),(1490,'狗友',''),(1491,'跟帖器',''),(1492,'防身枪',''),(1493,'短信投票业务',''),(1494,'顶帖器',''),(1495,'电子狗导航手机',''),(1496,'电击枪',''),(1497,'电话追杀系统',''),(1498,'地磅遥控器',''),(1499,'地磅解码器',''),(1500,'弹种',''),(1501,'弹夹',''),(1502,'代追债',''),(1503,'代讨债',''),(1504,'车用电子狗',''),(1505,'避孕膜',''),(1506,'斑蝥',''),(1507,'暗访包',''),(1508,'SIM卡复制器',''),(1509,'BB枪',''),(1510,'BB弹',''),(1511,'追债公司',''),(1512,'消声器',''),(1513,'霰弹',''),(1514,'卫星广播器材',''),(1515,'卫星高频头',''),(1516,'卫星电视',''),(1517,'土枪',''),(1518,'双筒',''),(1519,'双桶',''),(1520,'手榴弹',''),(1521,'人弹',''),(1522,'麻醉弹',''),(1523,'弓弩',''),(1524,'赴港生子',''),(1525,'电狗',''),(1526,'导爆索',''),(1527,'长狗',''),(1528,'爆炸物',''),(1529,'爆破',''),(1530,'左棍',''),(1531,'生孩子没屁眼',''),(1532,'傻逼',''),(1533,'日你妈',''),(1534,'妈了个逼',''),(1535,'贱人',''),(1536,'贱货',''),(1537,'狗日的',''),(1538,'狗娘养的',''),(1539,'粪青',''),(1540,'操你妈',''),(1541,'婊子',''),(1542,'淫兽',''),(1543,'阴毛',''),(1544,'阴蒂',''),(1545,'阴道',''),(1546,'阴唇',''),(1547,'性交',''),(1548,'缩阴',''),(1549,'少妇自拍',''),(1550,'色情片',''),(1551,'色情电影',''),(1552,'三级电影',''),(1553,'肉棒',''),(1554,'免费电影',''),(1555,'裸照',''),(1556,'奸杀',''),(1557,'禁网禁片',''),(1558,'肛交',''),(1559,'春宫图',''),(1560,'SM用品',''),(1561,'自动群发',''),(1562,'证件公司',''),(1563,'网站推广软件',''),(1564,'网络推广扩散器',''),(1565,'私家侦探服务',''),(1566,'生意宝',''),(1567,'商务快车',''),(1568,'商务短信',''),(1569,'群发软件',''),(1570,'群发广告机',''),(1571,'解密软件',''),(1572,'慧聪',''),(1573,'供应发票',''),(1574,'发贴机',''),(1575,'发贴工具',''),(1576,'发票代开',''),(1577,'短信猫',''),(1578,'顶贴机',''),(1579,'点金商务',''),(1580,'士的宁',''),(1581,'士的年',''),(1582,'六合采',''),(1583,'乐透码',''),(1584,'皇家轮盘',''),(1585,'俄罗斯轮盘',''),(1586,'赌具',''),(1587,'彩票预测',''),(1588,'彩票选号机',''),(1589,'包青天机',''),(1590,'百乐二呓',''),(1591,'百家乐',''),(1592,'阿凡提机',''),(1593,'6合彩',''),(1594,'祖母绿',''),(1595,'重亚硒酸钠',''),(1596,'粘氯酸',''),(1597,'原砷酸',''),(1598,'原藜芦碱A',''),(1599,'永伏虫',''),(1600,'蝇毒',''),(1601,'罂粟籽',''),(1602,'罂粟壳',''),(1603,'银氰化钾',''),(1604,'因毒硫磷',''),(1605,'因毒磷',''),(1606,'异氰酸甲酯',''),(1607,'异氰酸苯酯',''),(1608,'异硫氰酸烯丙酯',''),(1609,'乙酰亚砷酸铜',''),(1610,'乙酰替硫脲',''),(1611,'乙烯甲醇',''),(1612,'乙酸亚铊',''),(1613,'乙酸铊',''),(1614,'乙酸三乙基锡',''),(1615,'乙酸三甲基锡',''),(1616,'乙酸甲氧基乙基汞',''),(1617,'乙酸汞',''),(1618,'乙硼烷',''),(1619,'乙醇腈',''),(1620,'乙撑亚胺',''),(1621,'乙撑氯醇',''),(1622,'伊皮恩',''),(1623,'一氧化汞',''),(1624,'一氧化二氟',''),(1625,'一氯乙醛',''),(1626,'一氯丙酮',''),(1627,'氧氯化磷',''),(1628,'氧化亚铊',''),(1629,'氧化铊',''),(1630,'氧化二丁基锡',''),(1631,'烟碱',''),(1632,'亚硝酰乙氧',''),(1633,'亚硝酸乙酯',''),(1634,'亚硒酸氢钠',''),(1635,'亚硒酸镁',''),(1636,'亚硒酸二钠',''),(1637,'亚砷酸钠',''),(1638,'亚砷酸钾',''),(1639,'亚砷（酸）酐',''),(1640,'菊花洞',''),(1641,'1夜情',''),(1642,'12次下跪',''),(1643,'18岁以下勿看',''),(1644,'18岁以下勿入看',''),(1645,'27军',''),(1646,'27军军长',''),(1647,'54式',''),(1648,'64式',''),(1649,'77式',''),(1650,'92式',''),(1651,'97爱',''),(1652,'97色色',''),(1653,'97式',''),(1654,'97式防暴枪',''),(1655,'AV出售',''),(1656,'AV电影',''),(1657,'AV女',''),(1658,'AV女优',''),(1659,'A级',''),(1660,'a片网',''),(1661,'bt成人',''),(1662,'b好痒',''),(1663,'b穴',''),(1664,'b痒',''),(1665,'cosplay',''),(1666,'e夜情',''),(1667,'e夜温情',''),(1668,'GCT工程硕士',''),(1669,'go-vern-ment',''),(1670,'Government',''),(1671,'g情',''),(1672,'g情图片',''),(1673,'g情网站',''),(1674,'H站',''),(1675,'H片',''),(1676,'jiqingshaofu',''),(1677,'j巴',''),(1678,'j吧',''),(1679,'ktv公主',''),(1680,'mm穴',''),(1681,'Party',''),(1682,'PPK',''),(1683,'PX项目',''),(1684,'sex',''),(1685,'SM虐待',''),(1686,'todaynic',''),(1687,'VIP伴游',''),(1688,'vip公主',''),(1689,'WP证书',''),(1690,'x伴侣',''),(1691,'香港六',''),(1692,'yindi',''),(1693,'yinshui',''),(1694,'yin部',''),(1695,'yin道',''),(1696,'yin毛',''),(1697,'y蒂',''),(1698,'y户',''),(1699,'y茎',''),(1700,'zhuanfalu',''),(1701,'阿兵哥言语录',''),(1702,'阿里布达年代记',''),(1703,'爱神之传奇',''),(1704,'爱液',''),(1705,'瑷液',''),(1706,'安眠',''),(1707,'安眠药',''),(1708,'按摩小姐',''),(1709,'八背飞凫',''),(1710,'八奶',''),(1711,'罢餐',''),(1712,'罢吃',''),(1713,'罢饭',''),(1714,'罢食',''),(1715,'白小姐',''),(1716,'办证',''),(1717,'伴游私人',''),(1718,'包房公主',''),(1719,'包厢公主',''),(1720,'保钓',''),(1721,'爆乳',''),(1722,'被人干',''),(1723,'屄儿',''),(1724,'屄裏',''),(1725,'屄友',''),(1726,'逼好痒',''),(1727,'逼毛',''),(1728,'逼穴',''),(1729,'逼痒',''),(1730,'毕业证书',''),(1731,'波波',''),(1732,'波佳达',''),(1733,'勃朗宁',''),(1734,'勃朗宁微型',''),(1735,'博白县',''),(1736,'博彩',''),(1737,'不良少女日记',''),(1738,'部巡查',''),(1739,'财税代理',''),(1740,'彩票机',''),(1741,'沧澜曲',''),(1742,'操逼',''),(1743,'操比',''),(1744,'操我',''),(1745,'操小逼',''),(1746,'操穴',''),(1747,'肏屄',''),(1748,'肏干',''),(1749,'肏她',''),(1750,'肏妹妹',''),(1751,'肏妳',''),(1752,'肏娘',''),(1753,'肏破',''),(1754,'肏入',''),(1755,'肏死',''),(1756,'肏我',''),(1757,'肏穴',''),(1758,'肏这',''),(1759,'插爆',''),(1760,'插逼',''),(1761,'插的好舒服',''),(1762,'插的好舒适',''),(1763,'插肛',''),(1764,'插进来',''),(1765,'插进你的下面',''),(1766,'插进你下面',''),(1767,'插进穴',''),(1768,'插妹妹',''),(1769,'插你的下面',''),(1770,'插弄',''),(1771,'插女',''),(1772,'插肉',''),(1773,'插入穴',''),(1774,'插穴',''),(1775,'潮吹',''),(1776,'车牌反光',''),(1777,'陈海石',''),(1778,'陈良宇罢官',''),(1779,'成人bt',''),(1780,'成人导航',''),(1781,'成人電影',''),(1782,'成人俱乐部',''),(1783,'成人卡通',''),(1784,'成人聊天室',''),(1785,'成人漫画',''),(1786,'成人频道',''),(1787,'成人社区',''),(1788,'成人社區',''),(1789,'成人视频',''),(1790,'成人视频聊天',''),(1791,'成人图库',''),(1792,'成人卫星频道',''),(1793,'成人文学',''),(1794,'成人午夜场',''),(1795,'成人小电影',''),(1796,'成人影视',''),(1797,'成人影院',''),(1798,'成人在线',''),(1799,'成人在线电影',''),(1800,'成人站',''),(1801,'吃角子老虎',''),(1802,'赤裸',''),(1803,'抽插',''),(1804,'抽捣',''),(1805,'抽弄',''),(1806,'抽送',''),(1807,'出墙红杏',''),(1808,'出售AV',''),(1809,'出售处男',''),(1810,'出售处女',''),(1811,'出售美女',''),(1812,'出售妹妹',''),(1813,'处男出售',''),(1814,'处女出售',''),(1815,'处女地',''),(1816,'处女穴',''),(1817,'處女',''),(1818,'處女膜',''),(1819,'传奇私服',''),(1820,'创世之子猎艳之旅',''),(1821,'吹箫',''),(1822,'春宵',''),(1823,'粗大的玩意',''),(1824,'崔英杰',''),(1825,'打KING',''),(1826,'打倒',''),(1827,'打飞机',''),(1828,'打炮',''),(1829,'大jj',''),(1830,'大紀元',''),(1831,'大揭露',''),(1832,'大陆当局',''),(1833,'大陆当权者',''),(1834,'大陆独裁者',''),(1835,'大陆官员',''),(1836,'大奶mm',''),(1837,'大腿内侧',''),(1838,'大学艳遇',''),(1839,'大学艳遇史',''),(1840,'代考',''),(1841,'代考建造师',''),(1842,'代考网',''),(1843,'代考业务',''),(1844,'代注',''),(1845,'戴安娜',''),(1846,'单发猎狗',''),(1847,'单管猎枪',''),(1848,'单管五连发',''),(1849,'单管五连发猎枪',''),(1850,'单双管平式猎枪',''),(1851,'党代',''),(1852,'盗版',''),(1853,'盗电',''),(1854,'盗窃',''),(1855,'道县公安',''),(1856,'等你插',''),(1857,'邓小平',''),(1858,'抵制家乐福',''),(1859,'抵制日货',''),(1860,'第十六次代表',''),(1861,'第十六屆',''),(1862,'第十六届',''),(1863,'第拾陆届',''),(1864,'第一次破处',''),(1865,'点对点裸聊',''),(1866,'电影色情',''),(1867,'电子地磅解码器',''),(1868,'调情',''),(1869,'丁香社区',''),(1870,'丁香五月天',''),(1871,'顶得好深',''),(1872,'东北风情熟女之惑',''),(1873,'动乱',''),(1874,'動乱',''),(1875,'豆蔻',''),(1876,'逗肛',''),(1877,'逗乳',''),(1878,'毒米',''),(1879,'毒品',''),(1880,'买码',''),(1881,'卖码',''),(1882,'赌场',''),(1883,'赌城',''),(1884,'赌钱',''),(1885,'赌球',''),(1886,'赌骰子',''),(1887,'对日强硬',''),(1888,'多党执政',''),(1889,'多美康',''),(1890,'多美康安定片',''),(1891,'多夜情',''),(1892,'二奶大奖赛',''),(1893,'二十次',''),(1894,'二十大',''),(1895,'发浪',''),(1896,'发情',''),(1897,'发骚',''),(1898,'法lun功',''),(1899,'法輪功',''),(1900,'反动',''),(1901,'反动2',''),(1902,'反革命',''),(1903,'反右题材',''),(1904,'仿54',''),(1905,'仿64',''),(1906,'仿六四',''),(1907,'仿五四',''),(1908,'仿真假钞',''),(1909,'放入春药',''),(1910,'非标枪械',''),(1911,'肥东交警',''),(1912,'肥穴',''),(1913,'分裂国家',''),(1914,'分数修改',''),(1915,'粉红小b',''),(1916,'粉红小逼',''),(1917,'丰满坚挺',''),(1918,'丰乳肥臀',''),(1919,'丰韵少妇',''),(1920,'风尘劫',''),(1921,'风骚',''),(1922,'风骚侍女',''),(1923,'风月大陆',''),(1924,'疯狂盗窃',''),(1925,'凤反展翅',''),(1926,'凤抬头',''),(1927,'凤啄水',''),(1928,'夫妇乐园',''),(1929,'夫妻友论坛',''),(1930,'肤白胸大',''),(1931,'扶不起的阿斗',''),(1932,'富婆包我',''),(1933,'富人与农民工',''),(1934,'干柴烈火',''),(1935,'干你娘',''),(1936,'敢坐飞机吗',''),(1937,'赣江学院',''),(1938,'肛插',''),(1939,'肛恋',''),(1940,'高潮',''),(1941,'高级伴游',''),(1942,'高级服务生',''),(1943,'高级职称评审',''),(1944,'高树三姐妹',''),(1945,'高樹三姐妹',''),(1946,'高校群体事件',''),(1947,'高薪服务人员',''),(1948,'高薪服务生',''),(1949,'高薪日结',''),(1950,'高莺莺',''),(1951,'睪丸',''),(1952,'搞个处女',''),(1953,'哥的jj',''),(1954,'哥哥兼职',''),(1955,'各种枪',''),(1956,'工字牌气狗',''),(1957,'公安部巡查',''),(1958,'公关兼职',''),(1959,'公关男',''),(1960,'公关女',''),(1961,'公关小姐',''),(1962,'公关夜总会',''),(1963,'公关坐台',''),(1964,'公务员的工资',''),(1965,'公务员调资',''),(1966,'公务员工资',''),(1967,'公主ktv',''),(1968,'公主包厢',''),(1969,'攻击党政',''),(1970,'供应猎枪',''),(1971,'共铲党',''),(1972,'够鳋',''),(1973,'股市民谣',''),(1974,'官逼民反',''),(1975,'广安第二人民医院',''),(1976,'广东王',''),(1977,'龟缝',''),(1978,'龜頭',''),(1979,'国际足坛五大',''),(1980,'国家领导人',''),(1981,'国家领导人保镖',''),(1982,'国民党',''),(1983,'嗨妹',''),(1984,'嗨药',''),(1985,'海盗的悠闲生活',''),(1986,'海乐神',''),(1987,'酣乐欣',''),(1988,'含鸡鸡',''),(1989,'韩国身份证',''),(1990,'和奸成瘾',''),(1991,'和弦',''),(1992,'黑天使',''),(1993,'黑星女侠',''),(1994,'黑窑奴役',''),(1995,'狠肏',''),(1996,'红wy',''),(1997,'红灯区',''),(1998,'红海湾',''),(1999,'红楼绮梦',''),(2000,'后面插',''),(2001,'胡錦濤',''),(2002,'胡景涛',''),(2003,'胡新宇',''),(2004,'胡耀',''),(2005,'胡主席',''),(2006,'虎牌猎狗',''),(2007,'虎头牌双管平式',''),(2008,'护士的穴',''),(2009,'滑腻',''),(2010,'黃色小電影',''),(2011,'黄片',''),(2012,'黄色激情',''),(2013,'黄色免费电影',''),(2014,'黄色片',''),(2015,'黄色网',''),(2016,'黄色小说',''),(2017,'黄色照片',''),(2018,'黄小说',''),(2019,'黄站',''),(2020,'簧片',''),(2021,'挥发型迷药',''),(2022,'会计从业资格',''),(2023,'会计上岗证',''),(2024,'會陰',''),(2025,'混蛋神风流史',''),(2026,'火药制作',''),(2027,'鸡巴',''),(2028,'鸡吧',''),(2029,'激情成人',''),(2030,'激情短片',''),(2031,'激情黄色',''),(2032,'激情聊天',''),(2033,'激情視頻',''),(2034,'激情网站',''),(2035,'激情文学',''),(2036,'激情文學',''),(2037,'激情小说',''),(2038,'激情秀',''),(2039,'激情淫',''),(2040,'激情诱惑',''),(2041,'激情在线',''),(2042,'雞八',''),(2043,'雞巴',''),(2044,'雞雞',''),(2045,'极景',''),(2046,'极品穴',''),(2047,'计生风暴',''),(2048,'纪股票市场五卅惨案',''),(2049,'济南建设路',''),(2050,'甲基苯丙胺',''),(2051,'奸淫',''),(2052,'坚挺丰满的双峰',''),(2053,'兼职的妹妹',''),(2054,'兼职哥哥',''),(2055,'兼职公关',''),(2056,'兼职美女',''),(2057,'兼职妹妹',''),(2058,'监理工程师证',''),(2059,'监听卡',''),(2060,'建造师证',''),(2061,'建筑师证',''),(2062,'践踏中国女性',''),(2063,'江湖淫娘',''),(2064,'江山美人志',''),(2065,'江西田园置业集团',''),(2066,'江泽民',''),(2067,'蒋彦永',''),(2068,'交换夫妻',''),(2069,'交奸',''),(2070,'娇喘',''),(2071,'娇吟',''),(2072,'狡猾的风水相师',''),(2073,'搅珠',''),(2074,'叫床',''),(2075,'她的mm',''),(2076,'姐的穴',''),(2077,'姐开苞',''),(2078,'姐穴',''),(2079,'金伯帆',''),(2080,'金伯帆崔英杰',''),(2081,'金鳞岂是池中物',''),(2082,'金麟岂是池中物',''),(2083,'紧窄',''),(2084,'进口猎狗',''),(2085,'禁断少女',''),(2086,'禁区',''),(2087,'茎精',''),(2088,'精液',''),(2089,'靓穴',''),(2090,'九评',''),(2091,'就爱色',''),(2092,'就去爱',''),(2093,'就去播播',''),(2094,'就去干',''),(2095,'就去色色',''),(2096,'菊花蕾',''),(2097,'菊花穴',''),(2098,'菊穴',''),(2099,'巨波',''),(2100,'巨额骗储',''),(2101,'巨乳',''),(2102,'军火价格',''),(2103,'军枪',''),(2104,'军用',''),(2105,'军用54',''),(2106,'军用64',''),(2107,'军用77式',''),(2108,'军用M92式',''),(2109,'军用狗狗',''),(2110,'军用手狗',''),(2111,'开彩',''),(2112,'科技精英遇难',''),(2113,'抠b',''),(2114,'抠逼',''),(2115,'口活',''),(2116,'口技',''),(2117,'口鉸',''),(2118,'口头检查',''),(2119,'快餐美女',''),(2120,'快餐小姐',''),(2121,'狂操',''),(2122,'狂插',''),(2123,'狂风暴雨',''),(2124,'狂穴',''),(2125,'狅操',''),(2126,'拉登说中国',''),(2127,'拉凳',''),(2128,'狼友',''),(2129,'狼友俱乐部',''),(2130,'浪叫',''),(2131,'浪妻',''),(2132,'浪穴',''),(2133,'浪淫',''),(2134,'老虎机',''),(2135,'老师的穴',''),(2136,'老师穴',''),(2137,'雷明登来复枪',''),(2138,'雷鸣登',''),(2139,'累积大奖',''),(2140,'黎阳平',''),(2141,'礼品机',''),(2142,'李宏志',''),(2143,'李沛瑶',''),(2144,'李鹏',''),(2145,'力月西',''),(2146,'立式猎枪',''),(2147,'俪影蝎心',''),(2148,'连线机',''),(2149,'梁保华',''),(2150,'两乳之间',''),(2151,'两性狂情',''),(2152,'两性乐园',''),(2153,'两性生活',''),(2154,'两性私语',''),(2155,'两性屋',''),(2156,'两性淫乱',''),(2157,'亮穴',''),(2158,'猎枪子弹',''),(2159,'溜冰',''),(2160,'刘全喜',''),(2161,'流了好多的水',''),(2162,'流了好多水',''),(2163,'流氓无产者',''),(2164,'劉奇葆',''),(2165,'6和',''),(2166,'六合彩1',''),(2167,'六和采',''),(2168,'六和彩',''),(2169,'六九体位',''),(2170,'六决不',''),(2171,'六码',''),(2172,'六奶',''),(2173,'六四母亲',''),(2174,'六四屠城',''),(2175,'六四屠杀',''),(2176,'六四学潮',''),(2177,'六四血案',''),(2178,'六四政变',''),(2179,'六四之',''),(2180,'露逼',''),(2181,'露穴',''),(2182,'卢跃刚',''),(2183,'录取通知书',''),(2184,'卵蛋',''),(2185,'乱伦熟女',''),(2186,'乱淫',''),(2187,'亂倫',''),(2188,'伦理片',''),(2189,'轮奸',''),(2190,'轮盘机',''),(2191,'裸聊合法',''),(2192,'裸陪',''),(2193,'裸体写真',''),(2194,'裸體',''),(2195,'裸网',''),(2196,'骆冰淫传',''),(2197,'妈穴',''),(2198,'麻果',''),(2199,'麻醉酒',''),(2200,'马加爵',''),(2201,'卖逼',''),(2202,'卖比',''),(2203,'卖骚',''),(2204,'卖淫',''),(2205,'满床春色',''),(2206,'毛都露出',''),(2207,'毛穴',''),(2208,'毛爷爷复活',''),(2209,'玫瑰园',''),(2210,'美屄',''),(2211,'美国凯德',''),(2212,'美国之音',''),(2213,'美女出售',''),(2214,'美女会所',''),(2215,'美女快餐',''),(2216,'美女裸体',''),(2217,'美女全套',''),(2218,'美少妇的哀羞',''),(2219,'美穴',''),(2220,'妹开苞',''),(2221,'妹妹出售',''),(2222,'妹妹的屄',''),(2223,'妹妹穴',''),(2224,'猛操',''),(2225,'猛插',''),(2226,'猛料',''),(2227,'梦中的女孩',''),(2228,'迷幻喷雾',''),(2229,'迷幻香烟',''),(2230,'迷情',''),(2231,'秘部',''),(2232,'秘處',''),(2233,'秘唇',''),(2234,'秘肉',''),(2235,'密码破解',''),(2236,'密穴',''),(2237,'蜜唇',''),(2238,'蜜洞',''),(2239,'蜜壶',''),(2240,'蜜穴',''),(2241,'免费a片',''),(2242,'灭绝罪',''),(2243,'民警当副院长',''),(2244,'民为法执',''),(2245,'民运分子',''),(2246,'摸奶',''),(2247,'摸胸',''),(2248,'模拟机',''),(2249,'内射',''),(2250,'奶子',''),(2251,'男公关',''),(2252,'男体图片',''),(2253,'男性服务',''),(2254,'南京大屠杀',''),(2255,'南京大学法学院',''),(2256,'嫩b',''),(2257,'嫩屄',''),(2258,'嫩穴',''),(2259,'你敢上吗',''),(2260,'牛皮弹带',''),(2261,'弄穴',''),(2262,'奴事件',''),(2263,'奴役童工',''),(2264,'女ds',''),(2265,'女模招聘',''),(2266,'女男出售',''),(2267,'女人出售',''),(2268,'女人的胸男人为什么喜欢摸',''),(2269,'女人穴',''),(2270,'女死囚',''),(2271,'女特服',''),(2272,'女体',''),(2273,'女体图片',''),(2274,'女性服务',''),(2275,'女友坊',''),(2276,'虐恋',''),(2277,'欧美色图',''),(2278,'歐美bt',''),(2279,'拍肩粉',''),(2280,'牌九',''),(2281,'炮片',''),(2282,'炮图',''),(2283,'陪护私人',''),(2284,'陪裸',''),(2285,'喷潮',''),(2286,'喷尿',''),(2287,'喷沙枪',''),(2288,'喷雾型迷药',''),(2289,'喷血',''),(2290,'屁穴',''),(2291,'嫖娼',''),(2292,'聘女ds',''),(2293,'平码',''),(2294,'破瓜之',''),(2295,'破解密码',''),(2296,'七奶',''),(2297,'期货从业资格',''),(2298,'欺骗股民',''),(2299,'汽车爆炸案',''),(2300,'汽车解码器',''),(2301,'汽车拦截器',''),(2302,'千岛湖之旅',''),(2303,'枪淫少妇',''),(2304,'枪油',''),(2305,'枪支等违禁品',''),(2306,'强j',''),(2307,'强奸',''),(2308,'强姦',''),(2309,'强效失意药',''),(2310,'亲jj',''),(2311,'亲蛋蛋',''),(2312,'亲共行动',''),(2313,'亲吻蛋蛋',''),(2314,'秦青的幸福生活',''),(2315,'清华网管',''),(2316,'情感陪护',''),(2317,'情色',''),(2318,'情色论坛',''),(2319,'情色贴图',''),(2320,'情色图片',''),(2321,'情色网',''),(2322,'情色文学',''),(2323,'情色小说',''),(2324,'情色影片',''),(2325,'情欲',''),(2326,'求救遭拒',''),(2327,'全套服务',''),(2328,'全套美女',''),(2329,'群奸',''),(2330,'绕过封锁',''),(2331,'热辣',''),(2332,'人民报',''),(2333,'人妻',''),(2334,'人妻小说',''),(2335,'人权圣火',''),(2336,'人体艺术',''),(2337,'仁寿警方',''),(2338,'任你淫',''),(2339,'日本毒大米',''),(2340,'日本毒米',''),(2341,'日本小泉',''),(2342,'日批',''),(2343,'蹂躏',''),(2344,'肉屄',''),(2345,'肉洞',''),(2346,'肉缝',''),(2347,'肉根',''),(2348,'肉壶',''),(2349,'肉击',''),(2350,'肉茎',''),(2351,'肉具',''),(2352,'肉门',''),(2353,'肉丘',''),(2354,'肉圈',''),(2355,'肉体交融',''),(2356,'肉臀',''),(2357,'肉穴',''),(2358,'肉芽',''),(2359,'乳fan',''),(2360,'乳房',''),(2361,'乳球',''),(2362,'乳首',''),(2363,'乳晕',''),(2364,'赛马会',''),(2365,'三挫仑',''),(2366,'三角牌子弹',''),(2367,'三句硬话',''),(2368,'三奶',''),(2369,'三陪',''),(2370,'三肖',''),(2371,'三鱼比目',''),(2372,'搔穴',''),(2373,'骚屄',''),(2374,'骚逼',''),(2375,'骚比',''),(2376,'骚婊',''),(2377,'骚货',''),(2378,'骚姐姐',''),(2379,'骚浪',''),(2380,'骚妹',''),(2381,'骚水',''),(2382,'骚穴',''),(2383,'骚痒',''),(2384,'骚姊姊',''),(2385,'騷逼',''),(2386,'騷穴',''),(2387,'色界论坛',''),(2388,'色空寺',''),(2389,'色情导航',''),(2390,'色情六月天',''),(2391,'色情论坛',''),(2392,'色情五月天',''),(2393,'色情小说',''),(2394,'色情影视',''),(2395,'色情自拍',''),(2396,'色图亚洲',''),(2397,'色屋图片',''),(2398,'色淫',''),(2399,'色友',''),(2400,'色诱',''),(2401,'色欲',''),(2402,'杀猪粉',''),(2403,'山不过来',''),(2404,'山西黑砖窑',''),(2405,'山西洪洞',''),(2406,'汕頭頻傳擄童割器官',''),(2407,'汕尾事件',''),(2408,'商务陪伴',''),(2409,'商务陪护',''),(2410,'商务陪游',''),(2411,'商務伴游',''),(2412,'上海交警',''),(2413,'少儿勿入',''),(2414,'少妇白洁',''),(2415,'少妇熟女',''),(2416,'少妇穴',''),(2417,'少年阿宾',''),(2418,'少女高潮',''),(2419,'少爷坐台',''),(2420,'舌头添',''),(2421,'舌头舔',''),(2422,'舌战法庭',''),(2423,'射出来',''),(2424,'射精',''),(2425,'射乳',''),(2426,'涉毒',''),(2427,'神雕外传之郭襄',''),(2428,'沈阳公安',''),(2429,'生成身份证',''),(2430,'声色场所',''),(2431,'声优',''),(2432,'绳虐',''),(2433,'失身',''),(2434,'湿穴',''),(2435,'十八次',''),(2436,'十八山羊对树',''),(2437,'十景缎',''),(2438,'十九次',''),(2439,'十九大',''),(2440,'十临坛竹',''),(2441,'十六大',''),(2442,'十七次',''),(2443,'視頻表演',''),(2444,'手机定',''),(2445,'手机游戏',''),(2446,'手机注册',''),(2447,'手淫',''),(2448,'熟女俱乐部',''),(2449,'双管立式猎枪',''),(2450,'双腿叉开',''),(2451,'双腿间的禁地',''),(2452,'双鞋的故事',''),(2453,'双性恋',''),(2454,'爽电影',''),(2455,'爽片',''),(2456,'水晶冰凤',''),(2457,'睡着的武神',''),(2458,'私密处',''),(2459,'私人伴游',''),(2460,'私人陪护',''),(2461,'死刑过程',''),(2462,'死刑枪毙',''),(2463,'四海龙女',''),(2464,'四六级考题',''),(2465,'四奶',''),(2466,'四我周',''),(2467,'松花江污染',''),(2468,'苏东解体',''),(2469,'他妈的',''),(2470,'台湾身份证',''),(2471,'台湾性虎',''),(2472,'唐人电视台',''),(2473,'逃亡艳旅',''),(2474,'套弄',''),(2475,'套牌',''),(2476,'套图',''),(2477,'提供小姐',''),(2478,'天浴',''),(2479,'添逼',''),(2480,'添你下面',''),(2481,'添阴',''),(2482,'舔xue',''),(2483,'舔逼',''),(2484,'舔便',''),(2485,'舔遍',''),(2486,'舔肛',''),(2487,'舔花苞',''),(2488,'舔奶',''),(2489,'舔弄',''),(2490,'舔批',''),(2491,'舔舐',''),(2492,'舔吮',''),(2493,'舔下面',''),(2494,'舔穴',''),(2495,'舔阴',''),(2496,'厅房公主',''),(2497,'同性服务',''),(2498,'同性恋吧',''),(2499,'同淫',''),(2500,'同志服务',''),(2501,'童奴工',''),(2502,'痛批政法委',''),(2503,'偷电',''),(2504,'投注',''),(2505,'凸点装',''),(2506,'秃鹰',''),(2507,'突破封锁',''),(2508,'臀洞',''),(2509,'臀沟',''),(2510,'臀孔',''),(2511,'臀丘',''),(2512,'脱台',''),(2513,'外挂',''),(2514,'外海军火出售',''),(2515,'萬人暴',''),(2516,'王毓彬',''),(2517,'王子淫传',''),(2518,'网监',''),(2519,'网友自拍',''),(2520,'往事追忆录',''),(2521,'卫星锅',''),(2522,'卫星接收器',''),(2523,'卫星器',''),(2524,'卫星遭黑客攻击',''),(2525,'温家保',''),(2526,'温家堡',''),(2527,'温切斯特',''),(2528,'我包富婆',''),(2529,'我操',''),(2530,'我的性启蒙老师',''),(2531,'我周容',''),(2532,'无病毒无木马',''),(2533,'无毒无马',''),(2534,'无界浏览',''),(2535,'无界浏览器',''),(2536,'无码片',''),(2537,'无碼',''),(2538,'無碼',''),(2539,'五奶',''),(2540,'五奶小青',''),(2541,'午夜激情',''),(2542,'武警',''),(2543,'西藏暴动',''),(2544,'西藏天葬',''),(2545,'吸食',''),(2546,'吸舔',''),(2547,'下面的水',''),(2548,'厦门PX',''),(2549,'厦门大游行',''),(2550,'先烈的电话',''),(2551,'现代艳帝传奇',''),(2552,'限制级',''),(2553,'限制片',''),(2554,'相奸',''),(2555,'香港GHB水',''),(2556,'香港马会',''),(2557,'香舌',''),(2558,'想不到的黑幕',''),(2559,'销魂',''),(2560,'小jj',''),(2561,'小屄',''),(2562,'小洞',''),(2563,'小姐快餐',''),(2564,'小姐招募',''),(2565,'小姐招聘',''),(2566,'小姐招收',''),(2567,'小姐坐台',''),(2568,'小口径步枪',''),(2569,'小泉恶搞',''),(2570,'小姨子穴',''),(2571,'校花沉沦记',''),(2572,'校園文學',''),(2573,'邪恶的党',''),(2574,'泄题',''),(2575,'蟹骰',''),(2576,'新疆分裂主义',''),(2577,'新生网',''),(2578,'新诗年鉴',''),(2579,'信号复制器',''),(2580,'信号干扰器',''),(2581,'星光伴我淫',''),(2582,'刑警',''),(2583,'性爱教育',''),(2584,'性爱日记',''),(2585,'性爱网',''),(2586,'性爱文学',''),(2587,'性愛',''),(2588,'性吧',''),(2589,'性电影',''),(2590,'性服务工作者',''),(2591,'性高潮',''),(2592,'性教官',''),(2593,'性开放的',''),(2594,'性开放俱乐部',''),(2595,'性奴营',''),(2596,'性器',''),(2597,'性色社区',''),(2598,'性事',''),(2599,'性学教授',''),(2600,'性游戏',''),(2601,'性友谊',''),(2602,'性欲',''),(2603,'性欲泛滥',''),(2604,'性欲较强',''),(2605,'徐和柴学友',''),(2606,'穴洞',''),(2607,'穴口',''),(2608,'穴里',''),(2609,'穴前庭',''),(2610,'穴肉',''),(2611,'穴穴',''),(2612,'穴淫',''),(2613,'学生暴动',''),(2614,'学生与警察',''),(2615,'学位证书',''),(2616,'学校内部档案',''),(2617,'学运',''),(2618,'学运分子',''),(2619,'鸭子',''),(2620,'亚洲色图',''),(2621,'亞洲bt',''),(2622,'亞洲圖區',''),(2623,'艳狐软件',''),(2624,'艳门照',''),(2625,'艳情电影',''),(2626,'艳舞',''),(2627,'艳欲',''),(2628,'艳照门',''),(2629,'阳精',''),(2630,'阳具',''),(2631,'阳物',''),(2632,'杨林',''),(2633,'杨元元',''),(2634,'遥想当年春衫薄',''),(2635,'野外激情',''),(2636,'叶倩彤',''),(2637,'夜场兼职',''),(2638,'夜场女模特',''),(2639,'夜场招聘',''),(2640,'夜场直招',''),(2641,'夜总会公关',''),(2642,'夜总会模特',''),(2643,'夜总会招聘',''),(2644,'葉倩彤',''),(2645,'一安士海洛',''),(2646,'一波中特',''),(2647,'一蚕缠',''),(2648,'一码中特',''),(2649,'一四我',''),(2650,'一肖中特',''),(2651,'一夜情',''),(2652,'医师资格证',''),(2653,'医用乙醚',''),(2654,'倚天屠龙别记',''),(2655,'阴chun',''),(2656,'阴dao',''),(2657,'阴di',''),(2658,'阴壁',''),(2659,'阴部',''),(2660,'阴纯',''),(2661,'阴阜',''),(2662,'阴核',''),(2663,'阴护',''),(2664,'阴茎',''),(2665,'阴丘',''),(2666,'阴水',''),(2667,'阴穴',''),(2668,'陰部',''),(2669,'陰唇',''),(2670,'陰道',''),(2671,'陰蒂',''),(2672,'陰核',''),(2673,'陰戶',''),(2674,'陰户',''),(2675,'陰茎',''),(2676,'陰莖',''),(2677,'陰毛',''),(2678,'陰穴',''),(2679,'婬水',''),(2680,'淫b',''),(2681,'淫暴',''),(2682,'淫屄',''),(2683,'淫逼',''),(2684,'淫唇',''),(2685,'淫荡妈',''),(2686,'淫荡妹妹',''),(2687,'淫荡少妇',''),(2688,'淫荡娃娃',''),(2689,'淫蕩少婦',''),(2690,'淫蕩丗家',''),(2691,'淫蕩孕婦',''),(2692,'淫道',''),(2693,'淫电影',''),(2694,'淫洞',''),(2695,'淫妇',''),(2696,'淫棍',''),(2697,'淫秽词语',''),(2698,'淫间道',''),(2699,'淫叫',''),(2700,'淫浪',''),(2701,'淫乱电影',''),(2702,'淫亂',''),(2703,'淫美贴图',''),(2704,'淫妹',''),(2705,'淫民',''),(2706,'淫魔舞会',''),(2707,'淫男',''),(2708,'淫女',''),(2709,'淫虐',''),(2710,'淫片',''),(2711,'淫妻',''),(2712,'淫情女教师',''),(2713,'淫情贴图',''),(2714,'淫色',''),(2715,'淫色网站',''),(2716,'淫声',''),(2717,'淫兽学园',''),(2718,'淫术炼金士',''),(2719,'淫贴图',''),(2720,'淫图',''),(2721,'淫臀',''),(2722,'淫穴',''),(2723,'淫液',''),(2724,'淫阴',''),(2725,'淫影',''),(2726,'淫影片',''),(2727,'淫影院',''),(2728,'淫欲',''),(2729,'淫汁',''),(2730,'莹穴',''),(2731,'赢钱',''),(2732,'油田总部',''),(2733,'有码片',''),(2734,'有碼',''),(2735,'幼b',''),(2736,'幼逼',''),(2737,'幼女',''),(2738,'幼穴',''),(2739,'幼幼诱女',''),(2740,'诱惑电影',''),(2741,'诱惑视频',''),(2742,'诱奸',''),(2743,'诱人双峰',''),(2744,'娱乐城诚聘',''),(2745,'娱乐城招聘',''),(2746,'玉杵捣花径',''),(2747,'玉女吹箫',''),(2748,'玉穴',''),(2749,'欲生欲死',''),(2750,'欲仙欲死',''),(2751,'愈快乐愈堕落',''),(2752,'云雨图',''),(2753,'遭警察殴打',''),(2754,'造价工程师证',''),(2755,'曾道人',''),(2756,'张大权',''),(2757,'张开双腿',''),(2758,'招募小姐',''),(2759,'招女ds',''),(2760,'招女模',''),(2761,'招聘av',''),(2762,'招聘公主',''),(2763,'招聘兼职美女',''),(2764,'招聘模特',''),(2765,'招聘女模',''),(2766,'招聘小姐',''),(2767,'招聘坐台少爷',''),(2768,'招聘坐台小姐',''),(2769,'招收小姐',''),(2770,'招坐台少爷',''),(2771,'招坐台小姐',''),(2772,'赵紫阳',''),(2773,'趙紫陽',''),(2774,'这年头就这样',''),(2775,'针对台湾',''),(2776,'镇压学生',''),(2777,'证券从业资格',''),(2778,'证书办理',''),(2779,'执业药师',''),(2780,'执业医师',''),(2781,'执业证书',''),(2782,'智能H3',''),(2783,'智能Ｈ３',''),(2784,'中高级会计师',''),(2785,'中共独枭',''),(2786,'中共监狱',''),(2787,'中共警察',''),(2788,'中共流氓特务',''),(2789,'中共流氓政府',''),(2790,'中共流氓政权',''),(2791,'中共媒体',''),(2792,'中共迫害',''),(2793,'中共特务组织',''),(2794,'中共网特',''),(2795,'中共专制',''),(2796,'中国共产党亡',''),(2797,'中国军用运输机',''),(2798,'中国人都在上的四大当',''),(2799,'中级会计职称',''),(2800,'中央军委',''),(2801,'中原油田',''),(2802,'重题工',''),(2803,'周容重',''),(2804,'朱蒙',''),(2805,'朱镕基',''),(2806,'注册安全工程师',''),(2807,'注册备案资料',''),(2808,'注册会计师',''),(2809,'注册设备监理师',''),(2810,'注册税务师',''),(2811,'注册咨询工程师',''),(2812,'注册资产评估师',''),(2813,'专项整治',''),(2814,'追踪手机',''),(2815,'自拍区',''),(2816,'自慰',''),(2817,'自由亚州',''),(2818,'自制枪',''),(2819,'总统的讲话',''),(2820,'走光',''),(2821,'阻无通畅',''),(2822,'最牛钉子户',''),(2823,'最新黄站',''),(2824,'最淫官员',''),(2825,'作爱',''),(2826,'坐台公关',''),(2827,'做ai',''),(2828,'做爱',''),(2829,'做愛',''),(2830,'做要带套',''),(2831,'彩开',''),(2832,'彩资料',''),(2833,'内部单双',''),(2834,'彩曾',''),(2835,'100%包中',''),(2836,'四肖一码',''),(2837,'杀黑庄',''),(2838,'彩特',''),(2839,'码中心',''),(2840,'彩公司',''),(2841,'一肖彩经',''),(2842,'杀庄',''),(2843,'一肖新',''),(2844,'发财二码',''),(2845,'码主',''),(2846,'码庄',''),(2847,'传奇一条龙',''),(2848,'mir一条龙',''),(2849,'传奇游戏一条龙',''),(2850,'香港六合彩',''),(2851,'香港六和彩',''),(2852,'香港六和采',''),(2853,'香港六合采',''),(2854,'六合彩网',''),(2855,'六和彩网',''),(2856,'六和采网',''),(2857,'六合采网',''),(2858,'赚钱私服',''),(2859,'私服赚钱',''),(2860,'开私服时',''),(2861,'专业传奇一条龙',''),(2862,'私服一条龙',''),(2863,'劲舞团私服',''),(2864,'劲舞私服',''),(2865,'赌博系统',''),(2866,'魔兽私服',''),(2867,'魔域私服',''),(2868,'传世私服',''),(2869,'奇迹私服',''),(2870,'盛大私服',''),(2871,'巨人私服','巨人a');
/*!40000 ALTER TABLE `oscshop_bad_word` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_balance`
--

DROP TABLE IF EXISTS `oscshop_balance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_balance` (
  `bid` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `seller_id` int(11) NOT NULL COMMENT '卖家id',
  `money` float(10,2) NOT NULL COMMENT '结算金额',
  `redusmoney` float(10,2) NOT NULL COMMENT '扣除金额',
  `balance_time` int(10) NOT NULL COMMENT '结算日期',
  `state` tinyint(1) NOT NULL COMMENT '结算状态，0商家未确认，1：商家已确认，平台准备打开，2：平台已打款',
  `addtime` int(10) NOT NULL COMMENT '时钟运行时间',
  PRIMARY KEY (`bid`),
  KEY `seller_id` (`seller_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_balance`
--

LOCK TABLES `oscshop_balance` WRITE;
/*!40000 ALTER TABLE `oscshop_balance` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_balance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_balance_order`
--

DROP TABLE IF EXISTS `oscshop_balance_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_balance_order` (
  `boid` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `bid` int(10) NOT NULL COMMENT '结算id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `seller_id` int(10) NOT NULL COMMENT '卖家id',
  `money` float(10,2) NOT NULL COMMENT '结算金额',
  `redusmoney` float(10,2) NOT NULL COMMENT '扣除手续费金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`boid`),
  KEY `bid` (`bid`) USING BTREE,
  KEY `order_id` (`order_id`) USING BTREE,
  KEY `seller_id` (`seller_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_balance_order`
--

LOCK TABLES `oscshop_balance_order` WRITE;
/*!40000 ALTER TABLE `oscshop_balance_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_balance_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_bargain_goods`
--

DROP TABLE IF EXISTS `oscshop_bargain_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_bargain_goods` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `begin_time` int(10) NOT NULL COMMENT '开始时间',
  `end_time` int(10) NOT NULL COMMENT '结束时间',
  `bargain_count` int(10) NOT NULL COMMENT '砍价人数',
  `hour` float(10,2) NOT NULL COMMENT '砍价小时数',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `customer_id` int(10) NOT NULL COMMENT '所属商家',
  `bargain_price` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '砍价价格',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砍价商品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_bargain_goods`
--

LOCK TABLES `oscshop_bargain_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_bargain_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_bargain_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_bargain_order`
--

DROP TABLE IF EXISTS `oscshop_bargain_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_bargain_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `sku_str` varchar(255) NOT NULL COMMENT '规格，',
  `state` tinyint(1) NOT NULL COMMENT '状态，0进行中，1成功，2失败',
  `need_person` int(10) NOT NULL COMMENT '需要人数，',
  `total_person` int(10) DEFAULT '0' COMMENT '总需要多少人砍价',
  `total_money` float(10,2) DEFAULT NULL COMMENT '需要砍的总价',
  `deal_money` float(10,2) NOT NULL COMMENT '需要金额，',
  `begin_time` int(10) NOT NULL COMMENT '开始时间',
  `end_time` int(10) NOT NULL COMMENT '活动结束时间',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `address_id` int(10) NOT NULL COMMENT '会员收货地址',
  `is_share` tinyint(1) DEFAULT '0' COMMENT '是否分享过，分享过后，多砍一次价',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='好友砍价订单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_bargain_order`
--

LOCK TABLES `oscshop_bargain_order` WRITE;
/*!40000 ALTER TABLE `oscshop_bargain_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_bargain_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_bargain_order_detail`
--

DROP TABLE IF EXISTS `oscshop_bargain_order_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_bargain_order_detail` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '砍价的会员id',
  `kan_money` float(10,2) DEFAULT '0.00' COMMENT '砍价金额',
  `bargain_order_id` int(10) NOT NULL COMMENT '砍价人数',
  `addtime` int(10) NOT NULL COMMENT '砍价时间',
  `is_sleft` tinyint(1) DEFAULT '0' COMMENT '0不是自己，1是自己',
  `avatar` varchar(255) DEFAULT NULL COMMENT '头像',
  `nickname` varchar(255) DEFAULT NULL COMMENT '昵称',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砍价详情表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_bargain_order_detail`
--

LOCK TABLES `oscshop_bargain_order_detail` WRITE;
/*!40000 ALTER TABLE `oscshop_bargain_order_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_bargain_order_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_blog`
--

DROP TABLE IF EXISTS `oscshop_blog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_blog` (
  `blog_id` int(11) NOT NULL AUTO_INCREMENT,
  `category_id` int(11) NOT NULL,
  `type` enum('seller','pinjie','question','pc_news') DEFAULT NULL COMMENT '文章类型，seller 卖家后台查看，pinjie 拼团介绍，question 常见问题',
  `meta_keywords` varchar(128) NOT NULL,
  `meta_description` varchar(255) NOT NULL,
  `title` varchar(64) NOT NULL,
  `image` varchar(64) NOT NULL,
  `author` varchar(20) NOT NULL COMMENT '作者',
  `read_num` int(11) NOT NULL COMMENT '点击次数',
  `create_time` datetime NOT NULL COMMENT '创建时间',
  `update_time` datetime NOT NULL COMMENT '更新时间',
  `status` tinyint(1) NOT NULL COMMENT '状态',
  `reply` int(11) NOT NULL COMMENT '回复数量',
  `allow_reply` tinyint(1) NOT NULL COMMENT '是否可以评论',
  PRIMARY KEY (`blog_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_blog`
--

LOCK TABLES `oscshop_blog` WRITE;
/*!40000 ALTER TABLE `oscshop_blog` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_blog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_blog_category`
--

DROP TABLE IF EXISTS `oscshop_blog_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_blog_category` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '文档ID',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上级分类ID',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '标题',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '排序（同级有效）',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='后台菜单';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_blog_category`
--

LOCK TABLES `oscshop_blog_category` WRITE;
/*!40000 ALTER TABLE `oscshop_blog_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_blog_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_blog_content`
--

DROP TABLE IF EXISTS `oscshop_blog_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_blog_content` (
  `blog_id` int(11) NOT NULL,
  `summary` varchar(255) NOT NULL COMMENT '内容摘要',
  `content` text NOT NULL COMMENT '博客内容',
  KEY `article_id` (`blog_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_blog_content`
--

LOCK TABLES `oscshop_blog_content` WRITE;
/*!40000 ALTER TABLE `oscshop_blog_content` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_blog_content` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_blog_image`
--

DROP TABLE IF EXISTS `oscshop_blog_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_blog_image` (
  `blog_image_id` int(11) NOT NULL AUTO_INCREMENT,
  `blog_id` int(11) NOT NULL,
  `image` varchar(64) NOT NULL,
  `title` varchar(64) NOT NULL,
  `sort_order` int(11) NOT NULL,
  PRIMARY KEY (`blog_image_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_blog_image`
--

LOCK TABLES `oscshop_blog_image` WRITE;
/*!40000 ALTER TABLE `oscshop_blog_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_blog_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_blog_reply`
--

DROP TABLE IF EXISTS `oscshop_blog_reply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_blog_reply` (
  `reply_id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL COMMENT '标题',
  `content` text NOT NULL COMMENT '评论内容',
  `email` varchar(64) NOT NULL,
  `blog_id` int(11) NOT NULL COMMENT '所属文章',
  `ip` varchar(64) NOT NULL,
  `ip_region` varchar(20) NOT NULL,
  `create_time` datetime NOT NULL,
  `status` tinyint(1) NOT NULL,
  `device` varchar(255) NOT NULL COMMENT '设备',
  PRIMARY KEY (`reply_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_blog_reply`
--

LOCK TABLES `oscshop_blog_reply` WRITE;
/*!40000 ALTER TABLE `oscshop_blog_reply` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_blog_reply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_blog_seller_order`
--

DROP TABLE IF EXISTS `oscshop_blog_seller_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_blog_seller_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `blog_id` int(10) NOT NULL,
  `seller_id` int(10) NOT NULL,
  `addtime` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `blog_id` (`blog_id`,`seller_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='后台通知查看记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_blog_seller_order`
--

LOCK TABLES `oscshop_blog_seller_order` WRITE;
/*!40000 ALTER TABLE `oscshop_blog_seller_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_blog_seller_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_car`
--

DROP TABLE IF EXISTS `oscshop_car`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_car` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `token` varchar(200) NOT NULL COMMENT '客户端token,会员身份',
  `carkey` varchar(255) NOT NULL COMMENT '购物车key',
  `format_data` text NOT NULL COMMENT '购物车商品参数',
  `modifytime` int(10) DEFAULT '0' COMMENT '加入购物车时间',
  PRIMARY KEY (`id`),
  KEY `token` (`token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='客户端购物车表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_car`
--

LOCK TABLES `oscshop_car` WRITE;
/*!40000 ALTER TABLE `oscshop_car` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_car` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_comment`
--

DROP TABLE IF EXISTS `oscshop_comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_comment` (
  `comment_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL COMMENT '姓名',
  `email` varchar(20) NOT NULL COMMENT '电子邮件',
  `tel` varchar(40) NOT NULL COMMENT '电话',
  `content` text NOT NULL COMMENT '内容',
  `ip` varchar(40) NOT NULL COMMENT 'ip地址',
  `ip_region` varchar(20) NOT NULL,
  `create_time` int(11) NOT NULL,
  `create_time_date` datetime NOT NULL,
  `device` varchar(255) NOT NULL COMMENT '使用的设备',
  PRIMARY KEY (`comment_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='留言';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_comment`
--

LOCK TABLES `oscshop_comment` WRITE;
/*!40000 ALTER TABLE `oscshop_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_config`
--

DROP TABLE IF EXISTS `oscshop_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_config` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '配置ID',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '配置名称',
  `config_group` varchar(20) NOT NULL COMMENT '配置分组',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `value` text NOT NULL COMMENT '配置值',
  `info` varchar(255) NOT NULL COMMENT '描述',
  `sort` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  PRIMARY KEY (`id`),
  UNIQUE KEY `uk_name` (`name`),
  KEY `group` (`config_group`)
) ENGINE=InnoDB AUTO_INCREMENT=168 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_config`
--

LOCK TABLES `oscshop_config` WRITE;
/*!40000 ALTER TABLE `oscshop_config` DISABLE KEYS */;
INSERT INTO `oscshop_config` VALUES (7,'SMTP_HOST','smtp',1448266020,'smtp.qq.com','',0),(8,'SMTP_PORT','smtp',1448266020,'25','',0),(9,'SMTP_USER','smtp',1448266020,'yc@91ycc.com','',0),(10,'SMTP_PASS','smtp',1448266020,'ataxwzyrevuycaag','',0),(11,'FROM_EMAIL','smtp',1448266020,'yc@91ycc.com','',0),(12,'FROM_NAME','smtp',1448266020,'oscshop','',0),(13,'SITE_TITLE','site',1448285156,'狮子鱼拼团蘑菇街单商户版','',0),(14,'SITE_NAME','site',1448285156,'lionfish','',0),(15,'SITE_DESCRIPTION','site',1448285156,'狮子鱼拼团系统','',0),(16,'SITE_KEYWORDS','site',1448285156,'狮子鱼拼团系统','',0),(17,'SITE_URL','site',1448285156,'https://aazhishifan.com/','',0),(18,'SHORT_URL','site',1448285156,'','',0),(19,'SITE_ICP','site',1448285156,'闽icp备8787','ICP备案号',0),(20,'EMAIL','site',1448285156,'','',0),(21,'TELEPHONE','site',1448285156,'','',0),(22,'WEB_SITE_CLOSE','site',1448285156,'1','',0),(23,'common_image_thumb_width','image',1448293183,'255','',0),(24,'common_image_thumb_height','image',1448293183,'255','',0),(25,'gallery_thumb_width','image',1448293183,'127','',0),(26,'gallery_thumb_height','image',1448293183,'127','',0),(27,'gallery_related_thumb_width','image',1448293183,'150','',0),(28,'gallery_related_thumb_height','image',1448293183,'150','',0),(29,'blog_list_thumb_width','image',1448293183,'280','',0),(30,'blog_list_thumb_height','image',1448293183,'140','',0),(31,'goods_thumb_width','image',1448293183,'640','',0),(32,'goods_thumb_height','image',1448293183,'400','',0),(33,'goods_gallery_thumb_width','image',1448293183,'640','',0),(34,'goods_gallery_thumb_height','image',1448293183,'400','',0),(35,'goods_cart_thumb_width','image',1448293183,'80','',0),(36,'goods_cart_thumb_height','image',1448293183,'80','',0),(39,'length_class_id','other',1448588459,'2','',0),(40,'WEIGHT_ID','other',1448588459,'1','',0),(41,'FRONT_PAGE_NUM','other',1448588459,'8','',0),(42,'BACK_PAGE_NUM','other',1448588459,'20','',0),(43,'default_order_status_id','other',1448588459,'3','',0),(44,'paid_order_status_id','other',1448588459,'1','',0),(45,'complete_order_status_id','other',1448588459,'4','',0),(47,'URL_ID','other',1448588459,'10','',0),(48,'SITE_SLOGAN','site',1448285156,'狮子鱼拼团系统','',0),(51,'cancel_order_status_id','other',0,'5','',0),(52,'BLOG_TITLE','other',0,'博客','',0),(53,'SITE_ICON','site',0,'shop/2017-12-07/5a289c5d4cdf6.png','网站图标',0),(54,'goods_related_thumb_width','image',0,'280','',0),(55,'goods_related_thumb_height','image',0,'280','',0),(59,'PWD_KEY','site',1469757362,'aF;[Oo!~ds/ClKGkx=.z9pc]1}8&VHb0D#eyq7^6','',0),(60,'spike_thumb_width','image',0,'180','限时秒杀图片宽度',0),(61,'spike_thumb_height','image',0,'180','限时秒杀图片高度',0),(62,'HAITAO','other',0,'6','海淘分类id，请填写一级分类id，用户前台调用海淘商品',0),(63,'APPID','site',0,'wx80131aa7dfc4ff71','微信APPID',0),(64,'APPSECRET','site',0,'270830624fb0ccc6df8977645f75f33f','微信APPSECRET',0),(65,'MCHID','site',0,'1246637501','微信商户号',0),(66,'VERSION','site',0,'V4.2','系统版本',0),(67,'deliverNoticeId','weixin',0,'eGWpyoJInWgSNYdnkujvjAIF9hbJIGm4p4tDCwcmURI','订单标记发货通知',0),(68,'groupResultId','weixin',0,'jfNyI5kK7X5pyAaxkCmU2gRqjLB91fl_u1X0FVNWC0A','团购结果通知',0),(69,'expireId','weixin',0,'eceRXDPx1NnK7aR8Bp19hic0mcHMYl7rl74evMopxCU','到期提醒',0),(70,'joinGroupId','weixin',0,'9-XTIeZM_SLvRPy_P0dkdx36g5qIcZ_i35hhcoPcVcA','参团提醒',0),(71,'refundNoticeId','weixin',0,'TSALUPKOVdRm_HnyjZ7SIQHNPfgHXS4LSrEGlfff948','退款通知',0),(72,'customerResultId','weixin',0,'F2Utd_5ynVp1ad5DwFC2_a99lo3j8NLhFL6DdbA1nkI','客服处理提醒',0),(73,'awardResultId','weixin',0,'_CbY2H1sWm0eI5NXnZt9NoQG0YyGoRXY8i5z8sWcdPg','中奖结果通知',0),(74,'newOrdersNoticeId','weixin',0,'bBcn_N0dUuMkY_TDoOVfrNazO5hjsJQ-i2SocNFPHvA','最新订单信息提醒',0),(75,'verifyNoticeId','weixin',0,'ix9-WxwHbcp2bIsX8B63VS4CGjXKNKp7DFiBHIr7C8I','核销成功提醒',0),(76,'sendQuanNotice','weixin',0,'9y5fPX5XcusYN-oa-GzFX2bpA5w79Cmv7sB1a_8IBnY','赠送优惠券提醒',0),(77,'opencommiss','site',0,'1','是否开启分销',0),(78,'openhaitao','site',0,'0','是否开启分\r\n\r\n销',0),(79,'shenhegoods','site',0,'0','是否需要审核',0),(80,'autogetday','site',0,'15','自动确认收货时间',0),(81,'OPEN_COMMENT','site',0,'1','',0),(82,'autoshenrefundday','site',0,'5','',0),(83,'admin_backimage','site',0,'','',0),(84,'seller_backimage','site',0,'goods/2017-12-07/5a289c1cb2df2.png','',0),(85,'index_ly_image','site',0,'','',0),(86,'fan_ly_image','site',0,'','',0),(87,'site_tel','site',0,'','',0),(88,'site_woketime','site',0,'9:00-18:00','',0),(89,'site_qqun','site',0,'888888888','',0),(90,'admin_xxximage','site',0,'goods/2017-12-07/5a289c21b9f0b.png','',0),(91,'GoodsOnNoticeId','weixin',0,'','商品到货通知',0),(92,'kucun_method','site',0,'0','减库存方式',0),(93,'user_qrcode_image','site',0,'','团长二维码背景',0),(94,'user_qrcode_x','site',0,'','团长二维码X坐标',0),(95,'user_qrcode_y','site',0,'','团长二维码Y坐标',0),(96,'ziti_shouhuo','site',0,'0','',0),(97,'WATER_BG','site',0,'','',0),(98,'commiss_money_limit','site',0,'0','提现最小金额',0),(99,'EXPRESS_EBUSS_ID','other',0,'','快递鸟商户id',0),(100,'EXPRESS_APPKEY','other',0,'','',0),(101,'EXPRESS_OPEN','other',0,'0','',0),(102,'VOUCHER_FREE_STATE','site',0,'0','免单券状态',0),(103,'VOUCHER_FREE_DESC','site',0,'','免单券描述',0),(104,'VOUCHER_FREE_IMAGE','site',0,'','免单券封面图(360*240)',0),(105,'lottery_msg_title','site',0,'','',0),(106,'lottery_msg_desc','site',0,'','',0),(107,'weixin_group','site',0,'','',0),(108,'copyright','site',0,'狮子鱼','',0),(109,'open_duokefu','site',0,'1','',0),(110,'expr_day','site',0,'7','抽奖商品回收时间',0),(111,'kefu_person_need','site',1,'5','客服接待用户能力',0),(112,'subject_baom','site',0,'0','',0),(113,'open_sms','site',0,'0','审核成功商家发送短信',0),(114,'sms_username','site',0,'','',0),(115,'sms_password','site',0,'','',0),(116,'sms_template','site',0,'','',0),(117,'sms_userid','site',0,'','',0),(118,'index_searchkeywords','site',0,'连衣裙,小白鞋,省心套装,碎花连衣裙,明星同款,高跟鞋,美妆,墨镜','首页关键词配置',0),(119,'weprogram_appid','weixin',0,'wx0c95abbbc01623ba','微信小程序的APPID',0),(120,'weprogram_appscret','weixin',0,'e974cdfc8edeaf69b88a97fe7497b64e','微信小程序的appscret',0),(121,'weprogram_pay_key','weixin',0,'dfjalksdjflkasdjfklsdjksdjfakljd','微信小程序支付key',0),(122,'weprogram_mch_id','weixin',0,'1246637501','微信小程序商户id',0),(123,'weprogram_template_take_pin','weixin',0,'dIOGduRb8S28Ktp7Y-zocQUgOdSfeFgfJ3BsjM3-hZY','拼团参与通知',0),(124,'weprogram_template_success_pin','weixin',0,'ygij9h-Rbll02yeglFnJq58fr2SGym_6cYi3jLadpQw','拼团成功通知',0),(125,'weprogram_template_fail_pin','weixin',0,'51--pbSW9KS-rGLeSsDAjRGCMOTNDJDqJH9PtwMYvLw','拼团失败通知',0),(126,'weprogram_template_refund_order','weixin',0,' 74vjSjyQPfLirwpecSbDJEWfE_klsgUKL2kuF6uWiZY','退款成功通知',0),(127,'weprogram_template_tip_pin','weixin',0,'hE_nDnLGXFa9yPOO0o33-mOM9hgxVq1Rzs8fV1RfR90','参团人数不足通知',0),(128,'weprogram_template_pay_order','weixin',0,'8YX436RNVanBF1JHaBeorjL-gJqyh9CrOAzhWEIzmBE','订单支付成功通知',0),(129,'weprogram_template_lottery_result','weixin',0,'1CCajAjY9BxPfOJ3w4XTwYQEuVXSlDaReZguYH7qkfg','抽奖结果通知',0),(130,'weprogram_template_open_pin','weixin',0,'pUBO0lF2JF3yXet39pnDAJet7pLneZe34GTKFHHTsLg','拼团开团通知',0),(131,'weprogram_template_send_order','weixin',0,'EVzcEN5J8mD64wNuliTJxV_P3x7z8Lt1c4pSgqrG54Q','订单发货提醒',0),(132,'index_share_titile','site',0,'自定义分享-狮子鱼拼团系统','首页分享标题自定义',0),(133,'commiss_level_num','site',0,'3','分销等级',0),(134,'wxprog_member_take_in','weixin',0,'nKhUP1r7ObhiH_JdjA-EWz3cvZLkalEUnWHsESy_zuU','新会员加入通知',0),(135,'weprog_neworder_commiss','weixin',0,'AfH6DlMZqv83uysJxbipkuOQMErrOXDE23ncKJakzM0','分销会员订单佣金',0),(136,'weprogram_template_hexiao_success','weixin',0,'','核销成功',0),(137,'kefu_wait_msg','site',0,'','卖家不在线留言',0),(138,'24hours_new_sg','site',0,'','24小时后访问首次自动回复',0),(139,'kan_description','site',0,'1.砍价活动不涉及任何支付行为； 2.发起砍价只需填写收货信息，用于砍价成功后的发货，不收取任何费用包括邮费； 3.帮忙砍价不需要提供任何信息，帮好友砍价即可； 4.拼多多承诺保护消费者的信息，放心砍价免费拿！ ','砍价活动介绍',0),(140,'kan_rules','site',0,'1.邀请好友一起砍价，在24小时内砍到0元即可免费领取商品； 2.每次砍价金额随机，参与好友越多越容易成功； 3.您每天最多能帮助3个好友砍价，对于同一个砍价，只能帮助砍价一次； 4.帮好友砍价，可以随机获得【宝刀】哦； 5.【宝刀】可以在自己砍价时使用，每个砍价可使用一次宝刀，金额随机（最多可以直接砍到0元）； 6.拼多多可在法律法规允许范围内对活动规则解释；','砍价规则',0),(141,'kan_person_count','site',0,'3','每人每天帮好友砍价数量',0),(142,'weprogram_template_kan_msg','weixin',0,'','',0),(143,'THEME_TYPE','site',0,'','前端主题类型',0),(144,'buy_send_score','site',0,'','购物返积分',0),(145,'integral_description','site',0,'','积分商城兑换规则',0),(146,'is_open_integral','site',0,'1','是否开启积分商城',0),(147,'member_default_levelname','site',0,'默认会员','会员默认等级默认折扣',0),(148,'member_defualt_discount','site',0,'100','会员默认等级默认折扣',0),(149,'member_level_is_open','site',0,'0','是否开启会员等级',0),(150,'is_open_fissionbonus','site',0,'0','开启红包裂变功能',0),(151,'distribute_type','site',0,'0','红包分配方式，0随机，1平均',0),(152,'bonus_count','site',0,'4','红包人数',0),(153,'bonus_money','site',0,'1','红包总金额',0),(154,'bonus_game_time','site',0,'12','拆红包有效时间',0),(155,'bonus_rule','site',0,'拆红包','活动规则',0),(156,'bonus_share_title','site',0,'','红包分享标题',0),(157,'is_yue_open','site',0,'0','开启余额支付',0),(158,'member_upgrade_msg','weixin',0,'','会员升级模板消息通知',0),(159,'fissionbonus_index_image','site',0,'','首页裂变弹窗图片',0),(160,'fissionbonus_detail_image','site',0,'','红包详情页弹出窗口',0),(161,'fissionbonus_index_tan','site',0,'1','开启首页弹窗',0),(162,'fissionbonus_share_image','site',0,'','裂变红包分享图',0),(163,'is_open_fissionsharing','site',0,'0','是否开启裂变分享',0),(164,'fissionsharing_level','site',0,'1','裂变分享等级',0),(165,'show_fissionsharing_level','site',0,'1','前台展示级数',0),(166,'fissionsharing_type','site',0,'1','裂变分享方式',0),(167,'fissionsharing_effecttime','site',0,'0','分享链接过期时间',0);
/*!40000 ALTER TABLE `oscshop_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_core_attachment`
--

DROP TABLE IF EXISTS `oscshop_core_attachment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_core_attachment` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uniacid` int(10) unsigned NOT NULL,
  `uid` int(10) unsigned NOT NULL,
  `filename` varchar(255) NOT NULL,
  `attachment` varchar(255) NOT NULL,
  `type` tinyint(3) unsigned NOT NULL,
  `createtime` int(10) unsigned NOT NULL,
  `module_upload_dir` varchar(100) NOT NULL,
  `group_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=44 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_core_attachment`
--

LOCK TABLES `oscshop_core_attachment` WRITE;
/*!40000 ALTER TABLE `oscshop_core_attachment` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_core_attachment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_core_attachment_group`
--

DROP TABLE IF EXISTS `oscshop_core_attachment_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_core_attachment_group` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(100) NOT NULL COMMENT '分类名称',
  `uniacid` int(10) NOT NULL,
  `uid` int(10) NOT NULL DEFAULT '1' COMMENT '默认都是1',
  `type` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城图片分类表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_core_attachment_group`
--

LOCK TABLES `oscshop_core_attachment_group` WRITE;
/*!40000 ALTER TABLE `oscshop_core_attachment_group` DISABLE KEYS */;
INSERT INTO `oscshop_core_attachment_group` VALUES (1,'未命名',0,1,0);
/*!40000 ALTER TABLE `oscshop_core_attachment_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_fen_tixian_order`
--

DROP TABLE IF EXISTS `oscshop_fen_tixian_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_fen_tixian_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0申请中，1提现成功，2体现失败',
  `shentime` int(10) NOT NULL COMMENT '审核时间',
  `addtime` int(10) NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分销佣金提现表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_fen_tixian_order`
--

LOCK TABLES `oscshop_fen_tixian_order` WRITE;
/*!40000 ALTER TABLE `oscshop_fen_tixian_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_fen_tixian_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_fissionbonus`
--

DROP TABLE IF EXISTS `oscshop_fissionbonus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_fissionbonus` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `count` int(10) NOT NULL COMMENT '分享人数',
  `bonus_ser` text NOT NULL COMMENT '裂变红包金额队列',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '状态，0未成功，1已经成功',
  `begin_time` int(10) NOT NULL COMMENT '开始时间',
  `end_time` int(10) NOT NULL COMMENT '结束时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城裂变红包表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_fissionbonus`
--

LOCK TABLES `oscshop_fissionbonus` WRITE;
/*!40000 ALTER TABLE `oscshop_fissionbonus` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_fissionbonus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_fissionbonus_flow`
--

DROP TABLE IF EXISTS `oscshop_fissionbonus_flow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_fissionbonus_flow` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `fissionbonus_id` int(10) NOT NULL COMMENT '来源订单id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `send_member_id` int(10) NOT NULL COMMENT '点击人id',
  `money` decimal(10,2) NOT NULL COMMENT '金额',
  `type` tinyint(1) NOT NULL COMMENT '1:自己签到，2：别人帮忙金额得到 3，给别人点赞得到金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `fissionbonus_id` (`fissionbonus_id`,`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城裂变红包流水表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_fissionbonus_flow`
--

LOCK TABLES `oscshop_fissionbonus_flow` WRITE;
/*!40000 ALTER TABLE `oscshop_fissionbonus_flow` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_fissionbonus_flow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_fissionbonus_order`
--

DROP TABLE IF EXISTS `oscshop_fissionbonus_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_fissionbonus_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `fissionbonus_id` int(10) NOT NULL COMMENT '订单id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `is_self` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否自己的签到，0否，1是',
  `is_notify` tinyint(1) DEFAULT '0' COMMENT '是否通知，0未通知，1已经通知',
  `money` decimal(10,2) NOT NULL COMMENT '红包金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `fissionbonus_id` (`fissionbonus_id`,`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城裂变红包订单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_fissionbonus_order`
--

LOCK TABLES `oscshop_fissionbonus_order` WRITE;
/*!40000 ALTER TABLE `oscshop_fissionbonus_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_fissionbonus_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_fissionsharing_link`
--

DROP TABLE IF EXISTS `oscshop_fissionsharing_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_fissionsharing_link` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `type` enum('page','goods') NOT NULL COMMENT '记录类型',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `share_one_id` int(10) NOT NULL COMMENT '1级分享会员id',
  `share_two_id` int(10) NOT NULL COMMENT '二级分享会员id',
  `share_three_id` int(10) NOT NULL COMMENT '三级分销会员id',
  `modify_time` int(10) NOT NULL COMMENT '最近修改时间',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`,`member_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='分享裂变分享情况记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_fissionsharing_link`
--

LOCK TABLES `oscshop_fissionsharing_link` WRITE;
/*!40000 ALTER TABLE `oscshop_fissionsharing_link` DISABLE KEYS */;
INSERT INTO `oscshop_fissionsharing_link` VALUES (1,'page',0,0,0,0,0,1599036624);
/*!40000 ALTER TABLE `oscshop_fissionsharing_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods`
--

DROP TABLE IF EXISTS `oscshop_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods` (
  `goods_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `model` varchar(64) NOT NULL COMMENT '商品型号',
  `sku` varchar(64) NOT NULL COMMENT '库存单元',
  `is_index_show` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否推荐首页显示',
  `is_all_sale` tinyint(1) DEFAULT '0' COMMENT '是否所有团长售卖',
  `index_sort` int(10) NOT NULL DEFAULT '0' COMMENT '首页商品排序',
  `seller_count` int(11) NOT NULL DEFAULT '0' COMMENT '真实销售数量',
  `virtual_count` int(10) NOT NULL DEFAULT '0' COMMENT '虚拟销售数量',
  `quantity` int(4) NOT NULL DEFAULT '0' COMMENT '商品数目',
  `head_disc` int(10) DEFAULT '100' COMMENT '团长折扣',
  `image` varchar(255) DEFAULT NULL,
  `fan_image` varchar(255) DEFAULT NULL COMMENT '商品方形图片',
  `store_id` int(11) NOT NULL DEFAULT '0' COMMENT '商家id（关联seller主键）',
  `stock_status_id` int(11) NOT NULL COMMENT '库存状态编号（关联stock_status主键）',
  `shipping` tinyint(1) NOT NULL DEFAULT '1' COMMENT '统一运费或者使用运费模板',
  `pick_just` tinyint(1) DEFAULT '0' COMMENT '是否仅自提',
  `pick_up` varchar(255) DEFAULT NULL COMMENT '自提点信息',
  `is_free_in` tinyint(1) DEFAULT '0' COMMENT '参加免单团',
  `express_list` varchar(255) DEFAULT NULL COMMENT '选中快递列表',
  `goods_freight` decimal(10,2) DEFAULT '0.00' COMMENT '运费 0为免运费',
  `transport_id` mediumint(8) DEFAULT '0' COMMENT '运费模板id',
  `price` decimal(15,2) NOT NULL DEFAULT '0.00' COMMENT '商品价格',
  `danprice` decimal(15,2) NOT NULL DEFAULT '0.00' COMMENT '单独购买价格',
  `points` int(8) NOT NULL DEFAULT '0' COMMENT '积分',
  `type` enum('lottery','subject','zeyuan','super_spike','spike','pintuan','oneyuan','haitao','normal','bargain','integral') DEFAULT 'normal' COMMENT '商品类型：normal普通商品，spike限时秒杀，super_spike超值大牌，zeyuan免费试用，subject主题活动，lottery抽奖,niyuan9.9元主题活动,oneyuan一元主题活动,haitao海淘活动',
  `lock_type` enum('normal','spike','super_spike','zeyuan','subject','niyuan','oneyuan','haitao','bargain','lottery','pintuan','newman') DEFAULT 'normal' COMMENT '商品类型：normal普通商品，spike限时秒杀，super_spike超值大牌，zeyuan免费试用，subject主题活动，lottery抽奖,niyuan9.9元，oneyuan1元购'',haitao海淘活动',
  `lock_price` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否锁定价格',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `date_added` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT '加入时间',
  `date_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT '修改的时间',
  `weight` decimal(15,2) DEFAULT '0.00' COMMENT '重量(kg)',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods`
--

LOCK TABLES `oscshop_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_area`
--

DROP TABLE IF EXISTS `oscshop_goods_area`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_area` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `goods_id` int(10) NOT NULL DEFAULT '0',
  `area_ids_text` text,
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_area`
--

LOCK TABLES `oscshop_goods_area` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_area` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_area` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_category`
--

DROP TABLE IF EXISTS `oscshop_goods_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_category` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上级分类ID',
  `is_search` tinyint(1) NOT NULL DEFAULT '1' COMMENT '是否搜索页显示，0不显示，1显示',
  `is_haitao` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否海淘分类，0否，1是',
  `is_hot` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否推荐到导航条显示',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '标题',
  `logo` varchar(255) DEFAULT NULL COMMENT '商品分类logo',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  `c_sort_order` int(10) NOT NULL DEFAULT '0' COMMENT '搜索页排序',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品分类';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_category`
--

LOCK TABLES `oscshop_goods_category` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_description`
--

DROP TABLE IF EXISTS `oscshop_goods_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_description` (
  `goods_id` int(11) NOT NULL,
  `summary` varchar(255) NOT NULL COMMENT '产品简介',
  `activity_summary` text COMMENT '互动规则',
  `description` text NOT NULL COMMENT '商品详情',
  `is_untake_level` tinyint(1) DEFAULT '0' COMMENT '是否不参与会员折扣',
  `level_discount` varchar(255) DEFAULT NULL COMMENT '商品会员折扣',
  `video_src` varchar(255) DEFAULT NULL COMMENT '视频地址',
  `video_size_width` varchar(50) DEFAULT '0' COMMENT '视频尺寸',
  `vedio_size_height` varchar(20) DEFAULT '0' COMMENT '视频高度',
  `is_video` tinyint(1) DEFAULT '0' COMMENT '是否视频',
  `share_group_title` varchar(255) DEFAULT NULL COMMENT '拼团详细页自定义分享',
  `water_image` varchar(255) DEFAULT NULL COMMENT '加水印分享图片',
  `wepro_qrcode_image` varchar(255) DEFAULT NULL COMMENT '小程序商品分享图',
  `tag` text NOT NULL COMMENT '产品标签',
  `per_number` int(10) DEFAULT '0' COMMENT '每人限购数量',
  `share_title` varchar(200) DEFAULT NULL COMMENT '自定义分享标题',
  `share_descript` varchar(255) DEFAULT NULL COMMENT '自定义分享描述',
  `reason` varchar(255) DEFAULT NULL COMMENT '审核原因',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='产品信息描述表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_description`
--

LOCK TABLES `oscshop_goods_description` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_description` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_description` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_discount`
--

DROP TABLE IF EXISTS `oscshop_goods_discount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_discount` (
  `product_discount_id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_id` int(11) NOT NULL,
  `quantity` int(4) NOT NULL DEFAULT '0',
  `price` decimal(15,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`product_discount_id`),
  KEY `product_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='数量折扣';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_discount`
--

LOCK TABLES `oscshop_goods_discount` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_discount` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_discount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_image`
--

DROP TABLE IF EXISTS `oscshop_goods_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_image` (
  `goods_image_id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_id` int(11) NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `sort_order` int(3) NOT NULL DEFAULT '0',
  `is_video_click` tinyint(1) DEFAULT '0' COMMENT '是否视频点击',
  PRIMARY KEY (`goods_image_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品图片表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_image`
--

LOCK TABLES `oscshop_goods_image` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_option`
--

DROP TABLE IF EXISTS `oscshop_goods_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_option` (
  `goods_option_id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_id` int(11) NOT NULL,
  `option_id` int(11) NOT NULL,
  `option_name` varchar(64) NOT NULL,
  `type` varchar(40) NOT NULL,
  `required` tinyint(1) NOT NULL,
  PRIMARY KEY (`goods_option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_option`
--

LOCK TABLES `oscshop_goods_option` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_option_mult_value`
--

DROP TABLE IF EXISTS `oscshop_goods_option_mult_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_option_mult_value` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rela_goodsoption_valueid` varchar(50) NOT NULL COMMENT '关联属性id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `pin_price` float(10,2) NOT NULL COMMENT '拼团价格',
  `dan_price` float(10,2) NOT NULL COMMENT '单独价格',
  `quantity` int(10) NOT NULL COMMENT '库存数量',
  `image` varchar(255) NOT NULL COMMENT '图片',
  `weight` float(10,2) DEFAULT '0.00',
  PRIMARY KEY (`id`),
  KEY `rela_goodsoption_valueid` (`rela_goodsoption_valueid`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='多规格属性表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_option_mult_value`
--

LOCK TABLES `oscshop_goods_option_mult_value` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_option_mult_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_option_mult_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_option_value`
--

DROP TABLE IF EXISTS `oscshop_goods_option_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_option_value` (
  `goods_option_value_id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_option_id` int(11) NOT NULL,
  `goods_id` int(11) NOT NULL,
  `option_id` int(11) NOT NULL,
  `option_value_id` int(11) NOT NULL,
  `image` varchar(255) NOT NULL,
  `quantity` int(3) NOT NULL,
  `subtract` tinyint(1) NOT NULL,
  `price` decimal(15,4) NOT NULL,
  `price_prefix` varchar(1) NOT NULL,
  `weight` decimal(15,8) NOT NULL,
  `weight_prefix` varchar(1) NOT NULL,
  PRIMARY KEY (`goods_option_value_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_option_value`
--

LOCK TABLES `oscshop_goods_option_value` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_option_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_option_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_share_image`
--

DROP TABLE IF EXISTS `oscshop_goods_share_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_share_image` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `image_path` varchar(255) NOT NULL COMMENT '图片路径',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='会员商品分享图';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_share_image`
--

LOCK TABLES `oscshop_goods_share_image` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_share_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_share_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_goods_to_category`
--

DROP TABLE IF EXISTS `oscshop_goods_to_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_goods_to_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_id` int(11) NOT NULL,
  `class_id1` int(11) NOT NULL,
  `class_id2` int(11) NOT NULL,
  `class_id3` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `pk` (`goods_id`,`class_id1`,`class_id2`,`class_id3`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品对应分类表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_goods_to_category`
--

LOCK TABLES `oscshop_goods_to_category` WRITE;
/*!40000 ALTER TABLE `oscshop_goods_to_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_goods_to_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_group`
--

DROP TABLE IF EXISTS `oscshop_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_group` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `seller_id` int(10) NOT NULL COMMENT '所属商家',
  `title` varchar(255) NOT NULL COMMENT '圈子标题',
  `post_count` int(10) NOT NULL,
  `status` tinyint(1) NOT NULL COMMENT '1，正常。0禁止',
  `member_count` int(10) NOT NULL COMMENT '会员数量',
  `quan_share` varchar(255) DEFAULT NULL COMMENT '圈子分享标题',
  `is_synchro` tinyint(1) DEFAULT '1' COMMENT '同步评论到圈子',
  `limit_send_member` tinyint(1) DEFAULT NULL COMMENT '是否限制会员发布',
  `quan_logo` varchar(255) DEFAULT NULL COMMENT '圈子logo',
  `quan_banner` varchar(255) NOT NULL COMMENT '圈子banner图片',
  `quan_share_desc` varchar(255) NOT NULL COMMENT '圈子分享描述',
  `member_ids` text COMMENT '限制的会员发布id',
  `create_time` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `seller_id` (`seller_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='圈子群组表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_group`
--

LOCK TABLES `oscshop_group` WRITE;
/*!40000 ALTER TABLE `oscshop_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_group_lzl_reply`
--

DROP TABLE IF EXISTS `oscshop_group_lzl_reply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_group_lzl_reply` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `post_id` int(10) NOT NULL COMMENT '贴子id',
  `content` text NOT NULL COMMENT '回复内容',
  `member_id` int(10) NOT NULL COMMENT '用户id',
  `to_member_id` int(10) NOT NULL COMMENT '回复对象用户id',
  `status` tinyint(1) NOT NULL COMMENT '状态',
  `create_time` int(10) NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='群组帖子楼中楼回复表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_group_lzl_reply`
--

LOCK TABLES `oscshop_group_lzl_reply` WRITE;
/*!40000 ALTER TABLE `oscshop_group_lzl_reply` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_group_lzl_reply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_group_member`
--

DROP TABLE IF EXISTS `oscshop_group_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_group_member` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `group_id` int(10) NOT NULL COMMENT '群组id',
  `member_id` int(10) NOT NULL COMMENT '用户id',
  `status` tinyint(1) NOT NULL COMMENT '状态，1正常',
  `last_view` int(10) NOT NULL COMMENT '上次进入该群组时间',
  `position` tinyint(1) NOT NULL COMMENT '1为普通成员，2为管理员，3为创建者',
  `create_time` int(10) NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='群组成员表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_group_member`
--

LOCK TABLES `oscshop_group_member` WRITE;
/*!40000 ALTER TABLE `oscshop_group_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_group_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_group_post`
--

DROP TABLE IF EXISTS `oscshop_group_post`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_group_post` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `is_vir` tinyint(1) DEFAULT '0' COMMENT '是否虚拟评价同步',
  `avatar` varchar(255) DEFAULT NULL COMMENT '机器人头像',
  `user_name` varchar(255) DEFAULT NULL COMMENT '用户名称',
  `group_id` int(10) NOT NULL COMMENT '群组id',
  `goods_id` int(10) DEFAULT '0' COMMENT '动态商品id',
  `title` varchar(255) NOT NULL COMMENT '标题',
  `content` text NOT NULL COMMENT '帖子内容',
  `status` tinyint(1) NOT NULL COMMENT '状态 1正常，0被删除',
  `last_reply_time` int(10) NOT NULL COMMENT '上次回复时间',
  `fav_count` int(10) NOT NULL COMMENT '喜欢量',
  `reply_count` int(10) NOT NULL COMMENT '回复量',
  `is_share` tinyint(1) DEFAULT '0' COMMENT '是否分享',
  `link` varchar(255) DEFAULT NULL COMMENT '跳转地址',
  `create_time` int(10) NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`group_id`),
  KEY `group_id` (`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='群组帖子表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_group_post`
--

LOCK TABLES `oscshop_group_post` WRITE;
/*!40000 ALTER TABLE `oscshop_group_post` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_group_post` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_group_post_fav`
--

DROP TABLE IF EXISTS `oscshop_group_post_fav`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_group_post_fav` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `post_id` int(10) NOT NULL COMMENT '帖子id',
  `fav_time` int(10) NOT NULL COMMENT '喜欢时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`post_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='帖子喜欢记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_group_post_fav`
--

LOCK TABLES `oscshop_group_post_fav` WRITE;
/*!40000 ALTER TABLE `oscshop_group_post_fav` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_group_post_fav` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_guobie`
--

DROP TABLE IF EXISTS `oscshop_guobie`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_guobie` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(50) NOT NULL COMMENT '国别名称',
  `logo` varchar(255) NOT NULL COMMENT '国别logo,用于海淘首页展示圆形logo',
  `banner` varchar(255) NOT NULL COMMENT '海淘国家详细页',
  `icon` varchar(255) NOT NULL COMMENT '国旗',
  `is_index` tinyint(1) NOT NULL COMMENT '是否推荐首页显示',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='海淘国别表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_guobie`
--

LOCK TABLES `oscshop_guobie` WRITE;
/*!40000 ALTER TABLE `oscshop_guobie` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_guobie` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_integral_flow`
--

DROP TABLE IF EXISTS `oscshop_integral_flow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_integral_flow` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `in_out` enum('in','out') NOT NULL COMMENT '增加积分，还是减少积分',
  `type` enum('goodsbuy','refundorder','system_add','system_del','orderbuy') NOT NULL COMMENT '积分获赠/减少 类型',
  `order_id` int(10) DEFAULT NULL COMMENT '订单id',
  `score` float(10,2) DEFAULT '0.00' COMMENT '积分数量',
  `state` tinyint(1) DEFAULT '0' COMMENT '0 还未赠送，1处理成功，',
  `remark` varchar(255) DEFAULT NULL COMMENT '说明',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='积分流水记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_integral_flow`
--

LOCK TABLES `oscshop_integral_flow` WRITE;
/*!40000 ALTER TABLE `oscshop_integral_flow` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_integral_flow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_integral_order`
--

DROP TABLE IF EXISTS `oscshop_integral_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_integral_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `score` float(10,2) NOT NULL COMMENT '所使用积分',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='积分兑换订单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_integral_order`
--

LOCK TABLES `oscshop_integral_order` WRITE;
/*!40000 ALTER TABLE `oscshop_integral_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_integral_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_intgral_goods`
--

DROP TABLE IF EXISTS `oscshop_intgral_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_intgral_goods` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `customer_id` int(10) NOT NULL COMMENT '所属商家',
  `score` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '积分兑换价格',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='积分商品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_intgral_goods`
--

LOCK TABLES `oscshop_intgral_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_intgral_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_intgral_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_jiaorder`
--

DROP TABLE IF EXISTS `oscshop_jiaorder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_jiaorder` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `uname` varchar(255) NOT NULL COMMENT '昵称',
  `avatar` varchar(255) NOT NULL COMMENT '头像',
  `order_sn` varchar(100) NOT NULL COMMENT '订单编号',
  `mobile` varchar(20) NOT NULL COMMENT '手机号',
  `addtime` int(10) DEFAULT NULL COMMENT '加入时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_jiaorder`
--

LOCK TABLES `oscshop_jiaorder` WRITE;
/*!40000 ALTER TABLE `oscshop_jiaorder` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_jiaorder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_jiapinorder`
--

DROP TABLE IF EXISTS `oscshop_jiapinorder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_jiapinorder` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pin_id` int(10) NOT NULL COMMENT '拼团id',
  `uname` varchar(255) NOT NULL COMMENT '昵称',
  `avatar` varchar(255) NOT NULL COMMENT '头像',
  `order_sn` varchar(100) NOT NULL COMMENT '订单编号',
  `mobile` varchar(20) NOT NULL COMMENT '手机号',
  `addtime` int(10) DEFAULT NULL COMMENT '加入时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_jiapinorder`
--

LOCK TABLES `oscshop_jiapinorder` WRITE;
/*!40000 ALTER TABLE `oscshop_jiapinorder` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_jiapinorder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_jiauser`
--

DROP TABLE IF EXISTS `oscshop_jiauser`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_jiauser` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `username` varchar(32) DEFAULT NULL,
  `avatar` varchar(255) DEFAULT NULL,
  `mobile` varchar(16) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_jiauser`
--

LOCK TABLES `oscshop_jiauser` WRITE;
/*!40000 ALTER TABLE `oscshop_jiauser` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_jiauser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_length_class`
--

DROP TABLE IF EXISTS `oscshop_length_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_length_class` (
  `length_class_id` int(11) NOT NULL AUTO_INCREMENT,
  `value` decimal(15,8) NOT NULL COMMENT '1厘米转换成该单位的值',
  `title` varchar(32) NOT NULL COMMENT '长度标题',
  `unit` varchar(4) NOT NULL COMMENT '长度单位英文简写',
  PRIMARY KEY (`length_class_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='长度单位';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_length_class`
--

LOCK TABLES `oscshop_length_class` WRITE;
/*!40000 ALTER TABLE `oscshop_length_class` DISABLE KEYS */;
INSERT INTO `oscshop_length_class` VALUES (1,100.00000000,'厘米','cm'),(2,1.00000000,'米','m');
/*!40000 ALTER TABLE `oscshop_length_class` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_community_head`
--

DROP TABLE IF EXISTS `oscshop_lionfish_community_head`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_community_head` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `agent_id` int(10) DEFAULT '0' COMMENT '推荐人id',
  `level_id` int(10) DEFAULT '0' COMMENT '团长等级id',
  `community_name` varchar(255) DEFAULT NULL COMMENT '小区名称',
  `head_name` varchar(100) NOT NULL COMMENT '团长名称',
  `head_mobile` varchar(50) NOT NULL COMMENT '团长手机号',
  `groupid` int(10) DEFAULT '0' COMMENT '分组id',
  `wechat` varchar(100) DEFAULT NULL COMMENT '微信号',
  `province_id` int(10) NOT NULL COMMENT '省',
  `city_id` int(10) NOT NULL COMMENT '市',
  `country_id` int(10) NOT NULL COMMENT '镇/街道',
  `area_id` int(10) NOT NULL COMMENT '区',
  `address` varchar(200) NOT NULL COMMENT '详细地址',
  `lon` float NOT NULL DEFAULT '0' COMMENT '经度',
  `lat` float NOT NULL DEFAULT '0' COMMENT '纬度',
  `state` tinyint(1) NOT NULL COMMENT '状态0 未审核，1已审核,2未审核',
  `enable` tinyint(1) DEFAULT '1' COMMENT '禁用状态 0：禁用 1：启用',
  `rest` tinyint(1) DEFAULT '0' COMMENT '团长休息',
  `is_default` tinyint(1) DEFAULT '0' COMMENT '0非默认，1 默认，只有开启单团长模式下可用',
  `apptime` int(10) NOT NULL COMMENT '申请时间',
  `is_modify_shipping_method` tinyint(1) DEFAULT '0' COMMENT '0跟随系统，1，开启，2关闭',
  `is_modify_shipping_fare` tinyint(1) DEFAULT '0' COMMENT '是否开启自定义运费',
  `shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '配送费',
  `addtime` int(10) NOT NULL COMMENT '成为团长时间',
  PRIMARY KEY (`id`),
  KEY `lon` (`lon`,`lat`),
  KEY `member_id` (`member_id`),
  KEY `agent_id` (`agent_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购团长表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_community_head`
--

LOCK TABLES `oscshop_lionfish_community_head` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_community_head_commiss`
--

DROP TABLE IF EXISTS `oscshop_lionfish_community_head_commiss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_community_head_commiss` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `head_id` int(10) NOT NULL COMMENT '团长ID',
  `money` float(10,2) DEFAULT '0.00' COMMENT '可提现金额',
  `dongmoney` float(10,2) DEFAULT '0.00' COMMENT '提现中金额',
  `getmoney` float(10,2) DEFAULT '0.00' COMMENT '已提现金额',
  `bankname` varchar(200) DEFAULT NULL COMMENT '银行名称',
  `bankaccount` varchar(200) DEFAULT NULL COMMENT '卡号',
  `bankusername` varchar(200) DEFAULT NULL COMMENT '持卡人姓名',
  `share_avatar` varchar(200) DEFAULT NULL COMMENT '团长群分享头像',
  `share_wxcode` varchar(200) DEFAULT NULL COMMENT '团长群分享二维码',
  `share_title` varchar(200) DEFAULT NULL COMMENT '团长群分享标题',
  `share_desc` varchar(255) DEFAULT NULL COMMENT '团长群分享描述',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `head_id` (`head_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_community_head_commiss`
--

LOCK TABLES `oscshop_lionfish_community_head_commiss` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_commiss` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_commiss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_community_head_commiss_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_community_head_commiss_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_community_head_commiss_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `head_id` int(10) NOT NULL COMMENT '团长id',
  `child_head_id` int(10) DEFAULT '0' COMMENT '下级团长id',
  `type` enum('orderbuy','commiss','tuijian') NOT NULL DEFAULT 'orderbuy' COMMENT 'orderbuy 团员订单购买 ,commiss 下级的会员订单购买,tuijian 推荐团长的佣金',
  `fen_type` tinyint(1) DEFAULT '0' COMMENT '0,按照比例计算的，1按照实际金额计算的',
  `bili` float(10,2) DEFAULT '0.00' COMMENT '分销分佣比例',
  `level` int(10) DEFAULT '0' COMMENT '第几层分佣',
  `order_id` int(10) NOT NULL COMMENT '订单ID',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '商品订单id',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否结算：0，待计算。1，已结算。2，订单取消',
  `money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '分佣金额',
  `add_shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '团长配送费',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `head_id` (`head_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_community_head_commiss_order`
--

LOCK TABLES `oscshop_lionfish_community_head_commiss_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_commiss_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_commiss_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_community_head_goods`
--

DROP TABLE IF EXISTS `oscshop_lionfish_community_head_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_community_head_goods` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `head_id` int(10) NOT NULL COMMENT '团长id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `head_id` (`head_id`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购，团长商品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_community_head_goods`
--

LOCK TABLES `oscshop_lionfish_community_head_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_community_head_group`
--

DROP TABLE IF EXISTS `oscshop_lionfish_community_head_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_community_head_group` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `groupname` varchar(255) NOT NULL COMMENT '分组名称',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城团长分组表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_community_head_group`
--

LOCK TABLES `oscshop_lionfish_community_head_group` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_community_head_invite_recod`
--

DROP TABLE IF EXISTS `oscshop_lionfish_community_head_invite_recod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_community_head_invite_recod` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `head_id` int(10) NOT NULL COMMENT '团长id',
  `agent_member_id` int(10) NOT NULL COMMENT '推荐人id',
  `money` float(10,2) NOT NULL COMMENT '奖励金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `head_id` (`head_id`),
  KEY `agent_member_id` (`agent_member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼团长推荐团长记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_community_head_invite_recod`
--

LOCK TABLES `oscshop_lionfish_community_head_invite_recod` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_invite_recod` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_invite_recod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_community_head_tixian_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_community_head_tixian_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_community_head_tixian_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL,
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `head_id` int(10) NOT NULL COMMENT '团长id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `service_charge` float(10,2) DEFAULT '0.00' COMMENT '手续费',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0申请中，1提现成功，2体现失败',
  `shentime` int(10) NOT NULL COMMENT '审核时间',
  `is_send_fail` tinyint(1) DEFAULT '0' COMMENT '是否发送是否，1是，0否',
  `fail_msg` varchar(255) DEFAULT NULL COMMENT '发送失败原因',
  `type` tinyint(1) DEFAULT '0' COMMENT '0 原系统参数，1 余额，2微信，3支付宝，4 银行卡',
  `bankname` varchar(100) DEFAULT NULL COMMENT '银行卡名称',
  `bankaccount` varchar(100) DEFAULT NULL COMMENT '卡号',
  `bankusername` varchar(100) DEFAULT NULL COMMENT '持卡人姓名',
  `addtime` int(10) NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `head_id` (`head_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分销佣金提现表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_community_head_tixian_order`
--

LOCK TABLES `oscshop_lionfish_community_head_tixian_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_tixian_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_community_head_tixian_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_community_history`
--

DROP TABLE IF EXISTS `oscshop_lionfish_community_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_community_history` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `head_id` int(10) NOT NULL COMMENT '社区id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`head_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购上个小区历史记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_community_history`
--

LOCK TABLES `oscshop_lionfish_community_history` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_community_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_community_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_address`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_address` (
  `address_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(11) NOT NULL COMMENT '会员id',
  `name` varchar(100) NOT NULL COMMENT '收货人姓名',
  `telephone` varchar(50) NOT NULL COMMENT '电话',
  `address` varchar(255) NOT NULL COMMENT '收货地址',
  `address_name` enum('HOME','WORK') NOT NULL DEFAULT 'HOME' COMMENT '收货地址类型',
  `lon_lat` varchar(30) DEFAULT '' COMMENT '地址经纬度',
  `lou_meng_hao` varchar(100) DEFAULT '' COMMENT '门牌号-楼号',
  `is_default` tinyint(1) NOT NULL COMMENT '是否默认的收货地址',
  `city_id` int(10) NOT NULL COMMENT '市',
  `country_id` int(10) NOT NULL COMMENT '县乡',
  `province_id` int(10) NOT NULL COMMENT '省',
  PRIMARY KEY (`address_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城地址库';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_address`
--

LOCK TABLES `oscshop_lionfish_comshop_address` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_address` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_adv`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_adv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_adv` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `advname` varchar(200) NOT NULL COMMENT '广告名称',
  `thumb` varchar(255) NOT NULL COMMENT '图片地址',
  `link` varchar(255) NOT NULL COMMENT '广告链接地址',
  `appid` varchar(255) DEFAULT NULL COMMENT '外部小程序appid',
  `linktype` tinyint(1) NOT NULL DEFAULT '1' COMMENT '0外链 1小程序内 2外部小程序',
  `type` enum('slider','nav','pintuan','recipe','presale') NOT NULL COMMENT '广告类型，slider幻灯，nav导航小图',
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `enabled` tinyint(1) NOT NULL COMMENT '是否生效，1生效，0不生效',
  `addtime` int(10) NOT NULL COMMENT '添加广告时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品广告表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_adv`
--

LOCK TABLES `oscshop_lionfish_comshop_adv` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_adv` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_adv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_adv_category`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_adv_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_adv_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `cate_id` int(10) NOT NULL COMMENT '分类id',
  `advname` varchar(200) NOT NULL COMMENT '广告名称',
  `thumb` varchar(255) NOT NULL COMMENT '图片地址',
  `link` varchar(255) NOT NULL COMMENT '广告链接地址',
  `appid` varchar(255) DEFAULT NULL COMMENT '外部小程序appid',
  `linktype` tinyint(1) NOT NULL DEFAULT '1' COMMENT '0外链 1小程序内 2外部小程序',
  `type` enum('slider','nav','pintuan','recipe','presale') NOT NULL COMMENT '广告类型，slider幻灯，nav导航小图',
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `enabled` tinyint(1) NOT NULL COMMENT '是否生效，1生效，0不生效',
  `addtime` int(10) NOT NULL COMMENT '添加广告时间',
  PRIMARY KEY (`id`),
  KEY `cate_id` (`cate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品广告表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_adv_category`
--

LOCK TABLES `oscshop_lionfish_comshop_adv_category` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_adv_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_adv_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_advimg`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_advimg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_advimg` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `thumb` varchar(255) NOT NULL COMMENT '广告图片地址',
  `link` varchar(255) NOT NULL COMMENT '广告链接地址',
  `linktype` tinyint(1) NOT NULL DEFAULT '1' COMMENT '0外链 1小程序内 2外部小程序',
  `appid` varchar(255) NOT NULL COMMENT '外部小程序appid',
  `enabled` tinyint(1) NOT NULL COMMENT '状态 0关闭 1隐藏',
  `pos` varchar(50) NOT NULL COMMENT '展示位置 0首页 1详情 2个人中心',
  `displayorder` int(10) NOT NULL COMMENT '排序',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城图片广告';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_advimg`
--

LOCK TABLES `oscshop_lionfish_comshop_advimg` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_advimg` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_advimg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_area`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_area`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_area` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '11',
  `name` varchar(100) NOT NULL COMMENT '地区名称',
  `pid` int(11) NOT NULL COMMENT '上级id',
  `code` varchar(20) NOT NULL COMMENT '地区编号',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=3636 DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城地区配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_area`
--

LOCK TABLES `oscshop_lionfish_comshop_area` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_area` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_area` VALUES (1,'安徽省',0,'340000'),(2,'合肥市',1,'340100'),(3,'瑶海区',2,'340102'),(4,'庐阳区',2,'340103'),(5,'蜀山区',2,'340104'),(6,'包河区',2,'340111'),(7,'长丰县',2,'340121'),(8,'肥东县',2,'340122'),(9,'肥西县',2,'340123'),(10,'巢湖市',2,'341400'),(11,'庐江县',2,'341421'),(12,'芜湖市',1,'340200'),(13,'镜湖区',12,'340202'),(14,'弋江区',12,'340203'),(15,'鸠江区',12,'340207'),(16,'三山区',12,'340208'),(17,'芜湖县',12,'340221'),(18,'繁昌县',12,'340222'),(19,'南陵县',12,'340223'),(20,'无为县',12,'341422'),(21,'蚌埠市',1,'340300'),(22,'龙子湖区',21,'340302'),(23,'蚌山区',21,'340303'),(24,'禹会区',21,'340304'),(25,'淮上区',21,'340311'),(26,'怀远县',21,'340321'),(27,'五河县',21,'340322'),(28,'固镇县',21,'340323'),(29,'淮南市',1,'340400'),(30,'大通区',29,'340402'),(31,'田家庵区',29,'340403'),(32,'谢家集区',29,'340404'),(33,'八公山区',29,'340405'),(34,'潘集区',29,'340406'),(35,'凤台县',29,'340421'),(36,'马鞍山市',1,'340500'),(37,'花山区',36,'340503'),(38,'雨山区',36,'340504'),(39,'博望区',36,'340506'),(40,'当涂县',36,'340521'),(41,'含山县',36,'341423'),(42,'和县',36,'341424'),(43,'淮北市',1,'340600'),(44,'杜集区',43,'340602'),(45,'相山区',43,'340603'),(46,'烈山区',43,'340604'),(47,'濉溪县',43,'340621'),(48,'铜陵市',1,'340700'),(49,'铜官山区',48,'340702'),(50,'狮子山区',48,'340703'),(51,'郊区',48,'340711'),(52,'铜陵县',48,'340721'),(53,'安庆市',1,'340800'),(54,'迎江区',53,'340802'),(55,'大观区',53,'340803'),(56,'宜秀区',53,'340811'),(57,'怀宁县',53,'340822'),(58,'枞阳县',53,'340823'),(59,'潜山县',53,'340824'),(60,'太湖县',53,'340825'),(61,'宿松县',53,'340826'),(62,'望江县',53,'340827'),(63,'岳西县',53,'340828'),(64,'桐城市',53,'340881'),(65,'黄山市',1,'341000'),(66,'屯溪区',65,'341002'),(67,'黄山区',65,'341003'),(68,'徽州区',65,'341004'),(69,'歙县',65,'341021'),(70,'休宁县',65,'341022'),(71,'黟县',65,'341023'),(72,'祁门县',65,'341024'),(73,'滁州市',1,'341100'),(74,'琅琊区',73,'341102'),(75,'南谯区',73,'341103'),(76,'来安县',73,'341122'),(77,'全椒县',73,'341124'),(78,'定远县',73,'341125'),(79,'凤阳县',73,'341126'),(80,'天长市',73,'341181'),(81,'明光市',73,'341182'),(82,'阜阳市',1,'341200'),(83,'颍州区',82,'341202'),(84,'颍东区',82,'341203'),(85,'颍泉区',82,'341204'),(86,'临泉县',82,'341221'),(87,'太和县',82,'341222'),(88,'阜南县',82,'341225'),(89,'颍上县',82,'341226'),(90,'界首市',82,'341282'),(91,'宿州市',1,'341300'),(92,'埇桥区',91,'341302'),(93,'砀山县',91,'341321'),(94,'萧县',91,'341322'),(95,'灵璧县',91,'341323'),(96,'泗县',91,'341324'),(97,'六安市',1,'341500'),(98,'金安区',97,'341502'),(99,'裕安区',97,'341503'),(100,'寿县',97,'341521'),(101,'霍邱县',97,'341522'),(102,'舒城县',97,'341523'),(103,'金寨县',97,'341524'),(104,'霍山县',97,'341525'),(105,'亳州市',1,'341600'),(106,'谯城区',105,'341602'),(107,'涡阳县',105,'341621'),(108,'蒙城县',105,'341622'),(109,'利辛县',105,'341623'),(110,'池州市',1,'341700'),(111,'贵池区',110,'341702'),(112,'东至县',110,'341721'),(113,'石台县',110,'341722'),(114,'青阳县',110,'341723'),(115,'宣城市',1,'341800'),(116,'宣州区',115,'341802'),(117,'郎溪县',115,'341821'),(118,'广德县',115,'341822'),(119,'泾县',115,'341823'),(120,'绩溪县',115,'341824'),(121,'旌德县',115,'341825'),(122,'宁国市',115,'341881'),(123,'北京市',0,'110000'),(124,'北京市',123,'110000'),(125,'北京市',123,'110000'),(126,'重庆市',0,'500000'),(127,'重庆市',126,'500000'),(128,'重庆市',126,'500000'),(129,'福建省',0,'350000'),(130,'福州市',129,'350100'),(131,'鼓楼区',130,'350102'),(132,'台江区',130,'350103'),(133,'仓山区',130,'350104'),(134,'马尾区',130,'350105'),(135,'晋安区',130,'350111'),(136,'闽侯县',130,'350121'),(137,'连江县',130,'350122'),(138,'罗源县',130,'350123'),(139,'闽清县',130,'350124'),(140,'永泰县',130,'350125'),(141,'平潭县',130,'350128'),(142,'福清市',130,'350181'),(143,'长乐市',130,'350182'),(144,'厦门市',129,'350200'),(145,'思明区',144,'350203'),(146,'海沧区',144,'350205'),(147,'湖里区',144,'350206'),(148,'集美区',144,'350211'),(149,'同安区',144,'350212'),(150,'翔安区',144,'350213'),(151,'莆田市',129,'350300'),(152,'城厢区',151,'350302'),(153,'涵江区',151,'350303'),(154,'荔城区',151,'350304'),(155,'秀屿区',151,'350305'),(156,'仙游县',151,'350322'),(157,'三明市',129,'350400'),(158,'梅列区',157,'350402'),(159,'三元区',157,'350403'),(160,'明溪县',157,'350421'),(161,'清流县',157,'350423'),(162,'宁化县',157,'350424'),(163,'大田县',157,'350425'),(164,'尤溪县',157,'350426'),(165,'沙县',157,'350427'),(166,'将乐县',157,'350428'),(167,'泰宁县',157,'350429'),(168,'建宁县',157,'350430'),(169,'永安市',157,'350481'),(170,'泉州市',129,'350500'),(171,'鲤城区',170,'350502'),(172,'丰泽区',170,'350503'),(173,'洛江区',170,'350504'),(174,'泉港区',170,'350505'),(175,'惠安县',170,'350521'),(176,'安溪县',170,'350524'),(177,'永春县',170,'350525'),(178,'德化县',170,'350526'),(179,'金门县',170,'350527'),(180,'石狮市',170,'350581'),(181,'晋江市',170,'350582'),(182,'南安市',170,'350583'),(183,'漳州市',129,'350600'),(184,'芗城区',183,'350602'),(185,'龙文区',183,'350603'),(186,'云霄县',183,'350622'),(187,'漳浦县',183,'350623'),(188,'诏安县',183,'350624'),(189,'长泰县',183,'350625'),(190,'东山县',183,'350626'),(191,'南靖县',183,'350627'),(192,'平和县',183,'350628'),(193,'华安县',183,'350629'),(194,'龙海市',183,'350681'),(195,'南平市',129,'350700'),(196,'延平区',195,'350702'),(197,'顺昌县',195,'350721'),(198,'浦城县',195,'350722'),(199,'光泽县',195,'350723'),(200,'松溪县',195,'350724'),(201,'政和县',195,'350725'),(202,'邵武市',195,'350781'),(203,'武夷山市',195,'350782'),(204,'建瓯市',195,'350783'),(205,'建阳市',195,'350784'),(206,'龙岩市',129,'350800'),(207,'新罗区',206,'350802'),(208,'长汀县',206,'350821'),(209,'永定县',206,'350822'),(210,'上杭县',206,'350823'),(211,'武平县',206,'350824'),(212,'连城县',206,'350825'),(213,'漳平市',206,'350881'),(214,'宁德市',129,'350900'),(215,'蕉城区',214,'350902'),(216,'霞浦县',214,'350921'),(217,'古田县',214,'350922'),(218,'屏南县',214,'350923'),(219,'寿宁县',214,'350924'),(220,'周宁县',214,'350925'),(221,'柘荣县',214,'350926'),(222,'福安市',214,'350981'),(223,'福鼎市',214,'350982'),(224,'甘肃省',0,'620000'),(225,'兰州市',224,'620100'),(226,'城关区',225,'620102'),(227,'七里河区',225,'620103'),(228,'西固区',225,'620104'),(229,'安宁区',225,'620105'),(230,'红古区',225,'620111'),(231,'永登县',225,'620121'),(232,'皋兰县',225,'620122'),(233,'榆中县',225,'620123'),(234,'嘉峪关市',224,'620200'),(235,'嘉峪关区',234,'620200001'),(236,'金昌市',224,'620300'),(237,'金川区',236,'620302'),(238,'永昌县',236,'620321'),(239,'白银市',224,'620400'),(240,'白银区',239,'620402'),(241,'平川区',239,'620403'),(242,'靖远县',239,'620421'),(243,'会宁县',239,'620422'),(244,'景泰县',239,'620423'),(245,'天水市',224,'620500'),(246,'秦州区',245,'620502'),(247,'麦积区',245,'620503'),(248,'清水县',245,'620521'),(249,'秦安县',245,'620522'),(250,'甘谷县',245,'620523'),(251,'武山县',245,'620524'),(252,'张家川县',245,'620525'),(253,'武威市',224,'620600'),(254,'凉州区',253,'620602'),(255,'民勤县',253,'620621'),(256,'古浪县',253,'620622'),(257,'天祝县',253,'620623'),(258,'张掖市',224,'620700'),(259,'甘州区',258,'620702'),(260,'肃南县',258,'620721'),(261,'民乐县',258,'620722'),(262,'临泽县',258,'620723'),(263,'高台县',258,'620724'),(264,'山丹县',258,'620725'),(265,'平凉市',224,'620800'),(266,'崆峒区',265,'620802'),(267,'泾川县',265,'620821'),(268,'灵台县',265,'620822'),(269,'崇信县',265,'620823'),(270,'华亭县',265,'620824'),(271,'庄浪县',265,'620825'),(272,'静宁县',265,'620826'),(273,'酒泉市',224,'620900'),(274,'肃州区',273,'620902'),(275,'金塔县',273,'620921'),(276,'瓜州县',273,'620922'),(277,'肃北县',273,'620923'),(278,'阿克塞',273,'620924'),(279,'玉门市',273,'620981'),(280,'敦煌市',273,'620982'),(281,'庆阳市',224,'621000'),(282,'西峰区',281,'621002'),(283,'庆城县',281,'621021'),(284,'环县',281,'621022'),(285,'华池县',281,'621023'),(286,'合水县',281,'621024'),(287,'正宁县',281,'621025'),(288,'宁县',281,'621026'),(289,'镇原县',281,'621027'),(290,'定西市',224,'621100'),(291,'安定区',290,'621102'),(292,'通渭县',290,'621121'),(293,'陇西县',290,'621122'),(294,'渭源县',290,'621123'),(295,'临洮县',290,'621124'),(296,'漳县',290,'621125'),(297,'岷县',290,'621126'),(298,'陇南市 ',224,'621200'),(299,'武都区',298,'621202'),(300,'成县',298,'621221'),(301,'文县',298,'621222'),(302,'宕昌',298,'621223'),(303,'康县',298,'621224'),(304,'西和昌',298,'621225'),(305,'礼县',298,'621226'),(306,'徽县',298,'621227'),(307,'两当昌',298,'621228'),(308,'临夏州',224,'622900'),(309,'临夏市',308,'622901'),(310,'临夏县',308,'622921'),(311,'康乐县',308,'622922'),(312,'永靖县',308,'622923'),(313,'广河县',308,'622924'),(314,'和政县',308,'622925'),(315,'东乡县',308,'622926'),(316,'积石山县',308,'622927'),(317,'甘南州',224,'623000'),(318,'合作市',317,'623001'),(319,'临潭县',317,'623021'),(320,'卓尼县',317,'623022'),(321,'舟曲县',317,'623023'),(322,'迭部县',317,'623024'),(323,'玛曲县',317,'623025'),(324,'碌曲县',317,'623026'),(325,'夏河县',317,'623027'),(326,'广东省',0,'440000'),(327,'广州市',326,'440100'),(328,'荔湾区',327,'440103'),(329,'越秀区',327,'440104'),(330,'海珠区',327,'440105'),(331,'天河区',327,'440106'),(332,'白云区',327,'440111'),(333,'黄埔区',327,'440112'),(334,'番禺区',327,'440113'),(335,'花都区',327,'440114'),(336,'南沙区',327,'440115'),(337,'萝岗区',327,'440116'),(338,'增城区',327,'440183'),(339,'从化区',327,'440184'),(340,'韶关市',326,'440200'),(341,'武江区',340,'440203'),(342,'浈江区',340,'440204'),(343,'曲江区',340,'440205'),(344,'始兴县',340,'440222'),(345,'仁化县',340,'440224'),(346,'翁源县',340,'440229'),(347,'乳源瑶族自治县',340,'440232'),(348,'新丰县',340,'440233'),(349,'乐昌市',340,'440281'),(350,'南雄市',340,'440282'),(351,'深圳市',326,'440300'),(352,'罗湖区',351,'440303'),(353,'福田区',351,'440304'),(354,'南山区',351,'440305'),(355,'宝安区',351,'440306'),(356,'龙岗区',351,'440307'),(357,'盐田区',351,'440308'),(358,'珠海市',326,'440400'),(359,'香洲区',358,'440402'),(360,'斗门区',358,'440403'),(361,'金湾区',358,'440404'),(362,'汕头市',326,'440500'),(363,'龙湖区',362,'440507'),(364,'金平区',362,'440511'),(365,'濠江区',362,'440512'),(366,'潮阳区',362,'440513'),(367,'潮南区',362,'440514'),(368,'澄海区',362,'440515'),(369,'南澳县',362,'440523'),(370,'佛山市',326,'440600'),(371,'禅城区',370,'440604'),(372,'南海区',370,'440605'),(373,'顺德区',370,'440606'),(374,'三水区',370,'440607'),(375,'高明区',370,'440608'),(376,'江门市',326,'440700'),(377,'蓬江区',376,'440703'),(378,'江海区',376,'440704'),(379,'新会区',376,'440705'),(380,'台山市',376,'440781'),(381,'开平市',376,'440783'),(382,'鹤山市',376,'440784'),(383,'恩平市',376,'440785'),(384,'湛江市',326,'440800'),(385,'赤坎区',384,'440802'),(386,'霞山区',384,'440803'),(387,'坡头区',384,'440804'),(388,'麻章区',384,'440811'),(389,'遂溪县',384,'440823'),(390,'徐闻县',384,'440825'),(391,'廉江市',384,'440881'),(392,'雷州市',384,'440882'),(393,'吴川市',384,'440883'),(394,'茂名市',326,'440900'),(395,'茂南区',394,'440902'),(396,'电白县',394,'440903'),(397,'高州市',394,'440981'),(398,'化州市',394,'440982'),(399,'信宜市',394,'440983'),(400,'肇庆市',326,'441200'),(401,'端州区',400,'441202'),(402,'鼎湖区',400,'441203'),(403,'广宁县',400,'441223'),(404,'怀集县',400,'441224'),(405,'封开县',400,'441225'),(406,'德庆县',400,'441226'),(407,'高要市',400,'441283'),(408,'四会市',400,'441284'),(409,'惠州市',326,'441300'),(410,'惠城区',409,'441302'),(411,'惠阳区',409,'441303'),(412,'博罗县',409,'441322'),(413,'惠东县',409,'441323'),(414,'龙门县',409,'441324'),(415,'梅州市',326,'441400'),(416,'梅江区',415,'441402'),(417,'梅县县',415,'441421'),(418,'大埔县',415,'441422'),(419,'丰顺县',415,'441423'),(420,'五华县',415,'441424'),(421,'平远县',415,'441426'),(422,'蕉岭县',415,'441427'),(423,'兴宁市',415,'441481'),(424,'汕尾市',326,'441500'),(425,'城区',424,'441502'),(426,'海丰县',424,'441521'),(427,'陆河县',424,'441523'),(428,'陆丰市',424,'441581'),(429,'河源市',326,'441600'),(430,'源城区',429,'441602'),(431,'紫金县',429,'441621'),(432,'龙川县',429,'441622'),(433,'连平县',429,'441623'),(434,'和平县',429,'441624'),(435,'东源县',429,'441625'),(436,'阳江市',326,'441700'),(437,'江城区',436,'441702'),(438,'阳西县',436,'441721'),(439,'阳东县',436,'441723'),(440,'阳春市',436,'441781'),(441,'清远市',326,'441800'),(442,'清城区',441,'441802'),(443,'佛冈县',441,'441821'),(444,'阳山县',441,'441823'),(445,'连山县',441,'441825'),(446,'连南县',441,'441826'),(447,'清新县',441,'441827'),(448,'英德市',441,'441881'),(449,'连州市',441,'441882'),(450,'东莞市',326,'441900'),(451,'东莞',450,'441900001'),(452,'中山市',326,'442000'),(453,'中山',452,'442000001'),(454,'潮州市',326,'445100'),(455,'湘桥区',454,'445102'),(456,'潮安区',454,'445121'),(457,'饶平县',454,'445122'),(458,'揭阳市',326,'445200'),(459,'榕城区',458,'445202'),(460,'揭东县',458,'445221'),(461,'揭西县',458,'445222'),(462,'惠来县',458,'445224'),(463,'普宁市',458,'445281'),(464,'云浮市',326,'445300'),(465,'云城区',464,'445302'),(466,'新兴县',464,'445321'),(467,'郁南县',464,'445322'),(468,'云安县',464,'445323'),(469,'罗定市',464,'445381'),(470,'广西省',0,'450000'),(471,'南宁市',470,'450100'),(472,'兴宁区',471,'450102'),(473,'青秀区',471,'450103'),(474,'江南区',471,'450105'),(475,'西乡塘区',471,'450107'),(476,'良庆区',471,'450108'),(477,'邕宁区',471,'450109'),(478,'武鸣区',471,'450122'),(479,'隆安县',471,'450123'),(480,'马山县',471,'450124'),(481,'上林县',471,'450125'),(482,'宾阳县',471,'450126'),(483,'横县',471,'450127'),(484,'柳州市',470,'450200'),(485,'城中区',484,'450202'),(486,'鱼峰区',484,'450203'),(487,'柳南区',484,'450204'),(488,'柳北区',484,'450205'),(489,'柳江县',484,'450221'),(490,'柳城县',484,'450222'),(491,'鹿寨县',484,'450223'),(492,'融安县',484,'450224'),(493,'融水县',484,'450225'),(494,'三江县',484,'450226'),(495,'桂林市',470,'450300'),(496,'秀峰区',495,'450302'),(497,'叠彩区',495,'450303'),(498,'象山区',495,'450304'),(499,'七星区',495,'450305'),(500,'雁山区',495,'450311'),(501,'阳朔县',495,'450321'),(502,'临桂县',495,'450322'),(503,'灵川县',495,'450323'),(504,'全州县',495,'450324'),(505,'兴安县',495,'450325'),(506,'永福县',495,'450326'),(507,'灌阳县',495,'450327'),(508,'龙胜县',495,'450328'),(509,'资源县',495,'450329'),(510,'平乐县',495,'450330'),(511,'荔浦县',495,'450331'),(512,'恭城县',495,'450332'),(513,'梧州市',470,'450400'),(514,'万秀区',513,'450403'),(515,'长洲区',513,'450405'),(516,'龙圩区',513,'450406'),(517,'苍梧县',513,'450421'),(518,'藤县',513,'450422'),(519,'蒙山县',513,'450423'),(520,'岑溪市',513,'450481'),(521,'北海市',470,'450500'),(522,'海城区',521,'450502'),(523,'银海区',521,'450503'),(524,'铁山港区',521,'450512'),(525,'合浦县',521,'450521'),(526,'防城港市',470,'450600'),(527,'港口区',526,'450602'),(528,'防城区',526,'450603'),(529,'上思县',526,'450621'),(530,'东兴市',526,'450681'),(531,'钦州市',470,'450700'),(532,'钦南区',531,'450702'),(533,'钦北区',531,'450703'),(534,'灵山县',531,'450721'),(535,'浦北县',531,'450722'),(536,'贵港市',470,'450800'),(537,'港北区',536,'450802'),(538,'港南区',536,'450803'),(539,'覃塘区',536,'450804'),(540,'平南县',536,'450821'),(541,'桂平市',536,'450881'),(542,'玉林市',470,'450900'),(543,'玉州区',542,'450902'),(544,'福绵县',542,'450903'),(545,'容县',542,'450921'),(546,'陆川县',542,'450922'),(547,'博白县',542,'450923'),(548,'兴业县',542,'450924'),(549,'北流市',542,'450981'),(550,'百色市',470,'451000'),(551,'右江区',550,'451002'),(552,'田阳县',550,'451021'),(553,'田东县',550,'451022'),(554,'平果县',550,'451023'),(555,'德保县',550,'451024'),(556,'靖西县',550,'451025'),(557,'那坡县',550,'451026'),(558,'凌云县',550,'451027'),(559,'乐业县',550,'451028'),(560,'田林县',550,'451029'),(561,'西林县',550,'451030'),(562,'隆林县',550,'451031'),(563,'贺州市',470,'451100'),(564,'八步区',563,'451102'),(565,'平桂管理区',563,'451119'),(566,'昭平县',563,'451121'),(567,'钟山县',563,'451122'),(568,'富川县',563,'451123'),(569,'河池市',470,'451200'),(570,'金城江区',569,'451202'),(571,'南丹县',569,'451221'),(572,'天峨县',569,'451222'),(573,'凤山县',569,'451223'),(574,'东兰县',569,'451224'),(575,'罗城县',569,'451225'),(576,'环江县',569,'451226'),(577,'巴马县',569,'451227'),(578,'都安县',569,'451228'),(579,'大化县',569,'451229'),(580,'宜州市',569,'451281'),(581,'来宾市',470,'451300'),(582,'兴宾区',581,'451302'),(583,'忻城县',581,'451321'),(584,'象州县',581,'451322'),(585,'武宣县',581,'451323'),(586,'金秀县',581,'451324'),(587,'合山市',581,'451381'),(588,'崇左市',470,'451400'),(589,'江州区',588,'451402'),(590,'扶绥县',588,'451421'),(591,'宁明县',588,'451422'),(592,'龙州县',588,'451423'),(593,'大新县',588,'451424'),(594,'天等县',588,'451425'),(595,'凭祥市',588,'451481'),(596,'贵州省',0,'520000'),(597,'贵阳市',596,'520100'),(598,'南明区',597,'520102'),(599,'云岩区',597,'520103'),(600,'花溪区',597,'520111'),(601,'乌当区',597,'520112'),(602,'白云区',597,'520113'),(603,'开阳县',597,'520121'),(604,'息烽县',597,'520122'),(605,'修文县',597,'520123'),(606,'观山湖区',597,'520151'),(607,'清镇市',597,'520181'),(608,'六盘水市',596,'520200'),(609,'钟山区',608,'520201'),(610,'六枝特区',608,'520203'),(611,'水城县',608,'520221'),(612,'盘县',608,'520222'),(613,'遵义市',596,'520300'),(614,'红花岗区',613,'520302'),(615,'汇川区',613,'520303'),(616,'遵义县',613,'520321'),(617,'桐梓县',613,'520322'),(618,'绥阳县',613,'520323'),(619,'正安县',613,'520324'),(620,'道真县',613,'520325'),(621,'务川县',613,'520326'),(622,'凤冈县',613,'520327'),(623,'湄潭县',613,'520328'),(624,'余庆县',613,'520329'),(625,'习水县',613,'520330'),(626,'赤水市',613,'520381'),(627,'仁怀市',613,'520382'),(628,'安顺市',596,'520400'),(629,'西秀区',628,'520402'),(630,'平坝县',628,'520421'),(631,'普定县',628,'520422'),(632,'镇宁布依族苗族自治县',628,'520423'),(633,'关岭布依族苗族自治县',628,'520424'),(634,'紫云苗族布依族自治县',628,'520425'),(635,'铜仁市',596,'522200'),(636,'碧江区',635,'522201'),(637,'江口县',635,'522222'),(638,'玉屏侗族自治县',635,'522223'),(639,'石阡县',635,'522224'),(640,'思南县',635,'522225'),(641,'印江土家族苗族自治县',635,'522226'),(642,'德江县',635,'522227'),(643,'沿河土家族自治县',635,'522228'),(644,'松桃苗族自治县',635,'522229'),(645,'万山区',635,'522230'),(646,'黔西南州',596,'522300'),(647,'兴义市',646,'522301'),(648,'兴仁县',646,'522322'),(649,'普安县',646,'522323'),(650,'晴隆县',646,'522324'),(651,'贞丰县',646,'522325'),(652,'望谟县',646,'522326'),(653,'册亨县',646,'522327'),(654,'安龙县',646,'522328'),(655,'毕节市',596,'522400'),(656,'七星关区',655,'522401'),(657,'大方县',655,'522422'),(658,'黔西县',655,'522423'),(659,'金沙县',655,'522424'),(660,'织金县',655,'522425'),(661,'纳雍县',655,'522426'),(662,'威宁彝族语族苗族自治县',655,'522427'),(663,'赫章县',655,'522428'),(664,'黔东南州',596,'522600'),(665,'凯里市',664,'522601'),(666,'黄平县',664,'522622'),(667,'施秉市',664,'522623'),(668,'三穗县',664,'522624'),(669,'镇远县',664,'522625'),(670,'岑巩县',664,'522626'),(671,'天柱县',664,'522627'),(672,'锦屏县',664,'522628'),(673,'剑河县',664,'522629'),(674,'台江县',664,'522630'),(675,'黎平县',664,'522631'),(676,'榕江县',664,'522632'),(677,'从江县',664,'522633'),(678,'雷山县',664,'522634'),(679,'麻江县',664,'522635'),(680,'丹寨县',664,'522636'),(681,'黔南州',596,'522700'),(682,'都匀市',681,'522701'),(683,'福泉市',681,'522702'),(684,'荔波县',681,'522722'),(685,'贵定县',681,'522723'),(686,'瓮安县',681,'522725'),(687,'独山县',681,'522726'),(688,'平塘县',681,'522727'),(689,'罗甸县',681,'522728'),(690,'长顺县',681,'522729'),(691,'龙里县',681,'522730'),(692,'惠水县',681,'522731'),(693,'三都县',681,'522732'),(694,'海南省',0,'460000'),(695,'海口市',694,'460100'),(696,'秀英区',695,'460105'),(697,'龙华区',695,'460106'),(698,'琼山区',695,'460107'),(699,'美兰区',695,'460108'),(700,'三亚市',694,'460200'),(701,'海棠湾镇',700,'460202'),(702,'吉阳镇',700,'460203'),(703,'天涯镇',700,'460204'),(704,'崖城镇',700,'460205'),(705,'三沙',694,'460300'),(706,'西沙群岛',705,'460321'),(707,'南沙群岛',705,'460322'),(708,'中沙群岛',705,'460323'),(709,'五指山市',694,'469001'),(710,'五指山市',709,'469001001'),(711,'琼海市',694,'469002'),(712,'琼海市',711,'469002001'),(713,'儋州市',694,'469003'),(714,'儋州市',713,'469003001'),(715,'文昌市',694,'469005'),(716,'文昌市',715,'469005001'),(717,'万宁市',694,'469006'),(718,'万宁市',717,'469006001'),(719,'东方市',694,'469007'),(720,'东方市',719,'469007001'),(721,'定安县',694,'469025'),(722,'定安县',721,'469025001'),(723,'屯昌县',694,'469026'),(724,'屯昌县',723,'469026001'),(725,'澄迈县',694,'469027'),(726,'澄迈县',725,'469027001'),(727,'临高县',694,'469028'),(728,'临高县',727,'469028001'),(729,'白沙县',694,'469030'),(730,'白沙县',729,'469030001'),(731,'昌江县',694,'469031'),(732,'昌江县',731,'469031001'),(733,'乐东县',694,'469033'),(734,'乐东县',733,'469033001'),(735,'陵水县',694,'469034'),(736,'陵水县',735,'469034001'),(737,'保亭县',694,'469035'),(738,'保亭县',737,'469035001'),(739,'琼中县',694,'469036'),(740,'琼中县',739,'469036001'),(741,'河北省',0,'130000'),(742,'石家庄市',741,'130100'),(743,'长安区',742,'130102'),(744,'桥东区',742,'130103'),(745,'桥西区',742,'130104'),(746,'新华区',742,'130105'),(747,'井陉区矿',742,'130107'),(748,'裕华区',742,'130108'),(749,'井陉县',742,'130121'),(750,'正定县',742,'130123'),(751,'栾城县',742,'130124'),(752,'行唐县',742,'130125'),(753,'灵寿县',742,'130126'),(754,'高邑县',742,'130127'),(755,'深泽县',742,'130128'),(756,'赞皇县',742,'130129'),(757,'无极县',742,'130130'),(758,'平山县',742,'130131'),(759,'元氏县',742,'130132'),(760,'赵县',742,'130133'),(761,'辛集市',742,'130181'),(762,'藁城市',742,'130182'),(763,'晋州市',742,'130183'),(764,'新乐市',742,'130184'),(765,'鹿泉市',742,'130185'),(766,'唐山市',741,'130200'),(767,'路南区',766,'130202'),(768,'路北区',766,'130203'),(769,'古冶区',766,'130204'),(770,'开平区',766,'130205'),(771,'丰南区',766,'130207'),(772,'丰润区',766,'130208'),(773,'滦县',766,'130223'),(774,'滦南县',766,'130224'),(775,'乐亭县',766,'130225'),(776,'迁西县',766,'130227'),(777,'玉田县',766,'130229'),(778,'曹妃甸区',766,'130230'),(779,'遵化市',766,'130281'),(780,'迁安市',766,'130283'),(781,'秦皇岛市',741,'130300'),(782,'海港区',781,'130302'),(783,'山海关区',781,'130303'),(784,'北戴河区',781,'130304'),(785,'青龙县',781,'130321'),(786,'昌黎县',781,'130322'),(787,'抚宁县',781,'130323'),(788,'卢龙县',781,'130324'),(789,'邯郸市',741,'130400'),(790,'邯山区',789,'130402'),(791,'丛台区',789,'130403'),(792,'复兴区',789,'130404'),(793,'峰峰矿区',789,'130406'),(794,'邯郸县',789,'130421'),(795,'临漳县',789,'130423'),(796,'成安县',789,'130424'),(797,'大名县',789,'130425'),(798,'涉县',789,'130426'),(799,'磁县',789,'130427'),(800,'肥乡县',789,'130428'),(801,'永年县',789,'130429'),(802,'邱县县',789,'130430'),(803,'鸡泽县',789,'130431'),(804,'广平县',789,'130432'),(805,'馆陶县',789,'130433'),(806,'魏县',789,'130434'),(807,'曲周县',789,'130435'),(808,'武安市',789,'130481'),(809,'邢台市',741,'130500'),(810,'桥东区',809,'130502'),(811,'桥西区',809,'130503'),(812,'邢台县',809,'130521'),(813,'临城县',809,'130522'),(814,'内丘县',809,'130523'),(815,'柏乡县',809,'130524'),(816,'隆尧县',809,'130525'),(817,'任县',809,'130526'),(818,'南和县',809,'130527'),(819,'宁晋县',809,'130528'),(820,'巨鹿县',809,'130529'),(821,'新河县',809,'130530'),(822,'广宗县',809,'130531'),(823,'平乡县',809,'130532'),(824,'威县',809,'130533'),(825,'清河县',809,'130534'),(826,'临西县',809,'130535'),(827,'南宫市',809,'130581'),(828,'沙河市',809,'130582'),(829,'保定市',741,'130600'),(830,'新市区',829,'130602'),(831,'北市区',829,'130603'),(832,'南市区',829,'130604'),(833,'满城县',829,'130621'),(834,'清苑县',829,'130622'),(835,'涞水县',829,'130623'),(836,'阜平县',829,'130624'),(837,'徐水县',829,'130625'),(838,'定兴县',829,'130626'),(839,'唐县',829,'130627'),(840,'高阳县',829,'130628'),(841,'容城县',829,'130629'),(842,'涞源县',829,'130630'),(843,'望都县',829,'130631'),(844,'安新县',829,'130632'),(845,'易县',829,'130633'),(846,'曲阳县',829,'130634'),(847,'蠡县',829,'130635'),(848,'顺平县',829,'130636'),(849,'博野县',829,'130637'),(850,'雄县',829,'130638'),(851,'涿州市',829,'130681'),(852,'定州市',829,'130682'),(853,'安国市',829,'130683'),(854,'高碑店市',829,'130684'),(855,'张家口',741,'130700'),(856,'桥东区',855,'130702'),(857,'桥西区',855,'130703'),(858,'宣化区',855,'130705'),(859,'下花园区',855,'130706'),(860,'宣化县',855,'130721'),(861,'张北县',855,'130722'),(862,'康保县',855,'130723'),(863,'沽源县',855,'130724'),(864,'尚义县',855,'130725'),(865,'蔚县',855,'130726'),(866,'阳原县',855,'130727'),(867,'怀安县',855,'130728'),(868,'万全县',855,'130729'),(869,'怀来县',855,'130730'),(870,'涿鹿县',855,'130731'),(871,'赤城县',855,'130732'),(872,'崇礼县',855,'130733'),(873,'承德市',741,'130800'),(874,'双桥区',873,'130802'),(875,'双滦区',873,'130803'),(876,'鹰手营子矿区',873,'130804'),(877,'承德县',873,'130821'),(878,'兴隆县',873,'130822'),(879,'平泉县',873,'130823'),(880,'滦平县',873,'130824'),(881,'隆化县',873,'130825'),(882,'丰宁县',873,'130826'),(883,'宽城县',873,'130827'),(884,'围场县',873,'130828'),(885,'沧州市',741,'130900'),(886,'新华区',885,'130902'),(887,'运河区',885,'130903'),(888,'沧县',885,'130921'),(889,'青县',885,'130922'),(890,'东光县',885,'130923'),(891,'海兴县',885,'130924'),(892,'盐山县',885,'130925'),(893,'肃宁县',885,'130926'),(894,'南皮县',885,'130927'),(895,'吴桥县',885,'130928'),(896,'献县',885,'130929'),(897,'孟村县',885,'130930'),(898,'泊头市',885,'130981'),(899,'任丘市',885,'130982'),(900,'黄骅市',885,'130983'),(901,'河间市',885,'130984'),(902,'廊坊市',741,'131000'),(903,'安次区',902,'131002'),(904,'广阳区',902,'131003'),(905,'固安县',902,'131022'),(906,'永清县',902,'131023'),(907,'香河县',902,'131024'),(908,'大城县',902,'131025'),(909,'文安县',902,'131026'),(910,'大厂县',902,'131028'),(911,'霸州市',902,'131081'),(912,'三河市',902,'131082'),(913,'衡水市',741,'131100'),(914,'桃城区',913,'131102'),(915,'枣强县',913,'131121'),(916,'武邑县',913,'131122'),(917,'武强县',913,'131123'),(918,'饶阳县',913,'131124'),(919,'安平县',913,'131125'),(920,'故城县',913,'131126'),(921,'景县',913,'131127'),(922,'阜城县',913,'131128'),(923,'冀州市',913,'131181'),(924,'深州市',913,'131182'),(925,'黑龙江省',0,'230000'),(926,'哈尔滨市',925,'230100'),(927,'道里区',926,'230102'),(928,'南岗区',926,'230103'),(929,'道外区',926,'230104'),(930,'香坊区',926,'230106'),(931,'平房区',926,'230108'),(932,'松北区',926,'230109'),(933,'呼兰区',926,'230111'),(934,'依兰县',926,'230123'),(935,'方正县',926,'230124'),(936,'宾县',926,'230125'),(937,'巴彦县',926,'230126'),(938,'木兰县',926,'230127'),(939,'通河县',926,'230128'),(940,'延寿县',926,'230129'),(941,'阿城区',926,'230181'),(942,'双城市',926,'230182'),(943,'尚志市',926,'230183'),(944,'五常市',926,'230184'),(945,'齐齐哈尔市',925,'230200'),(946,'龙沙区',945,'230202'),(947,'建华区',945,'230203'),(948,'铁锋区',945,'230204'),(949,'昂昂溪区',945,'230205'),(950,'富拉尔基区',945,'230206'),(951,'碾子山区',945,'230207'),(952,'梅里斯区',945,'230208'),(953,'龙江县',945,'230221'),(954,'依安县',945,'230223'),(955,'泰来县',945,'230224'),(956,'甘南县',945,'230225'),(957,'富裕县',945,'230227'),(958,'克山县',945,'230229'),(959,'克东县',945,'230230'),(960,'拜泉县',945,'230231'),(961,'讷河市',945,'230281'),(962,'鸡西市',925,'230300'),(963,'鸡冠区',962,'230302'),(964,'恒山区',962,'230303'),(965,'滴道区',962,'230304'),(966,'梨树区',962,'230305'),(967,'城子河区',962,'230306'),(968,'麻山区',962,'230307'),(969,'鸡东县',962,'230321'),(970,'虎林市',962,'230381'),(971,'密山市',962,'230382'),(972,'鹤岗市',925,'230400'),(973,'向阳区',972,'230402'),(974,'工农区',972,'230403'),(975,'南山区',972,'230404'),(976,'兴安区',972,'230405'),(977,'东山区',972,'230406'),(978,'兴山区',972,'230407'),(979,'萝北县',972,'230421'),(980,'绥滨县',972,'230422'),(981,'双鸭山市',925,'230500'),(982,'尖山区',981,'230502'),(983,'岭东区',981,'230503'),(984,'四方台区',981,'230505'),(985,'宝山区',981,'230506'),(986,'集贤县',981,'230521'),(987,'友谊县',981,'230522'),(988,'宝清县',981,'230523'),(989,'饶河县',981,'230524'),(990,'大庆市',925,'230600'),(991,'萨尔图区',990,'230602'),(992,'龙凤区',990,'230603'),(993,'让胡路区',990,'230604'),(994,'红岗区',990,'230605'),(995,'大同区',990,'230606'),(996,'肇州县',990,'230621'),(997,'肇源县',990,'230622'),(998,'林甸县',990,'230623'),(999,'杜尔伯特县',990,'230624'),(1000,'伊春市',925,'230700'),(1001,'伊春区',1000,'230702'),(1002,'南岔区',1000,'230703'),(1003,'友好区',1000,'230704'),(1004,'西林区',1000,'230705'),(1005,'翠峦区',1000,'230706'),(1006,'新青区',1000,'230707'),(1007,'美溪区',1000,'230708'),(1008,'金山屯区',1000,'230709'),(1009,'五营区',1000,'230710'),(1010,'乌马河区',1000,'230711'),(1011,'汤旺河区',1000,'230712'),(1012,'带岭区',1000,'230713'),(1013,'乌伊岭区',1000,'230714'),(1014,'红星区',1000,'230715'),(1015,'上甘岭区',1000,'230716'),(1016,'嘉荫县',1000,'230722'),(1017,'铁力市',1000,'230781'),(1018,'佳木斯市',925,'230800'),(1019,'向阳区',1018,'230803'),(1020,'前进区',1018,'230804'),(1021,'东风区',1018,'230805'),(1022,'郊区',1018,'230811'),(1023,'桦南县',1018,'230822'),(1024,'桦川县',1018,'230826'),(1025,'汤原县',1018,'230828'),(1026,'抚远县',1018,'230833'),(1027,'同江市',1018,'230881'),(1028,'富锦市',1018,'230882'),(1029,'七台河市',925,'230900'),(1030,'新兴区',1029,'230902'),(1031,'桃山区',1029,'230903'),(1032,'茄子河区',1029,'230904'),(1033,'勃利县',1029,'230921'),(1034,'牡丹江市',925,'231000'),(1035,'东安区',1034,'231002'),(1036,'阳明区',1034,'231003'),(1037,'爱民区',1034,'231004'),(1038,'西安区',1034,'231005'),(1039,'东宁县',1034,'231024'),(1040,'林口县',1034,'231025'),(1041,'绥芬河市',1034,'231081'),(1042,'海林市',1034,'231083'),(1043,'宁安市',1034,'231084'),(1044,'穆棱市',1034,'231085'),(1045,'黑河市',925,'231100'),(1046,'爱辉区',1045,'231102'),(1047,'嫩江县',1045,'231121'),(1048,'逊克县',1045,'231123'),(1049,'孙吴县',1045,'231124'),(1050,'北安市',1045,'231181'),(1051,'五大连池市',1045,'231182'),(1052,'绥化市',925,'231200'),(1053,'北林区',1052,'231202'),(1054,'望奎县',1052,'231221'),(1055,'兰西县',1052,'231222'),(1056,'青冈县',1052,'231223'),(1057,'庆安县',1052,'231224'),(1058,'明水县',1052,'231225'),(1059,'绥棱县',1052,'231226'),(1060,'安达市',1052,'231281'),(1061,'肇东市',1052,'231282'),(1062,'海伦市',1052,'231283'),(1063,'大兴安岭地区',925,'232700'),(1064,'松岭区',1063,'232702'),(1065,'新林区',1063,'232703'),(1066,'呼中区',1063,'232704'),(1067,'呼玛县',1063,'232721'),(1068,'塔河县',1063,'232722'),(1069,'漠河县',1063,'232723'),(1070,'加格达奇区',1063,'232724'),(1071,'河南省',0,'410000'),(1072,'郑州市',1071,'410100'),(1073,'中原区',1072,'410102'),(1074,'二七区',1072,'410103'),(1075,'管城区',1072,'410104'),(1076,'金水区',1072,'410105'),(1077,'上街区',1072,'410106'),(1078,'惠济区',1072,'410108'),(1079,'中牟县',1072,'410122'),(1080,'巩义市',1072,'410181'),(1081,'荥阳市',1072,'410182'),(1082,'新密市',1072,'410183'),(1083,'新郑市',1072,'410184'),(1084,'登封市',1072,'410185'),(1085,'开封市',1071,'410200'),(1086,'龙亭区',1085,'410202'),(1087,'顺河区',1085,'410203'),(1088,'鼓楼区',1085,'410204'),(1089,'禹王台区',1085,'410205'),(1090,'金明区',1085,'410211'),(1091,'杞县',1085,'410221'),(1092,'通许县',1085,'410222'),(1093,'尉氏县',1085,'410223'),(1094,'祥符县',1085,'410224'),(1095,'兰考县',1085,'410225'),(1096,'洛阳市',1071,'410300'),(1097,'老城区',1096,'410302'),(1098,'西工区',1096,'410303'),(1099,'瀍河区',1096,'410304'),(1100,'涧西区',1096,'410305'),(1101,'吉利区',1096,'410306'),(1102,'洛龙区',1096,'410307'),(1103,'孟津县',1096,'410322'),(1104,'新安县',1096,'410323'),(1105,'栾川县',1096,'410324'),(1106,'嵩县',1096,'410325'),(1107,'汝阳县',1096,'410326'),(1108,'宜阳县',1096,'410327'),(1109,'洛宁县',1096,'410328'),(1110,'伊川县',1096,'410329'),(1111,'偃师市',1096,'410381'),(1112,'平顶山市',1071,'410400'),(1113,'新华区',1112,'410402'),(1114,'卫东区',1112,'410403'),(1115,'石龙区',1112,'410404'),(1116,'湛河区',1112,'410411'),(1117,'宝丰县',1112,'410421'),(1118,'叶县',1112,'410422'),(1119,'鲁山县',1112,'410423'),(1120,'郏县',1112,'410425'),(1121,'舞钢市',1112,'410481'),(1122,'汝州市',1112,'410482'),(1123,'安阳市',1071,'410500'),(1124,'文峰区',1123,'410502'),(1125,'北关区',1123,'410503'),(1126,'殷都区',1123,'410505'),(1127,'龙安区',1123,'410506'),(1128,'安阳县',1123,'410522'),(1129,'汤阴县',1123,'410523'),(1130,'滑县',1123,'410526'),(1131,'内黄县',1123,'410527'),(1132,'林州市',1123,'410581'),(1133,'鹤壁市',1071,'410600'),(1134,'鹤山区',1133,'410602'),(1135,'山城区',1133,'410603'),(1136,'淇滨区',1133,'410611'),(1137,'浚县',1133,'410621'),(1138,'淇县',1133,'410622'),(1139,'新乡市',1071,'410700'),(1140,'红旗区',1139,'410702'),(1141,'卫滨区',1139,'410703'),(1142,'凤泉区',1139,'410704'),(1143,'牧野区',1139,'410711'),(1144,'新乡县',1139,'410721'),(1145,'获嘉县',1139,'410724'),(1146,'原阳县',1139,'410725'),(1147,'延津县',1139,'410726'),(1148,'封丘县',1139,'410727'),(1149,'长垣县',1139,'410728'),(1150,'卫辉市',1139,'410781'),(1151,'辉县市',1139,'410782'),(1152,'焦作市',1071,'410800'),(1153,'解放区',1152,'410802'),(1154,'中站区',1152,'410803'),(1155,'马村区',1152,'410804'),(1156,'山阳区',1152,'410811'),(1157,'修武县',1152,'410821'),(1158,'博爱县',1152,'410822'),(1159,'武陟县',1152,'410823'),(1160,'温县',1152,'410825'),(1161,'沁阳市',1152,'410882'),(1162,'孟州市',1152,'410883'),(1163,'济源市',1071,'410881'),(1164,'济源市',1163,'410881001'),(1165,'濮阳市',1071,'410900'),(1166,'华龙区',1165,'410902'),(1167,'清丰县',1165,'410922'),(1168,'南乐县',1165,'410923'),(1169,'范县',1165,'410926'),(1170,'台前县',1165,'410927'),(1171,'濮阳县',1165,'410928'),(1172,'许昌市',1071,'411000'),(1173,'魏都区',1172,'411002'),(1174,'许昌县',1172,'411023'),(1175,'鄢陵县',1172,'411024'),(1176,'襄城县',1172,'411025'),(1177,'禹州市',1172,'411081'),(1178,'长葛市',1172,'411082'),(1179,'漯河市',1071,'411100'),(1180,'源汇区',1179,'411102'),(1181,'郾城区',1179,'411103'),(1182,'召陵区',1179,'411104'),(1183,'舞阳县',1179,'411121'),(1184,'临颍县',1179,'411122'),(1185,'三门峡市',1071,'411200'),(1186,'湖滨区',1185,'411202'),(1187,'渑池县',1185,'411221'),(1188,'陕州县',1185,'411222'),(1189,'卢氏县',1185,'411224'),(1190,'义马市',1185,'411281'),(1191,'灵宝市',1185,'411282'),(1192,'南阳市',1071,'411300'),(1193,'宛城区',1192,'411302'),(1194,'卧龙区',1192,'411303'),(1195,'南召县',1192,'411321'),(1196,'方城县',1192,'411322'),(1197,'西峡县',1192,'411323'),(1198,'镇平县',1192,'411324'),(1199,'内乡县',1192,'411325'),(1200,'淅川县',1192,'411326'),(1201,'社旗县',1192,'411327'),(1202,'唐河县',1192,'411328'),(1203,'新野县',1192,'411329'),(1204,'桐柏县',1192,'411330'),(1205,'邓州市',1192,'411381'),(1206,'商丘市',1071,'411400'),(1207,'梁园区',1206,'411402'),(1208,'睢阳区',1206,'411403'),(1209,'民权县',1206,'411421'),(1210,'睢县',1206,'411422'),(1211,'宁陵县',1206,'411423'),(1212,'柘城县',1206,'411424'),(1213,'虞城县',1206,'411425'),(1214,'夏邑县',1206,'411426'),(1215,'永城市',1206,'411481'),(1216,'信阳市',1071,'411500'),(1217,'浉河区',1216,'411502'),(1218,'平桥区',1216,'411503'),(1219,'罗山县',1216,'411521'),(1220,'光山县',1216,'411522'),(1221,'新县',1216,'411523'),(1222,'商城县',1216,'411524'),(1223,'固始县',1216,'411525'),(1224,'潢川县',1216,'411526'),(1225,'淮滨县',1216,'411527'),(1226,'息县',1216,'411528'),(1227,'周口市',1071,'411600'),(1228,'川汇区',1227,'411602'),(1229,'扶沟县',1227,'411621'),(1230,'西华县',1227,'411622'),(1231,'商水县',1227,'411623'),(1232,'沈丘县',1227,'411624'),(1233,'郸城县',1227,'411625'),(1234,'淮阳县',1227,'411626'),(1235,'太康县',1227,'411627'),(1236,'鹿邑县',1227,'411628'),(1237,'项城市',1227,'411681'),(1238,'驻马店市',1071,'411700'),(1239,'驿城区',1238,'411702'),(1240,'西平县',1238,'411721'),(1241,'上蔡县',1238,'411722'),(1242,'平舆县',1238,'411723'),(1243,'正阳县',1238,'411724'),(1244,'确山县',1238,'411725'),(1245,'泌阳县',1238,'411726'),(1246,'汝南县',1238,'411727'),(1247,'遂平县',1238,'411728'),(1248,'新蔡县',1238,'411729'),(1249,'湖北省',0,'420000'),(1250,'武汉市',1249,'420100'),(1251,'江岸区',1250,'420102'),(1252,'江汉区',1250,'420103'),(1253,'硚口区',1250,'420104'),(1254,'汉阳区',1250,'420105'),(1255,'武昌区',1250,'420106'),(1256,'青山区',1250,'420107'),(1257,'洪山区',1250,'420111'),(1258,'东西湖区',1250,'420112'),(1259,'汉南区',1250,'420113'),(1260,'蔡甸区',1250,'420114'),(1261,'江夏区',1250,'420115'),(1262,'黄陂区',1250,'420116'),(1263,'新洲区',1250,'420117'),(1264,'黄石市',1249,'420200'),(1265,'黄石港区',1264,'420202'),(1266,'西塞山区',1264,'420203'),(1267,'下陆区',1264,'420204'),(1268,'铁山区',1264,'420205'),(1269,'阳新县',1264,'420222'),(1270,'大冶市',1264,'420281'),(1271,'十堰市',1249,'420300'),(1272,'茅箭区',1271,'420302'),(1273,'张湾区',1271,'420303'),(1274,'郧县',1271,'420321'),(1275,'郧西县',1271,'420322'),(1276,'竹山县',1271,'420323'),(1277,'竹溪县',1271,'420324'),(1278,'房县',1271,'420325'),(1279,'丹江口市',1271,'420381'),(1280,'宜昌市',1249,'420500'),(1281,'西陵区',1280,'420502'),(1282,'伍家岗区',1280,'420503'),(1283,'点军区',1280,'420504'),(1284,'猇亭区',1280,'420505'),(1285,'夷陵区',1280,'420506'),(1286,'远安县',1280,'420525'),(1287,'兴山县',1280,'420526'),(1288,'秭归县',1280,'420527'),(1289,'长阳土家族自治县',1280,'420528'),(1290,'五峰土家族自治县',1280,'420529'),(1291,'宜都市',1280,'420581'),(1292,'当阳市',1280,'420582'),(1293,'枝江市',1280,'420583'),(1294,'襄阳市',1249,'420600'),(1295,'襄城区',1294,'420602'),(1296,'樊城区',1294,'420606'),(1297,'襄州区',1294,'420607'),(1298,'南漳县',1294,'420624'),(1299,'谷城县',1294,'420625'),(1300,'保康县',1294,'420626'),(1301,'老河口市',1294,'420682'),(1302,'枣阳市',1294,'420683'),(1303,'宜城市',1294,'420684'),(1304,'鄂州市',1249,'420700'),(1305,'梁子湖区',1304,'420702'),(1306,'华容区',1304,'420703'),(1307,'鄂城区',1304,'420704'),(1308,'荆门市',1249,'420800'),(1309,'东宝区',1308,'420802'),(1310,'掇刀区',1308,'420804'),(1311,'京山县',1308,'420821'),(1312,'沙洋县',1308,'420822'),(1313,'钟祥市',1308,'420881'),(1314,'孝感市',1249,'420900'),(1315,'孝南区',1314,'420902'),(1316,'孝昌县',1314,'420921'),(1317,'大悟县',1314,'420922'),(1318,'云梦县',1314,'420923'),(1319,'应城市',1314,'420981'),(1320,'安陆市',1314,'420982'),(1321,'汉川市',1314,'420984'),(1322,'荆州市',1249,'421000'),(1323,'沙市区',1322,'421002'),(1324,'荆州区',1322,'421003'),(1325,'公安县',1322,'421022'),(1326,'监利县',1322,'421023'),(1327,'江陵县',1322,'421024'),(1328,'石首市',1322,'421081'),(1329,'洪湖市',1322,'421083'),(1330,'松滋市',1322,'421087'),(1331,'黄冈市',1249,'421100'),(1332,'黄州区',1331,'421102'),(1333,'团风县',1331,'421121'),(1334,'红安县',1331,'421122'),(1335,'罗田县',1331,'421123'),(1336,'英山县',1331,'421124'),(1337,'浠水县',1331,'421125'),(1338,'蕲春县',1331,'421126'),(1339,'黄梅县',1331,'421127'),(1340,'麻城市',1331,'421181'),(1341,'武穴市',1331,'421182'),(1342,'咸宁市',1249,'421200'),(1343,'咸安区',1342,'421202'),(1344,'嘉鱼县',1342,'421221'),(1345,'通城县',1342,'421222'),(1346,'崇阳县',1342,'421223'),(1347,'通山县',1342,'421224'),(1348,'赤壁市',1342,'421281'),(1349,'随州市',1249,'421300'),(1350,'曾都区',1349,'421302'),(1351,'随县',1349,'421321'),(1352,'广水市',1349,'421381'),(1353,'恩施州',1249,'422800'),(1354,'恩施市',1353,'422801'),(1355,'利川市',1353,'422802'),(1356,'建始县',1353,'422822'),(1357,'巴东县',1353,'422823'),(1358,'宣恩县',1353,'422825'),(1359,'咸丰县',1353,'422826'),(1360,'来凤县',1353,'422827'),(1361,'鹤峰县',1353,'422828'),(1362,'仙桃市',1249,'429004'),(1363,'仙桃市',1362,'429004001'),(1364,'潜江市',1249,'429005'),(1365,'潜江市',1364,'429005001'),(1366,'天门市',1249,'429006'),(1367,'天门市',1366,'429006001'),(1368,'神农架林区',1249,'429021'),(1369,'神农架林区',1368,'429021001'),(1370,'湖南省',0,'430000'),(1371,'长沙市',1370,'430100'),(1372,'芙蓉区',1371,'430102'),(1373,'天心区',1371,'430103'),(1374,'岳麓区',1371,'430104'),(1375,'开福区',1371,'430105'),(1376,'雨花区',1371,'430111'),(1377,'长沙县',1371,'430121'),(1378,'望城区',1371,'430122'),(1379,'宁乡县',1371,'430124'),(1380,'浏阳市',1371,'430181'),(1381,'株洲市',1370,'430200'),(1382,'荷塘区',1381,'430202'),(1383,'芦淞区',1381,'430203'),(1384,'石峰区',1381,'430204'),(1385,'天元区',1381,'430211'),(1386,'株洲县',1381,'430221'),(1387,'攸县',1381,'430223'),(1388,'茶陵县',1381,'430224'),(1389,'炎陵县',1381,'430225'),(1390,'醴陵市',1381,'430281'),(1391,'湘潭市',1370,'430300'),(1392,'雨湖区',1391,'430302'),(1393,'岳塘区',1391,'430304'),(1394,'湘潭县',1391,'430321'),(1395,'湘乡市',1391,'430381'),(1396,'韶山市',1391,'430382'),(1397,'衡阳市',1370,'430400'),(1398,'珠晖区',1397,'430405'),(1399,'雁峰区',1397,'430406'),(1400,'石鼓区',1397,'430407'),(1401,'蒸湘区',1397,'430408'),(1402,'南岳区',1397,'430412'),(1403,'衡阳县',1397,'430421'),(1404,'衡南县',1397,'430422'),(1405,'衡山县',1397,'430423'),(1406,'衡东县',1397,'430424'),(1407,'祁东县',1397,'430426'),(1408,'耒阳市',1397,'430481'),(1409,'常宁市',1397,'430482'),(1410,'邵阳市',1370,'430500'),(1411,'双清区',1410,'430502'),(1412,'大祥区',1410,'430503'),(1413,'北塔区',1410,'430511'),(1414,'邵东县',1410,'430521'),(1415,'新邵县',1410,'430522'),(1416,'邵阳县',1410,'430523'),(1417,'隆回县',1410,'430524'),(1418,'洞口县',1410,'430525'),(1419,'绥宁县',1410,'430527'),(1420,'新宁县',1410,'430528'),(1421,'城步县',1410,'430529'),(1422,'武冈市',1410,'430581'),(1423,'岳阳市',1370,'430600'),(1424,'岳阳楼区',1423,'430602'),(1425,'云溪区',1423,'430603'),(1426,'君山区',1423,'430611'),(1427,'岳阳县',1423,'430621'),(1428,'华容县',1423,'430623'),(1429,'湘阴县',1423,'430624'),(1430,'平江县',1423,'430626'),(1431,'汨罗市',1423,'430681'),(1432,'临湘市',1423,'430682'),(1433,'常德市',1370,'430700'),(1434,'武陵区',1433,'430702'),(1435,'鼎城区',1433,'430703'),(1436,'安乡县',1433,'430721'),(1437,'汉寿县',1433,'430722'),(1438,'澧县',1433,'430723'),(1439,'临澧县',1433,'430724'),(1440,'桃源县',1433,'430725'),(1441,'石门县',1433,'430726'),(1442,'津市市',1433,'430781'),(1443,'张家界市',1370,'430800'),(1444,'永定区',1443,'430802'),(1445,'武陵源区',1443,'430811'),(1446,'慈利县',1443,'430821'),(1447,'桑植县',1443,'430822'),(1448,'益阳市',1370,'430900'),(1449,'资阳区',1448,'430902'),(1450,'赫山区',1448,'430903'),(1451,'南县',1448,'430921'),(1452,'桃江县',1448,'430922'),(1453,'安化县',1448,'430923'),(1454,'沅江市',1448,'430981'),(1455,'郴州市',1370,'431000'),(1456,'北湖区',1455,'431002'),(1457,'苏仙区',1455,'431003'),(1458,'桂阳县',1455,'431021'),(1459,'宜章县',1455,'431022'),(1460,'永兴县',1455,'431023'),(1461,'嘉禾县',1455,'431024'),(1462,'临武县',1455,'431025'),(1463,'汝城县',1455,'431026'),(1464,'桂东县',1455,'431027'),(1465,'安仁县',1455,'431028'),(1466,'资兴市',1455,'431081'),(1467,'永州市',1370,'431100'),(1468,'零陵区',1467,'431102'),(1469,'冷水滩区',1467,'431103'),(1470,'祁阳县',1467,'431121'),(1471,'东安县',1467,'431122'),(1472,'双牌县',1467,'431123'),(1473,'道县',1467,'431124'),(1474,'江永县',1467,'431125'),(1475,'宁远县',1467,'431126'),(1476,'蓝山县',1467,'431127'),(1477,'新田县',1467,'431128'),(1478,'江华县',1467,'431129'),(1479,'怀化市',1370,'431200'),(1480,'鹤城区',1479,'431202'),(1481,'中方县',1479,'431221'),(1482,'沅陵县',1479,'431222'),(1483,'辰溪县',1479,'431223'),(1484,'溆浦县',1479,'431224'),(1485,'会同县',1479,'431225'),(1486,'麻阳县',1479,'431226'),(1487,'新晃县',1479,'431227'),(1488,'芷江县',1479,'431228'),(1489,'靖州县',1479,'431229'),(1490,'通道县',1479,'431230'),(1491,'洪江市',1479,'431281'),(1492,'娄底市',1370,'431300'),(1493,'娄星区',1492,'431302'),(1494,'双峰县',1492,'431321'),(1495,'新化县',1492,'431322'),(1496,'冷水江市',1492,'431381'),(1497,'涟源市',1492,'431382'),(1498,'湘西州',1370,'433100'),(1499,'吉首市',1498,'433101'),(1500,'泸溪县',1498,'433122'),(1501,'凤凰县',1498,'433123'),(1502,'花垣县',1498,'433124'),(1503,'保靖县',1498,'433125'),(1504,'古丈县',1498,'433126'),(1505,'永顺县',1498,'433127'),(1506,'龙山县',1498,'433130'),(1507,'江苏省',0,'320000'),(1508,'南京市',1507,'320100'),(1509,'玄武区',1508,'320102'),(1510,'秦淮区',1508,'320104'),(1511,'建邺区',1508,'320105'),(1512,'鼓楼区',1508,'320106'),(1513,'浦口区',1508,'320111'),(1514,'栖霞区',1508,'320113'),(1515,'雨花台区',1508,'320114'),(1516,'江宁区',1508,'320115'),(1517,'六合区',1508,'320116'),(1518,'溧水区',1508,'320124'),(1519,'高淳区',1508,'320125'),(1520,'无锡市',1507,'320200'),(1521,'崇安区',1520,'320202'),(1522,'南长区',1520,'320203'),(1523,'北塘区',1520,'320204'),(1524,'锡山区',1520,'320205'),(1525,'惠山区',1520,'320206'),(1526,'滨湖区',1520,'320211'),(1527,'江阴市',1520,'320281'),(1528,'宜兴市',1520,'320282'),(1529,'徐州市',1507,'320300'),(1530,'鼓楼区',1529,'320302'),(1531,'云龙区',1529,'320303'),(1532,'贾汪区',1529,'320305'),(1533,'泉山区',1529,'320311'),(1534,'丰县',1529,'320321'),(1535,'沛县',1529,'320322'),(1536,'铜山区',1529,'320323'),(1537,'睢宁县',1529,'320324'),(1538,'新沂市',1529,'320381'),(1539,'邳州市',1529,'320382'),(1540,'常州市',1507,'320400'),(1541,'天宁区',1540,'320402'),(1542,'钟楼区',1540,'320404'),(1543,'戚墅堰区',1540,'320405'),(1544,'新北区',1540,'320411'),(1545,'武进区',1540,'320412'),(1546,'溧阳市',1540,'320481'),(1547,'金坛区',1540,'320482'),(1548,'苏州市',1507,'320500'),(1549,'虎丘区',1548,'320505'),(1550,'吴中区',1548,'320506'),(1551,'相城区',1548,'320507'),(1552,'姑苏区',1548,'320508'),(1553,'常熟市',1548,'320581'),(1554,'张家港市',1548,'320582'),(1555,'昆山市',1548,'320583'),(1556,'吴江区',1548,'320584'),(1557,'太仓市',1548,'320585'),(1558,'南通市',1507,'320600'),(1559,'崇川区',1558,'320602'),(1560,'港闸区',1558,'320611'),(1561,'通州区',1558,'320612'),(1562,'海安县',1558,'320621'),(1563,'如东县',1558,'320623'),(1564,'启东市',1558,'320681'),(1565,'如皋市',1558,'320682'),(1566,'海门市',1558,'320684'),(1567,'连云港市',1507,'320700'),(1568,'连云区',1567,'320703'),(1569,'新浦区',1567,'320705'),(1570,'海州区',1567,'320706'),(1571,'赣榆区',1567,'320721'),(1572,'东海县',1567,'320722'),(1573,'灌云县',1567,'320723'),(1574,'灌南县',1567,'320724'),(1575,'淮安市',1507,'320800'),(1576,'清河区',1575,'320802'),(1577,'淮安区',1575,'320803'),(1578,'淮阴区',1575,'320804'),(1579,'清浦区',1575,'320811'),(1580,'涟水县',1575,'320826'),(1581,'洪泽县',1575,'320829'),(1582,'盱眙县',1575,'320830'),(1583,'金湖县',1575,'320831'),(1584,'盐城市',1507,'320900'),(1585,'亭湖区',1584,'320902'),(1586,'盐都区',1584,'320903'),(1587,'响水县',1584,'320921'),(1588,'滨海县',1584,'320922'),(1589,'阜宁县',1584,'320923'),(1590,'射阳县',1584,'320924'),(1591,'建湖县',1584,'320925'),(1592,'东台市',1584,'320981'),(1593,'大丰区',1584,'320982'),(1594,'扬州市',1507,'321000'),(1595,'广陵区',1594,'321002'),(1596,'邗江区',1594,'321003'),(1597,'宝应县',1594,'321023'),(1598,'仪征市',1594,'321081'),(1599,'高邮市',1594,'321084'),(1600,'江都区',1594,'321088'),(1601,'镇江市',1507,'321100'),(1602,'京口区',1601,'321102'),(1603,'润州区',1601,'321111'),(1604,'丹徒区',1601,'321112'),(1605,'丹阳市',1601,'321181'),(1606,'扬中市',1601,'321182'),(1607,'句容市',1601,'321183'),(1608,'泰州市',1507,'321200'),(1609,'海陵区',1608,'321202'),(1610,'高港区',1608,'321203'),(1611,'兴化市',1608,'321281'),(1612,'靖江市',1608,'321282'),(1613,'泰兴市',1608,'321283'),(1614,'姜堰区',1608,'321284'),(1615,'宿迁市',1507,'321300'),(1616,'宿城区',1615,'321302'),(1617,'宿豫区',1615,'321311'),(1618,'沭阳县',1615,'321322'),(1619,'泗阳县',1615,'321323'),(1620,'泗洪县',1615,'321324'),(1621,'江西省',0,'360000'),(1622,'南昌市',1621,'360100'),(1623,'东湖区',1622,'360102'),(1624,'西湖区',1622,'360103'),(1625,'青云谱区',1622,'360104'),(1626,'湾里区',1622,'360105'),(1627,'青山湖区',1622,'360111'),(1628,'南昌县',1622,'360121'),(1629,'新建县',1622,'360122'),(1630,'安义县',1622,'360123'),(1631,'进贤县',1622,'360124'),(1632,'景德镇市',1621,'360200'),(1633,'昌江区',1632,'360202'),(1634,'珠山区',1632,'360203'),(1635,'浮梁县',1632,'360222'),(1636,'乐平市',1632,'360281'),(1637,'萍乡市',1621,'360300'),(1638,'安源区',1637,'360302'),(1639,'湘东区',1637,'360313'),(1640,'莲花县',1637,'360321'),(1641,'上栗县',1637,'360322'),(1642,'芦溪县',1637,'360323'),(1643,'九江市',1621,'360400'),(1644,'庐山区',1643,'360402'),(1645,'浔阳区',1643,'360403'),(1646,'九江县',1643,'360421'),(1647,'武宁县',1643,'360423'),(1648,'修水县',1643,'360424'),(1649,'永修县',1643,'360425'),(1650,'德安县',1643,'360426'),(1651,'星子县',1643,'360427'),(1652,'都昌县',1643,'360428'),(1653,'湖口县',1643,'360429'),(1654,'彭泽县',1643,'360430'),(1655,'瑞昌县',1643,'360481'),(1656,'共青城市',1643,'360483'),(1657,'新余',1621,'360500'),(1658,'渝水区',1657,'360502'),(1659,'分宜县',1657,'360521'),(1660,'鹰潭市',1621,'360600'),(1661,'月湖区',1660,'360602'),(1662,'余江县',1660,'360622'),(1663,'贵溪市',1660,'360681'),(1664,'赣州市',1621,'360700'),(1665,'章贡区',1664,'360702'),(1666,'赣县',1664,'360721'),(1667,'信丰县',1664,'360722'),(1668,'大余县',1664,'360723'),(1669,'上犹县',1664,'360724'),(1670,'崇义县',1664,'360725'),(1671,'安远县',1664,'360726'),(1672,'龙南县',1664,'360727'),(1673,'定南县',1664,'360728'),(1674,'全南县',1664,'360729'),(1675,'宁都县',1664,'360730'),(1676,'于都县',1664,'360731'),(1677,'兴国县',1664,'360732'),(1678,'会昌县',1664,'360733'),(1679,'寻乌县',1664,'360734'),(1680,'石城县',1664,'360735'),(1681,'瑞金市',1664,'360781'),(1682,'南康市',1664,'360782'),(1683,'吉安市',1621,'360800'),(1684,'吉州区',1683,'360802'),(1685,'青原区',1683,'360803'),(1686,'吉安县',1683,'360821'),(1687,'吉水县',1683,'360822'),(1688,'峡江县',1683,'360823'),(1689,'新干县',1683,'360824'),(1690,'永丰县',1683,'360825'),(1691,'泰和县',1683,'360826'),(1692,'遂川县',1683,'360827'),(1693,'万安县',1683,'360828'),(1694,'安福县',1683,'360829'),(1695,'永新县',1683,'360830'),(1696,'井冈山市',1683,'360881'),(1697,'宜春市',1621,'360900'),(1698,'袁州区',1697,'360902'),(1699,'奉新县',1697,'360921'),(1700,'万载县',1697,'360922'),(1701,'上高县',1697,'360923'),(1702,'宜丰县',1697,'360924'),(1703,'靖安县',1697,'360925'),(1704,'铜鼓县',1697,'360926'),(1705,'丰城市',1697,'360981'),(1706,'樟树市',1697,'360982'),(1707,'高安市',1697,'360983'),(1708,'抚州市',1621,'361000'),(1709,'临川区',1708,'361002'),(1710,'南城县',1708,'361021'),(1711,'黎川县',1708,'361022'),(1712,'南丰县',1708,'361023'),(1713,'崇仁县',1708,'361024'),(1714,'乐安县',1708,'361025'),(1715,'宜黄县',1708,'361026'),(1716,'金溪县',1708,'361027'),(1717,'资溪县',1708,'361028'),(1718,'东乡县',1708,'361029'),(1719,'广昌县',1708,'361030'),(1720,'上饶市',1621,'361100'),(1721,'信州区',1720,'361102'),(1722,'上饶县',1720,'361121'),(1723,'广丰县',1720,'361122'),(1724,'玉山县',1720,'361123'),(1725,'铅山县',1720,'361124'),(1726,'横峰县',1720,'361125'),(1727,'弋阳县',1720,'361126'),(1728,'余干县',1720,'361127'),(1729,'鄱阳县',1720,'361128'),(1730,'万年县',1720,'361129'),(1731,'婺源县',1720,'361130'),(1732,'德兴市',1720,'361181'),(1733,'吉林省',0,'220000'),(1734,'长春市',1733,'220100'),(1735,'南关区',1734,'220102'),(1736,'宽城区',1734,'220103'),(1737,'朝阳区',1734,'220104'),(1738,'二道区',1734,'220105'),(1739,'绿园区',1734,'220106'),(1740,'双阳区',1734,'220112'),(1741,'农安县',1734,'220122'),(1742,'九台市',1734,'220181'),(1743,'榆树市',1734,'220182'),(1744,'德惠市',1734,'220183'),(1745,'吉林市',1733,'220200'),(1746,'昌邑区',1745,'220202'),(1747,'龙潭区',1745,'220203'),(1748,'船营区',1745,'220204'),(1749,'丰满区',1745,'220211'),(1750,'永吉县',1745,'220221'),(1751,'蛟河市',1745,'220281'),(1752,'桦甸市',1745,'220282'),(1753,'舒兰市',1745,'220283'),(1754,'磐石市',1745,'220284'),(1755,'四平市',1733,'220300'),(1756,'铁西区',1755,'220302'),(1757,'铁东区',1755,'220303'),(1758,'梨树县',1755,'220322'),(1759,'伊通县',1755,'220323'),(1760,'公主岭市',1755,'220381'),(1761,'双辽市',1755,'220382'),(1762,'辽源市',1733,'220400'),(1763,'龙山区',1762,'220402'),(1764,'西安区',1762,'220403'),(1765,'东丰县',1762,'220421'),(1766,'东辽县',1762,'220422'),(1767,'通化市',1733,'220500'),(1768,'东昌区',1767,'220502'),(1769,'二道江区',1767,'220503'),(1770,'通化县',1767,'220521'),(1771,'辉南县',1767,'220523'),(1772,'柳河县',1767,'220524'),(1773,'梅河口市',1767,'220581'),(1774,'集安市',1767,'220582'),(1775,'白山市',1733,'220600'),(1776,'浑江区',1775,'220602'),(1777,'抚松县',1775,'220621'),(1778,'靖宇县',1775,'220622'),(1779,'长白县',1775,'220623'),(1780,'江源区',1775,'220625'),(1781,'临江市',1775,'220681'),(1782,'松原市',1733,'220700'),(1783,'宁江区',1782,'220702'),(1784,'前郭县',1782,'220721'),(1785,'长岭县',1782,'220722'),(1786,'乾安县',1782,'220723'),(1787,'扶余县',1782,'220724'),(1788,'白城市',1733,'220800'),(1789,'洮北区',1788,'220802'),(1790,'镇赉县',1788,'220821'),(1791,'通榆县',1788,'220822'),(1792,'洮南市',1788,'220881'),(1793,'大安市',1788,'220882'),(1794,'延边州',1733,'222400'),(1795,'延吉市',1794,'222401'),(1796,'图们市',1794,'222402'),(1797,'敦化市',1794,'222403'),(1798,'珲春市',1794,'222404'),(1799,'龙井市',1794,'222405'),(1800,'和龙市',1794,'222406'),(1801,'汪清县',1794,'222424'),(1802,'安图县',1794,'222426'),(1803,'辽宁省',0,'210000'),(1804,'沈阳市',1803,'210100'),(1805,'和平区',1804,'210102'),(1806,'沈河区',1804,'210103'),(1807,'大东区',1804,'210104'),(1808,'皇姑区',1804,'210105'),(1809,'铁西区',1804,'210106'),(1810,'苏家屯区',1804,'210111'),(1811,'浑南新区',1804,'210112'),(1812,'新城子区',1804,'210113'),(1813,'于洪去',1804,'210114'),(1814,'辽中县',1804,'210122'),(1815,'康平县',1804,'210123'),(1816,'法库县',1804,'210124'),(1817,'新民市',1804,'210181'),(1818,'沈北新区',1804,'210184'),(1819,'大连市',1803,'210200'),(1820,'中山区',1819,'210202'),(1821,'西岗区',1819,'210203'),(1822,'沙河口区',1819,'210204'),(1823,'甘井子区',1819,'210211'),(1824,'旅顺口区',1819,'210212'),(1825,'金州区',1819,'210213'),(1826,'长海县',1819,'210224'),(1827,'瓦房店市',1819,'210281'),(1828,'普兰店市',1819,'210282'),(1829,'庄河市',1819,'210283'),(1830,'鞍山市',1803,'210300'),(1831,'铁东区',1830,'210302'),(1832,'铁西区',1830,'210303'),(1833,'立山区',1830,'210304'),(1834,'千山区',1830,'210311'),(1835,'台安县',1830,'210321'),(1836,'岫岩县',1830,'210323'),(1837,'海城市',1830,'210381'),(1838,'抚顺市',1803,'210400'),(1839,'新抚区',1838,'210402'),(1840,'东洲区',1838,'210403'),(1841,'望花区',1838,'210404'),(1842,'顺城区',1838,'210411'),(1843,'抚顺县',1838,'210421'),(1844,'新宾县',1838,'210422'),(1845,'清原县',1838,'210423'),(1846,'本溪市',1803,'210500'),(1847,'平山区',1846,'210502'),(1848,'溪湖区',1846,'210503'),(1849,'明山区',1846,'210504'),(1850,'南芬区',1846,'210505'),(1851,'本溪县',1846,'210521'),(1852,'桓仁县',1846,'210522'),(1853,'丹东市',1803,'210600'),(1854,'元宝区',1853,'210602'),(1855,'振兴区',1853,'210603'),(1856,'振安区',1853,'210604'),(1857,'宽甸县',1853,'210624'),(1858,'东港市',1853,'210681'),(1859,'凤城市',1853,'210682'),(1860,'锦州市',1803,'210700'),(1861,'古塔区',1860,'210702'),(1862,'凌河区',1860,'210703'),(1863,'太和区',1860,'210711'),(1864,'黑山县',1860,'210726'),(1865,'义县',1860,'210727'),(1866,'凌海市',1860,'210781'),(1867,'北镇市',1860,'210782'),(1868,'营口市',1803,'210800'),(1869,'站前区',1868,'210802'),(1870,'西市区',1868,'210803'),(1871,'鲅鱼圈区',1868,'210804'),(1872,'老边区',1868,'210811'),(1873,'盖州市',1868,'210881'),(1874,'大石桥市',1868,'210882'),(1875,'阜新市',1803,'210900'),(1876,'海州区',1875,'210902'),(1877,'新邱区',1875,'210903'),(1878,'太平区',1875,'210904'),(1879,'清河门区',1875,'210905'),(1880,'细河区',1875,'210911'),(1881,'阜新县',1875,'210921'),(1882,'彰武县',1875,'210922'),(1883,'辽阳市',1803,'211000'),(1884,'白塔区',1883,'211002'),(1885,'文圣区',1883,'211003'),(1886,'宏伟区',1883,'211004'),(1887,'弓长岭区',1883,'211005'),(1888,'太子河区',1883,'211011'),(1889,'辽阳县',1883,'211021'),(1890,'灯塔市',1883,'211081'),(1891,'盘锦市',1803,'211100'),(1892,'双台子区',1891,'211102'),(1893,'兴隆台区',1891,'211103'),(1894,'大洼县',1891,'211121'),(1895,'盘山县',1891,'211122'),(1896,'铁岭市',1803,'211200'),(1897,'银州区',1896,'211202'),(1898,'清河区',1896,'211204'),(1899,'铁岭县',1896,'211221'),(1900,'西丰县',1896,'211223'),(1901,'昌图县',1896,'211224'),(1902,'调兵山市',1896,'211281'),(1903,'开原市',1896,'211282'),(1904,'朝阳市',1803,'211300'),(1905,'双塔区',1904,'211302'),(1906,'龙城区',1904,'211303'),(1907,'朝阳县',1904,'211321'),(1908,'建平县',1904,'211322'),(1909,'喀左县',1904,'211324'),(1910,'北票市',1904,'211381'),(1911,'凌源市',1904,'211382'),(1912,'葫芦岛市',1803,'211400'),(1913,'连山区',1912,'211402'),(1914,'龙港区',1912,'211403'),(1915,'南票区',1912,'211404'),(1916,'绥中县',1912,'211421'),(1917,'建昌县',1912,'211422'),(1918,'兴城市',1912,'211481'),(1919,'内蒙古自治区',0,'150000'),(1920,'呼和浩特市',1919,'150100'),(1921,'新城区',1920,'150102'),(1922,'回民区',1920,'150103'),(1923,'玉泉区',1920,'150104'),(1924,'赛罕区',1920,'150105'),(1925,'土默特左旗',1920,'150121'),(1926,'托克托县',1920,'150122'),(1927,'和林格尔县',1920,'150123'),(1928,'清水河县',1920,'150124'),(1929,'武川县',1920,'150125'),(1930,'包头市',1919,'150200'),(1931,'东河区',1930,'150202'),(1932,'昆都仑区',1930,'150203'),(1933,'青山区',1930,'150204'),(1934,'石拐区',1930,'150205'),(1935,'白云矿区',1930,'150206'),(1936,'九原区',1930,'150207'),(1937,'土默特右旗',1930,'150221'),(1938,'固阳县',1930,'150222'),(1939,'达尔罕茂明安联合旗',1930,'150223'),(1940,'乌海市',1919,'150300'),(1941,'海勃湾区',1940,'150302'),(1942,'海南区',1940,'150303'),(1943,'乌达区',1940,'150304'),(1944,'赤峰市',1919,'150400'),(1945,'红山区',1944,'150402'),(1946,'元宝山区',1944,'150403'),(1947,'松山区',1944,'150404'),(1948,'阿鲁科尔沁旗',1944,'150421'),(1949,'巴林左旗',1944,'150422'),(1950,'巴林右旗',1944,'150423'),(1951,'林西旗',1944,'150424'),(1952,'克什克腾旗',1944,'150425'),(1953,'翁牛特旗',1944,'150426'),(1954,'喀喇沁旗',1944,'150428'),(1955,'宁城县',1944,'150429'),(1956,'敖汉旗',1944,'150430'),(1957,'通辽市',1919,'150500'),(1958,'科尔沁区',1957,'150502'),(1959,'科尔沁左翼中旗',1957,'150521'),(1960,'科尔沁左翼后旗',1957,'150522'),(1961,'开鲁县',1957,'150523'),(1962,'库伦旗',1957,'150524'),(1963,'奈曼旗',1957,'150525'),(1964,'扎鲁特旗',1957,'150526'),(1965,'霍林郭勒市',1957,'150581'),(1966,'鄂尔多斯市',1919,'150600'),(1967,'东胜区',1966,'150602'),(1968,'达拉特旗',1966,'150621'),(1969,'准格尔旗',1966,'150622'),(1970,'鄂托克前旗',1966,'150623'),(1971,'鄂托克旗',1966,'150624'),(1972,'杭锦旗',1966,'150625'),(1973,'乌审旗',1966,'150626'),(1974,'伊金霍洛旗',1966,'150627'),(1975,'呼伦贝尔市',1919,'150700'),(1976,'海拉尔区',1975,'150702'),(1977,'扎赉诺尔',1975,'150703'),(1978,'阿荣旗',1975,'150721'),(1979,'莫力达瓦旗',1975,'150722'),(1980,'鄂伦春旗',1975,'150723'),(1981,'鄂温克旗',1975,'150724'),(1982,'陈巴尔虎旗',1975,'150725'),(1983,'新巴尔虎左旗',1975,'150726'),(1984,'新巴尔虎右旗',1975,'150727'),(1985,'满洲里市',1975,'150781'),(1986,'牙克石市',1975,'150782'),(1987,'扎兰屯市',1975,'150783'),(1988,'额尔古纳市',1975,'150784'),(1989,'根河市',1975,'150785'),(1990,'巴彦淖尔市',1919,'150800'),(1991,'临河区',1990,'150802'),(1992,'五原县',1990,'150821'),(1993,'磴口县',1990,'150822'),(1994,'乌拉特前旗',1990,'150823'),(1995,'乌拉特中旗',1990,'150824'),(1996,'乌拉特后旗',1990,'150825'),(1997,'杭锦后旗',1990,'150826'),(1998,'乌兰察布市',1919,'150900'),(1999,'集宁区',1998,'150902'),(2000,'卓资县',1998,'150921'),(2001,'化德县',1998,'150922'),(2002,'商都县',1998,'150923'),(2003,'兴和县',1998,'150924'),(2004,'凉城县',1998,'150925'),(2005,'察哈尔右翼前旗',1998,'150926'),(2006,'察哈尔右翼中旗',1998,'150927'),(2007,'察哈尔右翼后旗',1998,'150928'),(2008,'四子王旗',1998,'150929'),(2009,'丰镇市',1998,'150981'),(2010,'兴安盟',1919,'152200'),(2011,'乌兰浩特市',2010,'152201'),(2012,'阿尔山市',2010,'152202'),(2013,'科尔沁右翼前旗',2010,'152221'),(2014,'科尔沁右翼中旗',2010,'152222'),(2015,'扎赉特旗',2010,'152223'),(2016,'突泉县',2010,'152224'),(2017,'锡林郭勒盟',1919,'152500'),(2018,'二连浩特市',2017,'152501'),(2019,'锡林浩特市',2017,'152502'),(2020,'阿巴嘎旗',2017,'152522'),(2021,'苏尼特左旗',2017,'152523'),(2022,'苏尼特右旗',2017,'152524'),(2023,'东乌珠穆沁旗',2017,'152525'),(2024,'西乌珠穆沁旗',2017,'152526'),(2025,'太仆寺旗',2017,'152527'),(2026,'镶黄旗',2017,'152528'),(2027,'正镶白旗',2017,'152529'),(2028,'正蓝旗',2017,'152530'),(2029,'多伦县',2017,'152531'),(2030,'阿拉善盟',1919,'152900'),(2031,'阿拉善左旗',2030,'152921'),(2032,'阿拉善右旗',2030,'152922'),(2033,'额济纳旗',2030,'152923'),(2034,'宁夏回族自治区',0,'640000'),(2035,'银川市',2034,'640100'),(2036,'兴庆区',2035,'640104'),(2037,'西夏区',2035,'640105'),(2038,'金凤区',2035,'640106'),(2039,'永宁县',2035,'640121'),(2040,'贺兰县',2035,'640122'),(2041,'灵武市',2035,'640181'),(2042,'石嘴山市',2034,'640200'),(2043,'大武口区',2042,'640202'),(2044,'惠农区',2042,'640205'),(2045,'平罗县',2042,'640221'),(2046,'吴忠市',2034,'640300'),(2047,'利通区',2046,'640302'),(2048,'红寺堡开发区',2046,'640303'),(2049,'盐池县',2046,'640323'),(2050,'同心县',2046,'640324'),(2051,'青铜峡市',2046,'640381'),(2052,'固原市',2034,'640400'),(2053,'原州区',2052,'640402'),(2054,'西吉县',2052,'640422'),(2055,'隆德县',2052,'640423'),(2056,'泾源县',2052,'640424'),(2057,'彭阳县',2052,'640425'),(2058,'中卫市',2034,'640500'),(2059,'沙坡头区',2058,'640502'),(2060,'中宁县',2058,'640521'),(2061,'海原县',2058,'640522'),(2062,'青海省',0,'630000'),(2063,'西宁市',2062,'630100'),(2064,'城东区',2063,'630102'),(2065,'城中区',2063,'630103'),(2066,'城西区',2063,'630104'),(2067,'城北区',2063,'630105'),(2068,'大通县',2063,'630121'),(2069,'湟中县',2063,'630122'),(2070,'湟源县',2063,'630123'),(2071,'海东地区',2062,'632100'),(2072,'平安县',2071,'632121'),(2073,'民和县',2071,'632122'),(2074,'乐都县',2071,'632123'),(2075,'互助县',2071,'632126'),(2076,'化隆县',2071,'632127'),(2077,'循化县',2071,'632128'),(2078,'海北州',2062,'632200'),(2079,'门源县',2078,'632221'),(2080,'祁连县',2078,'632222'),(2081,'海晏县',2078,'632223'),(2082,'刚察县',2078,'632224'),(2083,'黄南州',2062,'632300'),(2084,'同仁县',2083,'632321'),(2085,'尖扎县',2083,'632322'),(2086,'泽库县',2083,'632323'),(2087,'河南县',2083,'632324'),(2088,'海南州',2062,'632500'),(2089,'共和县',2088,'632521'),(2090,'同德县',2088,'632522'),(2091,'贵德县',2088,'632523'),(2092,'兴海县',2088,'632524'),(2093,'贵南县',2088,'632525'),(2094,'果洛州',2062,'632600'),(2095,'玛沁县',2094,'632621'),(2096,'班玛县',2094,'632622'),(2097,'甘德县',2094,'632623'),(2098,'达日县',2094,'632624'),(2099,'久治县',2094,'632625'),(2100,'玛多县',2094,'632626'),(2101,'玉树州',2062,'632700'),(2102,'玉树县',2101,'632721'),(2103,'杂多县',2101,'632722'),(2104,'称多县',2101,'632723'),(2105,'治多县',2101,'632724'),(2106,'囊谦县',2101,'632725'),(2107,'曲麻莱县',2101,'632726'),(2108,'海西州',2062,'632800'),(2109,'格尔木市',2108,'632801'),(2110,'德令哈市',2108,'632802'),(2111,'乌兰县',2108,'632821'),(2112,'都兰县',2108,'632822'),(2113,'天峻县',2108,'632823'),(2114,'山东省',0,'370000'),(2115,'济南市',2114,'370100'),(2116,'历下区',2115,'370102'),(2117,'市中区',2115,'370103'),(2118,'槐荫区',2115,'370104'),(2119,'天桥区',2115,'370105'),(2120,'历城区',2115,'370112'),(2121,'长清区',2115,'370113'),(2122,'平阴县',2115,'370124'),(2123,'济阳县',2115,'370125'),(2124,'商河县',2115,'370126'),(2125,'章丘市',2115,'370181'),(2126,'青岛市',2114,'370200'),(2127,'市南区',2126,'370202'),(2128,'市北区',2126,'370203'),(2129,'黄岛区',2126,'370211'),(2130,'崂山区',2126,'370212'),(2131,'李沧区',2126,'370213'),(2132,'城阳区',2126,'370214'),(2133,'胶州市',2126,'370281'),(2134,'即墨市',2126,'370282'),(2135,'平度市',2126,'370283'),(2136,'莱西市',2126,'370285'),(2137,'淄博市',2114,'370300'),(2138,'淄川区',2137,'370302'),(2139,'张店区',2137,'370303'),(2140,'博山区',2137,'370304'),(2141,'临淄区',2137,'370305'),(2142,'周村区',2137,'370306'),(2143,'桓台县',2137,'370321'),(2144,'高青县',2137,'370322'),(2145,'沂源县',2137,'370323'),(2146,'枣庄市',2114,'370400'),(2147,'市中区',2146,'370402'),(2148,'薛城区',2146,'370403'),(2149,'峄城区',2146,'370404'),(2150,'台儿庄区',2146,'370405'),(2151,'山亭区',2146,'370406'),(2152,'滕州市',2146,'370481'),(2153,'东营市',2114,'370500'),(2154,'东营区',2153,'370502'),(2155,'河口区',2153,'370503'),(2156,'垦利区',2153,'370521'),(2157,'利津县',2153,'370522'),(2158,'广饶县',2153,'370523'),(2159,'烟台市',2114,'370600'),(2160,'芝罘区',2159,'370602'),(2161,'福山区',2159,'370611'),(2162,'牟平区',2159,'370612'),(2163,'莱山区',2159,'370613'),(2164,'长岛县',2159,'370634'),(2165,'龙口市',2159,'370681'),(2166,'莱阳市',2159,'370682'),(2167,'莱州市',2159,'370683'),(2168,'蓬莱市',2159,'370684'),(2169,'招远市',2159,'370685'),(2170,'栖霞市',2159,'370686'),(2171,'海阳市',2159,'370687'),(2172,'潍坊市',2114,'370700'),(2173,'潍城区',2172,'370702'),(2174,'寒亭区',2172,'370703'),(2175,'坊子区',2172,'370704'),(2176,'奎文区',2172,'370705'),(2177,'临朐县',2172,'370724'),(2178,'昌乐县',2172,'370725'),(2179,'青州市',2172,'370781'),(2180,'诸城市',2172,'370782'),(2181,'寿光市',2172,'370783'),(2182,'安丘市',2172,'370784'),(2183,'高密市',2172,'370785'),(2184,'昌邑市',2172,'370786'),(2185,'济宁市',2114,'370800'),(2186,'市中区',2185,'370802'),(2187,'任城区',2185,'370811'),(2188,'微山县',2185,'370826'),(2189,'鱼台县',2185,'370827'),(2190,'金乡县',2185,'370828'),(2191,'嘉祥县',2185,'370829'),(2192,'汶上县',2185,'370830'),(2193,'泗水县',2185,'370831'),(2194,'梁山县',2185,'370832'),(2195,'曲阜市',2185,'370881'),(2196,'兖州市',2185,'370882'),(2197,'邹城市',2185,'370883'),(2198,'泰安市',2114,'370900'),(2199,'泰山区',2198,'370902'),(2200,'岱岳区',2198,'370903'),(2201,'宁阳县',2198,'370921'),(2202,'东平县',2198,'370923'),(2203,'新泰市',2198,'370982'),(2204,'肥城市',2198,'370983'),(2205,'威海市',2114,'371000'),(2206,'环翠区',2205,'371002'),(2207,'文登市',2205,'371081'),(2208,'荣成市',2205,'371082'),(2209,'乳山市',2205,'371083'),(2210,'日照市',2114,'371100'),(2211,'东港区',2210,'371102'),(2212,'岚山区',2210,'371103'),(2213,'五莲县',2210,'371121'),(2214,'莒县',2210,'371122'),(2215,'莱芜市',2114,'371200'),(2216,'莱城区',2215,'371202'),(2217,'钢城区',2215,'371203'),(2218,'临沂',2114,'371300'),(2219,'兰山区',2218,'371302'),(2220,'罗庄区',2218,'371311'),(2221,'河东区',2218,'371312'),(2222,'沂南县',2218,'371321'),(2223,'郯城县',2218,'371322'),(2224,'沂水县',2218,'371323'),(2225,'兰陵县',2218,'371324'),(2226,'费县',2218,'371325'),(2227,'平邑县',2218,'371326'),(2228,'莒南县',2218,'371327'),(2229,'蒙阴县',2218,'371328'),(2230,'临沭县',2218,'371329'),(2231,'德州市',2114,'371400'),(2232,'德城区',2231,'371402'),(2233,'陵城县',2231,'371421'),(2234,'宁津县',2231,'371422'),(2235,'庆云县',2231,'371423'),(2236,'临邑县',2231,'371424'),(2237,'齐河县',2231,'371425'),(2238,'平原县',2231,'371426'),(2239,'夏津县',2231,'371427'),(2240,'武城县',2231,'371428'),(2241,'乐陵市',2231,'371481'),(2242,'禹城市',2231,'371482'),(2243,'聊城市',2114,'371500'),(2244,'东昌府区',2243,'371502'),(2245,'阳谷县',2243,'371521'),(2246,'莘县',2243,'371522'),(2247,'茌平县',2243,'371523'),(2248,'东阿县',2243,'371524'),(2249,'冠县',2243,'371525'),(2250,'高唐县',2243,'371526'),(2251,'临清市',2243,'371581'),(2252,'滨州市',2114,'371600'),(2253,'滨城区',2252,'371602'),(2254,'惠民县',2252,'371621'),(2255,'阳信县',2252,'371622'),(2256,'无棣县',2252,'371623'),(2257,'沾化县',2252,'371624'),(2258,'博兴县',2252,'371625'),(2259,'邹平县',2252,'371626'),(2260,'菏泽市',2114,'371700'),(2261,'牡丹区',2260,'371702'),(2262,'曹县县',2260,'371721'),(2263,'单县县',2260,'371722'),(2264,'成武县',2260,'371723'),(2265,'巨野县',2260,'371724'),(2266,'郓城县',2260,'371725'),(2267,'鄄城县',2260,'371726'),(2268,'定陶县',2260,'371727'),(2269,'东明县',2260,'371728'),(2270,'上海市',0,'310000'),(2271,'上海市',2270,'310000'),(2272,'上海市',2270,'310000'),(2273,'山西省',0,'140000'),(2274,'太原市',2273,'140100'),(2275,'小店区',2274,'140105'),(2276,'迎泽区',2274,'140106'),(2277,'杏花岭区',2274,'140107'),(2278,'尖草坪区',2274,'140108'),(2279,'万柏林区',2274,'140109'),(2280,'晋源区',2274,'140110'),(2281,'清徐县',2274,'140121'),(2282,'阳曲县',2274,'140122'),(2283,'娄烦县',2274,'140123'),(2284,'古交市',2274,'140181'),(2285,'大同市',2273,'140200'),(2286,'城区',2285,'140202'),(2287,'矿区',2285,'140203'),(2288,'南郊区',2285,'140211'),(2289,'新荣区',2285,'140212'),(2290,'阳高县',2285,'140221'),(2291,'天镇县',2285,'140222'),(2292,'广灵县',2285,'140223'),(2293,'灵丘县',2285,'140224'),(2294,'浑源县',2285,'140225'),(2295,'左云县',2285,'140226'),(2296,'大同县',2285,'140227'),(2297,'阳泉市',2273,'140300'),(2298,'城区',2297,'140302'),(2299,'矿区',2297,'140303'),(2300,'郊区',2297,'140311'),(2301,'平定县',2297,'140321'),(2302,'盂县',2297,'140322'),(2303,'长治市',2273,'140400'),(2304,'长治县',2303,'140421'),(2305,'襄垣县',2303,'140423'),(2306,'屯留县',2303,'140424'),(2307,'平顺县',2303,'140425'),(2308,'黎城县',2303,'140426'),(2309,'壶关县',2303,'140427'),(2310,'长子县',2303,'140428'),(2311,'武乡县',2303,'140429'),(2312,'沁县',2303,'140430'),(2313,'沁源县',2303,'140431'),(2314,'潞城市',2303,'140481'),(2315,'城区',2303,'140482'),(2316,'郊区',2303,'140483'),(2317,'晋城市',2273,'140500'),(2318,'城区县',2317,'140502'),(2319,'沁水县',2317,'140521'),(2320,'阳城县',2317,'140522'),(2321,'陵川县',2317,'140524'),(2322,'泽州县',2317,'140525'),(2323,'高平市',2317,'140581'),(2324,'朔州市',2273,'140600'),(2325,'朔城区',2324,'140602'),(2326,'平鲁区',2324,'140603'),(2327,'山阴县',2324,'140621'),(2328,'应县',2324,'140622'),(2329,'右玉县',2324,'140623'),(2330,'怀仁县',2324,'140624'),(2331,'晋中市',2273,'140700'),(2332,'榆次县',2331,'140702'),(2333,'榆社县',2331,'140721'),(2334,'左权县',2331,'140722'),(2335,'和顺县',2331,'140723'),(2336,'昔阳县',2331,'140724'),(2337,'寿阳县',2331,'140725'),(2338,'太谷县',2331,'140726'),(2339,'祁县',2331,'140727'),(2340,'平遥县',2331,'140728'),(2341,'灵石县',2331,'140729'),(2342,'介休市',2331,'140781'),(2343,'运城市',2273,'140800'),(2344,'盐湖区',2343,'140802'),(2345,'临猗县',2343,'140821'),(2346,'万荣县',2343,'140822'),(2347,'闻喜县',2343,'140823'),(2348,'稷山县',2343,'140824'),(2349,'新绛县',2343,'140825'),(2350,'绛县',2343,'140826'),(2351,'垣曲县',2343,'140827'),(2352,'夏县',2343,'140828'),(2353,'平陆县',2343,'140829'),(2354,'芮城县',2343,'140830'),(2355,'永济市',2343,'140881'),(2356,'河津市',2343,'140882'),(2357,'忻州市',2273,'140900'),(2358,'忻府区',2357,'140902'),(2359,'定襄县',2357,'140921'),(2360,'五台县',2357,'140922'),(2361,'代县',2357,'140923'),(2362,'繁峙县',2357,'140924'),(2363,'宁武县',2357,'140925'),(2364,'静乐县',2357,'140926'),(2365,'神池县',2357,'140927'),(2366,'五寨县',2357,'140928'),(2367,'岢岚县',2357,'140929'),(2368,'河曲县',2357,'140930'),(2369,'保德县',2357,'140931'),(2370,'偏关县',2357,'140932'),(2371,'原平市',2357,'140981'),(2372,'临汾市',2273,'141000'),(2373,'尧都区',2372,'141002'),(2374,'曲沃县',2372,'141021'),(2375,'翼城县',2372,'141022'),(2376,'襄汾县',2372,'141023'),(2377,'洪洞县',2372,'141024'),(2378,'古县',2372,'141025'),(2379,'安泽县',2372,'141026'),(2380,'浮山县',2372,'141027'),(2381,'吉县',2372,'141028'),(2382,'乡宁县',2372,'141029'),(2383,'大宁县',2372,'141030'),(2384,'隰县',2372,'141031'),(2385,'永和县',2372,'141032'),(2386,'蒲县',2372,'141033'),(2387,'汾西县',2372,'141034'),(2388,'侯马市',2372,'141081'),(2389,'霍州市',2372,'141082'),(2390,'吕梁市',2273,'141100'),(2391,'离石区',2390,'141102'),(2392,'文水县',2390,'141121'),(2393,'交城县',2390,'141122'),(2394,'兴县',2390,'141123'),(2395,'临县',2390,'141124'),(2396,'柳林县',2390,'141125'),(2397,'石楼县',2390,'141126'),(2398,'岚县',2390,'141127'),(2399,'方山县',2390,'141128'),(2400,'中阳县',2390,'141129'),(2401,'交口县',2390,'141130'),(2402,'孝义市',2390,'141181'),(2403,'汾阳市',2390,'141182'),(2404,'陕西省',0,'610000'),(2405,'西安市',2404,'610100'),(2406,'新城区',2405,'610102'),(2407,'碑林区',2405,'610103'),(2408,'莲湖区',2405,'610104'),(2409,'灞桥区',2405,'610111'),(2410,'未央区',2405,'610112'),(2411,'雁塔区',2405,'610113'),(2412,'阎良区',2405,'610114'),(2413,'临潼区',2405,'610115'),(2414,'长安区',2405,'610116'),(2415,'蓝田县',2405,'610122'),(2416,'周至县',2405,'610124'),(2417,'户县',2405,'610125'),(2418,'高陵区',2405,'610126'),(2419,'铜川市',2404,'610200'),(2420,'王益区',2419,'610202'),(2421,'印台区',2419,'610203'),(2422,'耀州区',2419,'610204'),(2423,'宜君县',2419,'610222'),(2424,'宝鸡市',2404,'610300'),(2425,'渭滨区',2424,'610302'),(2426,'金台区',2424,'610303'),(2427,'陈仓区',2424,'610304'),(2428,'凤翔县',2424,'610322'),(2429,'岐山县',2424,'610323'),(2430,'扶风县',2424,'610324'),(2431,'眉县',2424,'610326'),(2432,'陇县',2424,'610327'),(2433,'千阳县',2424,'610328'),(2434,'麟游县',2424,'610329'),(2435,'凤县',2424,'610330'),(2436,'太白县',2424,'610331'),(2437,'咸阳市',2404,'610400'),(2438,'秦都区',2437,'610402'),(2439,'杨陵区',2437,'610403'),(2440,'渭城区',2437,'610404'),(2441,'三原县',2437,'610422'),(2442,'泾阳县',2437,'610423'),(2443,'乾县',2437,'610424'),(2444,'礼泉县',2437,'610425'),(2445,'永寿县',2437,'610426'),(2446,'彬县',2437,'610427'),(2447,'长武县',2437,'610428'),(2448,'旬邑县',2437,'610429'),(2449,'淳化县',2437,'610430'),(2450,'武功县',2437,'610431'),(2451,'兴平市',2437,'610481'),(2452,'渭南市',2404,'610500'),(2453,'临渭区',2452,'610502'),(2454,'华县',2452,'610521'),(2455,'潼关县',2452,'610522'),(2456,'大荔县',2452,'610523'),(2457,'合阳县',2452,'610524'),(2458,'澄城县',2452,'610525'),(2459,'蒲城县',2452,'610526'),(2460,'白水县',2452,'610527'),(2461,'富平县',2452,'610528'),(2462,'韩城市',2452,'610581'),(2463,'华阴市',2452,'610582'),(2464,'延安市',2404,'610600'),(2465,'宝塔区',2464,'610602'),(2466,'延长县',2464,'610621'),(2467,'延川县',2464,'610622'),(2468,'子长县',2464,'610623'),(2469,'安塞县',2464,'610624'),(2470,'志丹县',2464,'610625'),(2471,'吴起县',2464,'610626'),(2472,'甘泉县',2464,'610627'),(2473,'富县',2464,'610628'),(2474,'洛川县',2464,'610629'),(2475,'宜川县',2464,'610630'),(2476,'黄龙县',2464,'610631'),(2477,'黄陵县',2464,'610632'),(2478,'汉中市',2404,'610700'),(2479,'汉台区',2478,'610702'),(2480,'南郑县',2478,'610721'),(2481,'城固县',2478,'610722'),(2482,'洋县',2478,'610723'),(2483,'西乡县',2478,'610724'),(2484,'勉县',2478,'610725'),(2485,'宁强县',2478,'610726'),(2486,'略阳县',2478,'610727'),(2487,'镇巴县',2478,'610728'),(2488,'留坝县',2478,'610729'),(2489,'佛坪县',2478,'610730'),(2490,'榆林市',2404,'610800'),(2491,'榆阳区',2490,'610802'),(2492,'神木县',2490,'610821'),(2493,'府谷县',2490,'610822'),(2494,'横山县',2490,'610823'),(2495,'靖边县',2490,'610824'),(2496,'定边县',2490,'610825'),(2497,'绥德县',2490,'610826'),(2498,'米脂县',2490,'610827'),(2499,'佳县',2490,'610828'),(2500,'吴堡县',2490,'610829'),(2501,'清涧县',2490,'610830'),(2502,'子洲县',2490,'610831'),(2503,'安康市',2404,'610900'),(2504,'汉滨区',2503,'610902'),(2505,'汉阴县',2503,'610921'),(2506,'石泉县',2503,'610922'),(2507,'宁陕县',2503,'610923'),(2508,'紫阳县',2503,'610924'),(2509,'岚皋县',2503,'610925'),(2510,'平利县',2503,'610926'),(2511,'镇坪县',2503,'610927'),(2512,'旬阳县',2503,'610928'),(2513,'白河县',2503,'610929'),(2514,'商洛市',2404,'611000'),(2515,'商州区',2514,'611002'),(2516,'洛南县',2514,'611021'),(2517,'丹凤县',2514,'611022'),(2518,'商南县',2514,'611023'),(2519,'山阳县',2514,'611024'),(2520,'镇安县',2514,'611025'),(2521,'柞水县',2514,'611026'),(2522,'四川省',0,'510000'),(2523,'成都市',2522,'510100'),(2524,'锦江区',2523,'510104'),(2525,'青羊区',2523,'510105'),(2526,'金牛区',2523,'510106'),(2527,'武侯区',2523,'510107'),(2528,'成华区',2523,'510108'),(2529,'龙泉驿区',2523,'510112'),(2530,'青白江区',2523,'510113'),(2531,'新都区',2523,'510114'),(2532,'温江区',2523,'510115'),(2533,'金堂县',2523,'510121'),(2534,'双流县',2523,'510122'),(2535,'郫县',2523,'510124'),(2536,'大邑县',2523,'510129'),(2537,'蒲江县',2523,'510131'),(2538,'新津县',2523,'510132'),(2539,'都江堰市',2523,'510181'),(2540,'彭州市',2523,'510182'),(2541,'邛崃市',2523,'510183'),(2542,'崇州市',2523,'510184'),(2543,'自贡市',2522,'510300'),(2544,'自流井区',2543,'510302'),(2545,'贡井区',2543,'510303'),(2546,'大安区',2543,'510304'),(2547,'沿滩区',2543,'510311'),(2548,'荣县',2543,'510321'),(2549,'富顺县',2543,'510322'),(2550,'攀枝花市',2522,'510400'),(2551,'东区',2550,'510402'),(2552,'西区',2550,'510403'),(2553,'仁和区',2550,'510411'),(2554,'米易县',2550,'510421'),(2555,'盐边县',2550,'510422'),(2556,'泸州市',2522,'510500'),(2557,'江阳区',2556,'510502'),(2558,'纳溪区',2556,'510503'),(2559,'龙马潭区',2556,'510504'),(2560,'泸县',2556,'510521'),(2561,'合江县',2556,'510522'),(2562,'叙永县',2556,'510524'),(2563,'古蔺县',2556,'510525'),(2564,'德阳市',2522,'510600'),(2565,'旌阳区',2564,'510603'),(2566,'中江县',2564,'510623'),(2567,'罗江县',2564,'510626'),(2568,'广汉市',2564,'510681'),(2569,'什邡市',2564,'510682'),(2570,'绵竹市',2564,'510683'),(2571,'绵阳市',2522,'510700'),(2572,'涪城区',2571,'510703'),(2573,'游仙区',2571,'510704'),(2574,'三台县',2571,'510722'),(2575,'盐亭县',2571,'510723'),(2576,'安县',2571,'510724'),(2577,'梓潼县',2571,'510725'),(2578,'北川羌族自治县',2571,'510726'),(2579,'平武县',2571,'510727'),(2580,'江油市',2571,'510781'),(2581,'广元市',2522,'510800'),(2582,'利州区',2581,'510802'),(2583,'昭化区',2581,'510811'),(2584,'朝天区',2581,'510812'),(2585,'旺苍县',2581,'510821'),(2586,'青川县',2581,'510822'),(2587,'剑阁县',2581,'510823'),(2588,'苍溪县',2581,'510824'),(2589,'遂宁市',2522,'510900'),(2590,'船山区',2589,'510903'),(2591,'安居区',2589,'510904'),(2592,'蓬溪县',2589,'510921'),(2593,'射洪县',2589,'510922'),(2594,'大英县',2589,'510923'),(2595,'内江市',2522,'511000'),(2596,'市中区',2595,'511002'),(2597,'东兴区',2595,'511011'),(2598,'威远县',2595,'511024'),(2599,'资中县',2595,'511025'),(2600,'隆昌县',2595,'511028'),(2601,'乐山市',2522,'511100'),(2602,'市中区',2601,'511102'),(2603,'沙湾区',2601,'511111'),(2604,'五通桥区',2601,'511112'),(2605,'金口河区',2601,'511113'),(2606,'犍为县',2601,'511123'),(2607,'井研县',2601,'511124'),(2608,'夹江县',2601,'511126'),(2609,'沐川县',2601,'511129'),(2610,'峨边彝族自治区',2601,'511132'),(2611,'马边彝族自治区',2601,'511133'),(2612,'峨眉山市',2601,'511181'),(2613,'南充市',2522,'511300'),(2614,'顺庆区',2613,'511302'),(2615,'高坪区',2613,'511303'),(2616,'嘉陵区',2613,'511304'),(2617,'南部县',2613,'511321'),(2618,'营山县',2613,'511322'),(2619,'蓬安县',2613,'511323'),(2620,'仪陇县',2613,'511324'),(2621,'西充县',2613,'511325'),(2622,'阆中市',2613,'511381'),(2623,'眉山市',2522,'511400'),(2624,'东坡区',2623,'511402'),(2625,'仁寿县',2623,'511421'),(2626,'彭山区',2623,'511422'),(2627,'洪雅县',2623,'511423'),(2628,'丹棱县',2623,'511424'),(2629,'青神县',2623,'511425'),(2630,'宜宾市',2522,'511500'),(2631,'翠屏区',2630,'511502'),(2632,'宜宾县',2630,'511521'),(2633,'南溪区',2630,'511522'),(2634,'江安县',2630,'511523'),(2635,'长宁县',2630,'511524'),(2636,'高县',2630,'511525'),(2637,'珙县',2630,'511526'),(2638,'筠连县',2630,'511527'),(2639,'兴文县',2630,'511528'),(2640,'屏山县',2630,'511529'),(2641,'广安市',2522,'511600'),(2642,'广安区',2641,'511602'),(2643,'前锋区',2641,'511603'),(2644,'岳池县',2641,'511621'),(2645,'武胜县',2641,'511622'),(2646,'邻水县',2641,'511623'),(2647,'华蓥市',2641,'511681'),(2648,'达州市',2522,'511700'),(2649,'通川区',2648,'511702'),(2650,'达川区',2648,'511721'),(2651,'宣汉县',2648,'511722'),(2652,'开江县',2648,'511723'),(2653,'大竹县',2648,'511724'),(2654,'渠县',2648,'511725'),(2655,'万源市',2648,'511781'),(2656,'雅安市',2522,'511800'),(2657,'雨城区',2656,'511802'),(2658,'名山区',2656,'511821'),(2659,'荥经县',2656,'511822'),(2660,'汉源县',2656,'511823'),(2661,'石棉县',2656,'511824'),(2662,'天全县',2656,'511825'),(2663,'芦山县',2656,'511826'),(2664,'宝兴县',2656,'511827'),(2665,'巴中市',2522,'511900'),(2666,'巴州区',2665,'511902'),(2667,'恩阳区',2665,'511903'),(2668,'通江县',2665,'511921'),(2669,'南江县',2665,'511922'),(2670,'平昌县',2665,'511923'),(2671,'资阳市',2522,'512000'),(2672,'雁江区',2671,'512002'),(2673,'安岳县',2671,'512021'),(2674,'乐至县',2671,'512022'),(2675,'简阳市',2671,'512081'),(2676,'阿坝藏族羌族自治州',2522,'513200'),(2677,'汶川县',2676,'513221'),(2678,'理县',2676,'513222'),(2679,'茂县',2676,'513223'),(2680,'松潘县',2676,'513224'),(2681,'九寨沟县',2676,'513225'),(2682,'金川县',2676,'513226'),(2683,'小金县',2676,'513227'),(2684,'黑水县',2676,'513228'),(2685,'马尔康县',2676,'513229'),(2686,'壤塘县',2676,'513230'),(2687,'阿坝县',2676,'513231'),(2688,'若尔盖县',2676,'513232'),(2689,'红原县',2676,'513233'),(2690,'甘孜藏族自治州',2522,'513300'),(2691,'康定市',2690,'513321'),(2692,'泸定县',2690,'513322'),(2693,'丹巴县',2690,'513323'),(2694,'九龙县',2690,'513324'),(2695,'雅江县',2690,'513325'),(2696,'道孚县',2690,'513326'),(2697,'炉霍县',2690,'513327'),(2698,'甘孜县',2690,'513328'),(2699,'新龙县',2690,'513329'),(2700,'德格县',2690,'513330'),(2701,'白玉县',2690,'513331'),(2702,'石渠县',2690,'513332'),(2703,'色达县',2690,'513333'),(2704,'理塘县',2690,'513334'),(2705,'巴塘县',2690,'513335'),(2706,'乡城县',2690,'513336'),(2707,'稻城县',2690,'513337'),(2708,'得荣县',2690,'513338'),(2709,'凉山彝族自治州',2522,'513400'),(2710,'西昌市',2709,'513401'),(2711,'木里藏族自治县',2709,'513422'),(2712,'盐源县',2709,'513423'),(2713,'德昌县',2709,'513424'),(2714,'会理县',2709,'513425'),(2715,'会东县',2709,'513426'),(2716,'宁南县',2709,'513427'),(2717,'普格县',2709,'513428'),(2718,'布拖县',2709,'513429'),(2719,'金阳县',2709,'513430'),(2720,'昭觉县',2709,'513431'),(2721,'喜德县',2709,'513432'),(2722,'冕宁县',2709,'513433'),(2723,'越西县',2709,'513434'),(2724,'甘洛县',2709,'513435'),(2725,'美姑县',2709,'513436'),(2726,'雷波县',2709,'513437'),(2727,'天津',0,'120000'),(2728,'天津',2727,'120000'),(2729,'天津',2727,'120000'),(2730,'新疆维吾尔自治区',0,'650000'),(2731,'乌鲁木齐市',2730,'650100'),(2732,'天山区',2731,'650102'),(2733,'沙依巴克区',2731,'650103'),(2734,'新市区',2731,'650104'),(2735,'水磨沟区',2731,'650105'),(2736,'头屯河区',2731,'650106'),(2737,'达坂城区',2731,'650107'),(2738,'米东区',2731,'650109'),(2739,'乌鲁木齐县',2731,'650121'),(2740,'克拉玛依市',2730,'650200'),(2741,'独山子区',2740,'650202'),(2742,'克拉玛依区',2740,'650203'),(2743,'白碱滩区',2740,'650204'),(2744,'乌尔禾区',2740,'650205'),(2745,'吐鲁番市',2730,'652100'),(2746,'高昌区',2745,'652101'),(2747,'鄯善县',2745,'652122'),(2748,'托克逊县',2745,'652123'),(2749,'哈密地区',2730,'652200'),(2750,'哈密市',2749,'652201'),(2751,'巴里坤哈萨克自治县',2749,'652222'),(2752,'伊吾县',2749,'652223'),(2753,'昌吉回族自治州',2730,'652300'),(2754,'昌吉市',2753,'652301'),(2755,'阜康市',2753,'652302'),(2756,'呼图壁县',2753,'652323'),(2757,'玛纳斯县',2753,'652324'),(2758,'奇台县',2753,'652325'),(2759,'吉木萨尔县',2753,'652327'),(2760,'木垒哈萨克自治县',2753,'652328'),(2761,'博尔塔拉蒙古自治州',2730,'652700'),(2762,'博乐市',2761,'652701'),(2763,'阿拉山口市',2761,'652702'),(2764,'精河县',2761,'652722'),(2765,'温泉县',2761,'652723'),(2766,'巴音郭楞蒙古自治州',2730,'652800'),(2767,'库尔勒市',2766,'652801'),(2768,'轮台县',2766,'652822'),(2769,'尉犁县',2766,'652823'),(2770,'若羌县',2766,'652824'),(2771,'且末县',2766,'652825'),(2772,'焉耆县',2766,'652826'),(2773,'和静县',2766,'652827'),(2774,'和硕县',2766,'652828'),(2775,'博湖县',2766,'652829'),(2776,'阿克苏地区',2730,'652900'),(2777,'阿克苏市',2776,'652901'),(2778,'温宿县',2776,'652922'),(2779,'库车县',2776,'652923'),(2780,'沙雅县',2776,'652924'),(2781,'新和县',2776,'652925'),(2782,'拜城县',2776,'652926'),(2783,'乌什县',2776,'652927'),(2784,'阿瓦提县',2776,'652928'),(2785,'柯坪县',2776,'652929'),(2786,'克孜勒苏柯尔克孜自治州',2730,'653000'),(2787,'阿图什市',2786,'653001'),(2788,'阿克陶县',2786,'653022'),(2789,'阿合奇县',2786,'653023'),(2790,'乌恰县',2786,'653024'),(2791,'喀什地区',2730,'653100'),(2792,'喀什市',2791,'653101'),(2793,'疏附县',2791,'653121'),(2794,'疏勒县',2791,'653122'),(2795,'英吉沙县',2791,'653123'),(2796,'泽普县',2791,'653124'),(2797,'莎车县',2791,'653125'),(2798,'叶城县',2791,'653126'),(2799,'麦盖提县',2791,'653127'),(2800,'岳普湖县',2791,'653128'),(2801,'伽师县',2791,'653129'),(2802,'巴楚县',2791,'653130'),(2803,'塔什库尔干塔吉克自治县',2791,'653131'),(2804,'和田地区',2730,'653200'),(2805,'和田市',2804,'653201'),(2806,'和田县',2804,'653221'),(2807,'墨玉县',2804,'653222'),(2808,'皮山县',2804,'653223'),(2809,'洛浦县',2804,'653224'),(2810,'策勒县',2804,'653225'),(2811,'于田县',2804,'653226'),(2812,'民丰县',2804,'653227'),(2813,'伊犁哈萨克自治州',2730,'654000'),(2814,'伊宁市',2813,'654002'),(2815,'奎屯市',2813,'654003'),(2816,'伊宁县',2813,'654021'),(2817,'察布查尔锡伯自治县',2813,'654022'),(2818,'霍城县',2813,'654023'),(2819,'巩留县',2813,'654024'),(2820,'新源县',2813,'654025'),(2821,'昭苏县',2813,'654026'),(2822,'特克斯县',2813,'654027'),(2823,'尼勒克县',2813,'654028'),(2824,'塔城地区',2730,'654200'),(2825,'塔城市',2824,'654201'),(2826,'乌苏市',2824,'654202'),(2827,'额敏县',2824,'654221'),(2828,'沙湾县',2824,'654223'),(2829,'托里县',2824,'654224'),(2830,'裕民县',2824,'654225'),(2831,'和布克赛尔蒙古自治县',2824,'654226'),(2832,'阿勒泰地区',2730,'654300'),(2833,'阿勒泰市',2832,'654301'),(2834,'布尔津县',2832,'654321'),(2835,'富蕴县',2832,'654322'),(2836,'福海县',2832,'654323'),(2837,'哈巴河县',2832,'654324'),(2838,'青河县',2832,'654325'),(2839,'吉木乃县',2832,'654326'),(2840,'石河子市',2730,'659001'),(2841,'石河子乡',2840,'659001001'),(2842,'阿拉尔市',2730,'659002'),(2843,'阿拉尔农场',2842,'659002001'),(2844,'图木舒克市',2730,'659003'),(2845,'兵团图木舒克市永安坝',2844,'659003001'),(2846,'五家渠市',2730,'659004'),(2847,'五家渠',2846,'659004001'),(2848,'西藏自治区',0,'540000'),(2849,'拉萨市',2848,'540100'),(2850,'城关区',2849,'540102'),(2851,'林周县',2849,'540121'),(2852,'当雄县',2849,'540122'),(2853,'尼木县',2849,'540123'),(2854,'曲水县',2849,'540124'),(2855,'堆龙德庆县',2849,'540125'),(2856,'达孜县',2849,'540126'),(2857,'墨竹工卡县',2849,'540127'),(2858,'昌都市',2848,'542100'),(2859,'卡若区',2858,'542121'),(2860,'江达县',2858,'542122'),(2861,'贡觉县',2858,'542123'),(2862,'类乌齐县',2858,'542124'),(2863,'丁青县',2858,'542125'),(2864,'察雅县',2858,'542126'),(2865,'八宿县',2858,'542127'),(2866,'左贡县',2858,'542128'),(2867,'芒康县',2858,'542129'),(2868,'洛隆县',2858,'542132'),(2869,'边坝县',2858,'542133'),(2870,'山南地区',2848,'542200'),(2871,'乃东县',2870,'542221'),(2872,'扎囊县',2870,'542222'),(2873,'贡嘎县',2870,'542223'),(2874,'桑日县',2870,'542224'),(2875,'琼结县',2870,'542225'),(2876,'曲松县',2870,'542226'),(2877,'措美县',2870,'542227'),(2878,'洛扎县',2870,'542228'),(2879,'加查县',2870,'542229'),(2880,'隆子县',2870,'542231'),(2881,'错那县',2870,'542232'),(2882,'浪卡子县',2870,'542233'),(2883,'日喀则市',2848,'542300'),(2884,'桑珠孜区',2883,'542301'),(2885,'南木林县',2883,'542322'),(2886,'江孜县',2883,'542323'),(2887,'定日县',2883,'542324'),(2888,'萨迦县',2883,'542325'),(2889,'拉孜县',2883,'542326'),(2890,'昂仁县',2883,'542327'),(2891,'谢通门县',2883,'542328'),(2892,'白朗县',2883,'542329'),(2893,'仁布县',2883,'542330'),(2894,'康马县',2883,'542331'),(2895,'定结县',2883,'542332'),(2896,'仲巴县',2883,'542333'),(2897,'亚东县',2883,'542334'),(2898,'吉隆县',2883,'542335'),(2899,'聂拉木县',2883,'542336'),(2900,'萨嘎县',2883,'542337'),(2901,'岗巴县',2883,'542338'),(2902,'那曲地区',2848,'542400'),(2903,'那曲县',2902,'542421'),(2904,'嘉黎县',2902,'542422'),(2905,'比如县',2902,'542423'),(2906,'聂荣县',2902,'542424'),(2907,'安多县',2902,'542425'),(2908,'申扎县',2902,'542426'),(2909,'索县',2902,'542427'),(2910,'班戈县',2902,'542428'),(2911,'巴青县',2902,'542429'),(2912,'尼玛县',2902,'542430'),(2913,'双湖县',2902,'542432'),(2914,'阿里地区',2848,'542500'),(2915,'普兰县',2914,'542521'),(2916,'札达县',2914,'542522'),(2917,'噶尔县',2914,'542523'),(2918,'日土县',2914,'542524'),(2919,'革吉县',2914,'542525'),(2920,'改则县',2914,'542526'),(2921,'措勤县',2914,'542527'),(2922,'林芝市',2848,'542600'),(2923,'巴宜区',2922,'542621'),(2924,'工布江达县',2922,'542622'),(2925,'米林县',2922,'542623'),(2926,'墨脱县',2922,'542624'),(2927,'波密县',2922,'542625'),(2928,'察隅县',2922,'542626'),(2929,'朗县',2922,'542627'),(2930,'云南省',0,'530000'),(2931,'昆明市',2930,'530100'),(2932,'五华区',2931,'530102'),(2933,'盘龙区',2931,'530103'),(2934,'官渡区',2931,'530111'),(2935,'西山区',2931,'530112'),(2936,'东川区',2931,'530113'),(2937,'呈贡区',2931,'530121'),(2938,'晋宁县',2931,'530122'),(2939,'富民县',2931,'530124'),(2940,'宜良县',2931,'530125'),(2941,'石林彝族自治县',2931,'530126'),(2942,'嵩明县',2931,'530127'),(2943,'禄劝彝族苗族自治县',2931,'530128'),(2944,'寻甸回族彝族自治县',2931,'530129'),(2945,'安宁市',2931,'530181'),(2946,'曲靖市',2930,'530300'),(2947,'麒麟区',2946,'530302'),(2948,'马龙县',2946,'530321'),(2949,'陆良县',2946,'530322'),(2950,'师宗县',2946,'530323'),(2951,'罗平县',2946,'530324'),(2952,'富源县',2946,'530325'),(2953,'会泽县',2946,'530326'),(2954,'沾益县',2946,'530328'),(2955,'宣威市',2946,'530381'),(2956,'玉溪市',2930,'530400'),(2957,'红塔区',2956,'530402'),(2958,'江川县',2956,'530421'),(2959,'澄江县',2956,'530422'),(2960,'通海县',2956,'530423'),(2961,'华宁县',2956,'530424'),(2962,'易门县',2956,'530425'),(2963,'峨山彝族自治县',2956,'530426'),(2964,'新平彝族傣族自治县',2956,'530427'),(2965,'元江哈尼族彝族傣族自治县',2956,'530428'),(2966,'保山市',2930,'530500'),(2967,'隆阳区',2966,'530502'),(2968,'施甸县',2966,'530521'),(2969,'腾冲县',2966,'530522'),(2970,'龙陵县',2966,'530523'),(2971,'昌宁县',2966,'530524'),(2972,'昭通市',2930,'530600'),(2973,'昭阳区',2972,'530602'),(2974,'鲁甸县',2972,'530621'),(2975,'巧家县',2972,'530622'),(2976,'盐津县',2972,'530623'),(2977,'大关县',2972,'530624'),(2978,'永善县',2972,'530625'),(2979,'绥江县',2972,'530626'),(2980,'镇雄县',2972,'530627'),(2981,'彝良县',2972,'530628'),(2982,'威信县',2972,'530629'),(2983,'水富县',2972,'530630'),(2984,'丽江市',2930,'530700'),(2985,'古城区',2984,'530702'),(2986,'玉龙纳西族自治县',2984,'530721'),(2987,'永胜县',2984,'530722'),(2988,'华坪县',2984,'530723'),(2989,'宁蒗彝族自治县',2984,'530724'),(2990,'普洱市',2930,'530800'),(2991,'思茅区',2990,'530802'),(2992,'宁洱哈尼族彝族自治县',2990,'530821'),(2993,'墨江哈尼族自治县',2990,'530822'),(2994,'景东彝族自治县',2990,'530823'),(2995,'景谷傣族彝族自治县',2990,'530824'),(2996,'镇沅彝族哈尼族拉祜族自治县',2990,'530825'),(2997,'江城哈尼族彝族自治县',2990,'530826'),(2998,'孟连傣族拉祜族佤族自治县',2990,'530827'),(2999,'澜沧拉祜族自治县',2990,'530828'),(3000,'西盟佤族自治县',2990,'530829'),(3001,'临沧市',2930,'530900'),(3002,'临翔区',3001,'530902'),(3003,'凤庆县',3001,'530921'),(3004,'云县',3001,'530922'),(3005,'永德县',3001,'530923'),(3006,'镇康县',3001,'530924'),(3007,'双江拉祜族佤族布朗族傣族自治县',3001,'530925'),(3008,'耿马傣族佤族自治县',3001,'530926'),(3009,'沧源佤族自治县',3001,'530927'),(3010,'楚雄彝族自治州',2930,'532300'),(3011,'楚雄市',3010,'532301'),(3012,'双柏县',3010,'532322'),(3013,'牟定县',3010,'532323'),(3014,'南华县',3010,'532324'),(3015,'姚安县',3010,'532325'),(3016,'大姚县',3010,'532326'),(3017,'永仁县',3010,'532327'),(3018,'元谋县',3010,'532328'),(3019,'武定县',3010,'532329'),(3020,'禄丰县',3010,'532331'),(3021,'红河哈尼族彝族自治州',2930,'532500'),(3022,'个旧市',3021,'532501'),(3023,'开远市',3021,'532502'),(3024,'蒙自市',3021,'532522'),(3025,'屏边苗族自治县',3021,'532523'),(3026,'建水县',3021,'532524'),(3027,'石屏县',3021,'532525'),(3028,'弥勒市',3021,'532526'),(3029,'泸西县',3021,'532527'),(3030,'元阳县',3021,'532528'),(3031,'红河县',3021,'532529'),(3032,'金平苗族瑶族傣族自治县',3021,'532530'),(3033,'绿春县',3021,'532531'),(3034,'河口瑶族自治县',3021,'532532'),(3035,'文山壮族苗族自治州',2930,'532600'),(3036,'文山市',3035,'532621'),(3037,'砚山县',3035,'532622'),(3038,'西畴县',3035,'532623'),(3039,'麻栗坡县',3035,'532624'),(3040,'马关县',3035,'532625'),(3041,'丘北县',3035,'532626'),(3042,'广南县',3035,'532627'),(3043,'富宁县',3035,'532628'),(3044,'西双版纳傣族自治州',2930,'532800'),(3045,'景洪市',3044,'532801'),(3046,'勐海县',3044,'532822'),(3047,'勐腊县',3044,'532823'),(3048,'大理白族自治州',2930,'532900'),(3049,'大理市',3048,'532901'),(3050,'漾濞彝族自治县',3048,'532922'),(3051,'祥云县',3048,'532923'),(3052,'宾川县',3048,'532924'),(3053,'弥渡县',3048,'532925'),(3054,'南涧彝族自治县',3048,'532926'),(3055,'巍山彝族回族自治县',3048,'532927'),(3056,'永平下',3048,'532928'),(3057,'云龙县',3048,'532929'),(3058,'洱源县',3048,'532930'),(3059,'剑川县',3048,'532931'),(3060,'鹤庆县',3048,'532932'),(3061,'德宏傣族景颇族自治州',2930,'533100'),(3062,'瑞丽市',3061,'533102'),(3063,'芒市',3061,'533103'),(3064,'梁河县',3061,'533122'),(3065,'盈江县',3061,'533123'),(3066,'陇川县',3061,'533124'),(3067,'怒江傈傈族自治州',2930,'533300'),(3068,'泸水县',3067,'533321'),(3069,'福贡县',3067,'533323'),(3070,'贡山独龙族怒族自治县',3067,'533324'),(3071,'兰坪白族普米族自治县',3067,'533325'),(3072,'迪庆藏族自治州',2930,'533400'),(3073,'香格里拉市',3072,'533421'),(3074,'德钦县',3072,'533422'),(3075,'维西傈傈族自治县',3072,'533423'),(3076,'浙江省',0,'330000'),(3077,'杭州市',3076,'330100'),(3078,'上城区',3077,'330102'),(3079,'下城区',3077,'330103'),(3080,'江干区',3077,'330104'),(3081,'拱墅区',3077,'330105'),(3082,'西湖区',3077,'330106'),(3083,'滨江区',3077,'330108'),(3084,'萧山区',3077,'330109'),(3085,'余杭区',3077,'330110'),(3086,'桐庐县',3077,'330122'),(3087,'淳安县',3077,'330127'),(3088,'建德市',3077,'330182'),(3089,'富阳区',3077,'330183'),(3090,'临安市',3077,'330185'),(3091,'宁波市',3076,'330200'),(3092,'海曙区',3091,'330203'),(3093,'江东区',3091,'330204'),(3094,'江北区',3091,'330205'),(3095,'北仑区',3091,'330206'),(3096,'镇海区',3091,'330211'),(3097,'鄞州区',3091,'330212'),(3098,'象山县',3091,'330225'),(3099,'宁海县',3091,'330226'),(3100,'余姚市',3091,'330281'),(3101,'慈溪市',3091,'330282'),(3102,'奉化市',3091,'330283'),(3103,'温州市',3076,'330300'),(3104,'鹿城区',3103,'330302'),(3105,'龙湾区',3103,'330303'),(3106,'瓯海区',3103,'330304'),(3107,'洞头县',3103,'330322'),(3108,'永嘉县',3103,'330324'),(3109,'平阳县',3103,'330326'),(3110,'苍南县',3103,'330327'),(3111,'文成县',3103,'330328'),(3112,'泰顺县',3103,'330329'),(3113,'瑞安市',3103,'330381'),(3114,'乐清市',3103,'330382'),(3115,'嘉兴市',3076,'330400'),(3116,'南湖区',3115,'330402'),(3117,'秀洲区',3115,'330411'),(3118,'嘉善县',3115,'330421'),(3119,'海盐县',3115,'330424'),(3120,'海宁市',3115,'330481'),(3121,'平湖市',3115,'330482'),(3122,'桐乡市',3115,'330483'),(3123,'湖州市',3076,'330500'),(3124,'吴兴区',3123,'330502'),(3125,'南浔区',3123,'330503'),(3126,'德清县',3123,'330521'),(3127,'长兴县',3123,'330522'),(3128,'安吉县',3123,'330523'),(3129,'绍兴市',3076,'330600'),(3130,'越城区',3129,'330602'),(3131,'柯桥区',3129,'330621'),(3132,'新昌县',3129,'330624'),(3133,'诸暨市',3129,'330681'),(3134,'上虞区',3129,'330682'),(3135,'嵊州市',3129,'330683'),(3136,'金华市',3076,'330700'),(3137,'婺城区',3136,'330702'),(3138,'金东区',3136,'330703'),(3139,'武义县',3136,'330723'),(3140,'浦江县',3136,'330726'),(3141,'磐安县',3136,'330727'),(3142,'兰溪市',3136,'330781'),(3143,'义乌市',3136,'330782'),(3144,'东阳市',3136,'330783'),(3145,'永康市',3136,'330784'),(3146,'衢州市',3076,'330800'),(3147,'柯城区',3146,'330802'),(3148,'衢江区',3146,'330803'),(3149,'常山县',3146,'330822'),(3150,'开化县',3146,'330824'),(3151,'龙游县',3146,'330825'),(3152,'江山市',3146,'330881'),(3153,'舟山市',3076,'330900'),(3154,'定海区',3153,'330902'),(3155,'普陀区',3153,'330903'),(3156,'岱山县',3153,'330921'),(3157,'嵊泗县',3153,'330922'),(3158,'台州市',3076,'331000'),(3159,'椒江区',3158,'331002'),(3160,'黄岩区',3158,'331003'),(3161,'路桥区',3158,'331004'),(3162,'玉环县',3158,'331021'),(3163,'三门县',3158,'331022'),(3164,'天台县',3158,'331023'),(3165,'仙居县',3158,'331024'),(3166,'温岭市',3158,'331081'),(3167,'临海市',3158,'331082'),(3168,'丽水市',3076,'331100'),(3169,'莲都区',3168,'331102'),(3170,'青田县',3168,'331121'),(3171,'缙云县',3168,'331122'),(3172,'遂昌县',3168,'331123'),(3173,'松阳县',3168,'331124'),(3174,'云和县',3168,'331125'),(3175,'庆元县',3168,'331126'),(3176,'景宁畲族自治县',3168,'331127'),(3177,'龙泉市',3168,'331181'),(3178,'香港',0,'810000'),(3179,'九龙城区',3178,'810200'),(3180,'观塘区',3179,'810205'),(3181,'黄大仙区',3179,'810204'),(3182,'九龙城区',3179,'810201'),(3183,'深水埗区',3179,'810203'),(3184,'油尖旺区',3179,'810202'),(3185,'香港岛',3178,'810100'),(3186,'东区',3185,'810103'),(3187,'南区',3185,'810104'),(3188,'湾仔',3185,'810102'),(3189,'中西',3185,'810101'),(3190,'新界',3178,'810300'),(3191,'北区',3190,'810301'),(3192,'大埔区',3190,'810302'),(3193,'葵青区',3190,'810308'),(3194,'离岛区',3190,'810309'),(3195,'荃湾区',3190,'810307'),(3196,'沙田区',3190,'810303'),(3197,'屯门区',3190,'810306'),(3198,'西贡区',3190,'810304'),(3199,'元朗区',3190,'810305'),(3200,'澳门',0,'820000'),(3201,'澳门半岛',3200,'820100'),(3202,'澳门半岛',3201,'820100001'),(3203,'离岛',3200,'820200'),(3204,'离岛',3203,'820200001'),(3205,'台湾',0,'710000'),(3206,'连江县',3205,'712800'),(3207,'北竿乡',3206,'712806'),(3208,'东引乡',3206,'712808'),(3209,'莒光乡',3206,'712807'),(3210,'南竿乡',3206,'712805'),(3211,'高雄市',3205,'710200'),(3212,'阿莲区',3211,'710246'),(3213,'大寮区',3211,'710255'),(3214,'大社区',3211,'710243'),(3215,'大树区',3211,'710258'),(3216,'凤山区',3211,'710254'),(3217,'冈山区',3211,'710244'),(3218,'湖内区',3211,'710253'),(3219,'甲仙区',3211,'710264'),(3220,'苓雅区',3211,'710241'),(3221,'林园区',3211,'710256'),(3222,'六龟区',3211,'710261'),(3223,'路竹区',3211,'710245'),(3224,'茂林区',3211,'710267'),(3225,'美浓区',3211,'710260'),(3226,'弥陀区',3211,'710251'),(3227,'那玛夏区',3211,'710266'),(3228,'内门区',3211,'710262'),(3229,'鸟松区',3211,'710257'),(3230,'桥头区',3211,'710249'),(3231,'茄萣区',3211,'710268'),(3232,'旗山区',3211,'710259'),(3233,'仁武区',3211,'710242'),(3234,'杉林区',3211,'710263'),(3235,'桃源区',3211,'710265'),(3236,'田寮区',3211,'710247'),(3237,'燕巢区',3211,'710248'),(3238,'永安区',3211,'710252'),(3239,'梓官区',3211,'710250'),(3240,'鼓山区',3211,'710205'),(3241,'楠梓区',3211,'710210'),(3242,'前金区',3211,'710202'),(3243,'前镇区',3211,'710207'),(3244,'旗津区',3211,'710206'),(3245,'芩雅区',3211,'710203'),(3246,'三民区',3211,'710208'),(3247,'小港区',3211,'710211'),(3248,'新兴区',3211,'710201'),(3249,'盐埕区',3211,'710204'),(3250,'左营区',3211,'710209'),(3251,'花莲县',3205,'712600'),(3252,'丰滨乡',3251,'712623'),(3253,'凤林镇',3251,'712621'),(3254,'富里乡',3251,'712628'),(3255,'光复乡',3251,'712622'),(3256,'花莲市',3251,'712615'),(3257,'卓溪乡',3251,'712627'),(3258,'吉安乡',3251,'712619'),(3259,'瑞穗乡',3251,'712624'),(3260,'寿丰乡',3251,'712620'),(3261,'新城乡',3251,'712616'),(3262,'秀林乡',3251,'712618'),(3263,'太鲁阁',3251,'712617'),(3264,'万荣乡',3251,'712625'),(3265,'玉里镇',3251,'712626'),(3266,'嘉义市',3205,'710900'),(3267,'东区',3266,'710901'),(3268,'西区',3266,'710902'),(3269,'嘉义县',3205,'711900'),(3270,'阿里山乡',3269,'711922'),(3271,'鹿草乡',3269,'711926'),(3272,'布袋镇',3269,'711936'),(3273,'大林镇',3269,'711933'),(3274,'大埔乡',3269,'711924'),(3275,'东石乡',3269,'711929'),(3276,'番路乡',3269,'711919'),(3277,'中埔乡',3269,'711923'),(3278,'竹崎乡',3269,'711921'),(3279,'六脚乡',3269,'711930'),(3280,'梅山乡',3269,'711920'),(3281,'民雄乡',3269,'711932'),(3282,'朴子乡',3269,'711928'),(3283,'水上乡',3269,'711925'),(3284,'溪口乡',3269,'711934'),(3285,'新港乡',3269,'711931'),(3286,'太保乡',3269,'711927'),(3287,'义竹乡',3269,'711935'),(3288,'基隆市',3205,'710700'),(3289,'安乐区',3288,'710705'),(3290,'暖暖区',3288,'710706'),(3291,'七堵区',3288,'710707'),(3292,'仁爱区',3288,'710701'),(3293,'信义区',3288,'710702'),(3294,'中山区',3288,'710704'),(3295,'中正区',3288,'710703'),(3296,'金门县',3205,'710500'),(3297,'金城镇',3296,'710510'),(3298,'金湖镇',3296,'710508'),(3299,'金宁乡',3296,'710509'),(3300,'金沙镇',3296,'710507'),(3301,'烈屿乡',3296,'710511'),(3302,'乌坵乡',3296,'710512'),(3303,'苗栗县',3205,'711500'),(3304,'大湖乡',3303,'711531'),(3305,'公馆乡',3303,'711530'),(3306,'后龙镇',3303,'711524'),(3307,'竹南镇',3303,'711519'),(3308,'卓兰镇',3303,'711536'),(3309,'苗栗市',3303,'711527'),(3310,'南庄乡',3303,'711522'),(3311,'三湾乡',3303,'711521'),(3312,'三义乡',3303,'711534'),(3313,'狮潭乡',3303,'711523'),(3314,'西湖乡',3303,'711535'),(3315,'泰安乡',3303,'711532'),(3316,'铜锣乡',3303,'711533'),(3317,'通霄镇',3303,'711525'),(3318,'头份镇',3303,'711520'),(3319,'头屋乡',3303,'711529'),(3320,'苑里镇',3303,'711526'),(3321,'造桥乡',3303,'711528'),(3322,'南投县',3205,'710600'),(3323,'草屯镇',3322,'710616'),(3324,'国姓乡',3322,'710617'),(3325,'中寮乡',3322,'710615'),(3326,'竹山镇',3322,'710625'),(3327,'集集镇',3322,'710621'),(3328,'鹿谷乡',3322,'710626'),(3329,'名间乡',3322,'710620'),(3330,'南投市',3322,'710614'),(3331,'埔里镇',3322,'710618'),(3332,'仁爱乡',3322,'710619'),(3333,'水里乡',3322,'710622'),(3334,'信义乡',3322,'710624'),(3335,'鱼池乡',3322,'710623'),(3336,'澎湖县',3205,'712700'),(3337,'白沙乡',3336,'712711'),(3338,'七美乡',3336,'712710'),(3339,'湖西乡',3336,'712712'),(3340,'马公市',3336,'712707'),(3341,'西屿乡',3336,'712708'),(3342,'望安乡',3336,'712709'),(3343,'屏东县',3205,'712400'),(3344,'长治乡',3343,'712442'),(3345,'潮州镇',3343,'712447'),(3346,'车城乡',3343,'712463'),(3347,'春日乡',3343,'712461'),(3348,'东港镇',3343,'712455'),(3349,'枋寮乡',3343,'712459'),(3350,'枋山乡',3343,'712460'),(3351,'高树乡',3343,'712440'),(3352,'恒春镇',3343,'712465'),(3353,'竹田乡',3343,'712444'),(3354,'佳冬乡',3343,'712457'),(3355,'九如乡',3343,'712438'),(3356,'崁顶乡',3343,'712451'),(3357,'来义乡',3343,'712449'),(3358,'里港乡',3343,'712439'),(3359,'林边乡',3343,'712454'),(3360,'麟洛乡',3343,'712443'),(3361,'琉球乡',3343,'712456'),(3362,'玛家乡',3343,'712437'),(3363,'满州镇',3343,'712466'),(3364,'牡丹乡',3343,'712464'),(3365,'南州乡',3343,'712453'),(3366,'内埔乡',3343,'712445'),(3367,'屏东市',3343,'712434'),(3368,'三地门乡',3343,'712435'),(3369,'狮子乡',3343,'712462'),(3370,'新埤乡',3343,'712452'),(3371,'新园乡',3343,'712458'),(3372,'泰武乡',3343,'712448'),(3373,'万丹乡',3343,'712446'),(3374,'万峦乡',3343,'712450'),(3375,'雾台乡',3343,'712436'),(3376,'盐埔乡',3343,'712441'),(3377,'台北市',3205,'710100'),(3378,'北投区',3377,'710109'),(3379,'大安区',3377,'710105'),(3380,'大同区',3377,'710102'),(3381,'南港区',3377,'710111'),(3382,'内湖区',3377,'710110'),(3383,'信义区',3377,'710107'),(3384,'士林区',3377,'710108'),(3385,'松山区',3377,'710104'),(3386,'万华区',3377,'710106'),(3387,'文山区',3377,'710112'),(3388,'中山区',3377,'710103'),(3389,'中正区',3377,'710101'),(3390,'台东县',3205,'712500'),(3391,'卑南乡',3390,'712521'),(3392,'长滨乡',3390,'712528'),(3393,'成功镇',3390,'712527'),(3394,'池上乡',3390,'712525'),(3395,'达仁乡',3390,'712531'),(3396,'大武乡',3390,'712530'),(3397,'东河乡',3390,'712526'),(3398,'关山镇',3390,'712523'),(3399,'海端乡',3390,'712524'),(3400,'金峰乡',3390,'712529'),(3401,'兰屿乡',3390,'712519'),(3402,'鹿野乡',3390,'712522'),(3403,'绿岛乡',3390,'712518'),(3404,'台东市',3390,'712517'),(3405,'太麻里乡',3390,'712532'),(3406,'延平乡',3390,'712520'),(3407,'台南市',3205,'710300'),(3408,'安定区',3407,'710369'),(3409,'白河区',3407,'710359'),(3410,'北门区',3407,'710356'),(3411,'大内区',3407,'710366'),(3412,'东山区',3407,'710360'),(3413,'关庙区',3407,'710347'),(3414,'官田区',3407,'710349'),(3415,'归仁区',3407,'710340'),(3416,'后壁区',3407,'710358'),(3417,'佳里区',3407,'710351'),(3418,'将军区',3407,'710354'),(3419,'六甲区',3407,'710361'),(3420,'柳营区',3407,'710363'),(3421,'龙崎区',3407,'710348'),(3422,'麻豆区',3407,'710350'),(3423,'南化区',3407,'710345'),(3424,'楠西区',3407,'710344'),(3425,'七股区',3407,'710353'),(3426,'仁德区',3407,'710346'),(3427,'善化区',3407,'710365'),(3428,'山上区',3407,'710367'),(3429,'下营区',3407,'710362'),(3430,'西港区',3407,'710352'),(3431,'新化区',3407,'710341'),(3432,'新市区',3407,'710368'),(3433,'新营区',3407,'710357'),(3434,'学甲区',3407,'710355'),(3435,'盐水区',3407,'710364'),(3436,'永康区',3407,'710339'),(3437,'玉井区',3407,'710343'),(3438,'左镇区',3407,'710342'),(3439,'安南区',3407,'710306'),(3440,'安平区',3407,'710305'),(3441,'北区',3407,'710304'),(3442,'东区',3407,'710302'),(3443,'南区',3407,'710303'),(3444,'中西区',3407,'710301'),(3445,'台中',3205,'710400'),(3446,'大安区',3445,'710451'),(3447,'大肚区',3445,'710444'),(3448,'大甲区',3445,'710449'),(3449,'大里区',3445,'710432'),(3450,'大雅区',3445,'710442'),(3451,'东势区',3445,'710438'),(3452,'丰原区',3445,'710435'),(3453,'和平区',3445,'710439'),(3454,'后里区',3445,'710436'),(3455,'龙井区',3445,'710446'),(3456,'清水区',3445,'710448'),(3457,'沙鹿区',3445,'710445'),(3458,'神冈区',3445,'710443'),(3459,'石冈区',3445,'710437'),(3460,'太平区',3445,'710431'),(3461,'潭子区',3445,'710441'),(3462,'外埔区',3445,'710450'),(3463,'雾峰区',3445,'710433'),(3464,'梧栖区',3445,'710447'),(3465,'乌日区',3445,'710434'),(3466,'新社区',3445,'710440'),(3467,'北区',3445,'710405'),(3468,'北屯区',3445,'710406'),(3469,'东区',3445,'710402'),(3470,'南区',3445,'710403'),(3471,'南屯区',3445,'710408'),(3472,'西区',3445,'710404'),(3473,'西屯区',3445,'710407'),(3474,'中区',3445,'710401'),(3475,'桃园县',3205,'711400'),(3476,'八德市',3475,'711422'),(3477,'大溪镇',3475,'711423'),(3478,'大园乡',3475,'711425'),(3479,'复兴乡',3475,'711424'),(3480,'观音乡',3475,'711419'),(3481,'龟山乡',3475,'711421'),(3482,'中坜市',3475,'711414'),(3483,'龙潭乡',3475,'711416'),(3484,'芦竹乡',3475,'711426'),(3485,'平镇市',3475,'711415'),(3486,'新屋乡',3475,'711418'),(3487,'桃园市',3475,'711420'),(3488,'杨梅市',3475,'711417'),(3489,'新北市',3205,'711100'),(3490,'八里区',3489,'711155'),(3491,'板桥区',3489,'711132'),(3492,'淡水区',3489,'711156'),(3493,'贡寮区',3489,'711139'),(3494,'中和区',3489,'711144'),(3495,'金山区',3489,'711131'),(3496,'林口区',3489,'711152'),(3497,'芦洲区',3489,'711153'),(3498,'坪林区',3489,'711141'),(3499,'平溪区',3489,'711137'),(3500,'瑞芳区',3489,'711136'),(3501,'三重区',3489,'711149'),(3502,'三芝区',3489,'711157'),(3503,'三峡区',3489,'711146'),(3504,'深坑区',3489,'711134'),(3505,'石碇区',3489,'711135'),(3506,'石门区',3489,'711158'),(3507,'双溪区',3489,'711138'),(3508,'树林区',3489,'711147'),(3509,'汐止区',3489,'711133'),(3510,'新店区',3489,'711140'),(3511,'新庄区',3489,'711150'),(3512,'泰山区',3489,'711151'),(3513,'土城区',3489,'711145'),(3514,'万里区',3489,'711130'),(3515,'五股区',3489,'711154'),(3516,'乌来区',3489,'711142'),(3517,'莺歌区',3489,'711148'),(3518,'永和区',3489,'711143'),(3519,'新竹市',3205,'710800'),(3520,'北区',3519,'710802'),(3521,'东区',3519,'710801'),(3522,'香山区',3519,'710803'),(3523,'新竹县',3205,'711300'),(3524,'宝山乡',3523,'711320'),(3525,'北埔乡',3523,'711325'),(3526,'芎林乡',3523,'711319'),(3527,'峨眉乡',3523,'711326'),(3528,'关西镇',3523,'711318'),(3529,'横山乡',3523,'711323'),(3530,'湖口乡',3523,'711315'),(3531,'竹北市',3523,'711314'),(3532,'竹东镇',3523,'711321'),(3533,'尖石乡',3523,'711324'),(3534,'新丰乡',3523,'711316'),(3535,'新埔镇',3523,'711317'),(3536,'五峰乡',3523,'711322'),(3537,'宜兰县',3205,'711200'),(3538,'大同乡',3537,'711221'),(3539,'冬山乡',3537,'711223'),(3540,'壮围乡',3537,'711217'),(3541,'礁溪乡',3537,'711216'),(3542,'罗东镇',3537,'711219'),(3543,'南澳乡',3537,'711225'),(3544,'三星乡',3537,'711220'),(3545,'苏澳镇',3537,'711224'),(3546,'头城镇',3537,'711215'),(3547,'五结乡',3537,'711222'),(3548,'宜兰市',3537,'711214'),(3549,'员山乡',3537,'711218'),(3550,'钓鱼台',3537,'711226'),(3551,'云林县',3205,'712100'),(3552,'褒忠乡',3551,'712125'),(3553,'北港镇',3551,'712136'),(3554,'莿桐乡',3551,'712133'),(3555,'大埤乡',3551,'712122'),(3556,'东势乡',3551,'712126'),(3557,'斗六市',3551,'712130'),(3558,'斗南镇',3551,'712121'),(3559,'二仑乡',3551,'712135'),(3560,'古坑乡',3551,'712132'),(3561,'虎尾镇',3551,'712123'),(3562,'口湖乡',3551,'712138'),(3563,'林内乡',3551,'712131'),(3564,'仑背乡',3551,'712128'),(3565,'麦寮乡',3551,'712129'),(3566,'水林乡',3551,'712137'),(3567,'四湖乡',3551,'712139'),(3568,'西螺镇',3551,'712134'),(3569,'台西乡',3551,'712127'),(3570,'土库镇',3551,'712124'),(3571,'元长乡',3551,'712140'),(3572,'彰化县',3205,'711700'),(3573,'北斗镇',3572,'711744'),(3574,'大城乡',3572,'711750'),(3575,'大村乡',3572,'711741'),(3576,'二林镇',3572,'711749'),(3577,'二水乡',3572,'711752'),(3578,'芳苑乡',3572,'711751'),(3579,'芬园乡',3572,'711728'),(3580,'福兴乡',3572,'711732'),(3581,'和美镇',3572,'711734'),(3582,'花坛乡',3572,'711729'),(3583,'彰化县',3572,'711727'),(3584,'竹塘乡',3572,'711748'),(3585,'鹿港镇',3572,'711731'),(3586,'埤头乡',3572,'711746'),(3587,'埔心乡',3572,'711739'),(3588,'埔盐乡',3572,'711742'),(3589,'伸港乡',3572,'711735'),(3590,'社头乡',3572,'711737'),(3591,'线西乡',3572,'711733'),(3592,'溪湖镇',3572,'711740'),(3593,'溪州乡',3572,'711747'),(3594,'秀水乡',3572,'711730'),(3595,'田中镇',3572,'711743'),(3596,'田尾乡',3572,'711745'),(3597,'永靖乡',3572,'711738'),(3598,'员林镇',3572,'711736'),(3599,'东城区',123,'3599'),(3600,'东湖街道',0,'820200002'),(3601,'泉秀街道',0,'820200003'),(3602,'明光路街道',3,'820200004'),(3603,'鼓东街道',131,'820200005'),(3604,'海滨街道',171,'820200006'),(3605,'',0,'820200007'),(3606,'湖里街道',147,'820200008'),(3607,'上海路街道',1627,'820200009'),(3608,'西一路街道',1921,'820200010'),(3609,'人民街道',1239,'820200011'),(3610,'王城路街道',1098,'820200012'),(3611,'张家堡街道',2410,'820200013'),(3612,'仁兴街道',1756,'820200014'),(3613,'横塘街道',1549,'820200015'),(3614,'墟沟街道',1568,'820200016'),(3615,'安肃镇',837,'820200017'),(3616,'南岭街道',1735,'820200018'),(3617,'英雄街道',1756,'820200019'),(3618,'雕庄街道',1541,'820200020'),(3619,'东华门街道',3599,'820200021'),(3620,'万安街道',173,'820200022'),(3621,'酒泉路街道',226,'820200023'),(3622,'山腰街道',174,'820200024'),(3623,'梅溪湖街道',1374,'820200025'),(3624,'西城区',123,'123001'),(3625,'朝阳区',123,'123002'),(3626,'石景山区',123,'123003'),(3627,'海淀区',123,'123004'),(3628,'顺义区',123,'123005'),(3629,'通州区',123,'123006'),(3630,'大兴区',123,'123007'),(3631,'房山区',123,'123008'),(3632,'平谷区',23,'123009'),(3633,'密云区',123,'123010'),(3634,'东城区',123,'123011'),(3635,'延庆区',123,'123012');
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_area` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_article`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_article`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_article` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(11) NOT NULL COMMENT '公众号id',
  `title` varchar(100) NOT NULL COMMENT '标题',
  `content` mediumtext,
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `enabled` tinyint(1) NOT NULL COMMENT '是否生效，1生效，0不生效',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城文章列表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_article`
--

LOCK TABLES `oscshop_lionfish_comshop_article` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_article` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_article` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_car`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_car`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_car` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `token` varchar(200) NOT NULL COMMENT '客户端token,会员身份',
  `community_id` int(10) NOT NULL COMMENT '团长id',
  `carkey` varchar(255) NOT NULL COMMENT '购物车key',
  `format_data` text NOT NULL COMMENT '购物车商品参数',
  `modifytime` int(10) DEFAULT '0' COMMENT '加入购物车时间',
  PRIMARY KEY (`id`),
  KEY `token` (`token`),
  KEY `community_id` (`community_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='客户端购物车表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_car`
--

LOCK TABLES `oscshop_lionfish_comshop_car` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_car` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_car` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_chargetype`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_chargetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_chargetype` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `money` float(10,2) NOT NULL COMMENT '充值金额',
  `send_money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '赠送金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='会员充值选项表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_chargetype`
--

LOCK TABLES `oscshop_lionfish_comshop_chargetype` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_chargetype` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_chargetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_commission_level`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_commission_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_commission_level` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `levelname` varchar(50) NOT NULL,
  `commission1` decimal(10,2) DEFAULT '0.00',
  `commission2` decimal(10,2) DEFAULT '0.00',
  `commission3` decimal(10,2) DEFAULT '0.00',
  `ordermoney` decimal(10,2) DEFAULT '0.00',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城分销等级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_commission_level`
--

LOCK TABLES `oscshop_lionfish_comshop_commission_level` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_commission_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_commission_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_community_head_level`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_community_head_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_community_head_level` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `levelname` varchar(255) NOT NULL COMMENT '等级名称',
  `commission` float(10,2) DEFAULT '0.00' COMMENT '分销比例',
  `auto_upgrade` tinyint(1) DEFAULT '0' COMMENT '自动升级： 0 否，1 是',
  `condition_type` tinyint(1) DEFAULT NULL COMMENT '0 . 累计社区用户完成订单总金额, 1 .累计社区用户数量',
  `condition_one` float(10,2) DEFAULT '0.00' COMMENT '累计社区用户完成订单总金额',
  `condition_two` int(10) DEFAULT '0' COMMENT '累计社区用户数量',
  `condition_order_total` int(11) NOT NULL DEFAULT '0' COMMENT '团长升级订单满数升级条件',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城团长等级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_community_head_level`
--

LOCK TABLES `oscshop_lionfish_comshop_community_head_level` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_community_head_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_community_head_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_community_pickup_member`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_community_pickup_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_community_pickup_member` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `community_id` int(10) NOT NULL COMMENT '社区id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '状态，0未审核，1审核通过',
  `remark` varchar(255) DEFAULT NULL COMMENT '备注',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`),
  KEY `community_id` (`community_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='核销人员表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_community_pickup_member`
--

LOCK TABLES `oscshop_lionfish_comshop_community_pickup_member` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_community_pickup_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_community_pickup_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_community_pickup_member_record`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_community_pickup_member_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_community_pickup_member_record` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `order_sn` varchar(100) DEFAULT NULL COMMENT '订单编号',
  `community_id` int(10) NOT NULL COMMENT '社区id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='核销员核销记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_community_pickup_member_record`
--

LOCK TABLES `oscshop_lionfish_comshop_community_pickup_member_record` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_community_pickup_member_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_community_pickup_member_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_config`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_config` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=194 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_config`
--

LOCK TABLES `oscshop_lionfish_comshop_config` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_config` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_config` VALUES (1,'goods_stock_notice','100'),(2,'instructions','&amp;lt;p&amp;gt;我们竭诚为您服务&amp;lt;/p&amp;gt;'),(3,'default_comunity_money','10'),(4,'user_qrcode_image',''),(5,'user_qrcode_x','{php echo empty($data[\'user_qrcode_x\'])?0:$data[\'user_qrcode_x\']}'),(6,'user_qrcode_y','{php echo empty($data[\'user_qrcode_y\'])?0:$data[\'user_qrcode_y\']}'),(7,'communityhead_apply_page',''),(8,'shoname','社区团购'),(9,'shoplogo',''),(10,'shop_index_share_title',''),(11,'tx_map_key',''),(12,'shop_summary',''),(13,'open_diy_index_page','0'),(14,'shop_index_share_image',''),(15,'admin_login_image',''),(16,'loading',''),(17,'index_bottom_image',''),(18,'index_list_top_image',''),(19,'saleout',''),(20,'kanjia_index_image',''),(21,'pintuan_index_image',''),(22,'new_group_index_image',''),(23,'fenxiao_apply_index_image',''),(24,'wepro_appid',''),(25,'wepro_appsecret',''),(26,'wepro_partnerid',''),(27,'wepro_key',''),(28,'wepro_share_title',''),(29,'weprogram_template_pay_order','9tP_RxTj50s8J3beXXcBVrOEgQW9ENIhD9Q7Edfi1P8'),(30,'weprogram_template_send_order','L4iD7s-kehoEKrviOma05V8yK-GwTTS1EkJVSzNT3YY'),(31,'weprogram_template_hexiao_success','xJ8QgNgG3k8ljNBt3szlGfhquS-NRoE6Pkl-dNPVg_8'),(32,'weprogram_template_refund_order','HzB_1Sf4VPhXWbcLvECUAc7IsrZtA5iYd4vVE4R8FUk'),(33,'weprogram_template_apply_community','WxpXsO4tk960SfQBKvb0oT9M0nxOEO_P3ZWaUTD7o5I'),(34,'weprogram_template_apply_tixian','Y3fxF8crUSJ4-fGQuBunl-5oabAky59_lroDvJquENs'),(35,'wechat_apiclient_cert_pem','-----BEGIN CERTIFICATE-----\r\nMIIEbDCCA9WgAwIBAgIEAdH4WDANBgkqhkiG9w0BAQUFADCBijELMAkGA1UEBhMC\r\nQ04xEjAQBgNVBAgTCUd1YW5nZG9uZzERMA8GA1UEBxMIU2hlbnpoZW4xEDAOBgNV\r\nBAoTB1RlbmNlbnQxDDAKBgNVBAsTA1dYRzETMBEGA1UEAxMKTW1wYXltY2hDQTEf\r\nMB0GCSqGSIb3DQEJARYQbW1wYXltY2hAdGVuY2VudDAeFw0xODAzMTUwMzM2MDZa\r\nFw0yODAzMTIwMzM2MDZaMIGbMQswCQYDVQQGEwJDTjESMBAGA1UECBMJR3Vhbmdk\r\nb25nMREwDwYDVQQHEwhTaGVuemhlbjEQMA4GA1UEChMHVGVuY2VudDEOMAwGA1UE\r\nCxMFTU1QYXkxMDAuBgNVBAMUJ+WOpumXqOeLruWtkOmxvOe9kee7nOenkeaKgOac\r\niemZkOWFrOWPuDERMA8GA1UEBBMIMTA3NDk2NDAwggEiMA0GCSqGSIb3DQEBAQUA\r\nA4IBDwAwggEKAoIBAQDHMRPQnEbgRhry9RMxKnGEspJzROnmAGDuh0TQF/RzUT25\r\nIvXeUKcQ5pFJIUSaqc8PlMcIsMHCIw1TyG/ZlzdbwQZRxrVGmGoTMUnz6jWMkQge\r\n8zk0g/vnnpoVWMPLKbrahcnRgrVVvCwPMIzfoetDvz8nQ7c3fYbLLq4y8vBlSgLi\r\nlaUZe6iz95bWlh9QZVyIhNPqbzFUFnwZKpsW9oh5jZPv7NSBJacRmeaEPcPUqCx+\r\nDojxIKNLV+TA81nPOzOmDDcqu60UJvegC8ei+Dfrm/piglv61PqFmZzIIaEqprNu\r\nfbB0aqr/cz8qjvHQvAR6SlHTPr8mhYZIyhcnXOZHAgMBAAGjggFGMIIBQjAJBgNV\r\nHRMEAjAAMCwGCWCGSAGG+EIBDQQfFh0iQ0VTLUNBIEdlbmVyYXRlIENlcnRpZmlj\r\nYXRlIjAdBgNVHQ4EFgQUUOn/xoR8jmnsxP4uTlPbCiJedq8wgb8GA1UdIwSBtzCB\r\ntIAUPgUm9iJitBVbiM1kfrDUYqflhnShgZCkgY0wgYoxCzAJBgNVBAYTAkNOMRIw\r\nEAYDVQQIEwlHdWFuZ2RvbmcxETAPBgNVBAcTCFNoZW56aGVuMRAwDgYDVQQKEwdU\r\nZW5jZW50MQwwCgYDVQQLEwNXWEcxEzARBgNVBAMTCk1tcGF5bWNoQ0ExHzAdBgkq\r\nhkiG9w0BCQEWEG1tcGF5bWNoQHRlbmNlbnSCCQC7VJcrvADoVzAOBgNVHQ8BAf8E\r\nBAMCBsAwFgYDVR0lAQH/BAwwCgYIKwYBBQUHAwIwDQYJKoZIhvcNAQEFBQADgYEA\r\ndigek75p5H8Oi1qqmR70ZztL+oIBA36rzIqNdwpEJuTL6t4G5bxyT9KOSzQoICd3\r\n9niOz+EoKAXFdgUNa19PnBM5r/NKSG3n390nYIxyAVvxekYKiRLPohb0XW3reEj7\r\n4uoDZJd1ASNpKSBIvV3DL6ueVa49izDoY1T1wAM71yk=\r\n-----END CERTIFICATE-----'),(36,'wechat_apiclient_key_pem','-----BEGIN PRIVATE KEY-----\r\nMIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQDHMRPQnEbgRhry\r\n9RMxKnGEspJzROnmAGDuh0TQF/RzUT25IvXeUKcQ5pFJIUSaqc8PlMcIsMHCIw1T\r\nyG/ZlzdbwQZRxrVGmGoTMUnz6jWMkQge8zk0g/vnnpoVWMPLKbrahcnRgrVVvCwP\r\nMIzfoetDvz8nQ7c3fYbLLq4y8vBlSgLilaUZe6iz95bWlh9QZVyIhNPqbzFUFnwZ\r\nKpsW9oh5jZPv7NSBJacRmeaEPcPUqCx+DojxIKNLV+TA81nPOzOmDDcqu60UJveg\r\nC8ei+Dfrm/piglv61PqFmZzIIaEqprNufbB0aqr/cz8qjvHQvAR6SlHTPr8mhYZI\r\nyhcnXOZHAgMBAAECggEAcAvySnluAQBObnZfSlvGqU9NxBtyutdhrytWEPw4nJmJ\r\nb9fzmA+kOoSIGyvkjF+Swv/8ia3sAAl5mLR5/lrqX+mPZXayR7i6intCTztizeRT\r\nPh2xAxJvI9X6dKGO2XxqyDtT0E+HM2f7HLxBshZB4cT1gF+98y/gH/DtOmmfwklF\r\nGMnup6Q8UQTU8vGoFzNEpb8+eOjuAXOraXSp440R84+yurUKyasiFHA5T5zwVbff\r\nJeymmSLmH6B/aRNl2FWG+Z6XJC1XvjlVb346PDOoOfsyHz250jD/lp2/z1NZgvKZ\r\no5JZ/n3asphK5Wi89WynTS/8Io3gjrdQN5T2MNmdwQKBgQD7h1ZoowUgi4/r01xn\r\n3UrdGByTITZb/2dFIFab4vxrPQAy4U1aWZqIw/auLMekDuOUJEsXeGct/Om2JVz+\r\n1Xn6KRI5xak0SQlOUAmhG1+iHCQTLU2/Zj+tUSAn1Xg2mgnLbRbzmn0PUqt7cNBv\r\nDmd3nXt2J6Dh+PTN9PDmCTq9oQKBgQDKu5BLHHPLzpgHLaaRTIMEUTw30B8ujEaE\r\nYrwEFx3xbYL+1bIOepVZWKfv3ZaGwFRECO8HWdcC3IMzuohCU0qbikHH/Peq5jRy\r\npgd8TyBHqYr4q2ssF0oMV2NH5mWpjBdn48NnpXchfpuofgToujjZ/I4g4UnqAcFA\r\n/4euiEOK5wKBgQC3H+d3Mwjuku1rgmyKagCxS3ayX8HV5PLozwx/XhjscnMMmB/b\r\nIdVysUmNsah/9x8Vof7RzaVBRBtbs4QrPH0b9n8AdLomCO6vh3IbS3Sq79YL6DXs\r\nnaLKqn/AwJhPGIL9CiVlohpe549VxeLamCAYZB2Y/m0RWFHTCPvCXwHXQQKBgCeI\r\no/7BsaMQyny73jt/XB0/airIHwyItkeiqV9y0pf97wmaynogVXdy3mzcHTpxzvzl\r\ncRdR4afhMISp32BvtaDXOTSyk+lzss6YqeUH2RegbEVJyEB02i/F6spel3yUoQvV\r\nUomnrq+NbPVSfcqUZfm8Ukr/I9bKONFgAyl50RIJAoGBALWifNYkgRpQH116YKI9\r\nCDw0yBZU+4h4C/+V3qR7RakZN9e2J0nfUoPpcaLiQCHgLepT+L3fVyXReEStEh/8\r\njHmbHnu3cdDoR7+g3HALjDpo3kVJn/crw8Hb2lODCvaumldRCuU0zcz/vqM/Z8Uy\r\nTJwg6dWCNrbR2X1Zx5UahUZW\r\n-----END PRIVATE KEY-----'),(37,'footer_copyright_desc',''),(38,'footer_copyright_logo',''),(39,'footer_copyright_url',''),(40,'footer_copyright_dialing',''),(41,'footer_copyright_tel',''),(42,'auto_receive_time',''),(43,'open_auto_delete','1'),(44,'auto_cancle_order_time','1'),(45,'kucun_method','0'),(46,'open_auto_receive',''),(47,'open_comment_shenhe','1'),(48,'shop_domain','https:///'),(49,'supply_apply_page',''),(50,'site_version','V17.2.0'),(51,'cur_release','202106081450'),(56,'index_list_theme_type','0'),(57,'nav_bg_color',''),(58,'group_name',''),(59,'owner_name',''),(60,'index_share_switch','0'),(61,'enabled_front_supply','1'),(62,'is_show_buy_record','0'),(63,'is_show_comment_list','0'),(64,'is_show_list_timer','0'),(65,'is_show_list_count','0'),(66,'default_comunity_limit_mile','0'),(67,'nav_font_color',''),(68,'seller_backimage',''),(69,'index_share_qrcode_bg',''),(70,'qrcode_rgb',''),(71,'avatar_rgb',''),(72,'modify_index_share_time',''),(73,'index_list_top_image_on','0'),(74,'goods_details_middle_image',''),(75,'index_lead_image',''),(76,'is_show_index_lead_image','0'),(77,'common_header_backgroundimage',''),(78,'auth_bg_image',''),(79,'shop_limit_buy_distance','0'),(80,'shop_buy_distance',''),(81,'open_redis_server','0'),(82,'redis_host',''),(83,'redis_port',''),(84,'redis_auth',''),(85,'order_notify_switch','1'),(86,'order_pay_after_share','1'),(87,'order_pay_after_share_img',''),(88,'open_feier_print','1'),(89,'feier_print_sn',''),(90,'feier_print_key',''),(91,'is_open_order_message','0'),(92,'is_user_shenhe','1'),(93,'is_get_formdata','1'),(94,'is_show_auth_mobile','1'),(95,'supply_add_goods_shenhe','1'),(96,'supply_edit_goods_shenhe','1'),(97,'is_open_supply_print','1'),(99,'goods_details_price_bg',''),(100,'is_show_notice001','1'),(101,'haibao_group_name',''),(102,'index_top_img_bg_open','0'),(103,'index_change_cate_btn','0'),(104,'index_service_switch','0'),(105,'user_service_switch','1'),(106,'index_switch_search','0'),(107,'index_top_font_color',''),(108,'hide_community_change_word','0'),(109,'hide_community_change_btn','0'),(110,'hide_index_top_communityinfo','0'),(111,'index_communityinfo_showtype','0'),(112,'index_type_first_name',''),(113,'ishow_index_copy_text','0'),(114,'ishow_index_gotop','0'),(115,'ishow_special_share_btn','0'),(116,'ishow_user_loginout_btn','0'),(117,'fetch_coder_type','0'),(118,'show_user_pin','0'),(119,'show_user_change_comunity','0'),(120,'newauth_bg_image',''),(121,'newauth_cancel_image',''),(122,'newauth_confirm_image',''),(123,'weprogram_subtemplate_pay_order',''),(124,'weprogram_subtemplate_send_order',''),(125,'weprogram_subtemplate_hexiao_success',''),(126,'weprogram_subtemplate_apply_community',''),(127,'weprogram_subtemplate_open_tuan',''),(128,'weprogram_subtemplate_take_tuan',''),(129,'weprogram_subtemplate_pin_tuansuccess',''),(130,'weprogram_subtemplate_apply_tixian',''),(131,'weprogram_subtemplate_refund_order',''),(132,'index_sort_method','0'),(133,'is_show_new_buy','0'),(134,'is_show_spike_buy','0'),(135,'is_show_guess_like','0'),(136,'show_goods_guess_like','0'),(137,'num_guess_like','8'),(138,'is_show_ziti_time','0'),(139,'is_open_only_express','0'),(140,'is_open_goods_relative_goods','0'),(141,'is_close_details_time','0'),(142,'goodsdetails_addcart_bg_color',''),(143,'goodsdetails_buy_bg_color',''),(144,'is_show_goodsdetails_communityinfo','0'),(145,'is_show_goodsdetails_commiss_money','0'),(146,'ishow_index_pickup_time','0'),(147,'is_pop_vipmember_buytip','0'),(148,'pop_vipmember_buyimage',''),(149,'isopen_community_group_share','0'),(150,'group_share_avatar',''),(151,'group_share_title',''),(152,'group_share_desc',''),(153,'show_index_wechat_oa','0'),(154,'community_money_type','0'),(155,'zhi_tui_reward_money','0'),(156,'open_community_addhexiaomember','0'),(157,'index_hide_headdetail_address','0'),(158,'template_order_success_notice','0'),(159,'is_show_head_level','0'),(160,'is_head_takegoods','0'),(161,'open_community_head_leve','0'),(162,'community_head_commiss1','0'),(163,'community_head_commiss2','0'),(164,'community_head_commiss3','0'),(165,'close_community_apply_enter','0'),(166,'close_community_reset_btn','0'),(167,'close_community_delivery_orders','0'),(168,'open_danhead_model','0'),(169,'is_new_backadmin','1'),(170,'skin',''),(171,'user_top_font_color',''),(172,'show_user_tuan_mobile','0'),(173,'ishide_index_goodslist','0'),(174,'excharge_nav_name',''),(175,'technical_support',''),(176,'record_number',''),(177,'clear_goodsdaysales','1623340800'),(178,'is_hide_details_count','0'),(179,'is_show_spike_buy_time','0'),(180,'goods_avatar_rgb',''),(181,'is_open_goods_full_video','0'),(182,'haibao_gooods_bg2',''),(183,'goods_details_title_bg',''),(184,'ishide_details_desc','0'),(185,'isnull_goods_sale_unit','0'),(186,'goods_sale_unit',''),(187,'show_goods_subtitle','0'),(188,'show_goods_preview','0'),(189,'videolist_nav_title',''),(190,'videolist_share_title',''),(191,'videolist_share_poster',''),(192,'can_index_notice_alert','0'),(193,'show_user_change_comunity_map','0');
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_coupon`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_coupon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_coupon` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `catid` int(10) DEFAULT NULL COMMENT '分类id',
  `voucher_title` varchar(100) NOT NULL COMMENT '优惠券名称',
  `thumb` varchar(255) NOT NULL COMMENT '图片',
  `credit` float(10,2) NOT NULL COMMENT '代金额',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '类型。0店铺专用，1所有通用',
  `is_index_show` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否推荐首页，供用户领取',
  `is_index_alert` tinyint(1) DEFAULT '0' COMMENT '是否首页弹窗，0否，1是',
  `is_new_man` tinyint(1) DEFAULT '0' COMMENT '是否新人券，0非，1新人',
  `is_share_doubling` tinyint(1) DEFAULT '0' COMMENT '是否分享翻倍，0：不翻倍，1翻倍',
  `get_over_hour` float(10,2) DEFAULT '0.00' COMMENT '领券后过期时间',
  `is_limit_goods_buy` tinyint(1) DEFAULT '0' COMMENT '是否限制商品购买，0不限制，1限制',
  `limit_goods_list` text COMMENT '限制的商品id',
  `goodscates` int(10) DEFAULT '0' COMMENT '限制商品分类使用',
  `share_title` varchar(255) DEFAULT NULL COMMENT '优惠券分享标题',
  `share_desc` varchar(255) DEFAULT NULL COMMENT '优惠券分享描述',
  `share_logo` varchar(255) DEFAULT NULL COMMENT '分享logo',
  `timelimit` tinyint(1) NOT NULL COMMENT '0 获得后，1在日期',
  `person_limit_count` int(10) DEFAULT '0' COMMENT '每人限领数量，0表示不限制',
  `limit_money` float(10,2) NOT NULL COMMENT '订单金额满多少可用',
  `total_count` int(11) NOT NULL COMMENT '总生成张数',
  `send_count` int(11) NOT NULL COMMENT '已发送张数',
  `begin_time` int(10) NOT NULL COMMENT '可以使用开始时间',
  `end_time` int(10) NOT NULL COMMENT '结束时间',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  `displayorder` int(10) DEFAULT NULL COMMENT '排序',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_coupon`
--

LOCK TABLES `oscshop_lionfish_comshop_coupon` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_coupon` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_coupon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_coupon_category`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_coupon_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_coupon_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT '',
  `displayorder` int(11) DEFAULT '0',
  `status` int(11) DEFAULT '0',
  `merchid` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_displayorder` (`displayorder`),
  KEY `idx_status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_coupon_category`
--

LOCK TABLES `oscshop_lionfish_comshop_coupon_category` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_coupon_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_coupon_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_coupon_list`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_coupon_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_coupon_list` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `voucher_id` int(11) NOT NULL COMMENT '优惠券id',
  `voucher_title` varchar(100) NOT NULL COMMENT '优惠券标题',
  `store_id` int(10) NOT NULL COMMENT '商家id',
  `user_id` int(10) NOT NULL DEFAULT '0' COMMENT '领取的用户id',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0店铺专用，1所有通用',
  `ordersn` varchar(255) DEFAULT NULL COMMENT '订单编号',
  `credit` float(10,2) NOT NULL COMMENT '优惠金额',
  `usetime` int(10) DEFAULT NULL COMMENT '使用时间',
  `limit_money` float(10,2) NOT NULL COMMENT '满多少可用',
  `is_limit_goods_buy` tinyint(1) DEFAULT '0' COMMENT '是否限制商品购买，0不限制，1限制',
  `limit_goods_list` text COMMENT '限制的商品id',
  `goodscates` int(10) DEFAULT '0' COMMENT '限制商品分类使用',
  `consume` enum('N','Y') NOT NULL COMMENT '是否使用',
  `gettype` tinyint(1) DEFAULT '1' COMMENT '领取方式，1首页领取',
  `begin_time` int(10) NOT NULL COMMENT '开始时间',
  `end_time` int(10) NOT NULL COMMENT '结束时间',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  `receive_type` enum('normal','invitegift','invitegift_new') DEFAULT 'normal' COMMENT '优惠券获取类型：normal 普通获取，invitegift 邀新有礼赠送优惠券，invitegift_new 被邀请者赠送优惠券',
  `receive_id` int(10) DEFAULT '0' COMMENT '邀新有礼记录id',
  PRIMARY KEY (`id`),
  KEY `voucher_id` (`voucher_id`) USING BTREE,
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_coupon_list`
--

LOCK TABLES `oscshop_lionfish_comshop_coupon_list` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_coupon_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_coupon_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_cube`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_cube`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_cube` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(255) NOT NULL COMMENT '名称',
  `thumb` text NOT NULL COMMENT '图片',
  `num` tinyint(1) NOT NULL COMMENT '图片个数',
  `appid` varchar(255) DEFAULT NULL COMMENT '外部小程序appid',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT '类型',
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `enabled` tinyint(1) NOT NULL COMMENT '是否生效，1生效，0不生效',
  `linktype` tinyint(1) NOT NULL COMMENT '0外链 1小程序内 2外部小程序',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魔方图片';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_cube`
--

LOCK TABLES `oscshop_lionfish_comshop_cube` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_cube` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_cube` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_deliveryclerk`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_deliveryclerk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_deliveryclerk` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `line_id` int(10) NOT NULL COMMENT '线路id',
  `name` varchar(100) NOT NULL COMMENT '配送员名称',
  `logo` varchar(255) DEFAULT NULL COMMENT '头像',
  `mobile` varchar(50) NOT NULL COMMENT '配送员手机号',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`line_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购配送员表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_deliveryclerk`
--

LOCK TABLES `oscshop_lionfish_comshop_deliveryclerk` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliveryclerk` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliveryclerk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_deliveryline`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_deliveryline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_deliveryline` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `name` varchar(255) NOT NULL COMMENT '线路名称',
  `clerk_id` int(10) NOT NULL COMMENT '配送员id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`clerk_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购配送线路';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_deliveryline`
--

LOCK TABLES `oscshop_lionfish_comshop_deliveryline` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliveryline` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliveryline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_deliveryline_headrelative`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_deliveryline_headrelative`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_deliveryline_headrelative` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `line_id` int(10) NOT NULL COMMENT '线路id',
  `head_id` int(11) NOT NULL COMMENT '团长id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`line_id`),
  KEY `head_id` (`head_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购线路团长关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_deliveryline_headrelative`
--

LOCK TABLES `oscshop_lionfish_comshop_deliveryline_headrelative` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliveryline_headrelative` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliveryline_headrelative` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_deliverylist`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_deliverylist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_deliverylist` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `list_sn` varchar(50) NOT NULL COMMENT '编号',
  `head_id` int(10) DEFAULT NULL COMMENT '团长id',
  `head_name` varchar(100) NOT NULL COMMENT '团长名称',
  `head_mobile` varchar(20) DEFAULT NULL COMMENT '团长手机',
  `head_address` varchar(255) NOT NULL COMMENT '团长地址',
  `line_id` int(10) NOT NULL COMMENT '线路id',
  `line_name` varchar(200) DEFAULT NULL COMMENT '线路名称',
  `clerk_id` int(10) DEFAULT NULL COMMENT '配送员id',
  `clerk_name` varchar(100) DEFAULT NULL COMMENT '配送员名称',
  `clerk_mobile` varchar(50) DEFAULT NULL COMMENT '配送员手机号',
  `state` tinyint(1) NOT NULL COMMENT '配送状态：0未配送，1配送中，2已配送',
  `goods_count` int(10) NOT NULL COMMENT '商品数量',
  `express_time` int(10) NOT NULL COMMENT '配送时间',
  `head_get_time` int(10) DEFAULT NULL COMMENT '清单配送到时间',
  `create_time` int(10) NOT NULL COMMENT '创建清单时间',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`line_id`),
  KEY `clerk_id` (`clerk_id`),
  KEY `head_id` (`head_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购清单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_deliverylist`
--

LOCK TABLES `oscshop_lionfish_comshop_deliverylist` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliverylist` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliverylist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_deliverylist_goods`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_deliverylist_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_deliverylist_goods` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `list_id` int(10) NOT NULL COMMENT '清单id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `goods_name` varchar(255) NOT NULL COMMENT '商品标题',
  `rela_goodsoption_valueid` varchar(100) NOT NULL COMMENT '商品规格',
  `sku_str` varchar(255) DEFAULT NULL COMMENT '标签名称',
  `goods_image` varchar(255) NOT NULL COMMENT '商品图片',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `goods_count` int(10) NOT NULL COMMENT '商品数量',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `list_id` (`list_id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_deliverylist_goods`
--

LOCK TABLES `oscshop_lionfish_comshop_deliverylist_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliverylist_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliverylist_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_deliverylist_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_deliverylist_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_deliverylist_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `list_id` int(10) NOT NULL COMMENT '清单id',
  `order_id` int(11) NOT NULL COMMENT '订单id',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`list_id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购清单订单关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_deliverylist_order`
--

LOCK TABLES `oscshop_lionfish_comshop_deliverylist_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliverylist_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_deliverylist_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_diydata`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_diydata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_diydata` (
  `id` smallint(5) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `value` text CHARACTER SET utf8mb4,
  PRIMARY KEY (`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='自定义首页数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_diydata`
--

LOCK TABLES `oscshop_lionfish_comshop_diydata` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_diydata` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_diydata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_express`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_express`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_express` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(100) NOT NULL COMMENT '快递名称',
  `simplecode` varchar(100) NOT NULL COMMENT '快递简码',
  `customer_name` varchar(50) DEFAULT '' COMMENT '客户账号',
  `customer_pwd` varchar(30) DEFAULT '' COMMENT '客户密码',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=102 DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城快递表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_express`
--

LOCK TABLES `oscshop_lionfish_comshop_express` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_express` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_express` VALUES (1,'安捷快递','AJ','',''),(2,'安能物流','ANE','',''),(3,'安信达快递','AXD','',''),(4,'北青小红帽','BQXHM','',''),(5,'百福东方','BFDF','',''),(6,'百世快运','BTWL','',''),(7,'CCES快递','CCES','',''),(8,'城市100','CITY100','',''),(9,'COE东方快递','COE','',''),(10,'长沙创一','CSCY','',''),(11,'成都善途速运','CDSTKY','',''),(12,'德邦','DBL','',''),(13,'D速物流','DSWL','',''),(14,'大田物流','DTWL','',''),(15,'EMS','EMS','',''),(16,'快捷速递','FAST','',''),(17,'FEDEX联邦(国内件）','FEDEX','',''),(18,'FEDEX联邦(国际件）','FEDEX_GJ','',''),(19,'飞康达','FKD','',''),(20,'广东邮政','GDEMS','',''),(21,'共速达','GSD','',''),(22,'国通快递','GTO','',''),(23,'高铁速递','GTSD','',''),(24,'汇丰物流','HFWL','',''),(25,'天天快递','HHTT','',''),(26,'恒路物流','HLWL','',''),(27,'天地华宇','HOAU','',''),(28,'华强物流','hq568','',''),(29,'百世快递','HTKY','',''),(30,'华夏龙物流','HXLWL','',''),(31,'好来运快递','HYLSD','',''),(32,'京广速递','JGSD','',''),(33,'九曳供应链','JIUYE','',''),(34,'佳吉快运','JJKY','',''),(35,'嘉里物流','JLDT','',''),(36,'捷特快递','JTKD','',''),(37,'急先达','JXD','',''),(38,'晋越快递','JYKD','',''),(39,'加运美','JYM','',''),(40,'佳怡物流','JYWL','',''),(41,'跨越物流','KYWL','',''),(42,'龙邦快递','LB','',''),(43,'联昊通速递','LHT','',''),(44,'民航快递','MHKD','',''),(45,'明亮物流','MLWL','',''),(46,'能达速递','NEDA','',''),(47,'平安达腾飞快递','PADTF','',''),(48,'全晨快递','QCKD','',''),(49,'全峰快递','QFKD','',''),(50,'全日通快递','QRT','',''),(51,'如风达','RFD','',''),(52,'赛澳递','SAD','',''),(53,'圣安物流','SAWL','',''),(54,'盛邦物流','SBWL','',''),(55,'顺丰快递','SF','',''),(56,'盛丰物流','SFWL','',''),(57,'盛辉物流','SHWL','',''),(58,'速通物流','ST','',''),(59,'申通快递','STO','',''),(60,'速腾快递','STWL','',''),(61,'速尔快递','SURE','',''),(62,'唐山申通','TSSTO','',''),(63,'全一快递','UAPEX','',''),(64,'优速快递','UC','',''),(65,'万家物流','WJWL','',''),(66,'万象物流','WXWL','',''),(67,'新邦物流','XBWL','',''),(68,'信丰快递','XFEX','',''),(69,'希优特','XYT','',''),(70,'新杰物流','XJ','',''),(71,'源安达快递','YADEX','',''),(72,'远成物流','YCWL','',''),(73,'韵达快递','YD','',''),(74,'义达国际物流','YDH','',''),(75,'越丰物流','YFEX','',''),(76,'原飞航物流','YFHEX','',''),(77,'亚风快递','YFSD','',''),(78,'运通快递','YTKD','',''),(79,'圆通速递','YTO','',''),(80,'亿翔快递','YXKD','',''),(81,'邮政平邮/小包','YZPY','',''),(82,'增益快递','ZENY','',''),(83,'汇强快递','ZHQKD','',''),(84,'宅急送','ZJS','',''),(85,'众通快递','ZTE','',''),(86,'中铁快运','ZTKY','',''),(87,'中通速递','ZTO','',''),(88,'中铁物流','ZTWL','',''),(89,'中邮物流','ZYWL','',''),(90,'亚马逊物流','AMAZON','',''),(91,'速必达物流','SUBIDA','',''),(92,'瑞丰速递','RFEX','',''),(93,'快客快递','QUICK','',''),(94,'城际快递','CJKD','',''),(95,'CNPEX中邮快递','CNPEX','',''),(96,'鸿桥供应链','HOTSCM','',''),(97,'海派通物流公司','HPTEX','',''),(98,'澳邮专线','AYCA','',''),(99,'泛捷快递','PANEX','',''),(101,'UEQ Express','UEQ','','');
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_express` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_form_info`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_form_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_form_info` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `form_id` int(10) NOT NULL DEFAULT '0' COMMENT '表单id',
  `form_name` varchar(100) NOT NULL COMMENT '表单名称',
  `form_type` enum('order') NOT NULL DEFAULT 'order' COMMENT '表单类型：goods 商品表单，order 下单表单，apply 申请表单',
  `order_id` int(10) DEFAULT '0' COMMENT '关联订单id',
  `order_number` varchar(100) DEFAULT '' COMMENT '订单编号',
  `goods_id` int(10) DEFAULT '0' COMMENT '关联商品id',
  `user_id` int(10) DEFAULT '0' COMMENT '会员id',
  `addtime` int(10) DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='收集表单信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_form_info`
--

LOCK TABLES `oscshop_lionfish_comshop_form_info` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_form_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_form_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_form_item`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_form_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_form_item` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `form_id` int(10) NOT NULL DEFAULT '0' COMMENT '收集表单id',
  `type` enum('image','text','textarea','select','radiao','checked','area','date','date_range','idcard','time','time_range','telephone') NOT NULL DEFAULT 'image' COMMENT '项目类型：image 图片,text 单行文本,textarea 多行文本,\r\n		select 下拉框,radiao 单选框,checked 多选框,area 地区,date 日期,date_range 日期范围,\r\n		idcard 身份证号码,time 时间,time_range 时间范围,telephone 手机号码',
  `random_code` varchar(20) DEFAULT '' COMMENT '表单随机值',
  `item_name` varchar(100) DEFAULT '' COMMENT '表单项名称',
  `item_val` varchar(255) DEFAULT '' COMMENT '表单项值',
  `addtime` int(10) DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='收集表单子项信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_form_item`
--

LOCK TABLES `oscshop_lionfish_comshop_form_item` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_form_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_form_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_forms`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_forms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_forms` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `form_name` varchar(100) NOT NULL COMMENT '表单名称',
  `form_type` enum('order') NOT NULL DEFAULT 'order' COMMENT '表单类型：order 下单表单',
  `form_content` text COMMENT '表单内容',
  `addtime` int(10) DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='万能表单';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_forms`
--

LOCK TABLES `oscshop_lionfish_comshop_forms` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_forms` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_forms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_generalmall_adv`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_generalmall_adv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_generalmall_adv` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `advname` varchar(200) NOT NULL COMMENT '广告名称',
  `thumb` varchar(255) NOT NULL COMMENT '图片地址',
  `link` varchar(255) NOT NULL COMMENT '广告链接地址',
  `appid` varchar(255) DEFAULT NULL COMMENT '外部小程序appid',
  `linktype` tinyint(1) NOT NULL DEFAULT '1' COMMENT '0外链 1小程序内 2外部小程序',
  `type` enum('slider','nav','pintuan','recipe') NOT NULL COMMENT '广告类型，slider幻灯，nav导航小图',
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `enabled` tinyint(1) NOT NULL COMMENT '是否生效，1生效，0不生效',
  `addtime` int(10) NOT NULL COMMENT '添加广告时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城独立商城幻灯片表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_generalmall_adv`
--

LOCK TABLES `oscshop_lionfish_comshop_generalmall_adv` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_generalmall_adv` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_generalmall_adv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_generalmall_navigat`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_generalmall_navigat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_generalmall_navigat` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `navname` varchar(200) DEFAULT NULL COMMENT '名称',
  `thumb` varchar(255) NOT NULL COMMENT '图片地址',
  `link` varchar(255) NOT NULL COMMENT '链接地址',
  `appid` varchar(255) NOT NULL COMMENT '外部小程序appid',
  `type` tinyint(1) NOT NULL COMMENT '0外链 1小程序内链 2外部小程序',
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `enabled` tinyint(1) NOT NULL COMMENT '是否生效，1生效，0不生效',
  `addtime` int(10) NOT NULL COMMENT '添加广告时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城独立商城导航图标';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_generalmall_navigat`
--

LOCK TABLES `oscshop_lionfish_comshop_generalmall_navigat` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_generalmall_navigat` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_generalmall_navigat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_good_commiss`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_good_commiss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_good_commiss` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `nocommission` tinyint(1) NOT NULL COMMENT '0参与分销，1不参与分销',
  `hascommission` tinyint(1) NOT NULL COMMENT '启用独立佣金比例，1启动独立分销',
  `commission_type` tinyint(1) NOT NULL COMMENT '统一分销佣金',
  `commission1_rate` int(10) NOT NULL COMMENT '一级分销比例',
  `commission1_pay` decimal(10,2) NOT NULL COMMENT '一级分销金额',
  `commission2_rate` int(10) NOT NULL COMMENT '二级分销比例',
  `commission2_pay` decimal(10,2) NOT NULL COMMENT '二级分销金额',
  `commission3_rate` int(10) NOT NULL COMMENT '三级分销比例',
  `commission3_pay` decimal(10,2) NOT NULL COMMENT '三级分销金额',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品分销配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_good_commiss`
--

LOCK TABLES `oscshop_lionfish_comshop_good_commiss` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_good_commiss` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_good_commiss` VALUES (4,3,0,0,0,0,0.00,0,0.00,0,0.00),(5,2,0,0,0,0,0.00,0,0.00,0,0.00),(6,1,0,0,0,0,0.00,0,0.00,0,0.00);
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_good_commiss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_good_common`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_good_common`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_good_common` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `quality` varchar(50) NOT NULL COMMENT '正品保证',
  `seven` varchar(50) NOT NULL COMMENT '7天无理由退换',
  `repair` varchar(50) NOT NULL COMMENT '保修',
  `labelname` text NOT NULL COMMENT '自定义标签名称',
  `per_number` int(10) DEFAULT '0' COMMENT '商品限购数量，0 不限制。',
  `supply_id` int(10) DEFAULT '0' COMMENT '供货商id',
  `pick_just` tinyint(1) DEFAULT '0' COMMENT '仅自提',
  `pick_up_type` tinyint(1) DEFAULT NULL COMMENT '1 当日达，2次日达，3隔日达，4自定义',
  `pick_up_modify` varchar(255) DEFAULT NULL COMMENT '自定义自提日期信息',
  `one_limit_count` int(10) DEFAULT '0' COMMENT '单次最多购买次数，0不限制',
  `oneday_limit_count` int(10) DEFAULT '0' COMMENT '每天限购',
  `total_limit_count` int(10) DEFAULT '0' COMMENT '总的最多购买次数，0不限制',
  `goods_start_count` int(10) DEFAULT '1' COMMENT '商品起售数量默认1',
  `community_head_commission` float(10,2) DEFAULT '0.00' COMMENT '团长佣金比例',
  `is_community_head_commission` tinyint(1) DEFAULT '0' COMMENT '是否开启商品独立团长提成',
  `is_modify_head_commission` tinyint(1) DEFAULT '0' COMMENT '是否开启独立配置团长等级分佣',
  `community_head_commission_modify` text COMMENT '自定义团长等级分佣配置信息',
  `begin_time` int(10) NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `end_time` int(10) NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  `share_title` varchar(255) NOT NULL COMMENT '分享标题',
  `print_sub_title` varchar(200) DEFAULT NULL COMMENT '商品打印简短标题',
  `share_description` varchar(255) NOT NULL COMMENT '分享描述',
  `wepro_qrcode_image` varchar(255) DEFAULT NULL COMMENT '商品小程序分享背景图',
  `content` text NOT NULL COMMENT '商品内容',
  `big_img` varchar(255) DEFAULT NULL COMMENT '首页列表大图',
  `video` varchar(255) DEFAULT NULL COMMENT '商品视频',
  `goods_share_image` varchar(255) DEFAULT NULL COMMENT '商品分享图',
  `is_take_fullreduction` tinyint(1) DEFAULT '1' COMMENT '是否参加满减',
  `is_new_buy` tinyint(1) DEFAULT '0' COMMENT '是否新人购买，0否，1 是',
  `is_limit_levelunbuy` tinyint(1) DEFAULT '0' COMMENT '默认等级不能买',
  `is_limit_vipmember_buy` tinyint(1) DEFAULT '0' COMMENT '非VIP 不能购买',
  `is_spike_buy` tinyint(1) DEFAULT '0' COMMENT '是否限时秒杀，0不是，1是',
  `is_mb_level_buy` tinyint(1) DEFAULT '1' COMMENT '是否支持会员折扣购买',
  `is_modify_sendscore` tinyint(1) DEFAULT '0' COMMENT '是否自定义赠送积分',
  `send_socre` int(10) DEFAULT '0' COMMENT '买一个商品赠送积分多少',
  `is_only_express` tinyint(1) DEFAULT '0' COMMENT '是否仅快递',
  `is_only_hexiao` tinyint(1) DEFAULT '0' COMMENT '是否仅核销，0否，1是',
  `is_only_distribution` tinyint(1) DEFAULT '0' COMMENT '是否同城配送，0否，1是',
  `packing_free` float(10,2) DEFAULT '0.00' COMMENT '包装费',
  `relative_goods_list` text COMMENT '关联的商品id',
  `is_show_arrive` tinyint(1) NOT NULL DEFAULT '1' COMMENT '商品预达简介',
  `diy_arrive_switch` tinyint(1) NOT NULL DEFAULT '0' COMMENT '预达简介开关',
  `diy_arrive_details` varchar(200) DEFAULT NULL COMMENT '预达简介内容',
  `has_mb_level_buy` tinyint(1) NOT NULL DEFAULT '0' COMMENT '会员等级折扣独立规则状态：0、未启用，1、启用',
  `mb_level_buy_list` text COMMENT '独立规则会员等级折扣内容',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`),
  KEY `supply_id` (`supply_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品详情表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_good_common`
--

LOCK TABLES `oscshop_lionfish_comshop_good_common` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_good_common` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_good_common` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_good_pin`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_good_pin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_good_pin` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `pinprice` decimal(10,2) NOT NULL COMMENT '拼团价格',
  `pin_count` int(10) NOT NULL COMMENT '拼团人数',
  `pin_hour` decimal(10,2) NOT NULL COMMENT '拼团小时，可以小数点',
  `begin_time` int(10) NOT NULL COMMENT '拼团开始时间',
  `end_time` int(10) NOT NULL COMMENT '拼团结束时间',
  `is_commiss_tuan` tinyint(1) DEFAULT '0' COMMENT '是否佣金团，0否，1是',
  `is_zero_open` tinyint(1) DEFAULT '0' COMMENT '是否0元开团：0否，1是',
  `is_newman` tinyint(1) DEFAULT '0' COMMENT '是否仅新人参加：0否，1是',
  `commiss_type` tinyint(1) DEFAULT '0' COMMENT '0百分比，1固定金额',
  `commiss_money` float(10,2) DEFAULT '0.00' COMMENT '具体佣金比例或佣金',
  `is_pintuan_rebate` tinyint(1) NOT NULL DEFAULT '0' COMMENT '拼团返利是否开启：1、开启，0、关闭',
  `random_delivery_count` int(10) NOT NULL DEFAULT '0' COMMENT '随机发货人数',
  `rebate_reward` tinyint(1) NOT NULL DEFAULT '1' COMMENT '返利奖励：1、送积分，2、送余额',
  `reward_point` int(10) NOT NULL DEFAULT '0' COMMENT '赠送的积分数',
  `reward_balance` int(10) NOT NULL DEFAULT '0' COMMENT '赠送的余额',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城拼团商品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_good_pin`
--

LOCK TABLES `oscshop_lionfish_comshop_good_pin` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_good_pin` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_good_pin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goodsname` varchar(255) NOT NULL COMMENT '商品名称',
  `subtitle` varchar(255) NOT NULL COMMENT '商品简介',
  `grounding` tinyint(1) NOT NULL COMMENT '商品状态，1上架，0下架， 2 仓库中， 3 回收站',
  `price` decimal(10,2) NOT NULL COMMENT '商品价格',
  `costprice` float(10,2) DEFAULT '0.00' COMMENT '成本价',
  `card_price` float(10,2) DEFAULT '0.00' COMMENT '会员卡商品购买价格',
  `is_take_vipcard` tinyint(1) DEFAULT '0' COMMENT '是否参加会员卡，1参加，0不参加',
  `productprice` decimal(10,2) NOT NULL COMMENT '商品原价',
  `sales` int(10) NOT NULL COMMENT '已出售数',
  `seller_count` int(10) DEFAULT '0' COMMENT '实际销量',
  `type` enum('normal','pin','lottery','oldman','newman','commiss','ladder','flash','spike','integral','presale','virtualcard') DEFAULT 'normal' COMMENT '商品类型,presale预售,virtualcard礼品卡',
  `showsales` tinyint(1) NOT NULL COMMENT '显示销量',
  `dispatchtype` tinyint(1) NOT NULL COMMENT '运费类型：0运费模板，1统一运费',
  `dispatchid` int(10) NOT NULL COMMENT '运费模板id',
  `dispatchprice` decimal(10,2) NOT NULL COMMENT '运费价格',
  `codes` varchar(100) NOT NULL COMMENT '商品编码',
  `weight` int(10) NOT NULL COMMENT '商品重量，单位g',
  `total` int(10) NOT NULL COMMENT '商品库存',
  `day_salescount` int(10) DEFAULT '0' COMMENT '日销量',
  `hasoption` tinyint(1) NOT NULL COMMENT '启用规格，0否，1是',
  `is_index_show` tinyint(1) DEFAULT '0' COMMENT '是否首页推荐，0否，1是',
  `is_seckill` tinyint(1) DEFAULT '0' COMMENT '是否秒杀商品，1是，0否',
  `index_sort` int(10) DEFAULT '0' COMMENT '商品排序',
  `is_all_sale` tinyint(1) DEFAULT '0' COMMENT '是否全部团长可销售',
  `credit` int(10) NOT NULL COMMENT '积分赠送，多少积分',
  `buyagain` int(10) NOT NULL COMMENT '复购折扣',
  `buyagain_condition` tinyint(1) NOT NULL COMMENT '0.订单付款后， 1订单完成后',
  `buyagain_sale` tinyint(1) NOT NULL COMMENT '重复购买时可以使用优惠，1是，0否',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `istop` tinyint(1) DEFAULT '0' COMMENT '置顶 0否 1是',
  `settoptime` int(10) DEFAULT '0' COMMENT '置顶时间',
  `copy_times` int(5) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城普通商品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods`
--

LOCK TABLES `oscshop_lionfish_comshop_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_category`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pid` int(11) NOT NULL COMMENT '父类id',
  `is_hot` tinyint(1) NOT NULL COMMENT '推荐首页显示，0否，1是',
  `name` varchar(255) NOT NULL COMMENT '分类名称',
  `logo` varchar(255) DEFAULT NULL,
  `banner` varchar(255) DEFAULT NULL COMMENT '顶部主题图',
  `sort_order` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `cate_type` enum('normal','pintuan','recipe') DEFAULT 'normal' COMMENT '普通商品分类：normal,拼团商品。pintuan',
  `is_show` tinyint(1) NOT NULL DEFAULT '1' COMMENT '分类是否显示',
  `is_show_topic` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否显示3*3布局',
  `is_type_show` tinyint(1) DEFAULT '0' COMMENT '分类显示',
  `is_express_show` tinyint(1) DEFAULT '0' COMMENT '仅快递商品页显示',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品分类表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_category`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_category` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_images`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_images`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_images` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `image` varchar(255) NOT NULL COMMENT '图片',
  `thumb` varchar(255) DEFAULT NULL COMMENT '缩略图',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品图片表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_images`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_images` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_images` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_images` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_option`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_option` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `title` varchar(100) NOT NULL COMMENT '规格名称',
  `displayorder` int(10) NOT NULL COMMENT '排序',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品规格关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_option`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_option` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_option_item`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_option_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_option_item` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `goods_option_id` int(11) NOT NULL COMMENT '商品规格表',
  `title` varchar(200) NOT NULL COMMENT '规格值标题',
  `thumb` varchar(255) NOT NULL COMMENT '规格值图片',
  `displayorder` int(10) NOT NULL COMMENT '排序',
  PRIMARY KEY (`id`),
  KEY `goods_option_id` (`goods_option_id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品规格选项表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_option_item`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_option_item` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_option_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_option_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_option_item_value`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_option_item_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_option_item_value` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `option_item_ids` varchar(100) NOT NULL COMMENT '规格值关联id',
  `productprice` decimal(10,2) NOT NULL COMMENT '商品原价',
  `marketprice` decimal(10,2) NOT NULL COMMENT '商品价格',
  `pinprice` decimal(10,2) DEFAULT '0.00' COMMENT '拼团价格',
  `card_price` float(10,2) DEFAULT '0.00' COMMENT '会员卡购买价格',
  `stock` int(10) NOT NULL COMMENT '库存',
  `costprice` decimal(10,2) NOT NULL COMMENT '商品成本价',
  `goodssn` varchar(100) NOT NULL COMMENT '商品编码',
  `weight` int(10) NOT NULL COMMENT '商品重量',
  `title` varchar(200) NOT NULL COMMENT '商品规格关联标题',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品规格值关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_option_item_value`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_option_item_value` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_option_item_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_option_item_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_presale`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_presale`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_presale` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `presale_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '预售方式，0 定金，1全开',
  `presale_ding_money` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '定金金额',
  `presale_deduction_money` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '定金抵扣金额',
  `presale_ding_time_start` int(10) NOT NULL DEFAULT '0' COMMENT '定金支付开始时间',
  `presale_ding_time_end` int(10) NOT NULL DEFAULT '0' COMMENT '定金支付结束时间',
  `presale_limit_balancepaytime` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0不限制尾款支付时间， 1限制尾款支付时间',
  `presale_balance_paytime` int(10) NOT NULL DEFAULT '0' COMMENT ' 尾款支付时间 几天内',
  `presale_sendorder_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '预计发货时间，0 固定时间，1购买后几日发货',
  `presale_sendorder_datetime` int(10) NOT NULL DEFAULT '0' COMMENT 'presale_sendorder_datetime',
  `presale_sendorder_afterday` int(10) NOT NULL DEFAULT '0' COMMENT 'presale_sendorder_afterday',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品预售属性表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_presale`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_presale` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_presale` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_presale` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_relative_salesroom`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_relative_salesroom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_relative_salesroom` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `salesroom_id` int(10) NOT NULL COMMENT '门店id',
  `goods_id` int(10) DEFAULT '0' COMMENT '商品id',
  `is_hx_member` tinyint(1) DEFAULT '0' COMMENT '是否指定核销员：0、不指定，全部核销员，1、指定',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `salesroom_id` (`salesroom_id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品门店关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_relative_salesroom`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_relative_salesroom` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_relative_salesroom` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_relative_salesroom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_relative_smember`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_relative_smember`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_relative_smember` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `salesroom_id` int(10) NOT NULL COMMENT '门店id',
  `gr_id` int(10) DEFAULT '0' COMMENT '商品门店关联表id',
  `smember_id` int(10) DEFAULT '0' COMMENT '核销员id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `salesroom_id` (`salesroom_id`),
  KEY `gr_id` (`gr_id`),
  KEY `smember_id` (`smember_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品门店核销员关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_relative_smember`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_relative_smember` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_relative_smember` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_relative_smember` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_salesroom_limit`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_salesroom_limit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_salesroom_limit` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `salesroom_id` int(10) NOT NULL COMMENT '门店id',
  `smember_id` int(10) NOT NULL COMMENT '门店下核销员id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `goods_id` (`goods_id`),
  KEY `salesroom_id` (`salesroom_id`),
  KEY `smember_id` (`smember_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品核销限制表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_salesroom_limit`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_salesroom_limit` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_salesroom_limit` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_salesroom_limit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_salesroombase`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_salesroombase`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_salesroombase` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `is_only_hexiao` tinyint(1) DEFAULT '0' COMMENT '商品是否核销：0、否，1、是',
  `hexiao_type` tinyint(1) DEFAULT '0' COMMENT '核销方式：0、订单核销，1、自定义核销次数',
  `hx_one_goods_time` int(10) DEFAULT '0' COMMENT '单个商品核销次数，0默认不限次数',
  `hx_expire_type` tinyint(1) DEFAULT '0' COMMENT '核销有效期：0、购买后有效期，1、指定过期时间',
  `hx_expire_day` int(10) DEFAULT '0' COMMENT '有效天数，不填默认90天',
  `hx_expire_begin_time` int(10) DEFAULT '0' COMMENT '过期开始日期',
  `hx_expire_end_time` int(10) DEFAULT '0' COMMENT '过期结束日期',
  `hx_assign_salesroom` tinyint(1) DEFAULT '0' COMMENT '指定门店：0、所有门店，1、指定门店',
  `hx_auto_off_time` decimal(10,2) DEFAULT '0.00' COMMENT '提前下架时间（单位小时）',
  `hx_auto_off` tinyint(1) DEFAULT '0' COMMENT '下架时间设置：1、设置，0、未设置',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品核销基础表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_salesroombase`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_salesroombase` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_salesroombase` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_salesroombase` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_share_image`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_share_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_share_image` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `image_path` varchar(255) NOT NULL COMMENT '图片路径',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`goods_id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8 COMMENT='会员商品分享图';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_share_image`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_share_image` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_share_image` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_goods_share_image` VALUES (1,508,3,'Uploads/image/2018-12-23/last_qrcode8d78b5bbb0e82009a3522ef6fd1f9d60',1545568438),(2,508,3,'https://aazhishifan.com/Uploads/image/2018-12-23/last_qrcode1adadbaf6fa725fc5f15ada3bff0fef8',1545568585),(3,508,3,'https://aazhishifan.com/Uploads/image/2018-12-23/last_qrcode12e2b4ea13ec85626d0577ab4e6e3588',1545569033),(4,508,3,'https://aazhishifan.com/Uploads/image/2018-12-23/last_qrcode3232c1ea331afa752a7b67f04624a396',1545569963),(5,508,3,'https://aazhishifan.com/Uploads/image/2018-12-23/last_qrcodec60fda097259e0dfe2d4946a8569e491.jpg',1545570453),(6,508,3,'https://aazhishifan.com/Uploads/image/2018-12-23/last_qrcode90109f5e42c374a9d799ac13786d5b8a.jpg',1545570471),(7,2,2,'https://aazhishifan.com/Uploads/image/2018-12-24/last_qrcodeb1139a45b75ba5eb37eb092503f17a17.jpg',1545581003),(8,1,2,'https://aazhishifan.com/Uploads/image/2018-12-24/last_qrcode994896bd12acb4976581ee0a8dc1fc69.jpg',1545621619),(9,5,2,'https://aazhishifan.com/Uploads/image/2018-12-24/last_qrcodebae422d56656e45fb03a53f080c553c0.jpg',1545623497),(10,18,2,'https://aazhishifan.com/Uploads/image/2018-12-24/last_qrcode461676bae532333831448d8aab51def3.jpg',1545624529),(11,26,3,'https://aazhishifan.com/Uploads/image/2018-12-24/last_qrcodec237577a13a5540bca60064e6d2d3c90.jpg',1545626248),(12,34,3,'https://aazhishifan.com/Uploads/image/2018-12-24/last_qrcode62d31fa21df22e9cd80e8735c3eef37c.jpg',1545649369);
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_share_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_tags`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `tagname` varchar(255) NOT NULL COMMENT '标签组名称',
  `type` tinyint(1) DEFAULT '0' COMMENT '类型：0文字 1图片',
  `tag_type` enum('normal','pintuan') DEFAULT 'normal' COMMENT '商品标签类型',
  `tagcontent` text NOT NULL COMMENT '标签名',
  `state` tinyint(1) NOT NULL COMMENT '状态',
  `sort_order` int(10) NOT NULL COMMENT '排序',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品标签表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_tags`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_tags` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_tags` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_tags` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_to_category`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_to_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_to_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `cate_id` int(11) NOT NULL COMMENT '分类表',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品分类关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_to_category`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_to_category` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_to_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_to_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_tradecomponts`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_tradecomponts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_tradecomponts` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `state` tinyint(1) NOT NULL COMMENT '提交给腾讯审核状态，0 审核中,1 审核通过,2 拒绝， 3 取消提交审核',
  `qualification_imagelist` text COMMENT '审核所需要的图片',
  `third_cate_id` int(10) NOT NULL COMMENT '腾讯第三级分类类目',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `tx_product_id` varchar(50) DEFAULT NULL COMMENT '腾讯自定义的产品id',
  `reject_reason` text COMMENT '审核结果，腾讯返回的',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品交易组件';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_tradecomponts`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_tradecomponts` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_tradecomponts` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_tradecomponts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_goods_virturalcard`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_goods_virturalcard`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_goods_virturalcard` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(10) NOT NULL,
  `code_id` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`,`code_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品关联礼品兑换码表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_goods_virturalcard`
--

LOCK TABLES `oscshop_lionfish_comshop_goods_virturalcard` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_virturalcard` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_goods_virturalcard` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_imdada_area_code`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_imdada_area_code`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_imdada_area_code` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `city_name` varchar(100) NOT NULL COMMENT '城市名称',
  `city_code` varchar(10) NOT NULL COMMENT '城市编码',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=301 DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城达达配送城市编号表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_imdada_area_code`
--

LOCK TABLES `oscshop_lionfish_comshop_imdada_area_code` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_imdada_area_code` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_imdada_area_code` VALUES (1,'上海','021'),(2,'北京','010'),(3,'合肥','0551'),(4,'南京','025'),(5,'苏州','0512'),(6,'武汉','027'),(7,'无锡','0510'),(8,'常州','0519'),(9,'杭州','0571'),(10,'广州','020'),(11,'深圳','0755'),(12,'重庆','023'),(13,'长沙','0731'),(14,'成都','028'),(15,'天津','022'),(16,'厦门','0592'),(17,'福州','0591'),(18,'大连','0411'),(19,'青岛','0532'),(20,'哈尔滨','0451'),(21,'济南','0531'),(22,'郑州','0371'),(23,'西安','029'),(24,'宁波','0574'),(25,'温州','0577'),(26,'芜湖','0553'),(27,'南通','0513'),(28,'南昌','0791'),(29,'石家庄','0311'),(30,'潍坊','0536'),(31,'嘉兴','0573'),(32,'金华','0579'),(33,'绍兴','0575'),(34,'烟台','0535'),(35,'扬州','0514'),(36,'昆山','0512'),(37,'佛山','0757'),(38,'东莞','0769'),(39,'马鞍山','0555'),(40,'洛阳','0379'),(41,'大理','0872'),(42,'安庆','0556'),(43,'亳州','0558'),(44,'池州','0566'),(45,'滁州','0550'),(46,'阜阳','1558'),(47,'湖州','0572'),(48,'淮安','0517'),(49,'淮北','0561'),(50,'淮南','0554'),(51,'黄山','0559'),(52,'连云港','0518'),(53,'六安','0564'),(54,'衢州','0570'),(55,'台州','0576'),(56,'泰州','0523'),(57,'铜陵','0562'),(58,'宿迁','0527'),(59,'宿州','0557'),(60,'徐州','0516'),(61,'盐城','0515'),(62,'镇江','0511'),(63,'巴中','0827'),(64,'达州','0818'),(65,'德阳','0838'),(66,'广安','0826'),(67,'广元','0839'),(68,'贵阳','0851'),(69,'昆明','0871'),(70,'乐山','0833'),(71,'丽江','0888'),(72,'临沧','0883'),(73,'六盘水','0858'),(74,'泸州','0830'),(75,'眉山','1833'),(76,'绵阳','0816'),(77,'南充','0817'),(78,'内江','0832'),(79,'攀枝花','0812'),(80,'普洱','0879'),(81,'曲靖','0874'),(82,'遂宁','0825'),(83,'宜宾','0831'),(84,'玉溪','0877'),(85,'昭通','0870'),(86,'资阳','0832'),(87,'自贡','0813'),(88,'遵义','0852'),(89,'毕节','0857'),(90,'西昌','0834'),(91,'楚雄','0878'),(92,'红河','0873'),(93,'文山','0876'),(94,'广汉','028'),(95,'兴义','0859'),(96,'都匀','0854'),(97,'凯里','0855'),(98,'西双版纳','0691'),(99,'张家口','0313'),(100,'泰安','0538'),(101,'河源','0762'),(102,'兰州','0931'),(103,'潮州','0768'),(104,'承德','0314'),(105,'汕头','0754'),(106,'秦皇岛','0335'),(107,'茂名','0668'),(108,'沧州','0317'),(109,'汕尾','0660'),(110,'营口','0417'),(111,'韶关','0751'),(112,'梧州','0774'),(113,'太原','0351'),(114,'惠州','0752'),(115,'湛江','0759'),(116,'南宁','0771'),(117,'南平','0599'),(118,'百色','0776'),(119,'清远','0763'),(120,'龙岩','0597'),(121,'莆田','0594'),(122,'中山','0760'),(123,'漳州','0596'),(124,'揭阳','0663'),(125,'咸阳','0910'),(126,'鞍山','0412'),(127,'贵港','1755'),(128,'桂林','0773'),(129,'阳江','0662'),(130,'保定','0312'),(131,'宝鸡','0917'),(132,'柳州','0772'),(133,'珠海','0756'),(134,'沈阳','024'),(135,'泉州','0595'),(136,'汉中','0916'),(137,'邯郸','0310'),(138,'唐山','0315'),(139,'肇庆','0758'),(140,'长春','0431'),(141,'三明','0598'),(142,'邢台','0319'),(143,'廊坊','0316'),(144,'来宾','1772'),(145,'宁德','0593'),(146,'江门','0750'),(147,'渭南','0913'),(148,'银川','0951'),(149,'济宁','0537'),(150,'黄冈','0713'),(151,'孝感','0712'),(152,'襄阳','0710'),(153,'宜昌','0717'),(154,'荆州','0716'),(155,'荆门','0724'),(156,'新乡','0373'),(157,'南阳','0377'),(158,'信阳','0376'),(159,'衡阳','0734'),(160,'株洲','0733'),(161,'岳阳','0730'),(162,'赣州','0797'),(163,'宜春','0795'),(164,'凉山','0834'),(165,'黔东南','0855'),(166,'黔南','0854'),(167,'淄博','0533'),(168,'滨州','0543'),(169,'包头','0472'),(170,'临沂','0539'),(171,'晋中','0354'),(172,'运城','0359'),(173,'大同','0352'),(174,'威海','0631'),(175,'赤峰','0476'),(176,'鄂尔多斯','0477'),(177,'丹东','0415'),(178,'延安','0911'),(179,'榆林','0912'),(180,'商洛','0914'),(181,'石嘴山','0952'),(182,'吴忠','0953'),(183,'日照','0633'),(184,'长治','0355'),(185,'阳泉','0353'),(186,'吕梁','0358'),(187,'临汾','0357'),(188,'防城港','0770'),(189,'钦州','0777'),(190,'北海','0779'),(191,'安阳','0372'),(192,'常德','0736'),(193,'郴州','0735'),(194,'抚州','0794'),(195,'鹤壁','0392'),(196,'黄石','0714'),(197,'吉安','0796'),(198,'焦作','0391'),(199,'景德镇','0798'),(200,'九江','0792'),(201,'开封','0378'),(202,'娄底','0738'),(203,'平顶山','0375'),(204,'萍乡','0799'),(205,'三门峡','0398'),(206,'商丘','0370'),(207,'上饶','0793'),(208,'邵阳','0739'),(209,'随州','0722'),(210,'天门','1728'),(211,'仙桃','0728'),(212,'咸宁','0715'),(213,'湘潭','0732'),(214,'新余','0790'),(215,'许昌','0374'),(216,'益阳','0737'),(217,'鹰潭','0701'),(218,'永州','0746'),(219,'张家界','0744'),(220,'常熟','0512'),(221,'太仓','0512'),(222,'临安','0571'),(223,'黔西南布依族苗族自治州','0859'),(224,'辛集','0311'),(225,'江阴','0510'),(226,'胶州','0532'),(227,'彭州','028'),(228,'晋江','0595'),(229,'清镇','0851'),(230,'仁怀','0852'),(231,'普宁','0663'),(232,'安岳县','028'),(233,'夹江县','0833'),(234,'渠县','0818'),(235,'宣汉','0818'),(236,'仁寿县','028'),(237,'阆中','0817'),(238,'分宜县','0790'),(239,'新昌县','0575'),(240,'孝义','0358'),(241,'兰溪','0579'),(242,'武义县','0579'),(243,'盘州','0858'),(244,'洪湖','0716'),(245,'浦江','0579'),(246,'荣县','0813'),(247,'蕲春','0713'),(248,'麻城','0713'),(249,'安陆','0712'),(250,'霞浦','0593'),(251,'福鼎','0593'),(252,'英德','0763'),(253,'广宁','0758'),(254,'红安','0713'),(255,'汉川','0712'),(256,'德清','0572'),(257,'义乌','0579'),(258,'长兴','0572'),(259,'景洪','0691'),(260,'罗平','0874'),(261,'蒙自','0873'),(262,'个旧','0873'),(263,'建水','0873'),(264,'弥勒','0873'),(265,'宣威','0874'),(266,'冷水江','0738'),(267,'新化','0738'),(268,'应城','0712'),(269,'峨眉山','0833'),(270,'林州','0372'),(271,'张北','0313'),(272,'嵊州','0575'),(273,'诸暨','0575'),(274,'定州','0312'),(275,'绥阳县','0852'),(276,'武冈','0739'),(277,'营山县','0817'),(278,'南县','0737'),(279,'江安县','0831'),(280,'犍为县','0833'),(281,'思南县','0856'),(282,'临泉','0558'),(283,'什邡','0838'),(284,'高安','0795'),(285,'吉首','0743'),(286,'永安','0598'),(287,'福安','0593'),(288,'沁阳','0391'),(289,'天长','0550'),(290,'德庆','0758'),(291,'汾阳','0358'),(292,'监利','0716'),(293,'全椒','0550'),(294,'泗洪','0527'),(295,'明光','0550'),(296,'泗阳','0527'),(297,'东至','0566'),(298,'青阳','0566'),(299,'盱眙','0517'),(300,'温岭','0576');
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_imdada_area_code` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_invitegift_record`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_invitegift_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_invitegift_record` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `user_id` int(11) NOT NULL COMMENT '邀请者会员id',
  `inviter_reward_type` tinyint(1) NOT NULL COMMENT '邀请者奖励类型：0、送优惠券和积分，1、送优惠券，2、送积分',
  `inviter_reward_couponid` int(10) NOT NULL COMMENT '邀请者奖励优惠券id',
  `inviter_reward_point` int(10) NOT NULL COMMENT '邀请者奖励积分数',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '邀请者奖励状态：1、已领取，0、未领取',
  `invitee_userid` int(11) DEFAULT NULL COMMENT '被邀请者会员id',
  `invitees_reward_type` tinyint(1) NOT NULL COMMENT '被邀请者奖励类型：0、新人注册（授权登录）和下单分别奖励，1、新人注册（授权登录）即奖励，2、新人注册（授权登录）并且下单奖励',
  `invitees_register_reward_type` tinyint(1) NOT NULL COMMENT '被邀请者新人注册（授权登录）奖励类型：0、送优惠券和积分，1、送优惠券，2、送积分',
  `invitees_register_reward_couponid` int(10) NOT NULL COMMENT '被邀请者新人注册（授权登录）奖励优惠券id',
  `invitees_register_reward_point` int(10) NOT NULL COMMENT '被邀请者新人注册（授权登录）奖励积分数',
  `invitees_order_reward_type` tinyint(1) NOT NULL COMMENT '被邀请者下单完成奖励类型：0、送优惠券和积分，1、送优惠券，2、送积分',
  `invitees_order_reward_couponid` int(10) NOT NULL COMMENT '被邀请者下单完成奖励优惠券id',
  `invitees_order_reward_point` int(10) NOT NULL COMMENT '被邀请者下单完成奖励积分数',
  `invite_activity_reward_type` tinyint(1) NOT NULL COMMENT '被邀请者下单完成奖励时间：0、下单支付完成获得奖励，1、订单售后期结束获得奖励',
  `invitee_status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '被邀请者奖励状态：1、已领取，0、未领取',
  `invitee_register_status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '被邀请者新人注册(授权登录)和下单分别奖励时，新人注册奖励状态：1、已奖励，0、未奖励',
  `is_old` tinyint(1) NOT NULL DEFAULT '0' COMMENT '被邀请者是否是老用户（老用户不参与活动）：1、是，0、否',
  `addtime` int(10) NOT NULL COMMENT '邀请时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼邀新有礼记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_invitegift_record`
--

LOCK TABLES `oscshop_lionfish_comshop_invitegift_record` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_invitegift_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_invitegift_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_jiapinorder`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_jiapinorder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_jiapinorder` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(11) NOT NULL COMMENT '公众号id',
  `pin_id` int(10) NOT NULL COMMENT '拼团id',
  `uname` varchar(255) NOT NULL COMMENT '昵称',
  `avatar` varchar(255) NOT NULL COMMENT '头像',
  `order_sn` varchar(100) NOT NULL COMMENT '订单编号',
  `mobile` varchar(20) NOT NULL COMMENT '手机号',
  `addtime` int(10) DEFAULT NULL COMMENT '加入时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_jiapinorder`
--

LOCK TABLES `oscshop_lionfish_comshop_jiapinorder` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_jiapinorder` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_jiapinorder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_jiauser`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_jiauser`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_jiauser` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `username` varchar(32) DEFAULT NULL,
  `avatar` varchar(255) DEFAULT NULL,
  `mobile` varchar(16) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_jiauser`
--

LOCK TABLES `oscshop_lionfish_comshop_jiauser` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_jiauser` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_jiauser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_kdniao_list`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_kdniao_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_kdniao_list` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `express_name` varchar(100) NOT NULL DEFAULT '' COMMENT '快递公司名称',
  `express_code` varchar(100) NOT NULL DEFAULT '' COMMENT '快递公司编号',
  `customer_name` varchar(50) NOT NULL DEFAULT '' COMMENT '电子面单客户账号',
  `customer_pwd` varchar(30) NOT NULL DEFAULT '' COMMENT '电子面单密码',
  `month_code` varchar(20) NOT NULL DEFAULT '' COMMENT '月结编码',
  `send_site` varchar(30) NOT NULL DEFAULT '' COMMENT '网点名称',
  `send_staff` varchar(30) NOT NULL DEFAULT '' COMMENT '网点编码',
  `template_size` varchar(10) NOT NULL DEFAULT '' COMMENT '电子面单模板规格',
  `is_send_message` int(1) DEFAULT '0' COMMENT '订阅短信：0-不需要；1-需要',
  `is_send_goods` int(1) DEFAULT '0' COMMENT '打印商品：0-不需要；1-需要',
  `sender_company` varchar(30) NOT NULL DEFAULT '' COMMENT '发件人公司',
  `sender_name` varchar(30) NOT NULL DEFAULT '' COMMENT '发件人名称',
  `sender_tel` varchar(20) NOT NULL DEFAULT '' COMMENT '发件人电话',
  `sender_mobile` varchar(20) NOT NULL DEFAULT '' COMMENT '发件人手机',
  `sender_postcode` varchar(10) NOT NULL DEFAULT '' COMMENT '发件人邮编',
  `sender_address` varchar(100) NOT NULL DEFAULT '' COMMENT '发件人详细地址',
  `sender_province_name` varchar(20) NOT NULL DEFAULT '' COMMENT '发件人省',
  `sender_city_name` varchar(20) NOT NULL DEFAULT '' COMMENT '发件人市',
  `sender_area_name` varchar(20) NOT NULL DEFAULT '' COMMENT '发件人区',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城快递鸟电子面单列表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_kdniao_list`
--

LOCK TABLES `oscshop_lionfish_comshop_kdniao_list` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_kdniao_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_kdniao_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_kdniao_template`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_kdniao_template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_kdniao_template` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `express_name` varchar(100) NOT NULL COMMENT '快递公司名称',
  `express_code` varchar(20) NOT NULL COMMENT '快递公司编码',
  `template_name` varchar(100) NOT NULL COMMENT '模板样式',
  `template_spec` varchar(100) NOT NULL COMMENT '尺寸规格',
  `template_size` varchar(20) NOT NULL DEFAULT '0' COMMENT 'templateSize',
  `customer_area` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'customArea字段：0、不支持，1、支持',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=65 DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城快递鸟电子面单模板规格';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_kdniao_template`
--

LOCK TABLES `oscshop_lionfish_comshop_kdniao_template` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_kdniao_template` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_kdniao_template` VALUES (1,'安能快递','ANE','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(2,'安能快运','ANEKY','二联 180','宽 100mm,高 180mm,切点 110/70','0',1),(3,'承诺达','CND','二联 180','宽 100mm,高 180mm,切点 110/70','0',1),(4,'德邦快递','DBL','二联 177','宽 100mm,高 177mm,切点 107/70','0',0),(5,'德邦快递','DBL','二联 177 新','宽 100mm,高 177mm,切点 107/70','18001',0),(6,'德邦快递','DBL','三联 177 新','宽 100mm,高 177mm,切点 107/30/40','18002',0),(7,'德邦快递','DBL','一联 130','宽 76mm,高 130mm','130',1),(8,'德邦快运','DBLKY','三联 180','宽 100mm,高 180mm,切点 110/30/40','0',1),(9,'丹鸟物流','DNWL','一联 150','宽 100mm,高 150mm,切点 90/60','0',1),(10,'EMS','EMS','二联 150','宽 100mm,高 150mm,切点 90/60','0',0),(11,'EMS','EMS','二联 180','宽 100mm,高 180mm,切点 110/70','180',0),(12,'百世快递','HTKY','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(13,'百世快递','HTKY','二联 180 新','宽 100mm,高 180mm,切点 110/70','180',1),(14,'百世快递','HTKY','一联 130','宽 76mm,高 130mm','130',1),(15,'百世快运','HTKYKY','二联 180','宽 100mm,高 180mm,切点 110/70','0',1),(16,'佳吉快运','CNEX','一联 100','宽 90mm,高 100mm','0',0),(17,'京东快递','JD','二联 110','宽 100mm,高 110mm,切点 60/50','0',0),(18,'京东快递','JD','二联 110 新','宽 100mm,高 110mm,切点 60/50','110',0),(19,'京东快运','JDKY','二联 110','宽 100mm,高 110mm,切点 60/50','0',0),(20,'极兔速递','JTSD','一联 130','宽 76mm,高 130mm','130',1),(21,'极兔速递','JTSD','二联 180','宽 100mm,高 180mm,切点 110/70','0',1),(22,'跨越速运','KYSY','二联 137','宽 100mm,高 137mm,切点 101/36','0',1),(23,'跨越速运','KYSY','三联 210','宽 100mm,高 210mm,切点 90/60/60','210',1),(24,'龙邦快运','LB','三联 104','宽 75mm,高 104mm','0',0),(25,'联昊通速递','LHT','二联 150','宽 100mm,高 150mm,切点 90/60','0',0),(26,'品骏快递','PJ','一联 120','宽 80mm,高 120mm','0',0),(27,'全一快递','UAPEX','二联 150','宽 100mm,高 150mm,切点 90/60','0',1),(28,'顺丰速运','SF','二联 150 新','宽 100mm,高 150mm,切点 90/60','15001',1),(29,'顺丰速运','SF','二联 180 新','宽 100mm,高 180mm,切点 110/70','180',1),(30,'顺丰速运','SF','三联 210 新','宽 100mm,高 210mm,切点 90/60/60','21001',1),(31,'申通快递','STO','二联 150','宽 100mm,高 150mm,切点 90/60','150',0),(32,'申通快递','STO','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(33,'申通快递','STO','二联 180 新','宽 100mm,高 180mm,切点 110/70','180',1),(34,'申通快递','STO','三联 180 新','宽 100mm,高 180mm,切点 110/30/40','18003',1),(35,'申通快递','STO','一联 130','宽 76mm,高 130mm','130',1),(36,'速尔快递','SURE','二联 150','宽 100mm,高 150mm,切点 90/60','0',0),(37,'速尔快递','SURE','二联 150 新','宽 100mm,高 150mm,切点 90/60','150',1),(38,'速尔快递','SURE','二联 180 新','宽 100mm,高 180mm,切点 110/70','180',1),(39,'顺心捷达','SX','一联 105','宽 75mm,高 105mm','0',0),(40,'苏宁物流','SNWL','二联 180','宽 100mm,高 180mm,切点 110/70','0',1),(41,'腾林物流','TLWL','一联 70','宽 100mm,高 70mm','0',0),(42,'天地华宇','HOAU','二联 180','宽 100mm,高 180mm,切点 110/70','0',1),(43,'天天快递','HHTT','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(44,'信丰物流','XFEX','二联 150','宽 100mm,高 150mm,切点 90/60','0',0),(45,'韵达速递','YD','二联 203','宽 100mm,高 203mm,切点 152/51','0',0),(46,'韵达速递','YD','二联 180','宽 100mm,高 180mm,切点 110/70','180',1),(47,'韵达速递','YD','一联 130','宽 76mm,高 130mm','130',1),(48,'韵达快运','YDKY','二联 180','宽 100mm,高 180mm,切点 110/70','0',1),(49,'圆通速递','YTO','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(50,'圆通速递','YTO','三联 180','宽 100mm,高 180mm,切点 110/30/40','180',0),(51,'圆通速递','YTO','二联 180 新','宽 100mm,高 180mm,切点 110/70','18001',1),(52,'圆通速递','YTO','一联 130','宽 76mm,高 130mm','130',1),(53,'邮政国内标快','YZBK','二联 150','宽 100mm,高 150mm,切点 90/60','0',0),(54,'邮政快递包裹','YZPY','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(55,'邮政快递包裹','YZPY','二联 180 新','宽 100mm,高 180mm,切点 110/70','180',1),(56,'优速快递','UC','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(57,'远成快运','YCWL','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(58,'宅急送','ZJS','二联 120','宽 100mm,高 116mm,切点 98/18','0',0),(59,'宅急送','ZJS','二联 180','宽 100mm,高 180mm,切点 110/70','180',1),(60,'宅急送','ZJS','二联 120 新','宽 100mm,高 116mm,切点 98/18','120',0),(61,'中通快递','ZTO','二联 180','宽 100mm,高 180mm,切点 110/70','0',0),(62,'中通快递','ZTO','二联 180 新','宽 100mm,高 180mm,切点 110/70','180',1),(63,'中通快递','ZTO','一联 130','宽 76mm,高 130mm','130',1),(64,'中通快运','ZTOKY','二联 180','宽 100mm,高 180mm,切点 110/70','0',0);
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_kdniao_template` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member` (
  `member_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `openid` varchar(255) NOT NULL COMMENT '微信openid',
  `we_openid` varchar(255) NOT NULL COMMENT '小程序openid',
  `unionid` varchar(200) NOT NULL COMMENT '联合id',
  `share_id` int(10) DEFAULT NULL COMMENT '分享人id',
  `agentid` int(10) NOT NULL DEFAULT '0' COMMENT '推荐人id',
  `comsiss_flag` tinyint(1) DEFAULT '0' COMMENT '是否分销商，0 非，1是',
  `comsiss_state` tinyint(1) DEFAULT '0' COMMENT '分销商状态',
  `commission_level_id` int(10) DEFAULT '0' COMMENT '分销等级id',
  `comsiss_time` int(10) DEFAULT NULL COMMENT '成为分销商时间',
  `groupid` int(10) DEFAULT '0' COMMENT '会员分组id',
  `level_id` int(10) DEFAULT '0' COMMENT '会员等级',
  `isblack` tinyint(1) DEFAULT '0' COMMENT '是否黑名单',
  `account_money` decimal(10,2) DEFAULT NULL,
  `score` decimal(10,2) DEFAULT NULL,
  `reg_type` enum('weixin','weprogram') NOT NULL COMMENT '会员注册类型',
  `username` varchar(200) NOT NULL COMMENT '会员名称',
  `realname` varchar(100) DEFAULT NULL COMMENT '会员真实姓名',
  `telephone` varchar(30) DEFAULT NULL COMMENT '电话',
  `avatar` varchar(255) NOT NULL COMMENT '会员头像',
  `wepro_qrcode` varchar(255) DEFAULT NULL COMMENT '分销商小程序二维码图',
  `hexiao_qrcod` varchar(255) DEFAULT NULL COMMENT '提货核销二维码',
  `commiss_qrcode` varchar(255) DEFAULT NULL COMMENT '分销商二维码',
  `content` varchar(255) DEFAULT NULL COMMENT '备注',
  `last_login_time` int(10) DEFAULT NULL COMMENT '最后一次登录时间',
  `create_time` int(10) NOT NULL COMMENT '注册时间',
  `last_login_ip` varchar(50) DEFAULT NULL COMMENT '最后一次登录ip',
  `pickup_id` int(10) DEFAULT '0' COMMENT '自提关联id',
  `full_user_name` varchar(200) NOT NULL COMMENT '带logo头像',
  `is_writecommiss_form` tinyint(1) DEFAULT '0' COMMENT '是否收集过表单',
  `is_share_tj` tinyint(1) DEFAULT '0' COMMENT '是否分销条件中，分享成为',
  `commiss_formcontent` text COMMENT '表单收集的内容',
  `card_id` int(10) DEFAULT '0' COMMENT '会员卡id',
  `card_begin_time` int(10) DEFAULT '0' COMMENT '会员卡开始时间',
  `card_end_time` int(10) DEFAULT '0' COMMENT '会员卡结束时间',
  `is_comsiss_admin` tinyint(1) DEFAULT '0' COMMENT '0 非后台设置，1 后台设置',
  `is_comsiss_audit` tinyint(1) DEFAULT '0' COMMENT '0 未审核，1 已审核',
  `is_apply_state` tinyint(1) DEFAULT '1' COMMENT '是否审核过，0否，1是，2拒绝',
  `is_write_form` tinyint(1) DEFAULT '0' COMMENT '是否写过表单，0否，1是',
  `form_info` text COMMENT '表单内容',
  `share_status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '邀请状态：1、可以邀请，0、禁止邀请',
  PRIMARY KEY (`member_id`),
  KEY `openid` (`openid`(191)),
  KEY `we_openid` (`we_openid`(191)),
  KEY `agentid` (`agentid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城会员表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member`
--

LOCK TABLES `oscshop_lionfish_comshop_member` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_card`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_card` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `cardname` varchar(255) NOT NULL COMMENT '会员卡名称',
  `orignprice` float(10,2) NOT NULL COMMENT '原价',
  `price` float(10,2) NOT NULL COMMENT '实际购买价格',
  `expire_day` float(10,2) NOT NULL COMMENT '有效期天数，支持小数点',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='付费会员卡表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_card`
--

LOCK TABLES `oscshop_lionfish_comshop_member_card` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_card` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_card_equity`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_card_equity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_card_equity` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `equity_name` varchar(255) NOT NULL COMMENT '权益名称',
  `image` varchar(255) NOT NULL COMMENT '权益图标',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='会员卡权益';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_card_equity`
--

LOCK TABLES `oscshop_lionfish_comshop_member_card_equity` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_card_equity` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_card_equity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_card_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_card_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_card_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_sn` varchar(50) NOT NULL COMMENT '订单编号',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `pay_type` enum('weixin','yuer','admin') NOT NULL COMMENT '支付类型，微信，余额，后台购买',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '支付状态：0未支付，1已支付',
  `car_id` int(10) NOT NULL COMMENT '购买的 会员卡id',
  `trans_id` varchar(255) DEFAULT NULL COMMENT '微信交易单号',
  `formid` varchar(255) DEFAULT NULL COMMENT '支付formid',
  `expire_day` float(10,2) NOT NULL COMMENT '有效期天数，支持小数点',
  `price` float(10,2) NOT NULL COMMENT '购买价格',
  `order_type` tinyint(1) DEFAULT '1' COMMENT '购买类型：1首次购买，2有效期内续期，3过期后续费',
  `begin_time` int(10) DEFAULT '0' COMMENT '有效期开始时间',
  `end_time` int(10) NOT NULL DEFAULT '0' COMMENT '有效期截止时间点',
  `pay_time` int(10) DEFAULT '0' COMMENT '支付的时间点',
  `addtime` int(10) NOT NULL COMMENT '下单的时间',
  PRIMARY KEY (`id`),
  KEY `order_sn` (`order_sn`),
  KEY `uniacid` (`uniacid`),
  KEY `member_id` (`member_id`),
  KEY `car_id` (`car_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='付费会员卡 购买订单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_card_order`
--

LOCK TABLES `oscshop_lionfish_comshop_member_card_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_card_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_card_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_charge_flow`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_charge_flow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_charge_flow` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `formid` varchar(255) DEFAULT NULL COMMENT '充值时候的prepayid',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `trans_id` varchar(100) DEFAULT NULL COMMENT '交易号',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '订单商品id',
  `money` decimal(10,2) NOT NULL COMMENT '充值金额',
  `give_money` float(10,2) DEFAULT '0.00' COMMENT '赠送金额',
  `operate_end_yuer` decimal(10,2) DEFAULT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0，未支付，1已支付,3余额付款，4退款到余额，5后台充值,6 裂变红包,7 会员升级，8后台扣款，9 分销提现到余额, 10 团长提现到余额,11 拼团佣金提现到余额, 12 配送佣金提现到余额, 20 礼品卡兑换, 21 拼团返利',
  `charge_time` int(10) NOT NULL COMMENT '充值时间',
  `remark` varchar(255) DEFAULT NULL COMMENT '充值描述',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城会员充值记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_charge_flow`
--

LOCK TABLES `oscshop_lionfish_comshop_member_charge_flow` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_charge_flow` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_charge_flow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_commiss`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_commiss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_commiss` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `money` float(10,2) DEFAULT '0.00' COMMENT '可提现金额',
  `dongmoney` float(10,2) DEFAULT '0.00' COMMENT '提现中金额',
  `type` tinyint(1) DEFAULT '0' COMMENT '1余额，2 weixin，3alipay，4bank ',
  `getmoney` float(10,2) DEFAULT '0.00' COMMENT '已提现金额',
  `bankname` varchar(200) DEFAULT NULL COMMENT '银行名称',
  `bankaccount` varchar(200) DEFAULT NULL COMMENT '卡号',
  `bankusername` varchar(200) DEFAULT NULL COMMENT '持卡人姓名',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_commiss`
--

LOCK TABLES `oscshop_lionfish_comshop_member_commiss` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_commiss` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_commiss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_commiss_apply`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_commiss_apply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_commiss_apply` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `state` tinyint(1) NOT NULL COMMENT '审核状态，0申请中，1已通过，2拒绝',
  `addtime` int(10) NOT NULL COMMENT '申请时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_commiss_apply`
--

LOCK TABLES `oscshop_lionfish_comshop_member_commiss_apply` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_commiss_apply` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_commiss_apply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_commiss_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_commiss_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_commiss_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `child_member_id` int(10) NOT NULL COMMENT '下级会员ID',
  `order_id` int(10) NOT NULL COMMENT '订单ID',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '商品订单id',
  `level` int(10) DEFAULT '1' COMMENT '第几层分佣',
  `type` tinyint(1) DEFAULT '1' COMMENT '1按照比例。2按照固定金额',
  `bili` float(10,2) DEFAULT '0.00' COMMENT '比例，如果是固定金额，那么这里就是固定金额',
  `commission_level_id` int(10) DEFAULT '0' COMMENT '分销等级id',
  `store_id` int(10) NOT NULL COMMENT '店铺ID',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否结算：0，待计算。1，已结算。2，订单取消',
  `money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '分佣金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_commiss_order`
--

LOCK TABLES `oscshop_lionfish_comshop_member_commiss_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_commiss_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_commiss_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_formid`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_formid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_formid` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `state` tinyint(1) NOT NULL COMMENT '状态，0未使用，已使用',
  `formid` varchar(255) NOT NULL COMMENT '用来群发使用的',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8 COMMENT='会员的群发formid表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_formid`
--

LOCK TABLES `oscshop_lionfish_comshop_member_formid` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_formid` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_member_formid` VALUES (1,0,0,'42926bd3c3cc4caa867d931ebb2b6e47',1582508720),(2,0,0,'d5e617175ee94127890e69a266c6015e',1582509080),(3,0,0,'f02817d1d6b94d26b162c888c3dd2524',1582509087),(4,0,0,'53f2a6777b354398976d94298ee25966',1582509301),(5,0,0,'463cfb80eb9547e7a7288b15d995f382',1582529046),(6,0,0,'ced4d7a25b6e4b69b0b93223354df1b1',1582597299),(7,0,0,'0f098cde324b4aebbf57aeac5f45bc16',1582597324),(8,5,0,'ece98a012b5a4f578688c2f6718acac4',1582619109),(9,5,0,'7dd69312e87444e6af799b2702b1780e',1582619121),(10,5,0,'e1d9f57df4d640be8df0c95cf401ec6c',1582619127),(11,5,0,'7ed40e6d4dcb4032b82668f6c4a0886b',1582619130),(12,5,0,'7f379c18e8014df79161213360000d59',1582619137),(13,5,0,'187949c693184c48ab6020b18d7a466b',1582619263),(14,5,0,'de269197b8b94ccc82043eef496dae38',1582619270),(15,5,0,'707fe3b79bb748e3b43566c0d0a0397d',1582685393);
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_formid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_group`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `groupname` varchar(255) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_group`
--

LOCK TABLES `oscshop_lionfish_comshop_member_group` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_integral_flow`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_integral_flow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_integral_flow` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `in_out` enum('in','out') NOT NULL COMMENT '增加积分，还是减少积分',
  `type` enum('goodsbuy','refundorder','system_add','system_del','orderbuy','signin_send','integral_exchange','goodscomment','invitegift','invitegift_new','pintuan_rebate') DEFAULT NULL COMMENT '积分类型：goodsbuy 购买商品赠送积分，refundorder 退款增加积分，system_add 后台增加积分，system_del 后台减少积分，orderbuy 下单扣除积分，signin_send 签到送积分，integral_exchange 积分兑换商品，goodscomment 好评赠送积分，invitegift 邀新有礼赠送积分，invitegift_new 被邀请者赠送积分, pintuan_rebate 拼团返利',
  `order_id` int(10) DEFAULT NULL COMMENT '订单id',
  `order_goods_id` int(10) DEFAULT NULL COMMENT '订单商品id',
  `score` float(10,2) DEFAULT '0.00' COMMENT '积分数量',
  `after_operate_score` float(10,2) DEFAULT '0.00' COMMENT '操作后的积分',
  `state` tinyint(1) DEFAULT '0' COMMENT '0 还未赠送，1处理成功，',
  `remark` varchar(255) DEFAULT NULL COMMENT '说明',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='积分流水记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_integral_flow`
--

LOCK TABLES `oscshop_lionfish_comshop_member_integral_flow` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_integral_flow` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_integral_flow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_invitegift`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_invitegift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_invitegift` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(11) NOT NULL COMMENT '会员id',
  `invite_addtime` int(10) NOT NULL DEFAULT '0' COMMENT '邀请码生成时间',
  `invite_image_path` varchar(255) DEFAULT NULL COMMENT '邀请小程序码',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼会员邀新有礼信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_invitegift`
--

LOCK TABLES `oscshop_lionfish_comshop_member_invitegift` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_invitegift` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_invitegift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_level`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_level` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `level` int(11) NOT NULL COMMENT '等级',
  `levelname` varchar(100) NOT NULL COMMENT '等级名称',
  `level_money` decimal(10,2) DEFAULT '0.00' COMMENT '会员升级金额',
  `is_auto_grade` tinyint(1) DEFAULT '0' COMMENT '是否自动升级，0 否，1是',
  `discount` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '折扣',
  `logo` varchar(255) DEFAULT NULL COMMENT '会员等级logo',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='会员等级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_level`
--

LOCK TABLES `oscshop_lionfish_comshop_member_level` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_shopinfo`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_shopinfo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_shopinfo` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `shop_name` varchar(255) NOT NULL COMMENT '店铺名称',
  `shop_mobile` varchar(50) NOT NULL COMMENT '店铺手机号',
  `imgGroup` text COMMENT '营业执照',
  `otherImgGroup` text COMMENT '其他证件',
  `state` tinyint(1) NOT NULL COMMENT '状态',
  `addtime` int(10) NOT NULL COMMENT '申请时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城用户店铺申请表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_shopinfo`
--

LOCK TABLES `oscshop_lionfish_comshop_member_shopinfo` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_shopinfo` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_shopinfo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_member_tixian_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_member_tixian_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_member_tixian_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `service_charge` float(10,2) DEFAULT '0.00' COMMENT '提现手续费比例',
  `service_charge_money` float(10,2) DEFAULT '0.00' COMMENT '提现后实际到账金额',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0申请中，1提现成功，2体现失败',
  `shentime` int(10) NOT NULL COMMENT '审核时间',
  `type` tinyint(1) DEFAULT '0' COMMENT '1余额，2微信 3支付宝 4 银行卡',
  `bankname` varchar(255) DEFAULT NULL COMMENT '银行卡名称',
  `bankaccount` varchar(255) DEFAULT NULL COMMENT '卡号',
  `bankusername` varchar(255) DEFAULT NULL COMMENT '持卡人姓名',
  `addtime` int(10) NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分销佣金提现表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_member_tixian_order`
--

LOCK TABLES `oscshop_lionfish_comshop_member_tixian_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_tixian_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_member_tixian_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_navigat`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_navigat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_navigat` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `navname` varchar(200) DEFAULT NULL COMMENT '名称',
  `thumb` varchar(255) NOT NULL COMMENT '图片地址',
  `link` varchar(255) NOT NULL COMMENT '链接地址',
  `appid` varchar(255) NOT NULL COMMENT '外部小程序appid',
  `type` tinyint(1) NOT NULL COMMENT '0外链 1小程序内链 2外部小程序',
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `enabled` tinyint(1) NOT NULL COMMENT '是否生效，1生效，0不生效',
  `addtime` int(10) NOT NULL COMMENT '添加广告时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='导航图标';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_navigat`
--

LOCK TABLES `oscshop_lionfish_comshop_navigat` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_navigat` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_navigat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_notice`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_notice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_notice` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `content` varchar(200) NOT NULL COMMENT '公告内容',
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  `enabled` tinyint(1) NOT NULL COMMENT '是否生效，1生效，0不生效',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城公告表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_notice`
--

LOCK TABLES `oscshop_lionfish_comshop_notice` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_notice` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_notice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_notify_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_notify_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_notify_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `username` varchar(255) NOT NULL COMMENT '会员名称',
  `member_id` int(10) DEFAULT '0',
  `avatar` varchar(255) NOT NULL COMMENT '头像',
  `order_time` int(10) NOT NULL COMMENT '购买时间',
  `order_id` int(10) DEFAULT '0' COMMENT '订单id',
  `state` int(10) NOT NULL COMMENT '状态，0未发送，1已发送',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  `order_url` varchar(100) NOT NULL COMMENT '订单id',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='最新订单消息通知';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_notify_order`
--

LOCK TABLES `oscshop_lionfish_comshop_notify_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_notify_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_notify_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order` (
  `order_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_num_alias` varchar(40) NOT NULL COMMENT '订单编号',
  `member_id` int(11) NOT NULL,
  `store_id` int(11) NOT NULL DEFAULT '0' COMMENT '商家id',
  `head_id` int(10) DEFAULT '0' COMMENT '团长id',
  `supply_id` int(10) DEFAULT '0' COMMENT '供应商id',
  `is_vipcard_buy` tinyint(1) DEFAULT '0' COMMENT '是否会员卡购买，0 否，1是',
  `is_level_buy` tinyint(1) DEFAULT '0' COMMENT '是否会员等级购买，1是，0 不是',
  `type` enum('pintuan','normal','lottery','virtual','bargain','integral','community','ignore') DEFAULT 'normal',
  `charge_mobile` varchar(30) DEFAULT NULL COMMENT '充值的手机号',
  `is_pin` tinyint(1) DEFAULT '0' COMMENT '是否拼团，0表示否，1表示是',
  `from_type` enum('weixin','wepro','tradecomponts') DEFAULT 'weixin' COMMENT '订单来源：weixin表示服务号，wepro表示小程序,tradecomponts 视频号',
  `perpay_id` varchar(255) DEFAULT NULL COMMENT '预支付id',
  `name` varchar(32) NOT NULL COMMENT '购买的会员名字',
  `email` varchar(96) NOT NULL,
  `telephone` varchar(32) NOT NULL COMMENT '下单会员电话',
  `delivery` enum('express','pickup','tuanz_send','localtown_delivery','hexiao') DEFAULT 'express' COMMENT '配送类型',
  `shipping_name` varchar(32) NOT NULL COMMENT '收货人姓名',
  `address_id` int(11) NOT NULL,
  `shipping_tel` varchar(20) NOT NULL COMMENT '收货人电话',
  `shipping_city_id` int(11) NOT NULL,
  `shipping_country_id` int(11) NOT NULL,
  `shipping_stree_id` int(10) DEFAULT NULL COMMENT '街道id',
  `shipping_province_id` int(11) NOT NULL,
  `shipping_address` varchar(255) NOT NULL COMMENT '快递详细地址',
  `tuan_send_address` varchar(255) DEFAULT NULL COMMENT '团长配送，送货详细地址',
  `ziti_name` varchar(255) DEFAULT NULL COMMENT '自提团长姓名',
  `ziti_mobile` varchar(50) DEFAULT NULL COMMENT '自提团长电话',
  `shipping_method` int(11) NOT NULL DEFAULT '0' COMMENT '货运方式，快递类型',
  `dispatchname` varchar(100) DEFAULT NULL COMMENT '配送的快递名称',
  `shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '运费',
  `packing_fare` float(10,2) DEFAULT '0.00' COMMENT '包装费',
  `is_free_shipping_fare` tinyint(1) DEFAULT '0' COMMENT '满金额减运费',
  `fare_shipping_free` float(10,2) DEFAULT '0.00' COMMENT '满x减免运费',
  `man_e_money` float(10,2) DEFAULT '0.00' COMMENT '满多少',
  `old_shipping_fare` decimal(10,2) DEFAULT '0.00' COMMENT '原来运费',
  `changedshipping_fare` decimal(10,2) DEFAULT '0.00' COMMENT '更改的运费',
  `shipping_no` varchar(255) DEFAULT '0' COMMENT '快递单号',
  `shipping_traces` text COMMENT '物流轨迹',
  `payment_code` varchar(128) NOT NULL COMMENT '支付方式',
  `score_for_money` float(10,2) DEFAULT '0.00' COMMENT '积分抵扣金额',
  `transaction_id` varchar(100) NOT NULL COMMENT '微信支付交易号',
  `comment` text NOT NULL,
  `remarksaler` varchar(255) DEFAULT NULL COMMENT '商家备注',
  `note_content` varchar(255) DEFAULT NULL COMMENT '自定义备注',
  `total` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `old_price` decimal(10,2) DEFAULT '0.00' COMMENT '原价',
  `changedtotal` decimal(10,2) DEFAULT '0.00' COMMENT '更改的订单总价',
  `voucher_id` int(11) NOT NULL DEFAULT '0' COMMENT '优惠券id',
  `voucher_credit` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '优惠券金额',
  `fullreduction_money` float(10,2) DEFAULT '0.00' COMMENT '满减金额',
  `order_status_id` int(11) NOT NULL,
  `last_refund_order_status_id` int(10) DEFAULT '0' COMMENT '申请退款时，该订单的上一订单状态',
  `is_balance` tinyint(1) NOT NULL DEFAULT '0' COMMENT '未结算',
  `lottery_win` tinyint(1) DEFAULT '0' COMMENT '0未中奖，1中奖',
  `ip` varchar(40) NOT NULL,
  `is_zhuli` tinyint(1) DEFAULT '0' COMMENT '是否砍价，0标识否，2标识砍价',
  `is_commission` tinyint(1) DEFAULT '0' COMMENT '是否分销订单',
  `day_paixu` int(10) DEFAULT '0' COMMENT '每日订单排序',
  `is_delivery_flag` tinyint(1) DEFAULT '0' COMMENT '是否已经打包',
  `is_print_suc` tinyint(1) DEFAULT '1' COMMENT '是否打印成功。',
  `is_kdn_print` tinyint(1) NOT NULL DEFAULT '0' COMMENT '面单打印状态：0、未打印，1、打印成功，2、打印失败',
  `ip_region` varchar(20) NOT NULL,
  `user_agent` varchar(255) NOT NULL COMMENT '用户系统信息',
  `date_added` int(11) NOT NULL,
  `date_modified` int(11) NOT NULL,
  `pay_time` int(11) NOT NULL COMMENT '付款时间',
  `canceltime` int(10) DEFAULT NULL COMMENT '取消订单时间',
  `receive_time` int(10) DEFAULT NULL COMMENT '确认收货时间',
  `finishtime` int(10) DEFAULT NULL COMMENT '订单完成时间',
  `express_time` int(10) DEFAULT '0' COMMENT '发货时间',
  `express_tuanz_time` int(10) DEFAULT NULL COMMENT '送达团长时间',
  `shipping_cha_time` int(10) DEFAULT '0' COMMENT '查询时间',
  `is_change_price` tinyint(1) DEFAULT '0' COMMENT '是否改价过，0、未改价，1、已改价',
  `is_localtown_free_shipping_fare` tinyint(1) DEFAULT '0' COMMENT '满金额减同城配送费',
  `localtown_free_shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '减免的同城配送费',
  `localtown_add_shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '加价配送费',
  `expected_delivery_time` varchar(20) DEFAULT '' COMMENT '指定配送时间',
  `third_distribution_type` varchar(20) DEFAULT '' COMMENT '第三方配送类型：达达配送：imdada；顺丰同城：sf；UU跑腿：uupt；点我达：dianwoda',
  `hexiao_volume_code` varchar(18) DEFAULT '' COMMENT '核销卷码',
  `hexiao_qr_code` varchar(255) DEFAULT '' COMMENT '核销二维码',
  PRIMARY KEY (`order_id`),
  KEY `member_id` (`member_id`),
  KEY `order_status_id` (`order_status_id`),
  KEY `date_added` (`date_added`),
  KEY `pay_time` (`pay_time`),
  KEY `head_id` (`head_id`),
  KEY `supply_id` (`supply_id`),
  KEY `order_num_alias` (`order_num_alias`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order`
--

LOCK TABLES `oscshop_lionfish_comshop_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_all`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_all`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_all` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id，',
  `member_id` int(10) NOT NULL COMMENT '所属会员',
  `is_pin` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否拼团订单',
  `total_money` float(10,2) DEFAULT '0.00' COMMENT '总需要支付金额',
  `order_num_alias` varchar(200) DEFAULT NULL COMMENT '支付的订单号',
  `order_status_id` int(10) NOT NULL COMMENT '订单状态id',
  `transaction_id` varchar(255) DEFAULT NULL COMMENT '微信交易号',
  `out_trade_no` varchar(100) DEFAULT '' COMMENT '提交给微信的订单号',
  `paytime` int(10) NOT NULL COMMENT '支付时间',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='订单总表，支付时候使用';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_all`
--

LOCK TABLES `oscshop_lionfish_comshop_order_all` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_all` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_all` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_comment`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_comment` (
  `comment_id` int(10) NOT NULL AUTO_INCREMENT COMMENT '评论id',
  `order_id` int(10) NOT NULL DEFAULT '0' COMMENT '订单id',
  `goods_id` int(10) NOT NULL DEFAULT '0' COMMENT '商品id',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否显示，0审核中，1：显示',
  `member_id` int(10) NOT NULL DEFAULT '0' COMMENT '会员id',
  `goods_name` varchar(255) DEFAULT NULL COMMENT '商品名称',
  `goods_image` text COMMENT '商品图片',
  `order_num_alias` varchar(100) DEFAULT NULL COMMENT '订单编号',
  `avatar` varchar(255) DEFAULT NULL COMMENT '头像',
  `user_name` varchar(100) DEFAULT NULL COMMENT '昵称',
  `type` tinyint(1) DEFAULT '0' COMMENT '0真实评价，1虚拟评价',
  `gd_type` enum('normal','pintuan') DEFAULT 'normal' COMMENT 'normal普通商品。pintuan 拼团商品',
  `star` int(10) NOT NULL DEFAULT '5' COMMENT '评价星级',
  `star3` int(10) DEFAULT NULL COMMENT '质量满意',
  `star2` int(10) DEFAULT NULL COMMENT '价格合理',
  `images` text COMMENT '图片',
  `is_picture` tinyint(1) DEFAULT '0' COMMENT '是否有图片',
  `content` text NOT NULL COMMENT '评价内容',
  `add_time` int(10) NOT NULL DEFAULT '0' COMMENT '评价时间',
  `is_send_point` tinyint(1) DEFAULT '0' COMMENT '好评有礼，0、好评未送积分，1、好评已送积分',
  PRIMARY KEY (`comment_id`),
  KEY `goods_id` (`goods_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_comment`
--

LOCK TABLES `oscshop_lionfish_comshop_order_comment` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_goods`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_goods` (
  `order_goods_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `goods_id` int(11) NOT NULL,
  `store_id` int(11) NOT NULL DEFAULT '0' COMMENT '商家id',
  `supply_id` int(10) DEFAULT NULL COMMENT '供应商id',
  `is_pin` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否拼团商品订单，0：单独购买，1：拼团商品',
  `pin_id` int(10) DEFAULT NULL,
  `shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '运费',
  `packing_fare` float(10,2) DEFAULT '0.00' COMMENT '包装费',
  `fare_shipping_free` float(10,2) DEFAULT '0.00' COMMENT '满x金额减运费',
  `name` varchar(255) NOT NULL,
  `head_disc` int(10) DEFAULT '100' COMMENT '团长折扣',
  `member_disc` int(10) DEFAULT '100' COMMENT '会员折扣，100 表示不打折',
  `level_name` varchar(200) DEFAULT NULL COMMENT '会员折扣等级名称',
  `goods_images` varchar(255) DEFAULT NULL COMMENT '商品图片',
  `goods_type` enum('pintuan','normal') DEFAULT 'normal' COMMENT '商品类型',
  `model` varchar(64) NOT NULL,
  `quantity` int(4) NOT NULL,
  `price` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `changeprice` decimal(10,2) DEFAULT '0.00' COMMENT '更改价格',
  `oldprice` decimal(10,2) DEFAULT '0.00' COMMENT '旧的商品总价',
  `fullreduction_money` float(10,2) DEFAULT '0.00' COMMENT '满减金额',
  `voucher_credit` float(10,2) DEFAULT '0.00' COMMENT '优惠券优惠金额',
  `score_for_money2` float(10,2) DEFAULT '0.00' COMMENT '积分抵扣金额',
  `score_for_money` float(10,2) DEFAULT '0.00' COMMENT '积分抵扣金额',
  `fenbi_li` float(10,2) DEFAULT '0.00' COMMENT '订单中金额占比',
  `total` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `has_refund_money` float(10,2) DEFAULT '0.00' COMMENT '已经退款金额',
  `has_refund_quantity` int(10) DEFAULT '0' COMMENT '已经退款数量',
  `is_vipcard_buy` tinyint(1) DEFAULT '0' COMMENT '0非vip价格购买，1是',
  `is_level_buy` tinyint(1) DEFAULT '0' COMMENT '是否会员等级购买，1是，0 不是',
  `old_total` float(10,2) DEFAULT '0.00' COMMENT '原始总价',
  `rela_goodsoption_valueid` varchar(50) DEFAULT NULL COMMENT '关联属性id',
  `is_refund_state` tinyint(1) DEFAULT '0' COMMENT '是否退款，0未退款，1已退款',
  `is_statements_state` tinyint(1) DEFAULT '1' COMMENT '是否结算',
  `statements_end_time` int(10) DEFAULT '0' COMMENT '结算时间',
  `comment` varchar(255) DEFAULT NULL COMMENT '会员留言',
  `commiss_one_money` float(10,2) DEFAULT '0.00' COMMENT '一级分佣金额',
  `commiss_two_money` float(10,2) DEFAULT '0.00' COMMENT '二级分佣金额',
  `commiss_three_money` float(10,2) DEFAULT '0.00' COMMENT '三级分佣金额',
  `commiss_fen_one_money` float(10,2) DEFAULT '0.00' COMMENT '分享一级佣金',
  `commiss_fen_two_money` float(10,2) DEFAULT '0.00' COMMENT '分享二级佣金',
  `commiss_fen_three_money` float(10,2) DEFAULT '0.00' COMMENT '分享三级佣金',
  `addtime` int(11) DEFAULT '1538487932' COMMENT '订单生成时间',
  `is_change_price` tinyint(1) DEFAULT '0' COMMENT '是否改价过，0、未改价，1、已改价',
  `cost_price` decimal(15,4) DEFAULT NULL COMMENT '商品成本价',
  `profit_total` decimal(15,4) DEFAULT NULL COMMENT '毛利金额',
  `reward_socre` int(10) NOT NULL COMMENT '赠送积分数量',
  PRIMARY KEY (`order_goods_id`),
  KEY `store_id` (`store_id`) USING BTREE,
  KEY `order_id` (`order_id`),
  KEY `pin_id` (`pin_id`) USING BTREE,
  KEY `supply_id` (`supply_id`),
  KEY `goods_id` (`goods_id`,`rela_goodsoption_valueid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_goods`
--

LOCK TABLES `oscshop_lionfish_comshop_order_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_goods_refund`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_goods_refund`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_goods_refund` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_goods_id` int(10) NOT NULL COMMENT '商品订单id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `real_refund_quantity` int(10) DEFAULT '0' COMMENT '实际退款的数量',
  `quantity` int(10) NOT NULL COMMENT '退款数量',
  `money` float(10,2) NOT NULL COMMENT '退款金额',
  `refund_shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '退运费',
  `order_status_id` int(10) NOT NULL COMMENT '退款时，订单状态',
  `is_back_quantity` tinyint(1) DEFAULT NULL COMMENT '是否退商品库存',
  `back_score_for_money` float(10,2) NOT NULL COMMENT '退还积分兑换商品的积分',
  `back_send_score` float(10,2) NOT NULL COMMENT '退还赠送积分',
  `back_head_orderbuycommiss` float(10,2) NOT NULL COMMENT '退还团长佣金',
  `back_head_supplycommiss` float(10,2) DEFAULT '0.00' COMMENT '退还供应商佣金',
  `back_head_commiss_1` float(10,2) NOT NULL COMMENT '退1级团长佣金',
  `back_head_commiss_2` float(10,2) NOT NULL COMMENT '退2级团长佣金',
  `back_head_commiss_3` float(10,2) NOT NULL COMMENT '退3级团长佣金',
  `back_member_commiss_1` float(10,2) NOT NULL COMMENT '退会员1级佣金',
  `back_member_commiss_2` float(10,2) NOT NULL COMMENT '退会员2级佣金',
  `back_member_commiss_3` float(10,2) NOT NULL COMMENT '退会员3级佣金',
  `addtime` int(10) NOT NULL COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `order_goods_id` (`order_goods_id`),
  KEY `order_id` (`order_id`),
  KEY `uniacid` (`uniacid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城订单商品退款记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_goods_refund`
--

LOCK TABLES `oscshop_lionfish_comshop_order_goods_refund` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_refund` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_refund` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_goods_refund_intrgral`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_goods_refund_intrgral`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_goods_refund_intrgral` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `order_goods_id` int(10) NOT NULL COMMENT '订单商品表',
  `order_id` int(10) NOT NULL COMMENT '订单表',
  `refund_score` float(10,2) NOT NULL COMMENT '积分',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城积分退款表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_goods_refund_intrgral`
--

LOCK TABLES `oscshop_lionfish_comshop_order_goods_refund_intrgral` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_refund_intrgral` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_refund_intrgral` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_goods_relative_salesroom`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_goods_relative_salesroom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_goods_relative_salesroom` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) DEFAULT '0' COMMENT '订单id',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '商品订单id',
  `salesroom_id` int(10) DEFAULT '0' COMMENT '门店id',
  `goods_id` int(10) DEFAULT '0' COMMENT '商品id',
  `is_hx_member` tinyint(1) DEFAULT '0' COMMENT '是否指定核销员：0、不指定，全部核销员，1、指定',
  `smember_id` text COMMENT '核销员id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `salesroom_id` (`salesroom_id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品门店关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_goods_relative_salesroom`
--

LOCK TABLES `oscshop_lionfish_comshop_order_goods_relative_salesroom` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_relative_salesroom` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_relative_salesroom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_goods_saleshexiao`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_goods_saleshexiao`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_goods_saleshexiao` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `order_goods_id` int(10) NOT NULL COMMENT '商品订单id',
  `goods_id` int(10) NOT NULL COMMENT '商品id ',
  `hexiao_count` int(10) NOT NULL COMMENT '总的可核销数量',
  `del_hexiao_count` int(10) NOT NULL COMMENT '剩余可核销数量',
  `is_hexiao_over` int(10) DEFAULT '0' COMMENT '是否核销完毕：0、未核销，1、已核销，2、已过期',
  `effect_begin_time` int(10) NOT NULL COMMENT '有效时间开始',
  `effect_end_time` int(10) NOT NULL COMMENT '有效时间结束',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `goods_quantity` int(10) DEFAULT '0' COMMENT '商品购买数量',
  `refund_quantity` int(10) DEFAULT '0' COMMENT '商品退款数量',
  `one_hexiao_count` int(10) DEFAULT '0' COMMENT '单个商品核销次数',
  `hx_assign_salesroom` tinyint(1) DEFAULT '0' COMMENT '指定门店：0、所有门店，1、指定门店',
  `expire_act_time` int(10) DEFAULT '0' COMMENT '过期操作时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `order_id` (`order_id`),
  KEY `order_goods_id` (`order_goods_id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城订单核销信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_goods_saleshexiao`
--

LOCK TABLES `oscshop_lionfish_comshop_order_goods_saleshexiao` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_saleshexiao` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_saleshexiao` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_goods_saleshexiao_record`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_goods_saleshexiao_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_goods_saleshexiao_record` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `order_goods_id` int(10) NOT NULL COMMENT '商品订单id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `hexiao_count` int(10) NOT NULL COMMENT '本次核销数量',
  `salesroom_id` int(10) NOT NULL COMMENT '核销门店id',
  `salesroom_name` varchar(255) NOT NULL COMMENT '核销门店名称',
  `salesmember_id` int(10) NOT NULL COMMENT '核销员id',
  `smember_name` varchar(200) NOT NULL COMMENT '核销员名称',
  `member_id` int(10) NOT NULL COMMENT '核销员会员id',
  `addtime` int(10) NOT NULL COMMENT '核销时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `order_id` (`order_id`),
  KEY `order_goods_id` (`order_goods_id`),
  KEY `goods_id` (`goods_id`),
  KEY `salesroom_id` (`salesroom_id`),
  KEY `salesmember_id` (`salesmember_id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城订单核销记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_goods_saleshexiao_record`
--

LOCK TABLES `oscshop_lionfish_comshop_order_goods_saleshexiao_record` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_saleshexiao_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_goods_saleshexiao_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_history`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_history` (
  `order_history_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `order_goods_id` int(10) DEFAULT '0' COMMENT '商品订单id',
  `order_status_id` int(5) NOT NULL,
  `notify` tinyint(1) NOT NULL,
  `comment` text NOT NULL,
  `date_added` int(11) NOT NULL,
  PRIMARY KEY (`order_history_id`),
  KEY `order_id` (`order_id`,`order_goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_history`
--

LOCK TABLES `oscshop_lionfish_comshop_order_history` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_kdniao_info`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_kdniao_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_kdniao_info` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `order_code` varchar(40) NOT NULL COMMENT '订单编号',
  `kdnOrderCode` varchar(40) DEFAULT NULL COMMENT '快递鸟编号',
  `uniquerRequestNumber` varchar(100) DEFAULT NULL COMMENT '唯一标识',
  `e_business_id` varchar(50) NOT NULL COMMENT '用户编号',
  `result_code` varchar(10) DEFAULT NULL COMMENT '打印结果编码',
  `status` tinyint(1) DEFAULT '0' COMMENT '打印结果：1、成功，0、失败',
  `print_template` mediumtext COMMENT '面单打印模板内容(html格式)',
  `reason` varchar(100) DEFAULT NULL COMMENT '打印结果',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城快递鸟打印面单信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_kdniao_info`
--

LOCK TABLES `oscshop_lionfish_comshop_order_kdniao_info` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_kdniao_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_kdniao_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_kdniao_print_log`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_kdniao_print_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_kdniao_print_log` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `print_count` int(10) NOT NULL DEFAULT '0' COMMENT '打印总单数',
  `succ_count` int(10) NOT NULL DEFAULT '0' COMMENT '打印成功单数',
  `fail_count` int(10) NOT NULL DEFAULT '0' COMMENT '打印失败单数',
  `fail_reason` text COMMENT '失败原因',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '打印状态：1、面单打印完成，0、打印中',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城快递鸟电子面单打印日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_kdniao_print_log`
--

LOCK TABLES `oscshop_lionfish_comshop_order_kdniao_print_log` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_kdniao_print_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_kdniao_print_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_option`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_option` (
  `order_option_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `order_goods_id` int(11) NOT NULL,
  `goods_option_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`order_option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_option`
--

LOCK TABLES `oscshop_lionfish_comshop_order_option` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_presale`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_presale`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_presale` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `is_notify` tinyint(1) DEFAULT '0' COMMENT '是否通知过，0否，1是',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `presale_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 定金， 1全款',
  `presale_ding_money` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '支付定金金额',
  `presale_deduction_money` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '定金抵扣金额',
  `presale_limit_balancepaytime` tinyint(1) NOT NULL DEFAULT '0' COMMENT '限制尾款支付时间， 0 限制， 1不限制',
  `presale_balance_beginpaytime` int(10) DEFAULT '0' COMMENT '限制尾款支付开始时间',
  `presale_balance_paytime` int(10) NOT NULL DEFAULT '0' COMMENT '限制尾款支付时间，具体结束时间',
  `presale_sendorder_datetime` int(10) NOT NULL COMMENT '具体发货时间',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 未付款，1已付定金 ,2 已付尾款',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `transaction_id_first` varchar(200) DEFAULT NULL COMMENT '定金支付时微信交易号',
  `transaction_id_second` varchar(200) DEFAULT NULL COMMENT '尾款支付时微信交易号',
  `first_paytime` int(10) DEFAULT NULL COMMENT '预约款支付时间',
  `second_paytime` int(10) DEFAULT NULL COMMENT '尾款支付时间',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`,`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='预售订单记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_presale`
--

LOCK TABLES `oscshop_lionfish_comshop_order_presale` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_presale` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_presale` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_quantity_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_quantity_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_quantity_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `quantity` int(10) NOT NULL COMMENT '数量',
  `last_quantity` int(10) DEFAULT NULL COMMENT '上一次库存',
  `rela_goodsoption_value_id` int(10) NOT NULL COMMENT '相关商品规格',
  `addtime` int(10) NOT NULL COMMENT '库存变更时间',
  `adddate` varchar(50) DEFAULT NULL COMMENT '日期',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0减少库存，1增加库存',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='库存记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_quantity_order`
--

LOCK TABLES `oscshop_lionfish_comshop_order_quantity_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_quantity_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_quantity_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_refund`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_refund`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_refund` (
  `ref_id` int(10) NOT NULL AUTO_INCREMENT COMMENT '退款自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `store_id` int(10) DEFAULT '0' COMMENT '供应商id',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '退款子订单编号',
  `real_refund_quantity` int(10) DEFAULT '0' COMMENT '退款几个商品',
  `head_id` int(10) DEFAULT '0' COMMENT '团长id',
  `ref_type` tinyint(1) NOT NULL COMMENT '退款类型：1仅退款，2退款退货',
  `ref_money` float(10,2) NOT NULL COMMENT '退款金额',
  `ref_shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '退款运费',
  `ref_member_id` int(10) NOT NULL COMMENT '会员id',
  `ref_name` varchar(255) NOT NULL COMMENT '退款原因',
  `ref_mobile` varchar(50) NOT NULL COMMENT '联系人手机号',
  `complaint_name` varchar(255) DEFAULT NULL COMMENT '联系人姓名',
  `ref_description` text COMMENT '问题描述',
  `state` tinyint(1) NOT NULL COMMENT '退款状态：0申请中，1商家拒绝，2平台介入，3退款成功，4退款失败,5:撤销申请',
  `remarkrefund` varchar(255) DEFAULT NULL COMMENT '管理员备注',
  `modify_time` int(10) DEFAULT '0' COMMENT '退款订单管理员修改时间',
  `addtime` int(10) NOT NULL COMMENT '申请时间',
  PRIMARY KEY (`ref_id`),
  KEY `ref_member_id` (`ref_member_id`) USING BTREE,
  KEY `head_id` (`head_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户退款表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_refund`
--

LOCK TABLES `oscshop_lionfish_comshop_order_refund` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_refund_disable`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_refund_disable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_refund_disable` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `ref_id` int(10) NOT NULL COMMENT '退款的id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `order_goods_id` int(10) NOT NULL COMMENT '子订单id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `ref_id` (`ref_id`),
  KEY `order_id` (`order_id`,`order_goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='禁止申请退款的订单';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_refund_disable`
--

LOCK TABLES `oscshop_lionfish_comshop_order_refund_disable` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_disable` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_disable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_refund_history`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_refund_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_refund_history` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '订单商品id',
  `message` text COMMENT '处理内容',
  `type` tinyint(1) NOT NULL COMMENT '类型：1用户反馈，2商家反馈',
  `ref_id` int(10) DEFAULT NULL COMMENT '退款记录id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `order_id` (`order_id`),
  KEY `ref_id` (`ref_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='退款订单处理历史表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_refund_history`
--

LOCK TABLES `oscshop_lionfish_comshop_order_refund_history` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_refund_history_image`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_refund_history_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_refund_history_image` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `orh_id` int(10) NOT NULL COMMENT '处理记录id',
  `image` varchar(255) NOT NULL COMMENT '图片地址',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `orh_id` (`orh_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='退款处理记录图片表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_refund_history_image`
--

LOCK TABLES `oscshop_lionfish_comshop_order_refund_history_image` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_history_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_history_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_refund_image`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_refund_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_refund_image` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '退款图片自增id',
  `ref_id` int(10) NOT NULL COMMENT '退款id',
  `image` varchar(255) NOT NULL COMMENT '图片地址',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `ref_id` (`ref_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='order_refund_image';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_refund_image`
--

LOCK TABLES `oscshop_lionfish_comshop_order_refund_image` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_refund_reson`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_refund_reson`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_refund_reson` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `title` varchar(255) NOT NULL COMMENT '退款原因',
  `sortby` int(10) NOT NULL COMMENT '排序',
  `state` tinyint(1) NOT NULL COMMENT '状态，0未开启，1开启',
  `addtime` int(10) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城订单退款原因表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_refund_reson`
--

LOCK TABLES `oscshop_lionfish_comshop_order_refund_reson` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_reson` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_refund_reson` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_relate`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_relate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_relate` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_all_id` int(10) NOT NULL COMMENT '订单总表id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `order_all_id` (`order_all_id`,`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='订单总表跟商家订单关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_relate`
--

LOCK TABLES `oscshop_lionfish_comshop_order_relate` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_relate` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_relate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_status`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_status` (
  `order_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL,
  PRIMARY KEY (`order_status_id`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8 COMMENT='订单状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_status`
--

LOCK TABLES `oscshop_lionfish_comshop_order_status` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_status` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_order_status` VALUES (1,'已付款待发货'),(2,'拼团中，已付款'),(3,'待付款'),(4,'已发货，待收货'),(5,'交易已取消'),(6,'已签收'),(7,'已退款'),(8,'退款并送券'),(9,'二等奖，已退款并送券'),(10,'退款失败，请手动退款'),(11,'已完成'),(12,'申请退款中'),(13,'平台介入退款'),(14,'配送中'),(15,'预售已付定金');
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_total`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_total` (
  `order_total_id` int(10) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `code` varchar(32) NOT NULL,
  `title` varchar(255) NOT NULL,
  `text` varchar(255) NOT NULL,
  `value` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `sort_order` int(3) NOT NULL,
  PRIMARY KEY (`order_total_id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_total`
--

LOCK TABLES `oscshop_lionfish_comshop_order_total` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_total` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_total` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_order_virtualcard`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_order_virtualcard`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_order_virtualcard` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `code_id` int(10) NOT NULL COMMENT '兑换码id',
  `code_sn` varchar(200) NOT NULL COMMENT '兑换码序号',
  `state` tinyint(1) NOT NULL COMMENT '0未支付,1未使用，2已使用，3已失效',
  `order_id` int(10) NOT NULL COMMENT '关联的订单id',
  `user_user_id` int(10) NOT NULL COMMENT '使用人',
  `buy_user_id` int(10) NOT NULL COMMENT '购买人',
  `code_money` decimal(10,2) NOT NULL COMMENT '兑换码金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `effect_type` tinyint(1) DEFAULT NULL COMMENT '0 有效期类型，0无限期，1限制时间',
  `effect_endtime` int(10) DEFAULT NULL COMMENT '到期时间',
  PRIMARY KEY (`id`),
  KEY `code_id` (`code_id`,`order_id`,`user_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='订单兑换码表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_order_virtualcard`
--

LOCK TABLES `oscshop_lionfish_comshop_order_virtualcard` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_virtualcard` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_order_virtualcard` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_orderdistribution`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_orderdistribution`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_orderdistribution` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `username` varchar(100) NOT NULL COMMENT '配送员姓名',
  `mobile` varchar(30) NOT NULL COMMENT '配送员电话',
  `member_id` int(10) NOT NULL COMMENT '关联会员id',
  `has_send_count` int(10) NOT NULL DEFAULT '0' COMMENT '已配送单数',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0禁用，1启用',
  `always_address` varchar(200) NOT NULL COMMENT '配送地址',
  `addtime` int(10) DEFAULT NULL COMMENT '添加时间',
  `store_id` int(10) DEFAULT '0' COMMENT '店铺id：0 平台自营，其他则为供应商',
  `is_new_notice` tinyint(1) DEFAULT '0' COMMENT '新订单语音通知：1、通知，0、不通知',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城订单配送员表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_orderdistribution`
--

LOCK TABLES `oscshop_lionfish_comshop_orderdistribution` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_orderdistribution_commiss`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_orderdistribution_commiss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_orderdistribution_commiss` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `orderdistribution_id` int(10) NOT NULL COMMENT '配送员id',
  `member_id` int(10) NOT NULL COMMENT '配送员关联会员id',
  `money` float(10,2) NOT NULL COMMENT '账户金额',
  `dongmoney` float(10,2) NOT NULL COMMENT '账户冻结，提现中金额',
  `getmoney` float(10,2) NOT NULL COMMENT '已经获得多少钱',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `orderdistribution_id` (`orderdistribution_id`,`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城配送员佣金账户表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_orderdistribution_commiss`
--

LOCK TABLES `oscshop_lionfish_comshop_orderdistribution_commiss` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_commiss` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_commiss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_orderdistribution_log`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_orderdistribution_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_orderdistribution_log` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `orderdistribution_id` int(10) NOT NULL COMMENT '配送员id',
  `state` tinyint(1) NOT NULL COMMENT '0 未付款，未配送，1已付款，未被抢  2 已付款，待配送，已被抢单，3，已拿货，配送中， 4、已送达，5、 已取消',
  `remark` varchar(255) NOT NULL COMMENT '备注',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城跑腿配送日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_orderdistribution_log`
--

LOCK TABLES `oscshop_lionfish_comshop_orderdistribution_log` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_orderdistribution_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_orderdistribution_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_orderdistribution_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `orderdistribution_id` int(10) NOT NULL COMMENT '骑手id',
  `distance` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '距离: 单位KM',
  `shop_lon` float(10,6) NOT NULL DEFAULT '0.000000' COMMENT '店家经度',
  `shop_lat` float(10,6) NOT NULL DEFAULT '0.000000' COMMENT '店家纬度',
  `shop_address` varchar(255) DEFAULT NULL COMMENT '商家配送地址',
  `member_lon` float(10,6) NOT NULL DEFAULT '0.000000' COMMENT '会员经度',
  `member_lat` float(10,6) NOT NULL DEFAULT '0.000000' COMMENT '会员纬度',
  `is_admin_assign` tinyint(1) DEFAULT '0' COMMENT '是否后台指定，1是，0否',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 未付款，未配送，1已付款，未被抢  2 已付款，待配送，已被抢单，3，已拿货，配送中， 4、已送达，5、 已取消',
  `distr_commiss_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '配送费 计费方式： 0 每单固定， 1每单按照订单配送费抽成，3按距离收配送费',
  `shipping_money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '配送员佣金',
  `is_statement` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否结算，0未结算，1已结算',
  `delivery_type` tinyint(1) DEFAULT '0' COMMENT '配送方式：0 默认，1、平台配送，2,、第三方配送',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `third_distribution_type` varchar(20) DEFAULT '' COMMENT '第三方配送类型：达达配送：imdada；顺丰同城：sf；UU跑腿：uupt；点我达：dianwoda',
  `dm_id` int(10) DEFAULT '0' COMMENT '第三方配送员编号',
  `dm_name` varchar(20) DEFAULT '' COMMENT '第三方配送员姓名',
  `dm_mobile` varchar(20) DEFAULT '' COMMENT '第三方配送员手机号',
  `cancel_reason` varchar(100) DEFAULT '' COMMENT '订单取消原因',
  `third_id` varchar(50) DEFAULT '' COMMENT '第三方配送运单号',
  `third_order_id` varchar(50) DEFAULT '' COMMENT '第三方配送订单号',
  `deduct_fee` decimal(10,2) DEFAULT '0.00' COMMENT '第三方配送扣除的违约金',
  `order_code` varchar(40) DEFAULT NULL COMMENT '蜂鸟即配商户订单号',
  PRIMARY KEY (`id`),
  KEY `order_id` (`order_id`,`orderdistribution_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城骑手配送费订单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_orderdistribution_order`
--

LOCK TABLES `oscshop_lionfish_comshop_orderdistribution_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_orderdistribution_thirth_log`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_orderdistribution_thirth_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_orderdistribution_thirth_log` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `third_distribution_type` varchar(20) NOT NULL COMMENT '第三方配送类型：达达配送：imdada；顺丰同城：sf；UU跑腿：uupt；点我达：dianwoda',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '状态：1、待接单，2、待取货，3、配送中，4、已完成，5、已取消，8、指派单，9、妥投异常之物品返回中，10、妥投异常之物品返回完成，11、订单异常，100、骑士到店，1000、创建达达运单失败',
  `remark` varchar(255) NOT NULL COMMENT '备注',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城第三方配送日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_orderdistribution_thirth_log`
--

LOCK TABLES `oscshop_lionfish_comshop_orderdistribution_thirth_log` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_thirth_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_thirth_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_orderdistribution_thirth_query`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_orderdistribution_thirth_query`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_orderdistribution_thirth_query` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `third_distribution_type` varchar(20) NOT NULL COMMENT '第三方配送公司（达达配送：imdada；顺丰同城：sf；）',
  `distance` decimal(11,2) NOT NULL DEFAULT '0.00' COMMENT '配送距离(单位：米)',
  `shipping_fee` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '实际运费(最终运费)',
  `shipping_delivery_fee` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '运费',
  `delivery_no` varchar(50) NOT NULL COMMENT '平台订单号',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '查询状态：1 成功，0 失败',
  `message` varchar(100) NOT NULL COMMENT '查询错误原因',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼第三方配送预查询费用表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_orderdistribution_thirth_query`
--

LOCK TABLES `oscshop_lionfish_comshop_orderdistribution_thirth_query` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_thirth_query` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_thirth_query` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_orderdistribution_tixian`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_orderdistribution_tixian`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_orderdistribution_tixian` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `orderdistribution_id` int(10) NOT NULL COMMENT '配送员id',
  `member_id` int(10) NOT NULL COMMENT '配送员关联会员id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `service_charge` int(10) NOT NULL COMMENT '提现服务费百分比%',
  `service_charge_money` float(10,2) NOT NULL COMMENT '提现服务费金额',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0申请中，1提现成功，2 提现失败',
  `shentime` int(10) NOT NULL COMMENT '审核时间',
  `type` tinyint(1) NOT NULL COMMENT '1余额，2微信，3支付宝，4银行卡',
  `bankname` varchar(255) NOT NULL COMMENT '银行卡名称',
  `bankaccount` varchar(255) NOT NULL COMMENT '银行卡账户',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `orderdistribution_id` (`orderdistribution_id`,`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城配送员提现表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_orderdistribution_tixian`
--

LOCK TABLES `oscshop_lionfish_comshop_orderdistribution_tixian` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_tixian` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_tixian` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_orderdistribution_tixian_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_orderdistribution_tixian_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_orderdistribution_tixian_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL,
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `service_charge` float(10,2) DEFAULT '0.00' COMMENT '提现手续费比例',
  `service_charge_money` float(10,2) DEFAULT '0.00' COMMENT '提现后实际到账金额',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0申请中，1提现成功，2体现失败',
  `shentime` int(10) NOT NULL COMMENT '审核时间',
  `type` tinyint(1) DEFAULT '0' COMMENT '1余额，2微信 3支付宝 4 银行卡',
  `bankname` varchar(255) DEFAULT NULL COMMENT '银行卡名称',
  `bankaccount` varchar(255) DEFAULT NULL COMMENT '卡号',
  `bankusername` varchar(255) DEFAULT NULL COMMENT '持卡人姓名',
  `addtime` int(10) NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='同城配送佣金提现表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_orderdistribution_tixian_order`
--

LOCK TABLES `oscshop_lionfish_comshop_orderdistribution_tixian_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_tixian_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_orderdistribution_tixian_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_perm_role`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_perm_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_perm_role` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rolename` varchar(255) DEFAULT '',
  `status` tinyint(3) DEFAULT '0',
  `perms` text,
  `deleted` tinyint(3) DEFAULT '0',
  `perms2` text,
  PRIMARY KEY (`id`),
  KEY `idx_status` (`status`),
  KEY `idx_deleted` (`deleted`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_perm_role`
--

LOCK TABLES `oscshop_lionfish_comshop_perm_role` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_perm_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_perm_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_perm_user`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_perm_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_perm_user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uniacid` int(11) DEFAULT '0',
  `uid` int(11) DEFAULT '0',
  `username` varchar(255) DEFAULT '',
  `password` varchar(255) DEFAULT '',
  `roleid` int(11) DEFAULT '0',
  `status` int(11) DEFAULT '0',
  `perms` text,
  `deleted` tinyint(3) DEFAULT '0',
  `realname` varchar(255) DEFAULT '',
  `mobile` varchar(255) DEFAULT '',
  `perms2` text,
  `openid` varchar(50) DEFAULT NULL,
  `openid_wa` varchar(50) DEFAULT NULL,
  `member_nick` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_uniacid` (`uniacid`),
  KEY `idx_uid` (`uid`),
  KEY `idx_roleid` (`roleid`),
  KEY `idx_status` (`status`),
  KEY `idx_deleted` (`deleted`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_perm_user`
--

LOCK TABLES `oscshop_lionfish_comshop_perm_user` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_perm_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_perm_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_pin`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_pin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_pin` (
  `pin_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '拼团id，自增',
  `order_id` int(11) NOT NULL DEFAULT '0' COMMENT '订单id',
  `user_id` int(11) NOT NULL DEFAULT '0' COMMENT '会员id',
  `need_count` int(11) NOT NULL DEFAULT '0' COMMENT '拼团人数',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '拼团状态，0拼团中，1拼团成功，2拼团失败并退款',
  `is_commiss_tuan` tinyint(1) DEFAULT '0' COMMENT '是否佣金团',
  `is_newman_takein` tinyint(1) DEFAULT '0' COMMENT '是否仅新人参加',
  `lottery_state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '抽奖状态，0抽奖中，1可退款，2已退款送券。',
  `is_lottery` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否抽奖拼团，0正常订单，1抽奖订单',
  `begin_time` int(11) NOT NULL COMMENT '拼团开始时间',
  `end_time` int(11) NOT NULL COMMENT '拼团结束时间',
  `add_time` int(11) NOT NULL COMMENT ' 添加时间',
  `success_time` int(10) DEFAULT NULL COMMENT '拼团成功时间',
  `is_jiqi` tinyint(1) DEFAULT '0' COMMENT '是否机器人成团',
  `qrcode` varchar(255) DEFAULT NULL COMMENT '二维码',
  `is_pintuan_rebate` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否拼团返利：1、是，0、否',
  `random_delivery_count` int(10) NOT NULL DEFAULT '0' COMMENT '随机发货人数',
  `rebate_reward` tinyint(1) NOT NULL DEFAULT '1' COMMENT '返利奖励：1、送积分，2、送余额',
  `reward_amount` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '赠送的积分数或余额',
  PRIMARY KEY (`pin_id`),
  KEY `user_id` (`user_id`) USING BTREE,
  KEY `order_id` (`order_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_pin`
--

LOCK TABLES `oscshop_lionfish_comshop_pin` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pin` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_pin_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_pin_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_pin_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pin_id` int(11) NOT NULL COMMENT '拼团id',
  `order_id` int(11) NOT NULL COMMENT '订单id',
  `add_time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `pin_id` (`pin_id`) USING BTREE,
  KEY `order_id` (`order_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_pin_order`
--

LOCK TABLES `oscshop_lionfish_comshop_pin_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pin_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pin_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_pintuan_commiss`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_pintuan_commiss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_pintuan_commiss` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `money` float(10,2) DEFAULT '0.00' COMMENT '可提现金额',
  `dongmoney` float(10,2) DEFAULT '0.00' COMMENT '提现中金额',
  `getmoney` float(10,2) DEFAULT '0.00' COMMENT '已提现金额',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `uniacid` (`uniacid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_pintuan_commiss`
--

LOCK TABLES `oscshop_lionfish_comshop_pintuan_commiss` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pintuan_commiss` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pintuan_commiss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_pintuan_commiss_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_pintuan_commiss_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_pintuan_commiss_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `uniacid` int(11) NOT NULL COMMENT '公众号id',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `order_id` int(10) NOT NULL COMMENT '订单ID',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '商品订单id',
  `type` tinyint(1) DEFAULT '1' COMMENT '1按照比例。2按照固定金额',
  `bili` float(10,2) DEFAULT '0.00' COMMENT '比例，如果是固定金额，那么这里就是固定金额',
  `store_id` int(10) NOT NULL COMMENT '店铺ID',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否结算：0，待计算。1，已结算。2，订单取消\r\n3、已打款',
  `money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '分佣金额',
  `statement_time` int(10) DEFAULT '0' COMMENT '结算时间',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE,
  KEY `uniacid` (`uniacid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_pintuan_commiss_order`
--

LOCK TABLES `oscshop_lionfish_comshop_pintuan_commiss_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pintuan_commiss_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pintuan_commiss_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_pintuan_tixian_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_pintuan_tixian_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_pintuan_tixian_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL,
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `service_charge` float(10,2) DEFAULT '0.00' COMMENT '提现手续费比例',
  `service_charge_money` float(10,2) DEFAULT '0.00' COMMENT '提现后实际到账金额',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0申请中，1提现成功，2体现失败',
  `shentime` int(10) NOT NULL COMMENT '审核时间',
  `type` tinyint(1) DEFAULT '0' COMMENT '1余额，2微信 3支付宝 4 银行卡',
  `bankname` varchar(255) DEFAULT NULL COMMENT '银行卡名称',
  `bankaccount` varchar(255) DEFAULT NULL COMMENT '卡号',
  `bankusername` varchar(255) DEFAULT NULL COMMENT '持卡人姓名',
  `addtime` int(10) NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分销佣金提现表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_pintuan_tixian_order`
--

LOCK TABLES `oscshop_lionfish_comshop_pintuan_tixian_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pintuan_tixian_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pintuan_tixian_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_pop_adv`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_pop_adv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_pop_adv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `adv_name` varchar(50) NOT NULL COMMENT '活动名称',
  `begin_time` int(10) DEFAULT '0' COMMENT '广告起始时间',
  `end_time` int(100) DEFAULT '0' COMMENT '广告结束时间',
  `send_person` tinyint(1) DEFAULT '0' COMMENT '投放类型：1、指定用户发送，2、按用户组等级发送，3、全部发送',
  `member_id` text COMMENT '关联会员编号',
  `member_group_id` int(11) DEFAULT '0' COMMENT '关联用户组',
  `pop_page` tinyint(1) DEFAULT '0' COMMENT '投放页面：0、商城首页，1、商品分类，2、商城购物车，3、商城个人中心',
  `is_index_show` tinyint(1) DEFAULT '0' COMMENT '首页访问页面时出现后，是否还出现：0、不再出现，1、再次出现',
  `show_hour` float(10,2) DEFAULT NULL,
  `status` tinyint(1) DEFAULT '0' COMMENT '活动状态：1、开启，0、关闭',
  `sort_order` int(10) DEFAULT '0' COMMENT '排序',
  `view_num` int(10) DEFAULT '0' COMMENT '查看次数',
  `open_num` int(10) DEFAULT '0' COMMENT '打开次数',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城弹窗广告活动';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_pop_adv`
--

LOCK TABLES `oscshop_lionfish_comshop_pop_adv` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pop_adv` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pop_adv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_pop_adv_list`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_pop_adv_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_pop_adv_list` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `ad_id` varchar(50) NOT NULL COMMENT '所属广告活动编号',
  `thumb` varchar(255) NOT NULL COMMENT '广告图片地址',
  `link` varchar(255) NOT NULL COMMENT '广告链接地址',
  `linktype` tinyint(1) NOT NULL DEFAULT '1' COMMENT '0外链 1小程序内 2外部小程序',
  `appid` varchar(255) NOT NULL COMMENT '外部小程序appid',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城弹窗广告内容';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_pop_adv_list`
--

LOCK TABLES `oscshop_lionfish_comshop_pop_adv_list` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pop_adv_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_pop_adv_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_printer`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_printer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_printer` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `printer_name` varchar(100) NOT NULL COMMENT '打印机名称',
  `printer_type` tinyint(1) NOT NULL DEFAULT '1' COMMENT '打印机类型：1、飞鹅打印机，2、易联云打印机',
  `api_id` varchar(100) DEFAULT NULL COMMENT '易联云应用id',
  `api_key` varchar(100) DEFAULT NULL COMMENT '易联云应用密钥key',
  `printer_sn` varchar(100) NOT NULL COMMENT '飞鹅sn值，易联云终端号',
  `printer_key` varchar(100) NOT NULL COMMENT '飞鹅key，易联云终端密钥',
  `printer_num` int(10) NOT NULL DEFAULT '0' COMMENT '打印联数',
  `status` tinyint(1) DEFAULT '0' COMMENT '状态：1、启用，0、禁用',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城打印机表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_printer`
--

LOCK TABLES `oscshop_lionfish_comshop_printer` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_printer` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_printer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_recipe`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_recipe`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_recipe` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `recipe_name` varchar(255) NOT NULL COMMENT '菜谱名称',
  `sub_name` varchar(255) DEFAULT NULL COMMENT '菜谱描述',
  `images` varchar(255) DEFAULT NULL COMMENT '菜谱图片',
  `video` varchar(255) DEFAULT NULL COMMENT '菜谱视频',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `cate_id` int(10) NOT NULL COMMENT '分类id',
  `make_time` varchar(100) DEFAULT NULL COMMENT '制作时间',
  `diff_type` tinyint(1) NOT NULL COMMENT '难易程度，1简单，2容易，3困难',
  `state` tinyint(1) DEFAULT NULL COMMENT '0禁用，1启用',
  `fav_count` int(10) DEFAULT '0' COMMENT '喜欢数',
  `content` text NOT NULL COMMENT '菜谱内容',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `cate_id` (`cate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城菜谱表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_recipe`
--

LOCK TABLES `oscshop_lionfish_comshop_recipe` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_recipe` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_recipe` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_recipe_fav`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_recipe_fav`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_recipe_fav` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `recipe_id` int(10) NOT NULL COMMENT '菜谱id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `recipe_id` (`recipe_id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城菜谱喜欢表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_recipe_fav`
--

LOCK TABLES `oscshop_lionfish_comshop_recipe_fav` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_recipe_fav` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_recipe_fav` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_recipe_ingredients`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_recipe_ingredients`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_recipe_ingredients` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `recipe_id` int(10) NOT NULL COMMENT '菜谱id',
  `goods_id` varchar(255) CHARACTER SET utf8mb4 DEFAULT NULL COMMENT '商品id,字符串多个逗号隔开 .',
  `title` varchar(255) NOT NULL COMMENT '食材标题',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `recipe_id` (`recipe_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城食材表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_recipe_ingredients`
--

LOCK TABLES `oscshop_lionfish_comshop_recipe_ingredients` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_recipe_ingredients` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_recipe_ingredients` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_salesroom`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_salesroom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_salesroom` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `supply_id` int(10) DEFAULT NULL COMMENT '商户id',
  `room_name` varchar(255) NOT NULL COMMENT '门店名称',
  `room_logo` varchar(255) NOT NULL COMMENT '门店logo',
  `province_id` varchar(10) NOT NULL COMMENT '省',
  `city_id` varchar(10) NOT NULL COMMENT '市',
  `country_id` varchar(10) NOT NULL COMMENT '区',
  `address` varchar(255) NOT NULL COMMENT '详细地址',
  `room_address` varchar(255) DEFAULT '0' COMMENT '门店地址',
  `lon` float NOT NULL COMMENT '经度',
  `lat` float NOT NULL COMMENT '纬度',
  `state` tinyint(1) NOT NULL COMMENT '状态，0禁用，1启用',
  `mobile` varchar(25) NOT NULL COMMENT '手机',
  `business_hours_begin` varchar(10) DEFAULT '0' COMMENT '营业开始时间',
  `business_hours_end` varchar(10) DEFAULT '0' COMMENT '营业结束时间',
  `business_hours` varchar(100) NOT NULL COMMENT '营业时间',
  `contacts` varchar(50) NOT NULL COMMENT '联系人',
  `introduction` text CHARACTER SET utf8mb4 NOT NULL COMMENT '门店介绍',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `disable_time` int(10) DEFAULT '0' COMMENT '禁用时间',
  `displayorder` int(10) NOT NULL COMMENT '排序，越大排序越前面',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `supply_id` (`supply_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='核销门店';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_salesroom`
--

LOCK TABLES `oscshop_lionfish_comshop_salesroom` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_salesroom` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_salesroom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_salesroom_member`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_salesroom_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_salesroom_member` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `supply_id` int(10) DEFAULT '0' COMMENT '商户id',
  `username` varchar(255) NOT NULL COMMENT '用户名',
  `mobile` varchar(25) NOT NULL COMMENT '手机号',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `state` tinyint(1) NOT NULL COMMENT '状态，0禁用，1启用',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `disable_time` int(10) DEFAULT '0' COMMENT '禁用时间',
  `last_salesroom_id` int(10) DEFAULT '0' COMMENT '上次门店信息',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='门店核销人员表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_salesroom_member`
--

LOCK TABLES `oscshop_lionfish_comshop_salesroom_member` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_salesroom_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_salesroom_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_salesroom_relative_member`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_salesroom_relative_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_salesroom_relative_member` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `salesroom_id` int(10) NOT NULL COMMENT '门店id',
  `smember_id` int(10) DEFAULT '0' COMMENT '核销会员id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `salesroom_id` (`salesroom_id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='门店核销人员跟门店关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_salesroom_relative_member`
--

LOCK TABLES `oscshop_lionfish_comshop_salesroom_relative_member` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_salesroom_relative_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_salesroom_relative_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_shipping`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_shipping`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_shipping` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(100) NOT NULL COMMENT '模板名称',
  `type` tinyint(1) NOT NULL COMMENT '1 按重量：，2 按件：，3：按体积',
  `sort_order` int(10) NOT NULL COMMENT '排序',
  `firstprice` decimal(10,2) NOT NULL COMMENT '首重价格',
  `secondprice` decimal(10,2) NOT NULL COMMENT '续重价格',
  `firstweight` int(11) NOT NULL COMMENT '首重 单位g',
  `secondweight` int(11) NOT NULL COMMENT '续重 单位g',
  `areas` longtext NOT NULL COMMENT '配送地区',
  `firstnum` int(11) NOT NULL COMMENT '首件',
  `secondnum` int(11) NOT NULL COMMENT '续件',
  `firstnumprice` decimal(10,2) NOT NULL COMMENT '首件价格',
  `secondnumprice` decimal(10,2) NOT NULL COMMENT '续件价格',
  `isdefault` tinyint(1) NOT NULL COMMENT '是否默认',
  `enabled` tinyint(1) DEFAULT '1' COMMENT '启用1:0关闭',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城运费模板表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_shipping`
--

LOCK TABLES `oscshop_lionfish_comshop_shipping` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_shipping` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_shipping` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_signinreward_record`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_signinreward_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_signinreward_record` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `continuity_day` int(10) NOT NULL COMMENT '连续签到几天',
  `reward_socre` int(10) NOT NULL COMMENT '赠送积分数量',
  `signin_time` int(10) NOT NULL COMMENT '签到时间',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城签到奖励记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_signinreward_record`
--

LOCK TABLES `oscshop_lionfish_comshop_signinreward_record` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_signinreward_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_signinreward_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_solitaire`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_solitaire`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_solitaire` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `head_id` int(10) NOT NULL COMMENT '团长id',
  `solitaire_name` varchar(255) NOT NULL COMMENT '接龙名称',
  `images_list` text COMMENT '图片列表',
  `addtype` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0平台添加，1团长添加',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0未审核，1已审核',
  `appstate` tinyint(1) DEFAULT '1' COMMENT '是否审核，1审核，0未审核',
  `begin_time` int(10) NOT NULL COMMENT '开始时间',
  `end_time` int(10) NOT NULL COMMENT '结束时间',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `content` text COMMENT '内容',
  `qrcode_image` varchar(255) DEFAULT NULL COMMENT '接龙二维码',
  `end` tinyint(1) DEFAULT '0' COMMENT '手动结束',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `head_id` (`head_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城群接龙活动表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_solitaire`
--

LOCK TABLES `oscshop_lionfish_comshop_solitaire` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_solitaire_goods`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_solitaire_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_solitaire_goods` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `soli_id` int(10) NOT NULL COMMENT '群接龙id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`soli_id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城接龙活动商品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_solitaire_goods`
--

LOCK TABLES `oscshop_lionfish_comshop_solitaire_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_solitaire_invite`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_solitaire_invite`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_solitaire_invite` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `soli_id` int(10) NOT NULL COMMENT '群接龙id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `soli_id` (`soli_id`,`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城群接龙访问记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_solitaire_invite`
--

LOCK TABLES `oscshop_lionfish_comshop_solitaire_invite` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_invite` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_invite` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_solitaire_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_solitaire_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_solitaire_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `soli_id` int(10) NOT NULL COMMENT '群接龙id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`soli_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城群接龙订单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_solitaire_order`
--

LOCK TABLES `oscshop_lionfish_comshop_solitaire_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_solitaire_post`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_solitaire_post`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_solitaire_post` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `soli_id` int(10) NOT NULL COMMENT '群接龙id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `pid` int(10) NOT NULL DEFAULT '0' COMMENT '回复id，默认0',
  `fav_count` int(10) NOT NULL COMMENT '点赞数',
  `content` text NOT NULL COMMENT '评论内容',
  `addtime` int(10) NOT NULL COMMENT '评论时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`,`soli_id`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城群接龙评论表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_solitaire_post`
--

LOCK TABLES `oscshop_lionfish_comshop_solitaire_post` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_post` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_post` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_solitaire_post_fav`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_solitaire_post_fav`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_solitaire_post_fav` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `soli_id` int(10) NOT NULL COMMENT '群接龙id',
  `post_id` int(10) NOT NULL COMMENT '评论id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`post_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城群接龙点赞表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_solitaire_post_fav`
--

LOCK TABLES `oscshop_lionfish_comshop_solitaire_post_fav` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_post_fav` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_solitaire_post_fav` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_spec`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_spec`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_spec` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(255) NOT NULL COMMENT '规格名称',
  `value` text NOT NULL COMMENT '规格值名称',
  `spec_type` enum('normal','pintuan') DEFAULT 'normal' COMMENT '商品规格类型，普通，拼团',
  `addtime` int(11) NOT NULL COMMENT '10',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城规格表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_spec`
--

LOCK TABLES `oscshop_lionfish_comshop_spec` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_spec` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_spec` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_special`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_special`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_special` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '专题id',
  `uniacid` int(11) DEFAULT '0' COMMENT '小程序id',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `cover` varchar(255) DEFAULT NULL COMMENT '封面',
  `goodsids` varchar(255) DEFAULT NULL COMMENT '商品id',
  `enabled` tinyint(1) DEFAULT '0' COMMENT '状态',
  `type` tinyint(1) DEFAULT '0' COMMENT '0单图 1图+商品',
  `special_title` varchar(255) DEFAULT NULL COMMENT '活动页面主题标题',
  `special_cover` varchar(255) DEFAULT NULL COMMENT '活动页面主题图片',
  `displayorder` int(10) DEFAULT '0' COMMENT '排序',
  `begin_time` int(10) NOT NULL COMMENT '活动开始时间',
  `end_time` int(10) NOT NULL COMMENT '活动结束时间',
  `is_index` tinyint(1) NOT NULL DEFAULT '1' COMMENT '首页显示',
  `index_pos` tinyint(1) NOT NULL DEFAULT '0' COMMENT '首页显示位置1底部',
  `show_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0小图，1大图',
  `bg_color` varchar(20) NOT NULL DEFAULT '#F6F6F6' COMMENT '背景颜色',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='后台专题管理';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_special`
--

LOCK TABLES `oscshop_lionfish_comshop_special` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_special` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_special` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_subscribe`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_subscribe`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_subscribe` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `template_id` varchar(255) NOT NULL COMMENT '模板',
  `type` enum('pay_order','send_order','hexiao_success','apply_community','open_tuan','take_tuan','pin_tuansuccess','apply_tixian','presale_ordercan_continuepay') NOT NULL COMMENT '消息类型',
  `addtime` int(10) NOT NULL COMMENT '订阅时间',
  PRIMARY KEY (`id`),
  KEY `uniacid` (`uniacid`),
  KEY `member_id` (`member_id`),
  KEY `member_id_2` (`member_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城用户订阅消息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_subscribe`
--

LOCK TABLES `oscshop_lionfish_comshop_subscribe` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_subscribe` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_subscribe` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_supply`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_supply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_supply` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `shopname` varchar(255) NOT NULL COMMENT '店铺名称',
  `name` varchar(100) NOT NULL COMMENT '供应商名称',
  `member_id` int(10) DEFAULT '0' COMMENT '关联会员id',
  `logo` varchar(255) DEFAULT NULL COMMENT 'logo',
  `storename` varchar(255) NOT NULL COMMENT '店铺名称',
  `banner` varchar(255) DEFAULT NULL COMMENT '店铺顶部图',
  `product` varchar(1000) DEFAULT NULL COMMENT '产品说明',
  `mobile` varchar(50) NOT NULL COMMENT '供应商手机号',
  `state` tinyint(1) NOT NULL COMMENT '供应商状态，0未审核，1已审核',
  `type` tinyint(1) DEFAULT '0' COMMENT '0 平台自营，1入驻',
  `is_open_mobilemanage` tinyint(1) DEFAULT '0' COMMENT '0关闭，1开启',
  `commiss_bili` int(10) DEFAULT '0' COMMENT '供应商提成。百分比',
  `apptime` int(10) DEFAULT NULL COMMENT '申请时间',
  `login_name` varchar(50) DEFAULT NULL COMMENT '供应商登录名称',
  `login_password` varchar(100) DEFAULT NULL COMMENT '供应商登录密码',
  `login_slat` varchar(50) DEFAULT NULL COMMENT '密码盐值',
  `qualifications` text COMMENT '工商资质',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼社区团购供应商表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_supply`
--

LOCK TABLES `oscshop_lionfish_comshop_supply` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_supply` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_supply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_supply_config`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_supply_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_supply_config` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `value` text NOT NULL,
  `supply_id` int(10) NOT NULL COMMENT '供应商id',
  PRIMARY KEY (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼供应商配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_supply_config`
--

LOCK TABLES `oscshop_lionfish_comshop_supply_config` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_supply_config` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_supply_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_systemoperation_log`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_systemoperation_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_systemoperation_log` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `operation_type` enum('detailed_list','order','goods','user','communityhead','supply','salesroom','article','group','marketing','generalmall','delivery','perm','attachment','config') NOT NULL COMMENT '操作类型，detailed_list清单，order订单，goods商品，user会员，communityhead团长，supply供应商，salesroom门店，article文章，group拼团，marketing营销，generalmall仅快递,delivery配送，perm权限，attachment附件，config设置',
  `operation_seller_id` int(10) NOT NULL COMMENT '管理员id',
  `operation_seller_name` varchar(50) NOT NULL COMMENT '管理员名称',
  `ip` varchar(50) NOT NULL COMMENT 'ip',
  `content` text NOT NULL COMMENT '操作内容',
  `addtime` int(10) NOT NULL COMMENT '操作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城系统操作日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_systemoperation_log`
--

LOCK TABLES `oscshop_lionfish_comshop_systemoperation_log` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_systemoperation_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_systemoperation_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_templatemsg`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_templatemsg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_templatemsg` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `uniacid` int(10) NOT NULL COMMENT '公众号id',
  `template_data` text NOT NULL COMMENT '发送数据',
  `url` varchar(255) DEFAULT NULL COMMENT '点击url',
  `open_id` varchar(255) NOT NULL COMMENT 'openid',
  `template_id` varchar(255) NOT NULL COMMENT '模板id',
  `type` tinyint(1) NOT NULL COMMENT '0 非群发，1 发送给所有人',
  `state` tinyint(1) NOT NULL COMMENT '0未发送状态，1已发送',
  `total_count` int(10) DEFAULT NULL COMMENT '一共多少条',
  `send_total_count` int(10) DEFAULT '0' COMMENT '已经发送了多少条',
  `addtime` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城群发模板消息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_templatemsg`
--

LOCK TABLES `oscshop_lionfish_comshop_templatemsg` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_templatemsg` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_templatemsg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_user_favgoods`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_user_favgoods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_user_favgoods` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城商品收藏表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_user_favgoods`
--

LOCK TABLES `oscshop_lionfish_comshop_user_favgoods` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_user_favgoods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_user_favgoods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_virtualcard_codes`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_virtualcard_codes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_virtualcard_codes` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `code_name` varchar(255) NOT NULL COMMENT '兑换码名称',
  `effect_type` tinyint(1) NOT NULL COMMENT '0 永久 ， 1限时',
  `effect_days` int(10) NOT NULL COMMENT '限时兑换购买后几天',
  `code_money` decimal(10,2) NOT NULL COMMENT '兑换码金额',
  `state` tinyint(1) NOT NULL COMMENT '状态，0禁用，1正常',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼品兑换码表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_virtualcard_codes`
--

LOCK TABLES `oscshop_lionfish_comshop_virtualcard_codes` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_virtualcard_codes` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_virtualcard_codes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_virtualcard_limit_user`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_virtualcard_limit_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_virtualcard_limit_user` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `user_id` int(10) NOT NULL COMMENT '封禁用户id',
  `limit_endtime` int(10) NOT NULL COMMENT '封禁截止时间',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='被封禁的用户';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_virtualcard_limit_user`
--

LOCK TABLES `oscshop_lionfish_comshop_virtualcard_limit_user` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_virtualcard_limit_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_virtualcard_limit_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_virtualcard_limituser_error`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_virtualcard_limituser_error`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_virtualcard_limituser_error` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `user_id` int(10) NOT NULL COMMENT '用户id',
  `addtime` int(10) NOT NULL COMMENT '错误时间',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='兑换错误日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_virtualcard_limituser_error`
--

LOCK TABLES `oscshop_lionfish_comshop_virtualcard_limituser_error` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_virtualcard_limituser_error` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_virtualcard_limituser_error` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_virtualcard_userecord`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_virtualcard_userecord`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_virtualcard_userecord` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `code_sn` varchar(200) NOT NULL COMMENT '兑换码序号',
  `code_id` int(10) NOT NULL COMMENT '兑换码id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `money` decimal(10,2) NOT NULL COMMENT '兑换码抵扣金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `use_user_id` int(10) NOT NULL COMMENT '使用人',
  PRIMARY KEY (`id`),
  KEY `id` (`id`,`code_id`,`order_id`,`use_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='兑换码使用记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_virtualcard_userecord`
--

LOCK TABLES `oscshop_lionfish_comshop_virtualcard_userecord` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_virtualcard_userecord` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_virtualcard_userecord` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_weprogram_token`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_weprogram_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_weprogram_token` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `token` varchar(255) NOT NULL COMMENT '会员标识',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `session_key` varchar(100) NOT NULL COMMENT '保持登录的session',
  `expires_in` int(10) NOT NULL COMMENT '过期时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COMMENT='狮子鱼商城小程序会员token表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_weprogram_token`
--

LOCK TABLES `oscshop_lionfish_comshop_weprogram_token` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_weprogram_token` DISABLE KEYS */;
INSERT INTO `oscshop_lionfish_comshop_weprogram_token` VALUES (3,'6c39a5622e37f5c2106613eca366ef16',1,'X+R1507kBClBKIfKs5DwKw==',1582453902),(4,'8f2a369e7f37035f6f96b556fcc9fbdf',2,'zVVTXc8vF+MJPKE+dX4BLw==',1582474534),(5,'0268c1a45ff93e7c2e0c130689e48d08',3,'00GOBY9mmyvhbbvIB9J9/A==',1582474535),(6,'b74d2f2ee1bc52f8bc56d07270e5e95e',4,'uc0UovN8gPoxtVSjwDmsPw==',1582604191),(7,'c666294688f88d62e8b54687841f295f',5,'PeyTaSha2pA2moZ2KBIDLA==',1582626271);
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_weprogram_token` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_wxlive`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_wxlive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_wxlive` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `share_img` varchar(255) DEFAULT NULL COMMENT '分享封面',
  `roomid` int(11) NOT NULL COMMENT '直播间id',
  `name` varchar(255) DEFAULT NULL COMMENT '标题',
  `cover_img` varchar(255) DEFAULT NULL COMMENT '封面',
  `live_status` int(5) DEFAULT NULL COMMENT '直播状态',
  `start_time` int(11) DEFAULT NULL COMMENT '开始时间',
  `end_time` int(11) DEFAULT NULL COMMENT '结束时间',
  `anchor_name` varchar(200) DEFAULT NULL COMMENT '主播',
  `anchor_img` varchar(255) DEFAULT NULL COMMENT '主播头像',
  `goods` text COMMENT '商品',
  `live_replay` text COMMENT '回放内容',
  `is_top` int(10) DEFAULT '0' COMMENT '置顶',
  `is_show` tinyint(1) NOT NULL DEFAULT '1' COMMENT '是否显示',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='微信直播插件';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_wxlive`
--

LOCK TABLES `oscshop_lionfish_comshop_wxlive` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_wxlive` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_wxlive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_comshop_wxlive_replay`
--

DROP TABLE IF EXISTS `oscshop_lionfish_comshop_wxlive_replay`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_comshop_wxlive_replay` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `live_id` int(11) DEFAULT NULL COMMENT '列表id',
  `roomid` int(11) DEFAULT NULL COMMENT '直播间id',
  `expire_time` int(11) DEFAULT NULL COMMENT '过期时间',
  `create_time` int(11) DEFAULT NULL COMMENT '创建时间',
  `media_url` varchar(255) DEFAULT NULL COMMENT '视频链接',
  `add_time` int(11) DEFAULT '0' COMMENT '添加时间',
  `more` text COMMENT '其他信息',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='直播回放';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_comshop_wxlive_replay`
--

LOCK TABLES `oscshop_lionfish_comshop_wxlive_replay` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_wxlive_replay` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_comshop_wxlive_replay` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_supply_commiss`
--

DROP TABLE IF EXISTS `oscshop_lionfish_supply_commiss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_supply_commiss` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `supply_id` int(10) NOT NULL COMMENT '供应商ID',
  `money` float(10,2) DEFAULT '0.00' COMMENT '可提现金额',
  `dongmoney` float(10,2) DEFAULT '0.00' COMMENT '提现中金额',
  `getmoney` float(10,2) DEFAULT '0.00' COMMENT '已提现金额',
  PRIMARY KEY (`id`),
  KEY `supply_id` (`supply_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_supply_commiss`
--

LOCK TABLES `oscshop_lionfish_supply_commiss` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_supply_commiss` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_supply_commiss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_supply_commiss_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_supply_commiss_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_supply_commiss_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `supply_id` int(10) NOT NULL COMMENT '供应商id',
  `order_id` int(10) NOT NULL COMMENT '订单ID',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '商品订单id',
  `total_money` float(10,2) DEFAULT '0.00' COMMENT '总金额',
  `comunity_blili` float(10,2) DEFAULT '0.00' COMMENT '服务费比例',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否结算：0，待计算。1，已结算。2，订单取消',
  `head_commiss_money` float(10,2) DEFAULT '0.00' COMMENT '团长分佣金额',
  `member_commiss_money` float(10,2) DEFAULT '0.00' COMMENT '会员分销金额',
  `money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '分佣金额',
  `shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '独立供应商有运费',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `supply_id` (`supply_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_supply_commiss_order`
--

LOCK TABLES `oscshop_lionfish_supply_commiss_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_supply_commiss_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_supply_commiss_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lionfish_supply_tixian_order`
--

DROP TABLE IF EXISTS `oscshop_lionfish_supply_tixian_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lionfish_supply_tixian_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `supply_id` int(10) NOT NULL COMMENT '团长id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `supply_apply_type` tinyint(1) DEFAULT '0' COMMENT '供应商提现类型：0原来默认，1 微信 2 支付宝 3银行卡',
  `service_charge` float(10,2) DEFAULT '0.00' COMMENT '手续费',
  `server_bili` float(10,2) DEFAULT '0.00' COMMENT '服务费比例',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0申请中，1提现成功，2体现失败',
  `shentime` int(10) NOT NULL COMMENT '审核时间',
  `is_send_fail` tinyint(1) DEFAULT '0' COMMENT '是否发送是否，1是，0否',
  `fail_msg` varchar(255) DEFAULT NULL COMMENT '发送失败原因',
  `bankname` varchar(200) DEFAULT NULL COMMENT '转账类型。微信，支付宝，银行',
  `bankaccount` varchar(200) DEFAULT NULL COMMENT '账户',
  `bankusername` varchar(200) DEFAULT NULL COMMENT '持卡人姓名',
  `addtime` int(10) NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `supply_id` (`supply_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分销佣金提现表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lionfish_supply_tixian_order`
--

LOCK TABLES `oscshop_lionfish_supply_tixian_order` WRITE;
/*!40000 ALTER TABLE `oscshop_lionfish_supply_tixian_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lionfish_supply_tixian_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_log`
--

DROP TABLE IF EXISTS `oscshop_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_log` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `text` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_log`
--

LOCK TABLES `oscshop_log` WRITE;
/*!40000 ALTER TABLE `oscshop_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_lottery_goods`
--

DROP TABLE IF EXISTS `oscshop_lottery_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_lottery_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `state` tinyint(1) NOT NULL COMMENT '抽奖状态，0申请中，1已通过，2已下架',
  `is_open_lottery` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0未开奖，1已开奖',
  `voucher_id` int(11) NOT NULL DEFAULT '0' COMMENT '指定退款赠送券代号',
  `quantity` int(11) NOT NULL COMMENT '商品数量',
  `is_auto_open` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否自动开奖',
  `win_quantity` int(10) NOT NULL DEFAULT '5' COMMENT '中奖人数',
  `real_win_quantity` int(10) NOT NULL DEFAULT '0' COMMENT '自动开奖时，真实中奖人数',
  `begin_time` int(11) NOT NULL COMMENT '开始时间',
  `end_time` int(11) NOT NULL COMMENT '结束时间',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  `seller_id` int(10) DEFAULT '0' COMMENT '商家id',
  PRIMARY KEY (`id`),
  KEY `state` (`state`,`quantity`,`begin_time`,`end_time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_lottery_goods`
--

LOCK TABLES `oscshop_lottery_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_lottery_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_lottery_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_mb_special`
--

DROP TABLE IF EXISTS `oscshop_mb_special`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_mb_special` (
  `special_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '专题编号',
  `special_desc` varchar(20) NOT NULL COMMENT '专题描述',
  `special_bgcolor` varchar(20) NOT NULL COMMENT '专题背景颜色',
  `share_image` varchar(255) DEFAULT NULL COMMENT '分享图片',
  `share_descript` varchar(255) DEFAULT NULL COMMENT '分享描述',
  `share_title` varchar(255) DEFAULT NULL COMMENT '分享标题',
  `special_bgimage` varchar(255) NOT NULL COMMENT '专题图片',
  PRIMARY KEY (`special_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='专题表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_mb_special`
--

LOCK TABLES `oscshop_mb_special` WRITE;
/*!40000 ALTER TABLE `oscshop_mb_special` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_mb_special` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_mb_special_item`
--

DROP TABLE IF EXISTS `oscshop_mb_special_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_mb_special_item` (
  `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '专题项目编号',
  `special_id` int(10) unsigned NOT NULL COMMENT '专题编号',
  `item_type` varchar(50) NOT NULL COMMENT '项目类型',
  `item_data` varchar(2000) NOT NULL COMMENT '项目内容',
  `item_usable` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '项目是否可用 0-不可用 1-可用',
  `item_sort` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '项目排序',
  PRIMARY KEY (`item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='专题项目表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_mb_special_item`
--

LOCK TABLES `oscshop_mb_special_item` WRITE;
/*!40000 ALTER TABLE `oscshop_mb_special_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_mb_special_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member`
--

DROP TABLE IF EXISTS `oscshop_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member` (
  `member_id` int(11) NOT NULL AUTO_INCREMENT,
  `openid` varchar(200) NOT NULL COMMENT '微信openid',
  `we_openid` varchar(100) DEFAULT NULL COMMENT '小程序openid',
  `unionid` varchar(200) DEFAULT NULL COMMENT 'unionid 同步多个应用之间的会员信息',
  `reg_type` enum('weixin','weprogram') DEFAULT 'weixin' COMMENT '登录类型',
  `bindmobile` varchar(50) DEFAULT NULL COMMENT '绑定手机号',
  `uname` varchar(20) NOT NULL COMMENT '用户名',
  `username` varchar(255) DEFAULT NULL COMMENT '会员名称',
  `full_user_name` varchar(200) DEFAULT NULL COMMENT '会员完成名称',
  `email` varchar(255) NOT NULL,
  `name` varchar(50) NOT NULL COMMENT '姓名',
  `avatar` varchar(255) NOT NULL,
  `pwd` varchar(255) NOT NULL,
  `account_money` decimal(10,2) DEFAULT '0.00' COMMENT '会员余额',
  `wepro_qrcode` varchar(255) DEFAULT NULL COMMENT '小程序个人二维码',
  `telephone` varchar(32) NOT NULL,
  `address_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户收货地址',
  `share_id` int(11) NOT NULL DEFAULT '0' COMMENT '上级ID，0表示无上级，',
  `score` float(10,2) DEFAULT '0.00' COMMENT '会员积分',
  `level_id` int(10) DEFAULT '0' COMMENT '等级id',
  `comsiss_flag` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否分销商，0非分销，1分销商',
  `bind_seller_id` int(11) NOT NULL DEFAULT '0' COMMENT '接受商家通知的微信号',
  `bind_seller_pickup` int(10) DEFAULT '0' COMMENT '店铺核销管理员',
  `cart` text NOT NULL COMMENT '购物车',
  `wishlist` text NOT NULL COMMENT '收藏',
  `id_cardreal_name` varchar(200) DEFAULT NULL COMMENT '海淘身份证真实姓名',
  `id_card` varchar(200) DEFAULT NULL COMMENT '身份证号码',
  `login_count` int(11) NOT NULL DEFAULT '0',
  `last_login_ip` varchar(40) NOT NULL DEFAULT '0',
  `last_ip_region` varchar(64) NOT NULL DEFAULT '0',
  `create_time` int(11) NOT NULL,
  `last_login_time` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(2) NOT NULL,
  PRIMARY KEY (`member_id`),
  UNIQUE KEY `openid` (`openid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='网站会员';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member`
--

LOCK TABLES `oscshop_member` WRITE;
/*!40000 ALTER TABLE `oscshop_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_charge_flow`
--

DROP TABLE IF EXISTS `oscshop_member_charge_flow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_charge_flow` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `trans_id` varchar(100) DEFAULT NULL COMMENT '交易号',
  `money` decimal(10,2) NOT NULL COMMENT '充值金额',
  `state` tinyint(1) NOT NULL COMMENT '6 裂变红包',
  `charge_time` int(10) NOT NULL COMMENT '充值时间',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狮子鱼商城会员充值记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_charge_flow`
--

LOCK TABLES `oscshop_member_charge_flow` WRITE;
/*!40000 ALTER TABLE `oscshop_member_charge_flow` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_charge_flow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_commiss`
--

DROP TABLE IF EXISTS `oscshop_member_commiss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_commiss` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `money` float(10,2) DEFAULT '0.00' COMMENT '可提现金额',
  `dongmoney` float(10,2) DEFAULT '0.00' COMMENT '提现中金额',
  `getmoney` float(10,2) DEFAULT '0.00' COMMENT '已提现金额',
  `bankname` varchar(200) DEFAULT NULL COMMENT '银行名称',
  `bankaccount` varchar(200) DEFAULT NULL COMMENT '卡号',
  `bankusername` varchar(200) DEFAULT NULL COMMENT '持卡人姓名',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_commiss`
--

LOCK TABLES `oscshop_member_commiss` WRITE;
/*!40000 ALTER TABLE `oscshop_member_commiss` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_commiss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_commiss_apply`
--

DROP TABLE IF EXISTS `oscshop_member_commiss_apply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_commiss_apply` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `state` tinyint(1) NOT NULL COMMENT '审核状态，0申请中，1已通过，2拒绝',
  `addtime` int(10) NOT NULL COMMENT '申请时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_commiss_apply`
--

LOCK TABLES `oscshop_member_commiss_apply` WRITE;
/*!40000 ALTER TABLE `oscshop_member_commiss_apply` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_commiss_apply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_commiss_order`
--

DROP TABLE IF EXISTS `oscshop_member_commiss_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_commiss_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `child_member_id` int(10) NOT NULL COMMENT '下级会员ID',
  `order_id` int(10) NOT NULL COMMENT '订单ID',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '商品订单id',
  `level` int(10) DEFAULT '1' COMMENT '第几层分佣',
  `store_id` int(10) NOT NULL COMMENT '店铺ID',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否结算：0，待计算。1，已结算。2，订单取消',
  `money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '分佣金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_commiss_order`
--

LOCK TABLES `oscshop_member_commiss_order` WRITE;
/*!40000 ALTER TABLE `oscshop_member_commiss_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_commiss_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_common`
--

DROP TABLE IF EXISTS `oscshop_member_common`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_common` (
  `member_id` int(10) NOT NULL AUTO_INCREMENT COMMENT '会员id',
  `qrcode_img` varchar(255) DEFAULT NULL COMMENT '团长二维码背景',
  PRIMARY KEY (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='会员公共信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_common`
--

LOCK TABLES `oscshop_member_common` WRITE;
/*!40000 ALTER TABLE `oscshop_member_common` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_common` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_formid`
--

DROP TABLE IF EXISTS `oscshop_member_formid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_formid` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `state` tinyint(1) NOT NULL COMMENT '状态，0未使用，已使用',
  `formid` varchar(100) NOT NULL COMMENT '用来群发使用的',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='会员的群发formid表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_formid`
--

LOCK TABLES `oscshop_member_formid` WRITE;
/*!40000 ALTER TABLE `oscshop_member_formid` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_formid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_level`
--

DROP TABLE IF EXISTS `oscshop_member_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_level` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `level` int(11) NOT NULL COMMENT '等级',
  `levelname` varchar(100) NOT NULL COMMENT '等级名称',
  `level_money` decimal(10,2) DEFAULT '0.00' COMMENT '会员升级金额',
  `discount` decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '折扣',
  `logo` varchar(255) DEFAULT NULL COMMENT '会员等级logo',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='会员等级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_level`
--

LOCK TABLES `oscshop_member_level` WRITE;
/*!40000 ALTER TABLE `oscshop_member_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_sharing`
--

DROP TABLE IF EXISTS `oscshop_member_sharing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_sharing` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `money` float(10,2) DEFAULT '0.00' COMMENT '可提现金额',
  `dongmoney` float(10,2) DEFAULT '0.00' COMMENT '提现中金额',
  `getmoney` float(10,2) DEFAULT '0.00' COMMENT '已提现金额',
  `bankname` varchar(200) DEFAULT NULL COMMENT '银行名称',
  `bankaccount` varchar(200) DEFAULT NULL COMMENT '卡号',
  `bankusername` varchar(200) DEFAULT NULL COMMENT '持卡人姓名',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_sharing`
--

LOCK TABLES `oscshop_member_sharing` WRITE;
/*!40000 ALTER TABLE `oscshop_member_sharing` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_sharing` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_member_sharing_order`
--

DROP TABLE IF EXISTS `oscshop_member_sharing_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_member_sharing_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `member_id` int(10) NOT NULL COMMENT '会员ID',
  `child_member_id` int(10) NOT NULL COMMENT '下级会员ID',
  `order_id` int(10) NOT NULL COMMENT '订单ID',
  `order_goods_id` int(10) DEFAULT '0' COMMENT '商品订单id',
  `level` int(10) DEFAULT '1' COMMENT '第几层分佣',
  `store_id` int(10) NOT NULL COMMENT '店铺ID',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否结算：0，待计算。1，已结算。2，订单取消',
  `money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '分佣金额',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_member_sharing_order`
--

LOCK TABLES `oscshop_member_sharing_order` WRITE;
/*!40000 ALTER TABLE `oscshop_member_sharing_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_member_sharing_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_menu`
--

DROP TABLE IF EXISTS `oscshop_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_menu` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '文档ID',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上级分类ID',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '标题',
  `url` char(255) NOT NULL DEFAULT '' COMMENT '链接地址',
  `icon` varchar(20) NOT NULL,
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '排序（同级有效）',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=78 DEFAULT CHARSET=utf8 COMMENT='后台菜单';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_menu`
--

LOCK TABLES `oscshop_menu` WRITE;
/*!40000 ALTER TABLE `oscshop_menu` DISABLE KEYS */;
INSERT INTO `oscshop_menu` VALUES (1,0,'系统','','icon-dashboard',7),(13,0,'插件','','icon-key',6),(19,28,'商品分类','GoodsCategory/index','',2),(20,13,'广告位','PluginsSlider/index','',1),(23,13,'帮助列表','Blog/index','',1),(28,0,'商品','','icon-gift',1),(29,28,'商品管理','Goods/index','',1),(35,0,'订单','','icon-credit-card',2),(36,35,'订单管理','Order/index','',1),(37,1,'系统配置','','',0),(38,37,'站点设置','settings/general','',1),(43,0,'用户','','icon-group',3),(44,43,'前台用户','member/index','',1),(49,0,'控制台','Index/index','icon-globe',0),(50,47,'角色管理','Roles/index','',1),(51,1,'管理员信息','AdminUser/index','',0),(53,59,'卖家管理','SellerManage/index','',3),(54,58,'限时秒杀活动商品','Spike/index','',2),(56,58,'主题活动','Subject/index','',4),(57,58,'抽奖活动','Lottery/index','',5),(58,1000,'营销活动','','icon-bookmark',4),(59,0,'商家管理','','icon-glass',3),(60,0,'结算中心','','icon-file-alt',5),(61,60,'结算管理','Balance/index','',0),(62,0,'平台优惠券','','icon-film',3),(63,62,'平台券管理','Voucher/index','',0),(64,60,'申请提现','Balance/assets','',2),(65,28,'活动商品管理','Goods/activity','',2),(67,0,'入驻中心','','icon-beer',5),(68,67,'申请管理','SellerManage/apply','',0),(70,1,'微信模板消息','settings/wxtempmsg','',2),(71,0,'快递配置','SellerManage/express','icon-cogs',6),(75,13,'专题管理','Special/index','',2),(76,35,'拼团管理','Pin/index','',3),(77,1,'微信小程序配置','settings/wxprogram','',3);
/*!40000 ALTER TABLE `oscshop_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_node`
--

DROP TABLE IF EXISTS `oscshop_node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_node` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `pid` int(11) NOT NULL COMMENT '父节点id',
  `name` varchar(32) NOT NULL COMMENT '节点名称',
  `title` varchar(32) NOT NULL COMMENT '节点标题',
  `level` tinyint(4) NOT NULL COMMENT '节点等级',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '节点状态',
  `created_at` int(11) NOT NULL COMMENT '创建时间',
  `updated_at` int(11) NOT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 COMMENT='节点表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_node`
--

LOCK TABLES `oscshop_node` WRITE;
/*!40000 ALTER TABLE `oscshop_node` DISABLE KEYS */;
INSERT INTO `oscshop_node` VALUES (1,0,'admin','后台管理',1,1,1470035346,1470035346),(2,1,'Index','控制台',2,1,1470035523,1470035523),(3,2,'index','查看控制台',3,1,1470035553,1470035553),(4,1,'Member','用户',2,1,1470035631,1470035631),(5,4,'index','前台用户',3,1,1470035681,1470035681),(6,4,'add','新增用户',3,1,1470035711,1470035711),(7,1,'SellerManage','卖家管理',2,1,1470315633,1470315633),(8,7,'add','新增卖家',3,1,1470315721,1470315721);
/*!40000 ALTER TABLE `oscshop_node` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_notify_order`
--

DROP TABLE IF EXISTS `oscshop_notify_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_notify_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `username` varchar(255) NOT NULL COMMENT '会员名称',
  `member_id` int(10) DEFAULT '0',
  `avatar` varchar(255) NOT NULL COMMENT '头像',
  `order_time` int(10) NOT NULL COMMENT '购买时间',
  `order_id` int(10) DEFAULT '0' COMMENT '订单id',
  `state` tinyint(1) NOT NULL COMMENT '状态，0未发送，1已发送',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  `order_url` varchar(100) NOT NULL COMMENT '订单id',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='最新订单消息通知';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_notify_order`
--

LOCK TABLES `oscshop_notify_order` WRITE;
/*!40000 ALTER TABLE `oscshop_notify_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_notify_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_option`
--

DROP TABLE IF EXISTS `oscshop_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_option` (
  `option_id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(32) NOT NULL,
  `store_id` int(11) NOT NULL DEFAULT '0' COMMENT '所属商家id',
  `name` varchar(128) NOT NULL,
  `value` text NOT NULL,
  `update_time` datetime NOT NULL,
  PRIMARY KEY (`option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='产品选项';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_option`
--

LOCK TABLES `oscshop_option` WRITE;
/*!40000 ALTER TABLE `oscshop_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_option_value`
--

DROP TABLE IF EXISTS `oscshop_option_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_option_value` (
  `option_value_id` int(11) NOT NULL AUTO_INCREMENT,
  `option_id` int(11) NOT NULL,
  `value_name` varchar(128) NOT NULL,
  `value_sort_order` int(3) NOT NULL,
  PRIMARY KEY (`option_value_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='选项值';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_option_value`
--

LOCK TABLES `oscshop_option_value` WRITE;
/*!40000 ALTER TABLE `oscshop_option_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_option_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order`
--

DROP TABLE IF EXISTS `oscshop_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order` (
  `order_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_num_alias` varchar(40) NOT NULL COMMENT '订单编号',
  `member_id` int(11) NOT NULL,
  `store_id` int(11) NOT NULL DEFAULT '0' COMMENT '商家id',
  `type` enum('pintuan','normal','lottery','virtual','bargain','integral') DEFAULT 'normal',
  `is_pin` tinyint(1) DEFAULT '0' COMMENT '是否拼团，0表示否，1表示是',
  `from_type` enum('weixin','wepro') DEFAULT 'weixin' COMMENT '订单来源：weixin表示服务号，wepro表示小程序',
  `perpay_id` varchar(255) DEFAULT NULL COMMENT '预支付id',
  `name` varchar(32) NOT NULL COMMENT '购买的会员名字',
  `email` varchar(96) NOT NULL,
  `telephone` varchar(32) NOT NULL COMMENT '下单会员电话',
  `delivery` enum('express','pickup') DEFAULT 'express' COMMENT '配送类型',
  `shipping_name` varchar(32) NOT NULL COMMENT '收货人姓名',
  `address_id` int(11) NOT NULL,
  `shipping_tel` varchar(20) NOT NULL COMMENT '收货人电话',
  `shipping_city_id` int(11) NOT NULL,
  `shipping_country_id` int(11) NOT NULL,
  `shipping_province_id` int(11) NOT NULL,
  `shipping_address` varchar(255) NOT NULL COMMENT '快递详细地址',
  `shipping_method` int(11) NOT NULL DEFAULT '0' COMMENT '货运方式，快递类型',
  `shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '运费',
  `shipping_no` varchar(255) DEFAULT '0' COMMENT '快递单号',
  `shipping_traces` text COMMENT '物流轨迹',
  `payment_code` varchar(128) NOT NULL COMMENT '支付方式',
  `transaction_id` varchar(100) NOT NULL COMMENT '微信支付交易号',
  `comment` text NOT NULL,
  `total` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `voucher_id` int(11) NOT NULL DEFAULT '0' COMMENT '优惠券id',
  `voucher_credit` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '优惠券金额',
  `order_status_id` int(11) NOT NULL,
  `is_balance` tinyint(1) NOT NULL DEFAULT '0' COMMENT '未结算',
  `lottery_win` tinyint(1) DEFAULT '0' COMMENT '0未中奖，1中奖',
  `ip` varchar(40) NOT NULL,
  `is_zhuli` tinyint(1) DEFAULT '0' COMMENT '是否砍价，0标识否，2标识砍价',
  `ip_region` varchar(20) NOT NULL,
  `user_agent` varchar(255) NOT NULL COMMENT '用户系统信息',
  `date_added` int(11) NOT NULL,
  `date_modified` int(11) NOT NULL,
  `pay_time` int(11) NOT NULL COMMENT '付款时间',
  `express_time` int(10) DEFAULT '0' COMMENT '发货时间',
  `shipping_cha_time` int(10) DEFAULT '0' COMMENT '查询时间',
  PRIMARY KEY (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order`
--

LOCK TABLES `oscshop_order` WRITE;
/*!40000 ALTER TABLE `oscshop_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_all`
--

DROP TABLE IF EXISTS `oscshop_order_all`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_all` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id，',
  `member_id` int(10) NOT NULL COMMENT '所属会员',
  `is_pin` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否拼团订单',
  `total_money` float(10,2) DEFAULT '0.00' COMMENT '总需要支付金额',
  `order_num_alias` varchar(200) DEFAULT NULL COMMENT '支付的订单号',
  `order_status_id` int(10) NOT NULL COMMENT '订单状态id',
  `transaction_id` varchar(255) DEFAULT NULL COMMENT '微信交易号',
  `paytime` int(10) NOT NULL COMMENT '支付时间',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='订单总表，支付时候使用';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_all`
--

LOCK TABLES `oscshop_order_all` WRITE;
/*!40000 ALTER TABLE `oscshop_order_all` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_all` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_comment`
--

DROP TABLE IF EXISTS `oscshop_order_comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_comment` (
  `comment_id` int(10) NOT NULL AUTO_INCREMENT COMMENT '评论id',
  `order_id` int(10) NOT NULL DEFAULT '0' COMMENT '订单id',
  `goods_id` int(10) NOT NULL DEFAULT '0' COMMENT '商品id',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否显示，0审核中，1：显示',
  `member_id` int(10) NOT NULL DEFAULT '0' COMMENT '会员id',
  `goods_name` varchar(255) DEFAULT NULL COMMENT '商品名称',
  `goods_image` varchar(255) DEFAULT NULL COMMENT '商品图片',
  `order_num_alias` varchar(100) DEFAULT NULL COMMENT '订单编号',
  `avatar` varchar(255) DEFAULT NULL COMMENT '头像',
  `user_name` varchar(100) DEFAULT NULL COMMENT '昵称',
  `type` tinyint(1) DEFAULT '0' COMMENT '0真实评价，1虚拟评价',
  `star` int(10) NOT NULL DEFAULT '5' COMMENT '评价星级',
  `star3` int(10) DEFAULT NULL COMMENT '质量满意',
  `star2` int(10) DEFAULT NULL COMMENT '价格合理',
  `images` text COMMENT '图片',
  `is_picture` tinyint(1) DEFAULT '0' COMMENT '是否有图片',
  `content` text NOT NULL COMMENT '评价内容',
  `add_time` int(10) NOT NULL DEFAULT '0' COMMENT '评价时间',
  PRIMARY KEY (`comment_id`),
  KEY `goods_id` (`goods_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_comment`
--

LOCK TABLES `oscshop_order_comment` WRITE;
/*!40000 ALTER TABLE `oscshop_order_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_goods`
--

DROP TABLE IF EXISTS `oscshop_order_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_goods` (
  `order_goods_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `goods_id` int(11) NOT NULL,
  `store_id` int(11) NOT NULL DEFAULT '0' COMMENT '商家id',
  `is_pin` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否拼团商品订单，0：单独购买，1：拼团商品',
  `pin_id` int(10) DEFAULT NULL,
  `shipping_fare` float(10,2) DEFAULT '0.00' COMMENT '运费',
  `name` varchar(255) NOT NULL,
  `head_disc` int(10) DEFAULT '100' COMMENT '团长折扣',
  `member_disc` int(10) DEFAULT '100' COMMENT '会员折扣，100 表示不打折',
  `level_name` varchar(200) DEFAULT NULL COMMENT '会员折扣等级名称',
  `goods_images` varchar(255) DEFAULT NULL COMMENT '商品图片',
  `goods_type` enum('pintuan','normal') DEFAULT 'normal' COMMENT '商品类型',
  `model` varchar(64) NOT NULL,
  `quantity` int(4) NOT NULL,
  `price` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `total` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `rela_goodsoption_valueid` varchar(50) DEFAULT NULL COMMENT '关联属性id',
  `comment` varchar(255) DEFAULT NULL COMMENT '会员留言',
  `commiss_one_money` float(10,2) DEFAULT '0.00' COMMENT '一级分佣金额',
  `commiss_two_money` float(10,2) DEFAULT '0.00' COMMENT '二级分佣金额',
  `commiss_three_money` float(10,2) DEFAULT '0.00' COMMENT '三级分佣金额',
  `commiss_fen_one_money` float(10,2) DEFAULT '0.00' COMMENT '分享一级佣金',
  `commiss_fen_two_money` float(10,2) DEFAULT '0.00' COMMENT '分享二级佣金',
  `commiss_fen_three_money` float(10,2) DEFAULT '0.00' COMMENT '分享三级佣金',
  PRIMARY KEY (`order_goods_id`),
  KEY `store_id` (`store_id`) USING BTREE,
  KEY `order_id` (`order_id`),
  KEY `pin_id` (`pin_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_goods`
--

LOCK TABLES `oscshop_order_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_order_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_goods_haitao`
--

DROP TABLE IF EXISTS `oscshop_order_goods_haitao`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_goods_haitao` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `real_name` varchar(200) NOT NULL COMMENT '真实姓名',
  `id_card` varchar(200) NOT NULL COMMENT '身份证号码',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='订单海淘信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_goods_haitao`
--

LOCK TABLES `oscshop_order_goods_haitao` WRITE;
/*!40000 ALTER TABLE `oscshop_order_goods_haitao` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_goods_haitao` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_history`
--

DROP TABLE IF EXISTS `oscshop_order_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_history` (
  `order_history_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `order_status_id` int(5) NOT NULL,
  `notify` tinyint(1) NOT NULL,
  `comment` text NOT NULL,
  `date_added` int(11) NOT NULL,
  PRIMARY KEY (`order_history_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_history`
--

LOCK TABLES `oscshop_order_history` WRITE;
/*!40000 ALTER TABLE `oscshop_order_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_option`
--

DROP TABLE IF EXISTS `oscshop_order_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_option` (
  `order_option_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `order_goods_id` int(11) NOT NULL,
  `goods_option_id` int(11) NOT NULL,
  `goods_option_value_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(32) NOT NULL,
  PRIMARY KEY (`order_option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_option`
--

LOCK TABLES `oscshop_order_option` WRITE;
/*!40000 ALTER TABLE `oscshop_order_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_quantity_order`
--

DROP TABLE IF EXISTS `oscshop_order_quantity_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_quantity_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `quantity` int(10) NOT NULL COMMENT '数量',
  `last_quantity` int(10) DEFAULT NULL COMMENT '上一次库存',
  `rela_goodsoption_value_id` int(10) NOT NULL COMMENT '相关商品id',
  `addtime` int(10) NOT NULL COMMENT '库存变更时间',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0减少库存，1增加库存',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='库存记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_quantity_order`
--

LOCK TABLES `oscshop_order_quantity_order` WRITE;
/*!40000 ALTER TABLE `oscshop_order_quantity_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_quantity_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_refund`
--

DROP TABLE IF EXISTS `oscshop_order_refund`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_refund` (
  `ref_id` int(10) NOT NULL AUTO_INCREMENT COMMENT '退款自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `ref_type` tinyint(1) NOT NULL COMMENT '退款类型：1仅退款，2退款退货',
  `ref_money` float(10,2) NOT NULL COMMENT '退款金额',
  `ref_member_id` int(10) NOT NULL COMMENT '会员id',
  `ref_name` varchar(255) NOT NULL COMMENT '退款原因',
  `ref_mobile` varchar(50) NOT NULL COMMENT '联系人手机号',
  `ref_description` text COMMENT '问题描述',
  `state` tinyint(1) NOT NULL COMMENT '退款状态：0申请中，1商家拒绝，2平台介入，3退款成功，4退款失败,5:撤销申请',
  `addtime` int(10) NOT NULL COMMENT '申请时间',
  PRIMARY KEY (`ref_id`),
  KEY `ref_member_id` (`ref_member_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户退款表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_refund`
--

LOCK TABLES `oscshop_order_refund` WRITE;
/*!40000 ALTER TABLE `oscshop_order_refund` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_refund` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_refund_history`
--

DROP TABLE IF EXISTS `oscshop_order_refund_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_refund_history` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `message` text COMMENT '处理内容',
  `type` tinyint(1) NOT NULL COMMENT '类型：1用户反馈，2商家反馈',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='退款订单处理历史表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_refund_history`
--

LOCK TABLES `oscshop_order_refund_history` WRITE;
/*!40000 ALTER TABLE `oscshop_order_refund_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_refund_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_refund_history_image`
--

DROP TABLE IF EXISTS `oscshop_order_refund_history_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_refund_history_image` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `orh_id` int(10) NOT NULL COMMENT '处理记录id',
  `image` varchar(255) NOT NULL COMMENT '图片地址',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `orh_id` (`orh_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='退款处理记录图片表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_refund_history_image`
--

LOCK TABLES `oscshop_order_refund_history_image` WRITE;
/*!40000 ALTER TABLE `oscshop_order_refund_history_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_refund_history_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_refund_image`
--

DROP TABLE IF EXISTS `oscshop_order_refund_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_refund_image` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '退款图片自增id',
  `ref_id` int(10) NOT NULL COMMENT '退款id',
  `image` varchar(255) NOT NULL COMMENT '图片地址',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `ref_id` (`ref_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='order_refund_image';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_refund_image`
--

LOCK TABLES `oscshop_order_refund_image` WRITE;
/*!40000 ALTER TABLE `oscshop_order_refund_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_refund_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_relate`
--

DROP TABLE IF EXISTS `oscshop_order_relate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_relate` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_all_id` int(10) NOT NULL COMMENT '订单总表id',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `order_all_id` (`order_all_id`,`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='订单总表跟商家订单关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_relate`
--

LOCK TABLES `oscshop_order_relate` WRITE;
/*!40000 ALTER TABLE `oscshop_order_relate` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_relate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_status`
--

DROP TABLE IF EXISTS `oscshop_order_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_status` (
  `order_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL,
  PRIMARY KEY (`order_status_id`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8 COMMENT='订单状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_status`
--

LOCK TABLES `oscshop_order_status` WRITE;
/*!40000 ALTER TABLE `oscshop_order_status` DISABLE KEYS */;
INSERT INTO `oscshop_order_status` VALUES (1,'已付款待发货'),(2,'拼团中，已付款'),(3,'待付款'),(4,'已发货，待收货'),(5,'交易已取消'),(6,'已签收'),(7,'已退款'),(8,'退款并送券'),(9,'二等奖，已退款并送券'),(10,'退款失败，请手动退款'),(11,'已完成'),(12,'申请退款中'),(13,'平台介入退款');
/*!40000 ALTER TABLE `oscshop_order_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_order_total`
--

DROP TABLE IF EXISTS `oscshop_order_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_order_total` (
  `order_total_id` int(10) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `code` varchar(32) NOT NULL,
  `title` varchar(255) NOT NULL,
  `text` varchar(255) NOT NULL,
  `value` decimal(15,4) NOT NULL DEFAULT '0.0000',
  `sort_order` int(3) NOT NULL,
  PRIMARY KEY (`order_total_id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_order_total`
--

LOCK TABLES `oscshop_order_total` WRITE;
/*!40000 ALTER TABLE `oscshop_order_total` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_order_total` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_payment`
--

DROP TABLE IF EXISTS `oscshop_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_payment` (
  `payment_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '支付索引id',
  `payment_code` char(10) NOT NULL COMMENT '支付代码名称',
  `payment_name` char(10) NOT NULL COMMENT '支付名称',
  `payment_config` text COMMENT '支付接口配置信息',
  `payment_state` enum('0','1') NOT NULL DEFAULT '0' COMMENT '接口状态0禁用1启用',
  PRIMARY KEY (`payment_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='支付方式表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_payment`
--

LOCK TABLES `oscshop_payment` WRITE;
/*!40000 ALTER TABLE `oscshop_payment` DISABLE KEYS */;
INSERT INTO `oscshop_payment` VALUES (1,'wxpay','微信支付','a:4:{s:14:\"alipay_service\";s:25:\"create_direct_pay_by_user\";s:14:\"alipay_account\";s:0:\"\";s:10:\"alipay_key\";s:0:\"\";s:14:\"alipay_partner\";s:0:\"\";}','1');
/*!40000 ALTER TABLE `oscshop_payment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_pick_member`
--

DROP TABLE IF EXISTS `oscshop_pick_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_pick_member` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `pick_up_id` int(10) DEFAULT NULL COMMENT '提货点id',
  `state` tinyint(1) NOT NULL COMMENT '状态：0不能核销，1正常',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `store_id` int(10) NOT NULL COMMENT '店铺id',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='提货人员表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_pick_member`
--

LOCK TABLES `oscshop_pick_member` WRITE;
/*!40000 ALTER TABLE `oscshop_pick_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_pick_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_pick_order`
--

DROP TABLE IF EXISTS `oscshop_pick_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_pick_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pick_sn` varchar(50) NOT NULL COMMENT '自提sn码，用于核销',
  `pick_id` int(10) NOT NULL COMMENT '自提id',
  `pick_member_id` int(10) DEFAULT '0' COMMENT '核销人员id',
  `ziti_name` varchar(100) DEFAULT NULL COMMENT '自提人名称',
  `ziti_mobile` varchar(50) DEFAULT NULL COMMENT '自提人手机',
  `order_id` int(10) NOT NULL COMMENT '订单id',
  `state` tinyint(1) NOT NULL COMMENT '核销状态，0待核销，1已核销',
  `tihuo_time` int(10) DEFAULT '0' COMMENT '提货时间',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `qrcode` varchar(255) DEFAULT NULL COMMENT '核销的小程序二维码',
  PRIMARY KEY (`id`),
  KEY `order_id` (`order_id`),
  KEY `pick_sn` (`pick_sn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='自提订单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_pick_order`
--

LOCK TABLES `oscshop_pick_order` WRITE;
/*!40000 ALTER TABLE `oscshop_pick_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_pick_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_pick_up`
--

DROP TABLE IF EXISTS `oscshop_pick_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_pick_up` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pick_name` varchar(255) NOT NULL COMMENT '自提点名称',
  `pick_pos` varchar(200) DEFAULT NULL COMMENT '自提点位置信息',
  `store_id` int(10) NOT NULL COMMENT '所属卖家',
  `passwd` varchar(200) DEFAULT NULL COMMENT '核销密码',
  `telephone` varchar(50) NOT NULL COMMENT '自提点电话',
  `lng` varchar(20) NOT NULL COMMENT '精度',
  `lat` varchar(20) NOT NULL COMMENT '纬度',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  `we_qrcode` varchar(255) DEFAULT NULL COMMENT '门店核销二维码',
  PRIMARY KEY (`id`),
  KEY `store_id` (`store_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='自提点表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_pick_up`
--

LOCK TABLES `oscshop_pick_up` WRITE;
/*!40000 ALTER TABLE `oscshop_pick_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_pick_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_pin`
--

DROP TABLE IF EXISTS `oscshop_pin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_pin` (
  `pin_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '拼团id，自增',
  `order_id` int(11) NOT NULL DEFAULT '0' COMMENT '订单id',
  `user_id` int(11) NOT NULL DEFAULT '0' COMMENT '会员id',
  `need_count` int(11) NOT NULL DEFAULT '0' COMMENT '拼团人数',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '拼团状态，0拼团中，1拼团成功，2拼团失败并退款',
  `lottery_state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '抽奖状态，0抽奖中，1可退款，2已退款送券。',
  `is_lottery` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否抽奖拼团，0正常订单，1抽奖订单',
  `begin_time` int(11) NOT NULL COMMENT '拼团开始时间',
  `end_time` int(11) NOT NULL COMMENT '拼团结束时间',
  `add_time` int(11) NOT NULL COMMENT ' 添加时间',
  `is_jiqi` tinyint(1) DEFAULT '0' COMMENT '是否机器人成团',
  PRIMARY KEY (`pin_id`),
  KEY `user_id` (`user_id`) USING BTREE,
  KEY `order_id` (`order_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_pin`
--

LOCK TABLES `oscshop_pin` WRITE;
/*!40000 ALTER TABLE `oscshop_pin` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_pin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_pin_goods`
--

DROP TABLE IF EXISTS `oscshop_pin_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_pin_goods` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(10) DEFAULT NULL COMMENT '商品id',
  `customer_id` int(10) DEFAULT NULL COMMENT '商家id',
  `pin_price` float(10,2) DEFAULT NULL COMMENT '拼团价格',
  `type` enum('normal','lottery','newman') DEFAULT 'normal',
  `begin_time` int(10) DEFAULT '0' COMMENT '拼团开始时间',
  `end_time` int(10) DEFAULT '0' COMMENT '拼团结束时间',
  `pin_hour` float(10,2) DEFAULT '1.00' COMMENT '拼团时间',
  `pin_count` int(10) DEFAULT '0' COMMENT '拼团人数',
  `addtime` int(10) DEFAULT NULL COMMENT '添加时间',
  `commiss_one_pin_disc` float(10,2) DEFAULT '0.00' COMMENT '一级分佣比例',
  `commiss_two_pin_disc` float(10,2) DEFAULT '0.00' COMMENT '二级分佣比例',
  `commiss_three_pin_disc` float(10,2) DEFAULT '0.00' COMMENT '三级分佣比例',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`) USING BTREE,
  KEY `customer_id` (`customer_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_pin_goods`
--

LOCK TABLES `oscshop_pin_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_pin_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_pin_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_pin_order`
--

DROP TABLE IF EXISTS `oscshop_pin_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_pin_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pin_id` int(11) NOT NULL COMMENT '拼团id',
  `order_id` int(11) NOT NULL COMMENT '订单id',
  `add_time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `pin_id` (`pin_id`) USING BTREE,
  KEY `order_id` (`order_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_pin_order`
--

LOCK TABLES `oscshop_pin_order` WRITE;
/*!40000 ALTER TABLE `oscshop_pin_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_pin_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_plugins_slider`
--

DROP TABLE IF EXISTS `oscshop_plugins_slider`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_plugins_slider` (
  `slider_id` int(11) NOT NULL AUTO_INCREMENT,
  `slider_name` varchar(100) NOT NULL COMMENT '广告位名称',
  `type` enum('index_ad_nav','index_ad_head','index_ad_list','pc_ad_head','pc_ad_scroll','pc_news','index_wepro_head','index_wepro_line','pin_index_ad','lottery_wepro_head','newman_wepro_head','index_wepro_iconnav','index_wepro_ziying_line','paihang_wepro_head','new_wepro_head','wepro_bargain_ad','wepro_integral_mall','wepro_integral_mall_bottom') NOT NULL DEFAULT 'index_ad_head',
  `image` varchar(255) NOT NULL COMMENT '图片',
  `url` varchar(255) NOT NULL COMMENT '图片超链接',
  `sort_order` int(11) NOT NULL,
  `webview_url` varchar(255) DEFAULT NULL COMMENT '外链',
  PRIMARY KEY (`slider_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图片轮播器';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_plugins_slider`
--

LOCK TABLES `oscshop_plugins_slider` WRITE;
/*!40000 ALTER TABLE `oscshop_plugins_slider` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_plugins_slider` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_role`
--

DROP TABLE IF EXISTS `oscshop_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_role` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `pid` int(11) NOT NULL COMMENT '父角色id',
  `name` varchar(32) NOT NULL COMMENT '角色名称',
  `description` text NOT NULL COMMENT '角色描述',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '角色状态',
  `created_at` int(11) NOT NULL COMMENT '创建时间',
  `updated_at` int(11) NOT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='角色表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_role`
--

LOCK TABLES `oscshop_role` WRITE;
/*!40000 ALTER TABLE `oscshop_role` DISABLE KEYS */;
INSERT INTO `oscshop_role` VALUES (1,0,'超级管理员','管理所有后台权限',1,0,1476241011),(2,0,'订单管理员','查看订单的状态',1,0,0),(3,1,'商品管理员','商品管理员',1,1470303850,1470303850);
/*!40000 ALTER TABLE `oscshop_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_seller`
--

DROP TABLE IF EXISTS `oscshop_seller`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_seller` (
  `s_id` mediumint(8) NOT NULL AUTO_INCREMENT,
  `s_uname` varchar(20) NOT NULL COMMENT '用户名',
  `s_true_name` varchar(20) NOT NULL COMMENT '真名',
  `s_mobile` varchar(40) NOT NULL COMMENT '客服电话',
  `s_passwd` varchar(255) NOT NULL,
  `s_role_id` int(11) NOT NULL DEFAULT '0' COMMENT '所属角色id',
  `s_login_count` mediumint(8) NOT NULL DEFAULT '0' COMMENT '登录次数',
  `s_last_login_ip` varchar(40) NOT NULL DEFAULT '0' COMMENT '最后登录ip',
  `s_last_ip_region` varchar(40) NOT NULL DEFAULT '0',
  `s_create_time` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `s_last_login_time` int(11) NOT NULL DEFAULT '0' COMMENT '最后登录',
  `s_status` tinyint(4) NOT NULL DEFAULT '1' COMMENT '状态',
  `perms` text COMMENT '权限',
  `deleted` tinyint(1) DEFAULT '0' COMMENT '是否禁用',
  PRIMARY KEY (`s_id`),
  KEY `fk_seller_role` (`s_role_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='卖家信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_seller`
--

LOCK TABLES `oscshop_seller` WRITE;
/*!40000 ALTER TABLE `oscshop_seller` DISABLE KEYS */;
INSERT INTO `oscshop_seller` VALUES (1,'admin','','','MDAwMDAwMDAwMJCMg9mTiWaXhaaXow',0,1,'27.205.22.206','',1470316613,1623382392,1,'',0);
/*!40000 ALTER TABLE `oscshop_seller` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_seller_ad`
--

DROP TABLE IF EXISTS `oscshop_seller_ad`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_seller_ad` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `seller_id` int(11) NOT NULL COMMENT '卖家id',
  `title` varchar(100) NOT NULL COMMENT '标题',
  `url` varchar(255) NOT NULL COMMENT '链接',
  `image` varchar(255) NOT NULL COMMENT '图片',
  `ordersort` int(11) NOT NULL COMMENT '排序',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `seller_id` (`seller_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='卖家店铺页轮播广告';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_seller_ad`
--

LOCK TABLES `oscshop_seller_ad` WRITE;
/*!40000 ALTER TABLE `oscshop_seller_ad` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_seller_ad` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_seller_balance`
--

DROP TABLE IF EXISTS `oscshop_seller_balance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_seller_balance` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `seller_id` int(10) NOT NULL COMMENT '卖家id',
  `money` float(10,2) NOT NULL DEFAULT '0.00' COMMENT '可提现金额',
  `hasgetmoney` float(10,2) NOT NULL COMMENT '已提现金额',
  `dongmoney` float(10,2) NOT NULL COMMENT '提现中金额',
  PRIMARY KEY (`id`),
  KEY `seller_id` (`seller_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_seller_balance`
--

LOCK TABLES `oscshop_seller_balance` WRITE;
/*!40000 ALTER TABLE `oscshop_seller_balance` DISABLE KEYS */;
INSERT INTO `oscshop_seller_balance` VALUES (1,1,0.25,0.01,0.00),(2,2,0.00,0.00,0.00);
/*!40000 ALTER TABLE `oscshop_seller_balance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_seller_express`
--

DROP TABLE IF EXISTS `oscshop_seller_express`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_seller_express` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '快递id，自增',
  `express_name` varchar(100) NOT NULL COMMENT '快递名称',
  `store_id` int(11) NOT NULL COMMENT '卖家id',
  `jianma` varchar(100) DEFAULT NULL COMMENT '快递简码',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `store_id` (`store_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_seller_express`
--

LOCK TABLES `oscshop_seller_express` WRITE;
/*!40000 ALTER TABLE `oscshop_seller_express` DISABLE KEYS */;
INSERT INTO `oscshop_seller_express` VALUES (10,'闪电快递',3,NULL,1474874645),(14,'本地配送',1,NULL,1475403236),(15,'商家1号快递1',1,NULL,1475918886),(16,'顺丰快递',2,NULL,1476274796),(17,'韵达',9,NULL,1476261538);
/*!40000 ALTER TABLE `oscshop_seller_express` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_seller_express_relat`
--

DROP TABLE IF EXISTS `oscshop_seller_express_relat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_seller_express_relat` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `express_id` int(10) NOT NULL DEFAULT '0' COMMENT '快递id',
  `store_id` int(10) NOT NULL DEFAULT '0' COMMENT '店铺ID',
  PRIMARY KEY (`id`),
  KEY `express_id, store_id` (`express_id`,`store_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='商家快递关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_seller_express_relat`
--

LOCK TABLES `oscshop_seller_express_relat` WRITE;
/*!40000 ALTER TABLE `oscshop_seller_express_relat` DISABLE KEYS */;
INSERT INTO `oscshop_seller_express_relat` VALUES (2,15,1);
/*!40000 ALTER TABLE `oscshop_seller_express_relat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_seller_log`
--

DROP TABLE IF EXISTS `oscshop_seller_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_seller_log` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `s_id` int(11) NOT NULL DEFAULT '0',
  `type` int(1) NOT NULL DEFAULT '0' COMMENT '日志类型 1登录 0退出 2订单 3商品',
  `content` text COMMENT '日志内容',
  `addtime` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_seller_log`
--

LOCK TABLES `oscshop_seller_log` WRITE;
/*!40000 ALTER TABLE `oscshop_seller_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_seller_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_seller_menu`
--

DROP TABLE IF EXISTS `oscshop_seller_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_seller_menu` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '文档ID',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上级分类ID',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '标题',
  `url` char(255) NOT NULL DEFAULT '' COMMENT '链接地址',
  `icon` varchar(50) NOT NULL,
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '排序（同级有效）',
  `is_mall` tinyint(1) DEFAULT '1' COMMENT '是否多商户',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=204 DEFAULT CHARSET=utf8 COMMENT='后台菜单';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_seller_menu`
--

LOCK TABLES `oscshop_seller_menu` WRITE;
/*!40000 ALTER TABLE `oscshop_seller_menu` DISABLE KEYS */;
INSERT INTO `oscshop_seller_menu` VALUES (28,0,'商品','','snailfishicon snailfishicon-goods',2,1),(29,28,'普通商品信息','Goods/index','',1,1),(35,0,'订单中心','','snailfishicon snailfishicon-order',3,1),(36,35,'订单列表','Order/index','',1,1),(48,28,'商品规格','Option/index','',6,1),(49,0,'概况','Index/index','snailfishicon snailfishicon-index',0,1),(51,0,'结算中心','','icon-file-alt',6,2),(52,51,'结算管理','Balance/index','',0,1),(54,51,'资产','Balance/assets','',1,1),(55,35,'批量发货','Order/sendexpress','',3,1),(57,0,'团长管理','','snailfishicon snailfishicon-communityhead',7,1),(59,10000,'活动中心','Activity/subject','icon-bookmark',5,1),(65,0,'会员','','snailfishicon snailfishicon-user',4,0),(67,0,'设置','','snailfishicon snailfishicon-setup',10,0),(68,67,'基本设置','settings/general','',0,0),(69,67,'小程序配置','settings/wxprogram','',4,0),(70,65,'会员列表','member/index','',0,0),(71,28,'商品分类','GoodsCategory/index','',2,0),(72,65,'机器人管理','member/jiaindex','',2,1),(76,35,'评价列表','Goodscomment/index','',6,1),(77,0,'文章','Blog/index','snailfishicon snailfishicon-discovery',9,1),(194,0,'供应','supply/index','snailfishicon snailfishicon-supply',8,1),(195,28,'商品设置','goods/config','',7,1),(196,35,'售后订单','order/orderaftersales','',4,1),(197,35,'订单设置','order/config','',6,1),(198,57,'团长列表','communityhead/index','',1,1),(199,57,'提现设置','communityhead/distributionpostal','',2,1),(200,57,'提现列表','communityhead/distribulist','',3,1),(201,57,'团长设置','communityhead/config','',4,1),(202,67,'幻灯片','PluginsSliderdan/index','',2,1),(203,67,'公告','Notice/index','',3,1);
/*!40000 ALTER TABLE `oscshop_seller_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_seller_tixian`
--

DROP TABLE IF EXISTS `oscshop_seller_tixian`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_seller_tixian` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `seller_id` int(10) NOT NULL COMMENT '卖家id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0：申请中，1已打款',
  `addtime` int(10) NOT NULL COMMENT '申请时间',
  PRIMARY KEY (`id`),
  KEY `seller_id` (`seller_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_seller_tixian`
--

LOCK TABLES `oscshop_seller_tixian` WRITE;
/*!40000 ALTER TABLE `oscshop_seller_tixian` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_seller_tixian` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_spike`
--

DROP TABLE IF EXISTS `oscshop_spike`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_spike` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(255) NOT NULL COMMENT '限时秒杀活动名称',
  `is_best` tinyint(1) DEFAULT '0' COMMENT '是否推荐首页',
  `begin_time` int(11) NOT NULL COMMENT '活动开始时间',
  `end_time` int(11) NOT NULL COMMENT ' 活动结束时间',
  `add_time` int(11) NOT NULL COMMENT '活动添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_spike`
--

LOCK TABLES `oscshop_spike` WRITE;
/*!40000 ALTER TABLE `oscshop_spike` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_spike` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_spike_goods`
--

DROP TABLE IF EXISTS `oscshop_spike_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_spike_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `spike_id` int(11) NOT NULL DEFAULT '0' COMMENT '秒杀id',
  `state` tinyint(1) NOT NULL COMMENT '限时秒杀状态，0申请中，1已通过，2已下架',
  `quantity` int(11) NOT NULL COMMENT '商品数量',
  `begin_time` int(11) NOT NULL COMMENT '开始时间',
  `end_time` int(11) NOT NULL COMMENT '结束时间',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  `seller_id` int(10) DEFAULT '0' COMMENT '商家id',
  PRIMARY KEY (`id`),
  KEY `state` (`state`,`quantity`,`begin_time`,`end_time`) USING BTREE,
  KEY `spike_id` (`spike_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_spike_goods`
--

LOCK TABLES `oscshop_spike_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_spike_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_spike_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_stock_status`
--

DROP TABLE IF EXISTS `oscshop_stock_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_stock_status` (
  `stock_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL,
  PRIMARY KEY (`stock_status_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='库存状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_stock_status`
--

LOCK TABLES `oscshop_stock_status` WRITE;
/*!40000 ALTER TABLE `oscshop_stock_status` DISABLE KEYS */;
INSERT INTO `oscshop_stock_status` VALUES (1,'有存货'),(2,'备货中');
/*!40000 ALTER TABLE `oscshop_stock_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_store_bind_class`
--

DROP TABLE IF EXISTS `oscshop_store_bind_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_store_bind_class` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `seller_id` int(11) unsigned DEFAULT '0' COMMENT '店铺ID',
  `commis_rate` tinyint(4) unsigned DEFAULT '0' COMMENT '佣金比例',
  `class_1` mediumint(9) unsigned DEFAULT '0' COMMENT '一级分类',
  `class_2` mediumint(9) unsigned DEFAULT '0' COMMENT '二级分类',
  `class_3` mediumint(9) unsigned DEFAULT '0' COMMENT '三级分类',
  `state` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '状态0审核中1已审核 2平台自营店铺',
  PRIMARY KEY (`bid`),
  KEY `seller_id` (`seller_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='店铺可发布商品类目表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_store_bind_class`
--

LOCK TABLES `oscshop_store_bind_class` WRITE;
/*!40000 ALTER TABLE `oscshop_store_bind_class` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_store_bind_class` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_subject`
--

DROP TABLE IF EXISTS `oscshop_subject`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_subject` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(255) NOT NULL COMMENT '活动名称',
  `type` enum('normal','zeyuan','niyuan','haitao','oneyuan') DEFAULT NULL COMMENT '活动类型，normal正常活动，zeyuan0元试用，niyuan9.9元，oneyuan1元购,haitao海淘活动',
  `logo` varchar(255) NOT NULL COMMENT '主题活动logo',
  `banner` varchar(255) DEFAULT NULL COMMENT '主题活动banner',
  `begin_time` int(11) NOT NULL COMMENT '开始时间',
  `end_time` int(11) NOT NULL COMMENT '结束时间',
  `price` float(10,2) NOT NULL COMMENT '限定价格',
  `can_shenqing` tinyint(1) NOT NULL DEFAULT '1' COMMENT '是否可以申请，0:不允许申请，1允许申请',
  `add_time` int(11) NOT NULL COMMENT '添加时间',
  `is_hot` tinyint(1) DEFAULT '1' COMMENT '是否推荐首页',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_subject`
--

LOCK TABLES `oscshop_subject` WRITE;
/*!40000 ALTER TABLE `oscshop_subject` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_subject` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_subject_goods`
--

DROP TABLE IF EXISTS `oscshop_subject_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_subject_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `subject_id` int(11) NOT NULL COMMENT '主题id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '状态,0申请中，1上线',
  `end_time` int(10) DEFAULT '0' COMMENT '结束时间',
  `begin_time` int(10) DEFAULT '0' COMMENT '开始时间',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  `seller_id` int(10) DEFAULT '0' COMMENT '商家id',
  PRIMARY KEY (`id`),
  KEY `subject_id` (`subject_id`) USING BTREE,
  KEY `goods_id` (`goods_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_subject_goods`
--

LOCK TABLES `oscshop_subject_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_subject_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_subject_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_super_spike`
--

DROP TABLE IF EXISTS `oscshop_super_spike`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_super_spike` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(255) NOT NULL COMMENT '超值大牌活动名称',
  `begin_time` int(11) NOT NULL COMMENT '活动开始时间',
  `end_time` int(11) NOT NULL COMMENT ' 活动结束时间',
  `add_time` int(11) NOT NULL COMMENT '活动添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_super_spike`
--

LOCK TABLES `oscshop_super_spike` WRITE;
/*!40000 ALTER TABLE `oscshop_super_spike` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_super_spike` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_super_spike_goods`
--

DROP TABLE IF EXISTS `oscshop_super_spike_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_super_spike_goods` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `super_spike_id` int(11) NOT NULL COMMENT '超值大牌活动id',
  `goods_id` int(11) NOT NULL COMMENT '商品id',
  `state` tinyint(1) NOT NULL COMMENT '状态，0申请中，1已审核',
  `begin_time` int(11) NOT NULL COMMENT '开始时间',
  `end_time` int(11) NOT NULL COMMENT '结束时间',
  `addtime` int(11) NOT NULL COMMENT '添加时间',
  `seller_id` int(10) DEFAULT '0' COMMENT '商家id',
  PRIMARY KEY (`id`),
  KEY `super_spike_id` (`super_spike_id`) USING BTREE,
  KEY `goods_id` (`goods_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_super_spike_goods`
--

LOCK TABLES `oscshop_super_spike_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_super_spike_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_super_spike_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_template_msg_order`
--

DROP TABLE IF EXISTS `oscshop_template_msg_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_template_msg_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `template_data` text NOT NULL COMMENT '发送数据',
  `url` varchar(255) NOT NULL COMMENT '点击URL',
  `open_id` varchar(255) NOT NULL COMMENT '会员OPENID',
  `template_id` varchar(255) NOT NULL COMMENT '模板消息ID',
  `type` tinyint(1) DEFAULT '0' COMMENT '消息类型：0模板消息，1客服消息',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '发送状态，0未发送，1已发送',
  `addtime` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='模板消息时钟表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_template_msg_order`
--

LOCK TABLES `oscshop_template_msg_order` WRITE;
/*!40000 ALTER TABLE `oscshop_template_msg_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_template_msg_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_tixian_order`
--

DROP TABLE IF EXISTS `oscshop_tixian_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_tixian_order` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `money` float(10,2) NOT NULL COMMENT '提现金额',
  `state` tinyint(1) NOT NULL COMMENT '提现状态，0申请中，1提现成功，2体现失败',
  `shentime` int(10) NOT NULL COMMENT '审核时间',
  `addtime` int(10) NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分销佣金提现表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_tixian_order`
--

LOCK TABLES `oscshop_tixian_order` WRITE;
/*!40000 ALTER TABLE `oscshop_tixian_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_tixian_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_transport`
--

DROP TABLE IF EXISTS `oscshop_transport`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_transport` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT COMMENT '运费模板ID',
  `title` varchar(30) NOT NULL COMMENT '运费模板名称',
  `seller_id` mediumint(8) NOT NULL COMMENT '商家id',
  `update_time` int(10) unsigned DEFAULT '0' COMMENT '最后更新时间',
  PRIMARY KEY (`id`),
  KEY `seller_id` (`seller_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='运费模板';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_transport`
--

LOCK TABLES `oscshop_transport` WRITE;
/*!40000 ALTER TABLE `oscshop_transport` DISABLE KEYS */;
INSERT INTO `oscshop_transport` VALUES (1,'快递',1,1471146919),(2,'顺丰',1,1472021297);
/*!40000 ALTER TABLE `oscshop_transport` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_transport_extend`
--

DROP TABLE IF EXISTS `oscshop_transport_extend`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_transport_extend` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT COMMENT '运费模板扩展ID',
  `area_id` text COMMENT '市级地区ID组成的串，以，隔开，两端也有，',
  `top_area_id` text COMMENT '省级地区ID组成的串，以，隔开，两端也有，',
  `area_name` text COMMENT '地区name组成的串，以，隔开',
  `snum` mediumint(8) unsigned DEFAULT '1' COMMENT '首重',
  `sprice` decimal(10,2) DEFAULT '0.00' COMMENT '首重运费',
  `xnum` mediumint(8) unsigned DEFAULT '1' COMMENT '续重',
  `xprice` decimal(10,2) DEFAULT '0.00' COMMENT '续重运费',
  `is_default` enum('1','2') DEFAULT '2' COMMENT '是否默认运费1是2否',
  `transport_id` mediumint(8) unsigned NOT NULL COMMENT '运费模板ID',
  `transport_title` varchar(60) DEFAULT NULL COMMENT '运费模板',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8 COMMENT='运费模板扩展表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_transport_extend`
--

LOCK TABLES `oscshop_transport_extend` WRITE;
/*!40000 ALTER TABLE `oscshop_transport_extend` DISABLE KEYS */;
INSERT INTO `oscshop_transport_extend` VALUES (19,'','','全国',1,5.00,1,2.00,'1',1,'快递'),(20,',5,95,106,96,97,98,99,100,101,102,103,104,105,4,84,85,86,87,88,89,90,91,92,93,94,1,36,3,83,82,81,80,73,74,75,76,77,78,79,2,40,17,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,16,243,257,256,255,254,244,245,246,247,248,249,250,251,252,253,242,240,241,18,283,284,285,286,287,288,282,281,280,275,276,277,278,279,20,310,311,312,313,314,315,316,317,318,319,320,321,322,323,21,334,335,336,337,338,339,340,341,342,343,333,332,331,324,325,326,327,328,329,330,344,19,294,308,309,307,306,305,295,296,297,298,299,300,301,302,303,304,289,290,291,292,293,13,205,206,207,208,209,210,211,204,203,',',5,4,1,3,2,17,16,18,20,21,19,13,','内蒙古,山西,北京,河北,天津,湖北,河南,湖南,广西,海南,广东,福建',1,6.00,1,2.00,'2',1,'快递'),(21,',34,534,33,529,530,531,532,533,528,527,526,516,517,518,519,520,521,522,523,524,525,32,503,504,505,506,507,508,509,510,511,512,502,501,500,493,494,495,496,497,498,499,513,514,515,35,45055,',',34,33,32,35,','澳门,香港,台湾,海外',1,7.00,1,3.00,'2',1,'快递'),(22,'','','全国',1,2.00,1,2.00,'1',2,'顺丰'),(23,',5,95,106,96,97,98,99,100,101,102,103,104,105,4,84,85,86,87,88,89,90,91,92,93,94,1,36,3,83,82,81,80,73,74,75,76,77,78,79,2,40,17,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,16,243,257,256,255,254,244,245,246,247,248,249,250,251,252,253,242,240,241,18,283,284,285,286,287,288,282,281,280,275,276,277,278,279,20,310,311,312,313,314,315,316,317,318,319,320,321,322,323,21,334,335,336,337,338,339,340,341,342,343,333,332,331,324,325,326,327,328,329,330,344,19,294,308,309,307,306,305,295,296,297,298,299,300,301,302,303,304,289,290,291,292,293,13,205,206,207,208,209,210,211,204,203,',',5,4,1,3,2,17,16,18,20,21,19,13,','内蒙古,山西,北京,河北,天津,湖北,河南,湖南,广西,海南,广东,福建',1,3.00,1,2.00,'2',2,'顺丰'),(24,',34,534,33,529,530,531,532,533,528,527,526,516,517,518,519,520,521,522,523,524,525,32,503,504,505,506,507,508,509,510,511,512,502,501,500,493,494,495,496,497,498,499,513,514,515,35,45055,',',34,33,32,35,','澳门,香港,台湾,海外',1,4.00,1,3.00,'2',2,'顺丰');
/*!40000 ALTER TABLE `oscshop_transport_extend` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_user_action`
--

DROP TABLE IF EXISTS `oscshop_user_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_user_action` (
  `ua_id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(40) NOT NULL COMMENT 'frontend,backend',
  `user_id` int(11) NOT NULL,
  `uname` varchar(40) NOT NULL COMMENT '用户名',
  `add_time` varchar(40) NOT NULL COMMENT '加入时间',
  `info` varchar(255) NOT NULL COMMENT '行为描述',
  PRIMARY KEY (`ua_id`)
) ENGINE=InnoDB AUTO_INCREMENT=182 DEFAULT CHARSET=utf8 COMMENT='用户行为';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_user_action`
--

LOCK TABLES `oscshop_user_action` WRITE;
/*!40000 ALTER TABLE `oscshop_user_action` DISABLE KEYS */;
INSERT INTO `oscshop_user_action` VALUES (85,'网站卖家',1,'admin','2020-07-29 22:15:48','登录了卖家后台'),(86,'网站卖家',1,'admin','2020-08-07 12:17:22','登录了卖家后台'),(87,'网站卖家',1,'admin','2020-08-10 19:29:29','登录了卖家后台'),(88,'网站卖家',1,'admin','2020-08-10 19:31:49','登录了卖家后台'),(89,'网站卖家',1,'admin','2020-08-11 10:16:43','登录了卖家后台'),(90,'网站卖家',1,'admin','2020-08-13 22:19:42','登录了卖家后台'),(91,'网站卖家',1,'admin','2020-08-13 23:12:39','登录了卖家后台'),(92,'网站卖家',1,'admin','2020-08-15 14:48:24','登录了卖家后台'),(93,'网站卖家',1,'admin','2020-08-19 01:33:18','登录了卖家后台'),(94,'网站卖家',1,'admin','2020-08-28 19:23:29','登录了卖家后台'),(95,'网站卖家',1,'admin','2020-08-28 19:23:30','登录了卖家后台'),(96,'网站卖家',1,'admin','2020-09-01 22:35:25','登录了卖家后台'),(97,'网站卖家',1,'admin','2020-09-02 13:33:52','登录了卖家后台'),(98,'网站卖家',1,'admin','2020-09-04 22:17:25','登录了卖家后台'),(99,'网站卖家',1,'admin','2020-09-07 15:07:24','登录了卖家后台'),(100,'网站卖家',1,'admin','2020-09-08 22:16:33','登录了卖家后台'),(101,'网站卖家',1,'admin','2020-09-12 15:07:19','登录了卖家后台'),(102,'网站卖家',1,'admin','2020-09-18 10:29:37','登录了卖家后台'),(103,'网站卖家',1,'admin','2020-09-19 14:39:02','登录了卖家后台'),(104,'网站卖家',1,'admin','2020-09-22 17:05:16','登录了卖家后台'),(105,'网站卖家',1,'admin','2020-09-24 16:47:40','登录了卖家后台'),(106,'网站卖家',1,'admin','2020-10-14 12:05:08','登录了卖家后台'),(107,'网站卖家',1,'admin','2020-10-17 14:47:53','登录了卖家后台'),(108,'网站卖家',1,'admin','2020-10-18 12:38:34','登录了卖家后台'),(109,'网站卖家',1,'admin','2020-10-21 13:41:17','登录了卖家后台'),(110,'网站卖家',1,'admin','2020-10-23 09:34:32','登录了卖家后台'),(111,'网站卖家',1,'admin','2020-10-23 22:08:01','登录了卖家后台'),(112,'网站卖家',1,'admin','2020-10-30 14:32:40','登录了卖家后台'),(113,'网站卖家',1,'admin','2020-11-02 17:24:21','登录了卖家后台'),(114,'网站卖家',1,'admin','2020-11-04 14:44:54','登录了卖家后台'),(115,'网站卖家',1,'admin','2020-11-05 09:32:45','登录了卖家后台'),(116,'网站卖家',1,'admin','2020-11-05 17:09:12','登录了卖家后台'),(117,'网站卖家',1,'admin','2020-11-06 15:16:25','登录了卖家后台'),(118,'网站卖家',1,'admin','2020-11-09 15:10:49','登录了卖家后台'),(119,'网站卖家',1,'admin','2020-11-12 13:46:43','登录了卖家后台'),(120,'网站卖家',1,'admin','2020-11-13 16:35:26','登录了卖家后台'),(121,'网站卖家',1,'admin','2020-11-18 09:19:24','登录了卖家后台'),(122,'网站卖家',1,'admin','2020-11-20 13:58:00','登录了卖家后台'),(123,'网站卖家',1,'admin','2020-11-21 16:11:54','登录了卖家后台'),(124,'网站卖家',1,'admin','2020-11-23 10:44:08','登录了卖家后台'),(125,'网站卖家',1,'admin','2020-11-26 11:19:35','登录了卖家后台'),(126,'网站卖家',1,'admin','2020-11-27 12:27:30','登录了卖家后台'),(127,'网站卖家',1,'admin','2020-12-09 19:06:41','登录了卖家后台'),(128,'网站卖家',1,'admin','2020-12-10 23:13:24','登录了卖家后台'),(129,'网站卖家',1,'admin','2020-12-13 01:18:22','登录了卖家后台'),(130,'网站卖家',1,'admin','2020-12-13 17:51:52','登录了卖家后台'),(131,'网站卖家',1,'admin','2020-12-15 21:30:10','登录了卖家后台'),(132,'网站卖家',1,'admin','2020-12-21 14:15:47','登录了卖家后台'),(133,'网站卖家',1,'admin','2020-12-22 09:55:28','登录了卖家后台'),(134,'网站卖家',1,'admin','2020-12-22 14:22:20','登录了卖家后台'),(135,'网站卖家',1,'admin','2020-12-23 14:10:47','登录了卖家后台'),(136,'网站卖家',1,'admin','2020-12-23 19:04:34','登录了卖家后台'),(137,'网站卖家',1,'admin','2020-12-28 09:16:21','登录了卖家后台'),(138,'网站卖家',1,'admin','2020-12-30 10:16:11','登录了卖家后台'),(139,'网站卖家',1,'admin','2020-12-31 14:38:05','登录了卖家后台'),(140,'网站卖家',1,'admin','2021-01-04 10:13:28','登录了卖家后台'),(141,'网站卖家',1,'admin','2021-01-05 14:26:04','登录了卖家后台'),(142,'网站卖家',1,'admin','2021-01-08 10:06:28','登录了卖家后台'),(143,'网站卖家',1,'admin','2021-01-11 09:19:02','登录了卖家后台'),(144,'网站卖家',1,'admin','2021-01-12 11:21:40','登录了卖家后台'),(145,'网站卖家',1,'admin','2021-01-12 12:53:30','登录了卖家后台'),(146,'网站卖家',1,'admin','2021-01-13 15:23:25','登录了卖家后台'),(147,'网站卖家',1,'admin','2021-01-14 10:04:49','登录了卖家后台'),(148,'网站卖家',1,'admin','2021-01-15 17:27:33','登录了卖家后台'),(149,'网站卖家',1,'admin','2021-01-16 09:39:46','登录了卖家后台'),(150,'网站卖家',1,'admin','2021-01-19 22:51:40','登录了卖家后台'),(151,'网站卖家',1,'admin','2021-01-20 08:51:37','登录了卖家后台'),(152,'网站卖家',1,'admin','2021-01-21 09:13:29','登录了卖家后台'),(153,'网站卖家',1,'admin','2021-01-22 10:11:56','登录了卖家后台'),(154,'网站卖家',1,'admin','2021-01-23 09:06:00','登录了卖家后台'),(155,'网站卖家',1,'admin','2021-01-26 10:43:26','登录了卖家后台'),(156,'网站卖家',1,'admin','2021-01-27 17:55:58','登录了卖家后台'),(157,'网站卖家',1,'admin','2021-01-29 13:30:36','登录了卖家后台'),(158,'网站卖家',1,'admin','2021-02-23 19:38:31','登录了卖家后台'),(159,'网站卖家',1,'admin','2021-02-28 21:35:35','登录了卖家后台'),(160,'网站卖家',1,'admin','2021-03-06 18:51:03','登录了卖家后台'),(161,'网站卖家',1,'admin','2021-03-10 01:02:08','登录了卖家后台'),(162,'网站卖家',1,'admin','2021-03-13 10:57:52','登录了卖家后台'),(163,'网站卖家',1,'admin','2021-03-19 12:06:07','登录了卖家后台'),(164,'网站卖家',1,'admin','2021-03-25 23:21:24','登录了卖家后台'),(165,'网站卖家',1,'admin','2021-03-27 21:58:21','登录了卖家后台'),(166,'网站卖家',1,'admin','2021-03-28 20:13:30','登录了卖家后台'),(167,'网站卖家',1,'admin','2021-03-29 13:14:21','登录了卖家后台'),(168,'网站卖家',1,'admin','2021-04-02 23:09:18','登录了卖家后台'),(169,'网站卖家',1,'admin','2021-04-06 09:25:22','登录了卖家后台'),(170,'网站卖家',1,'admin','2021-04-06 16:09:18','登录了卖家后台'),(171,'网站卖家',1,'admin','2021-06-02 15:35:32','登录了卖家后台'),(172,'网站卖家',1,'admin','2021-06-03 09:07:34','登录了卖家后台'),(173,'网站卖家',1,'admin','2021-06-04 20:39:22','登录了卖家后台'),(174,'网站卖家',1,'admin','2021-06-05 20:45:33','登录了卖家后台'),(175,'网站卖家',1,'admin','2021-06-06 13:09:30','登录了卖家后台'),(176,'网站卖家',1,'admin','2021-06-08 17:55:13','登录了卖家后台'),(177,'网站卖家',1,'admin','2021-06-08 18:54:24','登录了卖家后台'),(178,'网站卖家',1,'admin','2021-06-08 21:58:10','登录了卖家后台'),(179,'网站卖家',1,'admin','2021-06-10 15:05:27','登录了卖家后台'),(180,'网站卖家',1,'admin','2021-06-10 18:14:34','登录了卖家后台'),(181,'网站卖家',1,'admin','2021-06-11 11:33:12','登录了卖家后台');
/*!40000 ALTER TABLE `oscshop_user_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_user_favgoods`
--

DROP TABLE IF EXISTS `oscshop_user_favgoods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_user_favgoods` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  `add_time` int(10) NOT NULL COMMENT '关注时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品收藏表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_user_favgoods`
--

LOCK TABLES `oscshop_user_favgoods` WRITE;
/*!40000 ALTER TABLE `oscshop_user_favgoods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_user_favgoods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_user_favstore`
--

DROP TABLE IF EXISTS `oscshop_user_favstore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_user_favstore` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `store_id` int(10) NOT NULL COMMENT '店铺id',
  `add_time` int(10) NOT NULL COMMENT '关注时间',
  PRIMARY KEY (`id`),
  KEY `member_id` (`member_id`,`store_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品收藏表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_user_favstore`
--

LOCK TABLES `oscshop_user_favstore` WRITE;
/*!40000 ALTER TABLE `oscshop_user_favstore` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_user_favstore` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_visitors_ip`
--

DROP TABLE IF EXISTS `oscshop_visitors_ip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_visitors_ip` (
  `vi_id` int(11) NOT NULL AUTO_INCREMENT,
  `province` varchar(40) NOT NULL COMMENT '省',
  `city` varchar(40) NOT NULL COMMENT '市县',
  `ip` varchar(40) NOT NULL COMMENT 'ip地址',
  `first_visit_time` varchar(40) DEFAULT NULL COMMENT '首次访问时间',
  `last_visit_time` varchar(40) NOT NULL COMMENT '最近访问时间',
  `add_time` varchar(40) NOT NULL,
  `user_agent` varchar(255) NOT NULL COMMENT '用户系统信息',
  PRIMARY KEY (`vi_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='访客ip记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_visitors_ip`
--

LOCK TABLES `oscshop_visitors_ip` WRITE;
/*!40000 ALTER TABLE `oscshop_visitors_ip` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_visitors_ip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_voucher`
--

DROP TABLE IF EXISTS `oscshop_voucher`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_voucher` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `voucher_title` varchar(100) NOT NULL COMMENT '优惠券名称',
  `store_id` int(11) NOT NULL COMMENT '商家id，0表示不限制商家使用',
  `credit` float(10,2) NOT NULL COMMENT '代金额',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '类型。0店铺专用，1所有通用',
  `is_index_show` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否推荐首页，供用户领取',
  `is_share_doubling` tinyint(1) DEFAULT '0' COMMENT '是否分享翻倍，0：不翻倍，1翻倍',
  `get_over_hour` float(10,2) DEFAULT '0.00' COMMENT '领券后过期时间',
  `is_limit_goods_buy` tinyint(1) DEFAULT '0' COMMENT '是否限制商品购买，0不限制，1限制',
  `share_title` varchar(255) DEFAULT NULL COMMENT '优惠券分享标题',
  `share_desc` varchar(255) DEFAULT NULL COMMENT '优惠券分享描述',
  `share_logo` varchar(255) DEFAULT NULL COMMENT '分享logo',
  `person_limit_count` int(10) DEFAULT '0' COMMENT '每人限领数量，0表示不限制',
  `limit_money` float(10,2) NOT NULL COMMENT '订单金额满多少可用',
  `total_count` int(11) NOT NULL COMMENT '总生成张数',
  `send_count` int(11) NOT NULL COMMENT '已发送张数',
  `begin_time` int(10) NOT NULL COMMENT '可以使用开始时间',
  `end_time` int(10) NOT NULL COMMENT '结束时间',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_voucher`
--

LOCK TABLES `oscshop_voucher` WRITE;
/*!40000 ALTER TABLE `oscshop_voucher` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_voucher` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_voucher_free`
--

DROP TABLE IF EXISTS `oscshop_voucher_free`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_voucher_free` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `user_id` int(10) NOT NULL COMMENT '会员id',
  `order_id` int(10) NOT NULL COMMENT '使用的订单id',
  `state` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0未使用，1已使用',
  `addtime` int(10) NOT NULL COMMENT '获得时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='免单券列表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_voucher_free`
--

LOCK TABLES `oscshop_voucher_free` WRITE;
/*!40000 ALTER TABLE `oscshop_voucher_free` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_voucher_free` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_voucher_goods`
--

DROP TABLE IF EXISTS `oscshop_voucher_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_voucher_goods` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `voucher_id` int(10) NOT NULL COMMENT '优惠券id',
  `goods_id` int(10) NOT NULL COMMENT '商品id',
  PRIMARY KEY (`id`),
  KEY `voucher_id` (`voucher_id`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='优惠券限制商品使用表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_voucher_goods`
--

LOCK TABLES `oscshop_voucher_goods` WRITE;
/*!40000 ALTER TABLE `oscshop_voucher_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_voucher_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_voucher_list`
--

DROP TABLE IF EXISTS `oscshop_voucher_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_voucher_list` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `voucher_id` int(11) NOT NULL COMMENT '优惠券id',
  `voucher_title` varchar(100) NOT NULL COMMENT '优惠券标题',
  `store_id` int(10) NOT NULL COMMENT '商家id',
  `user_id` int(10) NOT NULL DEFAULT '0' COMMENT '领取的用户id',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0店铺专用，1所有通用',
  `credit` float(10,2) NOT NULL COMMENT '优惠金额',
  `limit_money` float(10,2) NOT NULL COMMENT '满多少可用',
  `is_limit_goods_buy` tinyint(1) DEFAULT '0' COMMENT '是否限制商品购买，0不限制，1限制',
  `consume` enum('N','Y') NOT NULL COMMENT '是否使用',
  `begin_time` int(10) NOT NULL COMMENT '开始时间',
  `end_time` int(10) NOT NULL COMMENT '结束时间',
  `add_time` int(10) NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `voucher_id` (`voucher_id`) USING BTREE,
  KEY `store_id` (`store_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_voucher_list`
--

LOCK TABLES `oscshop_voucher_list` WRITE;
/*!40000 ALTER TABLE `oscshop_voucher_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_voucher_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_weight_class`
--

DROP TABLE IF EXISTS `oscshop_weight_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_weight_class` (
  `weight_class_id` int(11) NOT NULL AUTO_INCREMENT,
  `value` decimal(15,8) NOT NULL DEFAULT '0.00000000',
  `title` varchar(32) NOT NULL,
  `unit` varchar(4) NOT NULL,
  PRIMARY KEY (`weight_class_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='重量单位';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_weight_class`
--

LOCK TABLES `oscshop_weight_class` WRITE;
/*!40000 ALTER TABLE `oscshop_weight_class` DISABLE KEYS */;
INSERT INTO `oscshop_weight_class` VALUES (1,1.00000000,'千克','kg'),(2,1000.00000000,'克','g');
/*!40000 ALTER TABLE `oscshop_weight_class` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oscshop_weprogram_token`
--

DROP TABLE IF EXISTS `oscshop_weprogram_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oscshop_weprogram_token` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '会员id',
  `token` varchar(100) NOT NULL COMMENT '会员标识',
  `member_id` int(10) NOT NULL COMMENT '会员id',
  `session_key` varchar(100) NOT NULL COMMENT '保持登录的session',
  `expires_in` int(10) NOT NULL COMMENT '过期时间',
  PRIMARY KEY (`id`),
  KEY `token` (`token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='小程序会员token表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oscshop_weprogram_token`
--

LOCK TABLES `oscshop_weprogram_token` WRITE;
/*!40000 ALTER TABLE `oscshop_weprogram_token` DISABLE KEYS */;
/*!40000 ALTER TABLE `oscshop_weprogram_token` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Dumping events for database 'shiziyu'
--

--
-- Dumping routines for database 'shiziyu'
--
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2021-06-11 11:34:21
